#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 1091
#define LARGE_STATE_COUNT 166
#define SYMBOL_COUNT 144
#define ALIAS_COUNT 4
#define TOKEN_COUNT 64
#define EXTERNAL_TOKEN_COUNT 12
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 8
#define PRODUCTION_ID_COUNT 7

enum {
  sym__backslash_escape = 1,
  sym_entity_reference = 2,
  sym_numeric_character_reference = 3,
  anon_sym_LBRACK = 4,
  anon_sym_RBRACK = 5,
  anon_sym_LT = 6,
  anon_sym_GT = 7,
  anon_sym_BANG = 8,
  anon_sym_DQUOTE = 9,
  anon_sym_POUND = 10,
  anon_sym_DOLLAR = 11,
  anon_sym_PERCENT = 12,
  anon_sym_AMP = 13,
  anon_sym_SQUOTE = 14,
  anon_sym_STAR = 15,
  anon_sym_PLUS = 16,
  anon_sym_COMMA = 17,
  anon_sym_DASH = 18,
  anon_sym_DOT = 19,
  anon_sym_SLASH = 20,
  anon_sym_COLON = 21,
  anon_sym_SEMI = 22,
  anon_sym_EQ = 23,
  anon_sym_QMARK = 24,
  anon_sym_AT = 25,
  anon_sym_BSLASH = 26,
  anon_sym_CARET = 27,
  anon_sym__ = 28,
  anon_sym_BQUOTE = 29,
  anon_sym_LBRACE = 30,
  anon_sym_PIPE = 31,
  anon_sym_RBRACE = 32,
  anon_sym_TILDE = 33,
  anon_sym_LPAREN = 34,
  anon_sym_RPAREN = 35,
  sym__newline_token = 36,
  sym_uri_autolink = 37,
  sym_email_autolink = 38,
  sym__attribute_name = 39,
  aux_sym__attribute_value_token1 = 40,
  anon_sym_LT_BANG_DASH_DASH = 41,
  anon_sym_DASH_DASH_GT = 42,
  anon_sym_LT_QMARK = 43,
  anon_sym_QMARK_GT = 44,
  aux_sym__declaration_token1 = 45,
  anon_sym_LT_BANG_LBRACKCDATA_LBRACK = 46,
  anon_sym_RBRACK_RBRACK_GT = 47,
  sym__whitespace_ge_2 = 48,
  aux_sym__whitespace_token1 = 49,
  sym__word_no_digit = 50,
  sym__digits = 51,
  sym__error = 52,
  sym__trigger_error = 53,
  sym__code_span_start = 54,
  sym__code_span_close = 55,
  sym__emphasis_open_star = 56,
  sym__emphasis_open_underscore = 57,
  sym__emphasis_close_star = 58,
  sym__emphasis_close_underscore = 59,
  sym__last_token_whitespace = 60,
  sym__last_token_punctuation = 61,
  sym__strikethrough_open = 62,
  sym__strikethrough_close = 63,
  sym_inline = 64,
  sym_backslash_escape = 65,
  sym_link_label = 66,
  sym_link_destination = 67,
  sym__link_destination_parenthesis = 68,
  sym__text_no_angle = 69,
  sym_link_title = 70,
  sym_code_span = 71,
  sym__link_text = 72,
  sym__link_text_non_empty = 73,
  sym_shortcut_link = 74,
  sym_full_reference_link = 75,
  sym_collapsed_reference_link = 76,
  sym_inline_link = 77,
  sym_image = 78,
  sym__image_inline_link = 79,
  sym__image_shortcut_link = 80,
  sym__image_full_reference_link = 81,
  sym__image_collapsed_reference_link = 82,
  sym__image_description = 83,
  sym__image_description_non_empty = 84,
  sym__html_tag = 85,
  sym__open_tag = 86,
  sym__closing_tag = 87,
  sym__tag_name = 88,
  sym__attribute = 89,
  sym__attribute_value = 90,
  sym__html_comment = 91,
  sym__processing_instruction = 92,
  sym__declaration = 93,
  sym__cdata_section = 94,
  sym_hard_line_break = 95,
  sym__whitespace = 96,
  sym__word = 97,
  sym__soft_line_break = 98,
  sym__inline_base = 99,
  sym__text_base = 100,
  sym__text_inline_no_link = 101,
  sym__inline_element = 102,
  aux_sym__inline = 103,
  sym__inline_element_no_star = 104,
  aux_sym__inline_no_star = 105,
  sym__inline_element_no_underscore = 106,
  aux_sym__inline_no_underscore = 107,
  sym__inline_element_no_tilde = 108,
  aux_sym__inline_no_tilde = 109,
  sym__strikethrough = 110,
  sym__emphasis_star = 111,
  sym__strong_emphasis_star = 112,
  sym__emphasis_underscore = 113,
  sym__strong_emphasis_underscore = 114,
  sym__inline_element_no_link = 115,
  aux_sym__inline_no_link = 116,
  sym__inline_element_no_star_no_link = 117,
  aux_sym__inline_no_star_no_link = 118,
  sym__inline_element_no_underscore_no_link = 119,
  aux_sym__inline_no_underscore_no_link = 120,
  sym__inline_element_no_tilde_no_link = 121,
  aux_sym__inline_no_tilde_no_link = 122,
  sym__strikethrough_no_link = 123,
  sym__emphasis_star_no_link = 124,
  sym__strong_emphasis_star_no_link = 125,
  sym__emphasis_underscore_no_link = 126,
  sym__strong_emphasis_underscore_no_link = 127,
  aux_sym_link_label_repeat1 = 128,
  aux_sym_link_destination_repeat1 = 129,
  aux_sym_link_destination_repeat2 = 130,
  aux_sym_link_title_repeat1 = 131,
  aux_sym_link_title_repeat2 = 132,
  aux_sym_link_title_repeat3 = 133,
  aux_sym_code_span_repeat1 = 134,
  aux_sym_inline_link_repeat1 = 135,
  aux_sym__open_tag_repeat1 = 136,
  aux_sym__tag_name_repeat1 = 137,
  aux_sym__attribute_value_repeat1 = 138,
  aux_sym__attribute_value_repeat2 = 139,
  aux_sym__html_comment_repeat1 = 140,
  aux_sym__processing_instruction_repeat1 = 141,
  aux_sym__declaration_repeat1 = 142,
  aux_sym__inline_base_repeat1 = 143,
  alias_sym_emphasis = 144,
  alias_sym_html_tag = 145,
  alias_sym_image_description = 146,
  alias_sym_link_text = 147,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__backslash_escape] = "_backslash_escape",
  [sym_entity_reference] = "entity_reference",
  [sym_numeric_character_reference] = "numeric_character_reference",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_BANG] = "!",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_PERCENT] = "%",
  [anon_sym_AMP] = "&",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_STAR] = "*",
  [anon_sym_PLUS] = "+",
  [anon_sym_COMMA] = ",",
  [anon_sym_DASH] = "-",
  [anon_sym_DOT] = ".",
  [anon_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_SEMI] = ";",
  [anon_sym_EQ] = "=",
  [anon_sym_QMARK] = "\?",
  [anon_sym_AT] = "@",
  [anon_sym_BSLASH] = "\\",
  [anon_sym_CARET] = "^",
  [anon_sym__] = "_",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LBRACE] = "{",
  [anon_sym_PIPE] = "|",
  [anon_sym_RBRACE] = "}",
  [anon_sym_TILDE] = "~",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [sym__newline_token] = "_newline_token",
  [sym_uri_autolink] = "uri_autolink",
  [sym_email_autolink] = "email_autolink",
  [sym__attribute_name] = "_attribute_name",
  [aux_sym__attribute_value_token1] = "_attribute_value_token1",
  [anon_sym_LT_BANG_DASH_DASH] = "<!--",
  [anon_sym_DASH_DASH_GT] = "-->",
  [anon_sym_LT_QMARK] = "<\?",
  [anon_sym_QMARK_GT] = "\?>",
  [aux_sym__declaration_token1] = "_declaration_token1",
  [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = "<![CDATA[",
  [anon_sym_RBRACK_RBRACK_GT] = "]]>",
  [sym__whitespace_ge_2] = "_whitespace_ge_2",
  [aux_sym__whitespace_token1] = "_whitespace_token1",
  [sym__word_no_digit] = "_word_no_digit",
  [sym__digits] = "_digits",
  [sym__error] = "_error",
  [sym__trigger_error] = "_trigger_error",
  [sym__code_span_start] = "_code_span_start",
  [sym__code_span_close] = "code_span_delimiter",
  [sym__emphasis_open_star] = "_emphasis_open_star",
  [sym__emphasis_open_underscore] = "_emphasis_open_underscore",
  [sym__emphasis_close_star] = "emphasis_delimiter",
  [sym__emphasis_close_underscore] = "emphasis_delimiter",
  [sym__last_token_whitespace] = "_last_token_whitespace",
  [sym__last_token_punctuation] = "_last_token_punctuation",
  [sym__strikethrough_open] = "_strikethrough_open",
  [sym__strikethrough_close] = "emphasis_delimiter",
  [sym_inline] = "inline",
  [sym_backslash_escape] = "backslash_escape",
  [sym_link_label] = "link_label",
  [sym_link_destination] = "link_destination",
  [sym__link_destination_parenthesis] = "_link_destination_parenthesis",
  [sym__text_no_angle] = "_text_no_angle",
  [sym_link_title] = "link_title",
  [sym_code_span] = "code_span",
  [sym__link_text] = "_link_text",
  [sym__link_text_non_empty] = "_link_text_non_empty",
  [sym_shortcut_link] = "shortcut_link",
  [sym_full_reference_link] = "full_reference_link",
  [sym_collapsed_reference_link] = "collapsed_reference_link",
  [sym_inline_link] = "inline_link",
  [sym_image] = "image",
  [sym__image_inline_link] = "_image_inline_link",
  [sym__image_shortcut_link] = "_image_shortcut_link",
  [sym__image_full_reference_link] = "_image_full_reference_link",
  [sym__image_collapsed_reference_link] = "_image_collapsed_reference_link",
  [sym__image_description] = "_image_description",
  [sym__image_description_non_empty] = "_image_description_non_empty",
  [sym__html_tag] = "_html_tag",
  [sym__open_tag] = "_open_tag",
  [sym__closing_tag] = "_closing_tag",
  [sym__tag_name] = "_tag_name",
  [sym__attribute] = "_attribute",
  [sym__attribute_value] = "_attribute_value",
  [sym__html_comment] = "_html_comment",
  [sym__processing_instruction] = "_processing_instruction",
  [sym__declaration] = "_declaration",
  [sym__cdata_section] = "_cdata_section",
  [sym_hard_line_break] = "hard_line_break",
  [sym__whitespace] = "_whitespace",
  [sym__word] = "_word",
  [sym__soft_line_break] = "_soft_line_break",
  [sym__inline_base] = "_inline_base",
  [sym__text_base] = "_text_base",
  [sym__text_inline_no_link] = "_text_inline_no_link",
  [sym__inline_element] = "_inline_element",
  [aux_sym__inline] = "_inline",
  [sym__inline_element_no_star] = "_inline_element_no_star",
  [aux_sym__inline_no_star] = "_inline_no_star",
  [sym__inline_element_no_underscore] = "_inline_element_no_underscore",
  [aux_sym__inline_no_underscore] = "_inline_no_underscore",
  [sym__inline_element_no_tilde] = "_inline_element_no_tilde",
  [aux_sym__inline_no_tilde] = "_inline_no_tilde",
  [sym__strikethrough] = "strikethrough",
  [sym__emphasis_star] = "_emphasis_star",
  [sym__strong_emphasis_star] = "strong_emphasis",
  [sym__emphasis_underscore] = "_emphasis_underscore",
  [sym__strong_emphasis_underscore] = "strong_emphasis",
  [sym__inline_element_no_link] = "_inline_element_no_link",
  [aux_sym__inline_no_link] = "_inline_no_link",
  [sym__inline_element_no_star_no_link] = "_inline_element_no_star_no_link",
  [aux_sym__inline_no_star_no_link] = "_inline_no_star_no_link",
  [sym__inline_element_no_underscore_no_link] = "_inline_element_no_underscore_no_link",
  [aux_sym__inline_no_underscore_no_link] = "_inline_no_underscore_no_link",
  [sym__inline_element_no_tilde_no_link] = "_inline_element_no_tilde_no_link",
  [aux_sym__inline_no_tilde_no_link] = "_inline_no_tilde_no_link",
  [sym__strikethrough_no_link] = "strikethrough",
  [sym__emphasis_star_no_link] = "_emphasis_star_no_link",
  [sym__strong_emphasis_star_no_link] = "strong_emphasis",
  [sym__emphasis_underscore_no_link] = "_emphasis_underscore_no_link",
  [sym__strong_emphasis_underscore_no_link] = "strong_emphasis",
  [aux_sym_link_label_repeat1] = "link_label_repeat1",
  [aux_sym_link_destination_repeat1] = "link_destination_repeat1",
  [aux_sym_link_destination_repeat2] = "link_destination_repeat2",
  [aux_sym_link_title_repeat1] = "link_title_repeat1",
  [aux_sym_link_title_repeat2] = "link_title_repeat2",
  [aux_sym_link_title_repeat3] = "link_title_repeat3",
  [aux_sym_code_span_repeat1] = "code_span_repeat1",
  [aux_sym_inline_link_repeat1] = "inline_link_repeat1",
  [aux_sym__open_tag_repeat1] = "_open_tag_repeat1",
  [aux_sym__tag_name_repeat1] = "_tag_name_repeat1",
  [aux_sym__attribute_value_repeat1] = "_attribute_value_repeat1",
  [aux_sym__attribute_value_repeat2] = "_attribute_value_repeat2",
  [aux_sym__html_comment_repeat1] = "_html_comment_repeat1",
  [aux_sym__processing_instruction_repeat1] = "_processing_instruction_repeat1",
  [aux_sym__declaration_repeat1] = "_declaration_repeat1",
  [aux_sym__inline_base_repeat1] = "_inline_base_repeat1",
  [alias_sym_emphasis] = "emphasis",
  [alias_sym_html_tag] = "html_tag",
  [alias_sym_image_description] = "image_description",
  [alias_sym_link_text] = "link_text",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__backslash_escape] = sym__backslash_escape,
  [sym_entity_reference] = sym_entity_reference,
  [sym_numeric_character_reference] = sym_numeric_character_reference,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_BSLASH] = anon_sym_BSLASH,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym__] = anon_sym__,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [sym__newline_token] = sym__newline_token,
  [sym_uri_autolink] = sym_uri_autolink,
  [sym_email_autolink] = sym_email_autolink,
  [sym__attribute_name] = sym__attribute_name,
  [aux_sym__attribute_value_token1] = aux_sym__attribute_value_token1,
  [anon_sym_LT_BANG_DASH_DASH] = anon_sym_LT_BANG_DASH_DASH,
  [anon_sym_DASH_DASH_GT] = anon_sym_DASH_DASH_GT,
  [anon_sym_LT_QMARK] = anon_sym_LT_QMARK,
  [anon_sym_QMARK_GT] = anon_sym_QMARK_GT,
  [aux_sym__declaration_token1] = aux_sym__declaration_token1,
  [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
  [anon_sym_RBRACK_RBRACK_GT] = anon_sym_RBRACK_RBRACK_GT,
  [sym__whitespace_ge_2] = sym__whitespace_ge_2,
  [aux_sym__whitespace_token1] = aux_sym__whitespace_token1,
  [sym__word_no_digit] = sym__word_no_digit,
  [sym__digits] = sym__digits,
  [sym__error] = sym__error,
  [sym__trigger_error] = sym__trigger_error,
  [sym__code_span_start] = sym__code_span_start,
  [sym__code_span_close] = sym__code_span_close,
  [sym__emphasis_open_star] = sym__emphasis_open_star,
  [sym__emphasis_open_underscore] = sym__emphasis_open_underscore,
  [sym__emphasis_close_star] = sym__emphasis_close_star,
  [sym__emphasis_close_underscore] = sym__emphasis_close_star,
  [sym__last_token_whitespace] = sym__last_token_whitespace,
  [sym__last_token_punctuation] = sym__last_token_punctuation,
  [sym__strikethrough_open] = sym__strikethrough_open,
  [sym__strikethrough_close] = sym__emphasis_close_star,
  [sym_inline] = sym_inline,
  [sym_backslash_escape] = sym_backslash_escape,
  [sym_link_label] = sym_link_label,
  [sym_link_destination] = sym_link_destination,
  [sym__link_destination_parenthesis] = sym__link_destination_parenthesis,
  [sym__text_no_angle] = sym__text_no_angle,
  [sym_link_title] = sym_link_title,
  [sym_code_span] = sym_code_span,
  [sym__link_text] = sym__link_text,
  [sym__link_text_non_empty] = sym__link_text_non_empty,
  [sym_shortcut_link] = sym_shortcut_link,
  [sym_full_reference_link] = sym_full_reference_link,
  [sym_collapsed_reference_link] = sym_collapsed_reference_link,
  [sym_inline_link] = sym_inline_link,
  [sym_image] = sym_image,
  [sym__image_inline_link] = sym__image_inline_link,
  [sym__image_shortcut_link] = sym__image_shortcut_link,
  [sym__image_full_reference_link] = sym__image_full_reference_link,
  [sym__image_collapsed_reference_link] = sym__image_collapsed_reference_link,
  [sym__image_description] = sym__image_description,
  [sym__image_description_non_empty] = sym__image_description_non_empty,
  [sym__html_tag] = sym__html_tag,
  [sym__open_tag] = sym__open_tag,
  [sym__closing_tag] = sym__closing_tag,
  [sym__tag_name] = sym__tag_name,
  [sym__attribute] = sym__attribute,
  [sym__attribute_value] = sym__attribute_value,
  [sym__html_comment] = sym__html_comment,
  [sym__processing_instruction] = sym__processing_instruction,
  [sym__declaration] = sym__declaration,
  [sym__cdata_section] = sym__cdata_section,
  [sym_hard_line_break] = sym_hard_line_break,
  [sym__whitespace] = sym__whitespace,
  [sym__word] = sym__word,
  [sym__soft_line_break] = sym__soft_line_break,
  [sym__inline_base] = sym__inline_base,
  [sym__text_base] = sym__text_base,
  [sym__text_inline_no_link] = sym__text_inline_no_link,
  [sym__inline_element] = sym__inline_element,
  [aux_sym__inline] = aux_sym__inline,
  [sym__inline_element_no_star] = sym__inline_element_no_star,
  [aux_sym__inline_no_star] = aux_sym__inline_no_star,
  [sym__inline_element_no_underscore] = sym__inline_element_no_underscore,
  [aux_sym__inline_no_underscore] = aux_sym__inline_no_underscore,
  [sym__inline_element_no_tilde] = sym__inline_element_no_tilde,
  [aux_sym__inline_no_tilde] = aux_sym__inline_no_tilde,
  [sym__strikethrough] = sym__strikethrough,
  [sym__emphasis_star] = sym__emphasis_star,
  [sym__strong_emphasis_star] = sym__strong_emphasis_star,
  [sym__emphasis_underscore] = sym__emphasis_underscore,
  [sym__strong_emphasis_underscore] = sym__strong_emphasis_star,
  [sym__inline_element_no_link] = sym__inline_element_no_link,
  [aux_sym__inline_no_link] = aux_sym__inline_no_link,
  [sym__inline_element_no_star_no_link] = sym__inline_element_no_star_no_link,
  [aux_sym__inline_no_star_no_link] = aux_sym__inline_no_star_no_link,
  [sym__inline_element_no_underscore_no_link] = sym__inline_element_no_underscore_no_link,
  [aux_sym__inline_no_underscore_no_link] = aux_sym__inline_no_underscore_no_link,
  [sym__inline_element_no_tilde_no_link] = sym__inline_element_no_tilde_no_link,
  [aux_sym__inline_no_tilde_no_link] = aux_sym__inline_no_tilde_no_link,
  [sym__strikethrough_no_link] = sym__strikethrough,
  [sym__emphasis_star_no_link] = sym__emphasis_star_no_link,
  [sym__strong_emphasis_star_no_link] = sym__strong_emphasis_star,
  [sym__emphasis_underscore_no_link] = sym__emphasis_underscore_no_link,
  [sym__strong_emphasis_underscore_no_link] = sym__strong_emphasis_star,
  [aux_sym_link_label_repeat1] = aux_sym_link_label_repeat1,
  [aux_sym_link_destination_repeat1] = aux_sym_link_destination_repeat1,
  [aux_sym_link_destination_repeat2] = aux_sym_link_destination_repeat2,
  [aux_sym_link_title_repeat1] = aux_sym_link_title_repeat1,
  [aux_sym_link_title_repeat2] = aux_sym_link_title_repeat2,
  [aux_sym_link_title_repeat3] = aux_sym_link_title_repeat3,
  [aux_sym_code_span_repeat1] = aux_sym_code_span_repeat1,
  [aux_sym_inline_link_repeat1] = aux_sym_inline_link_repeat1,
  [aux_sym__open_tag_repeat1] = aux_sym__open_tag_repeat1,
  [aux_sym__tag_name_repeat1] = aux_sym__tag_name_repeat1,
  [aux_sym__attribute_value_repeat1] = aux_sym__attribute_value_repeat1,
  [aux_sym__attribute_value_repeat2] = aux_sym__attribute_value_repeat2,
  [aux_sym__html_comment_repeat1] = aux_sym__html_comment_repeat1,
  [aux_sym__processing_instruction_repeat1] = aux_sym__processing_instruction_repeat1,
  [aux_sym__declaration_repeat1] = aux_sym__declaration_repeat1,
  [aux_sym__inline_base_repeat1] = aux_sym__inline_base_repeat1,
  [alias_sym_emphasis] = alias_sym_emphasis,
  [alias_sym_html_tag] = alias_sym_html_tag,
  [alias_sym_image_description] = alias_sym_image_description,
  [alias_sym_link_text] = alias_sym_link_text,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__backslash_escape] = {
    .visible = false,
    .named = true,
  },
  [sym_entity_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_numeric_character_reference] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym__newline_token] = {
    .visible = false,
    .named = true,
  },
  [sym_uri_autolink] = {
    .visible = true,
    .named = true,
  },
  [sym_email_autolink] = {
    .visible = true,
    .named = true,
  },
  [sym__attribute_name] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__attribute_value_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LT_BANG_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_GT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__declaration_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK_GT] = {
    .visible = true,
    .named = false,
  },
  [sym__whitespace_ge_2] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__whitespace_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__word_no_digit] = {
    .visible = false,
    .named = true,
  },
  [sym__digits] = {
    .visible = false,
    .named = true,
  },
  [sym__error] = {
    .visible = false,
    .named = true,
  },
  [sym__trigger_error] = {
    .visible = false,
    .named = true,
  },
  [sym__code_span_start] = {
    .visible = false,
    .named = true,
  },
  [sym__code_span_close] = {
    .visible = true,
    .named = true,
  },
  [sym__emphasis_open_star] = {
    .visible = false,
    .named = true,
  },
  [sym__emphasis_open_underscore] = {
    .visible = false,
    .named = true,
  },
  [sym__emphasis_close_star] = {
    .visible = true,
    .named = true,
  },
  [sym__emphasis_close_underscore] = {
    .visible = true,
    .named = true,
  },
  [sym__last_token_whitespace] = {
    .visible = false,
    .named = true,
  },
  [sym__last_token_punctuation] = {
    .visible = false,
    .named = true,
  },
  [sym__strikethrough_open] = {
    .visible = false,
    .named = true,
  },
  [sym__strikethrough_close] = {
    .visible = true,
    .named = true,
  },
  [sym_inline] = {
    .visible = true,
    .named = true,
  },
  [sym_backslash_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_link_label] = {
    .visible = true,
    .named = true,
  },
  [sym_link_destination] = {
    .visible = true,
    .named = true,
  },
  [sym__link_destination_parenthesis] = {
    .visible = false,
    .named = true,
  },
  [sym__text_no_angle] = {
    .visible = false,
    .named = true,
  },
  [sym_link_title] = {
    .visible = true,
    .named = true,
  },
  [sym_code_span] = {
    .visible = true,
    .named = true,
  },
  [sym__link_text] = {
    .visible = false,
    .named = true,
  },
  [sym__link_text_non_empty] = {
    .visible = false,
    .named = true,
  },
  [sym_shortcut_link] = {
    .visible = true,
    .named = true,
  },
  [sym_full_reference_link] = {
    .visible = true,
    .named = true,
  },
  [sym_collapsed_reference_link] = {
    .visible = true,
    .named = true,
  },
  [sym_inline_link] = {
    .visible = true,
    .named = true,
  },
  [sym_image] = {
    .visible = true,
    .named = true,
  },
  [sym__image_inline_link] = {
    .visible = false,
    .named = true,
  },
  [sym__image_shortcut_link] = {
    .visible = false,
    .named = true,
  },
  [sym__image_full_reference_link] = {
    .visible = false,
    .named = true,
  },
  [sym__image_collapsed_reference_link] = {
    .visible = false,
    .named = true,
  },
  [sym__image_description] = {
    .visible = false,
    .named = true,
  },
  [sym__image_description_non_empty] = {
    .visible = false,
    .named = true,
  },
  [sym__html_tag] = {
    .visible = false,
    .named = true,
  },
  [sym__open_tag] = {
    .visible = false,
    .named = true,
  },
  [sym__closing_tag] = {
    .visible = false,
    .named = true,
  },
  [sym__tag_name] = {
    .visible = false,
    .named = true,
  },
  [sym__attribute] = {
    .visible = false,
    .named = true,
  },
  [sym__attribute_value] = {
    .visible = false,
    .named = true,
  },
  [sym__html_comment] = {
    .visible = false,
    .named = true,
  },
  [sym__processing_instruction] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__cdata_section] = {
    .visible = false,
    .named = true,
  },
  [sym_hard_line_break] = {
    .visible = true,
    .named = true,
  },
  [sym__whitespace] = {
    .visible = false,
    .named = true,
  },
  [sym__word] = {
    .visible = false,
    .named = true,
  },
  [sym__soft_line_break] = {
    .visible = false,
    .named = true,
  },
  [sym__inline_base] = {
    .visible = false,
    .named = true,
  },
  [sym__text_base] = {
    .visible = false,
    .named = true,
  },
  [sym__text_inline_no_link] = {
    .visible = false,
    .named = true,
  },
  [sym__inline_element] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline] = {
    .visible = false,
    .named = false,
  },
  [sym__inline_element_no_star] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_no_star] = {
    .visible = false,
    .named = false,
  },
  [sym__inline_element_no_underscore] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_no_underscore] = {
    .visible = false,
    .named = false,
  },
  [sym__inline_element_no_tilde] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_no_tilde] = {
    .visible = false,
    .named = false,
  },
  [sym__strikethrough] = {
    .visible = true,
    .named = true,
  },
  [sym__emphasis_star] = {
    .visible = false,
    .named = true,
  },
  [sym__strong_emphasis_star] = {
    .visible = true,
    .named = true,
  },
  [sym__emphasis_underscore] = {
    .visible = false,
    .named = true,
  },
  [sym__strong_emphasis_underscore] = {
    .visible = true,
    .named = true,
  },
  [sym__inline_element_no_link] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_no_link] = {
    .visible = false,
    .named = false,
  },
  [sym__inline_element_no_star_no_link] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_no_star_no_link] = {
    .visible = false,
    .named = false,
  },
  [sym__inline_element_no_underscore_no_link] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_no_underscore_no_link] = {
    .visible = false,
    .named = false,
  },
  [sym__inline_element_no_tilde_no_link] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__inline_no_tilde_no_link] = {
    .visible = false,
    .named = false,
  },
  [sym__strikethrough_no_link] = {
    .visible = true,
    .named = true,
  },
  [sym__emphasis_star_no_link] = {
    .visible = false,
    .named = true,
  },
  [sym__strong_emphasis_star_no_link] = {
    .visible = true,
    .named = true,
  },
  [sym__emphasis_underscore_no_link] = {
    .visible = false,
    .named = true,
  },
  [sym__strong_emphasis_underscore_no_link] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_link_label_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_destination_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_destination_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_title_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_title_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_link_title_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_code_span_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_inline_link_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__open_tag_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__tag_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__attribute_value_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__attribute_value_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__html_comment_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__processing_instruction_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__inline_base_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_emphasis] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_html_tag] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_image_description] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_link_text] = {
    .visible = true,
    .named = true,
  },
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = alias_sym_html_tag,
  },
  [2] = {
    [0] = alias_sym_emphasis,
  },
  [3] = {
    [0] = sym__code_span_close,
  },
  [4] = {
    [0] = sym__emphasis_close_star,
  },
  [5] = {
    [1] = alias_sym_link_text,
  },
  [6] = {
    [2] = alias_sym_image_description,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__html_tag, 2,
    sym__html_tag,
    alias_sym_html_tag,
  aux_sym__inline, 2,
    aux_sym__inline,
    alias_sym_image_description,
  sym__emphasis_star, 2,
    sym__emphasis_star,
    alias_sym_emphasis,
  sym__emphasis_underscore, 2,
    sym__emphasis_underscore,
    alias_sym_emphasis,
  aux_sym__inline_no_link, 2,
    aux_sym__inline_no_link,
    alias_sym_link_text,
  sym__emphasis_star_no_link, 2,
    sym__emphasis_star_no_link,
    alias_sym_emphasis,
  sym__emphasis_underscore_no_link, 2,
    sym__emphasis_underscore_no_link,
    alias_sym_emphasis,
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(2178);
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2195);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2201);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2186);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2208);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2211);
      if (lookahead == ']') ADVANCE(2184);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 1:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2195);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2187);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '\\') ADVANCE(2211);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0 &&
          lookahead != '[') ADVANCE(2240);
      END_STATE();
    case 2:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2195);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2185);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2211);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 3:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2201);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2187);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 4:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2201);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2185);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 5:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2187);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2208);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 6:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2187);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2184);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 7:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2187);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 8:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2185);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2208);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 9:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2185);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2184);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 10:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2194);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2185);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2210);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 11:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead != 0 &&
          (lookahead < '<' || '>' < lookahead) &&
          lookahead != '`') ADVANCE(2226);
      END_STATE();
    case 12:
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == ':' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2225);
      END_STATE();
    case 13:
      if (lookahead == '-') ADVANCE(14);
      if (lookahead == '@') ADVANCE(2172);
      if (lookahead == '[') ADVANCE(424);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(2233);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('.' <= lookahead && lookahead <= '9') ||
          lookahead == '=' ||
          lookahead == '?' ||
          ('^' <= lookahead && lookahead <= '~')) ADVANCE(383);
      END_STATE();
    case 14:
      if (lookahead == '-') ADVANCE(2228);
      if (lookahead == '@') ADVANCE(2172);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('.' <= lookahead && lookahead <= '9') ||
          lookahead == '=' ||
          ('?' <= lookahead && lookahead <= 'Z') ||
          ('^' <= lookahead && lookahead <= '~')) ADVANCE(383);
      END_STATE();
    case 15:
      if (lookahead == '-') ADVANCE(137);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(136);
      END_STATE();
    case 16:
      if (lookahead == '-') ADVANCE(17);
      if (lookahead == '[') ADVANCE(424);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(2234);
      END_STATE();
    case 17:
      if (lookahead == '-') ADVANCE(2227);
      END_STATE();
    case 18:
      if (lookahead == '-') ADVANCE(2173);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(139);
      END_STATE();
    case 19:
      if (lookahead == '-') ADVANCE(2173);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(139);
      END_STATE();
    case 20:
      if (lookahead == '-') ADVANCE(23);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(22);
      END_STATE();
    case 21:
      if (lookahead == '-') ADVANCE(23);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == '-') ADVANCE(19);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(18);
      END_STATE();
    case 23:
      if (lookahead == '-') ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(18);
      END_STATE();
    case 24:
      if (lookahead == '-') ADVANCE(27);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(26);
      END_STATE();
    case 25:
      if (lookahead == '-') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == '-') ADVANCE(21);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(20);
      END_STATE();
    case 27:
      if (lookahead == '-') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(20);
      END_STATE();
    case 28:
      if (lookahead == '-') ADVANCE(31);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(30);
      END_STATE();
    case 29:
      if (lookahead == '-') ADVANCE(31);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(30);
      END_STATE();
    case 30:
      if (lookahead == '-') ADVANCE(25);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(24);
      END_STATE();
    case 31:
      if (lookahead == '-') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(24);
      END_STATE();
    case 32:
      if (lookahead == '-') ADVANCE(35);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(34);
      END_STATE();
    case 33:
      if (lookahead == '-') ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(34);
      END_STATE();
    case 34:
      if (lookahead == '-') ADVANCE(29);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 35:
      if (lookahead == '-') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(28);
      END_STATE();
    case 36:
      if (lookahead == '-') ADVANCE(39);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(38);
      END_STATE();
    case 37:
      if (lookahead == '-') ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == '-') ADVANCE(33);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(32);
      END_STATE();
    case 39:
      if (lookahead == '-') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(32);
      END_STATE();
    case 40:
      if (lookahead == '-') ADVANCE(43);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(42);
      END_STATE();
    case 41:
      if (lookahead == '-') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == '-') ADVANCE(37);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(36);
      END_STATE();
    case 43:
      if (lookahead == '-') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(36);
      END_STATE();
    case 44:
      if (lookahead == '-') ADVANCE(47);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(46);
      END_STATE();
    case 45:
      if (lookahead == '-') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == '-') ADVANCE(41);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(40);
      END_STATE();
    case 47:
      if (lookahead == '-') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(40);
      END_STATE();
    case 48:
      if (lookahead == '-') ADVANCE(51);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(50);
      END_STATE();
    case 49:
      if (lookahead == '-') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == '-') ADVANCE(45);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(44);
      END_STATE();
    case 51:
      if (lookahead == '-') ADVANCE(45);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(44);
      END_STATE();
    case 52:
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      END_STATE();
    case 53:
      if (lookahead == '-') ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(54);
      END_STATE();
    case 54:
      if (lookahead == '-') ADVANCE(49);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(48);
      END_STATE();
    case 55:
      if (lookahead == '-') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(48);
      END_STATE();
    case 56:
      if (lookahead == '-') ADVANCE(59);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(58);
      END_STATE();
    case 57:
      if (lookahead == '-') ADVANCE(59);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(58);
      END_STATE();
    case 58:
      if (lookahead == '-') ADVANCE(53);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(52);
      END_STATE();
    case 59:
      if (lookahead == '-') ADVANCE(53);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(52);
      END_STATE();
    case 60:
      if (lookahead == '-') ADVANCE(63);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(62);
      END_STATE();
    case 61:
      if (lookahead == '-') ADVANCE(63);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(62);
      END_STATE();
    case 62:
      if (lookahead == '-') ADVANCE(57);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      END_STATE();
    case 63:
      if (lookahead == '-') ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(56);
      END_STATE();
    case 64:
      if (lookahead == '-') ADVANCE(67);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(66);
      END_STATE();
    case 65:
      if (lookahead == '-') ADVANCE(67);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(66);
      END_STATE();
    case 66:
      if (lookahead == '-') ADVANCE(61);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(60);
      END_STATE();
    case 67:
      if (lookahead == '-') ADVANCE(61);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(60);
      END_STATE();
    case 68:
      if (lookahead == '-') ADVANCE(71);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(70);
      END_STATE();
    case 69:
      if (lookahead == '-') ADVANCE(71);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(70);
      END_STATE();
    case 70:
      if (lookahead == '-') ADVANCE(65);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(64);
      END_STATE();
    case 71:
      if (lookahead == '-') ADVANCE(65);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(64);
      END_STATE();
    case 72:
      if (lookahead == '-') ADVANCE(75);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(74);
      END_STATE();
    case 73:
      if (lookahead == '-') ADVANCE(75);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(74);
      END_STATE();
    case 74:
      if (lookahead == '-') ADVANCE(69);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 75:
      if (lookahead == '-') ADVANCE(69);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(68);
      END_STATE();
    case 76:
      if (lookahead == '-') ADVANCE(79);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(78);
      END_STATE();
    case 77:
      if (lookahead == '-') ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(78);
      END_STATE();
    case 78:
      if (lookahead == '-') ADVANCE(73);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(72);
      END_STATE();
    case 79:
      if (lookahead == '-') ADVANCE(73);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(72);
      END_STATE();
    case 80:
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(82);
      END_STATE();
    case 81:
      if (lookahead == '-') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(82);
      END_STATE();
    case 82:
      if (lookahead == '-') ADVANCE(77);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(76);
      END_STATE();
    case 83:
      if (lookahead == '-') ADVANCE(77);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(76);
      END_STATE();
    case 84:
      if (lookahead == '-') ADVANCE(87);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(86);
      END_STATE();
    case 85:
      if (lookahead == '-') ADVANCE(87);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(86);
      END_STATE();
    case 86:
      if (lookahead == '-') ADVANCE(81);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(80);
      END_STATE();
    case 87:
      if (lookahead == '-') ADVANCE(81);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(80);
      END_STATE();
    case 88:
      if (lookahead == '-') ADVANCE(91);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(90);
      END_STATE();
    case 89:
      if (lookahead == '-') ADVANCE(91);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(90);
      END_STATE();
    case 90:
      if (lookahead == '-') ADVANCE(85);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(84);
      END_STATE();
    case 91:
      if (lookahead == '-') ADVANCE(85);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(84);
      END_STATE();
    case 92:
      if (lookahead == '-') ADVANCE(95);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(94);
      END_STATE();
    case 93:
      if (lookahead == '-') ADVANCE(95);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(94);
      END_STATE();
    case 94:
      if (lookahead == '-') ADVANCE(89);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(88);
      END_STATE();
    case 95:
      if (lookahead == '-') ADVANCE(89);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(88);
      END_STATE();
    case 96:
      if (lookahead == '-') ADVANCE(99);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      END_STATE();
    case 97:
      if (lookahead == '-') ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(98);
      END_STATE();
    case 98:
      if (lookahead == '-') ADVANCE(93);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(92);
      END_STATE();
    case 99:
      if (lookahead == '-') ADVANCE(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(92);
      END_STATE();
    case 100:
      if (lookahead == '-') ADVANCE(103);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(102);
      END_STATE();
    case 101:
      if (lookahead == '-') ADVANCE(103);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(102);
      END_STATE();
    case 102:
      if (lookahead == '-') ADVANCE(97);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 103:
      if (lookahead == '-') ADVANCE(97);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(96);
      END_STATE();
    case 104:
      if (lookahead == '-') ADVANCE(107);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(106);
      END_STATE();
    case 105:
      if (lookahead == '-') ADVANCE(107);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(106);
      END_STATE();
    case 106:
      if (lookahead == '-') ADVANCE(101);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(100);
      END_STATE();
    case 107:
      if (lookahead == '-') ADVANCE(101);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(100);
      END_STATE();
    case 108:
      if (lookahead == '-') ADVANCE(111);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(110);
      END_STATE();
    case 109:
      if (lookahead == '-') ADVANCE(111);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(110);
      END_STATE();
    case 110:
      if (lookahead == '-') ADVANCE(105);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 111:
      if (lookahead == '-') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(104);
      END_STATE();
    case 112:
      if (lookahead == '-') ADVANCE(115);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(114);
      END_STATE();
    case 113:
      if (lookahead == '-') ADVANCE(115);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(114);
      END_STATE();
    case 114:
      if (lookahead == '-') ADVANCE(109);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(108);
      END_STATE();
    case 115:
      if (lookahead == '-') ADVANCE(109);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(108);
      END_STATE();
    case 116:
      if (lookahead == '-') ADVANCE(119);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(118);
      END_STATE();
    case 117:
      if (lookahead == '-') ADVANCE(119);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(118);
      END_STATE();
    case 118:
      if (lookahead == '-') ADVANCE(113);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(112);
      END_STATE();
    case 119:
      if (lookahead == '-') ADVANCE(113);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(112);
      END_STATE();
    case 120:
      if (lookahead == '-') ADVANCE(123);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 121:
      if (lookahead == '-') ADVANCE(123);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(122);
      END_STATE();
    case 122:
      if (lookahead == '-') ADVANCE(117);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(116);
      END_STATE();
    case 123:
      if (lookahead == '-') ADVANCE(117);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(116);
      END_STATE();
    case 124:
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 125:
      if (lookahead == '-') ADVANCE(127);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(126);
      END_STATE();
    case 126:
      if (lookahead == '-') ADVANCE(121);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 127:
      if (lookahead == '-') ADVANCE(121);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(120);
      END_STATE();
    case 128:
      if (lookahead == '-') ADVANCE(131);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 129:
      if (lookahead == '-') ADVANCE(131);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(130);
      END_STATE();
    case 130:
      if (lookahead == '-') ADVANCE(125);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(124);
      END_STATE();
    case 131:
      if (lookahead == '-') ADVANCE(125);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(124);
      END_STATE();
    case 132:
      if (lookahead == '-') ADVANCE(135);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(134);
      END_STATE();
    case 133:
      if (lookahead == '-') ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(134);
      END_STATE();
    case 134:
      if (lookahead == '-') ADVANCE(129);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(128);
      END_STATE();
    case 135:
      if (lookahead == '-') ADVANCE(129);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(128);
      END_STATE();
    case 136:
      if (lookahead == '-') ADVANCE(133);
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(132);
      END_STATE();
    case 137:
      if (lookahead == '-') ADVANCE(133);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(132);
      END_STATE();
    case 138:
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      END_STATE();
    case 139:
      if (lookahead == '.') ADVANCE(2172);
      if (lookahead == '>') ADVANCE(2224);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 140:
      if (lookahead == '1') ADVANCE(2147);
      if (lookahead == '3') ADVANCE(143);
      END_STATE();
    case 141:
      if (lookahead == '1') ADVANCE(2162);
      if (lookahead == ';') ADVANCE(2180);
      END_STATE();
    case 142:
      if (lookahead == '1') ADVANCE(2169);
      if (lookahead == '2') ADVANCE(2148);
      if (lookahead == '3') ADVANCE(2165);
      if (lookahead == '4') ADVANCE(145);
      if (lookahead == '5') ADVANCE(2149);
      if (lookahead == '7') ADVANCE(146);
      END_STATE();
    case 143:
      if (lookahead == '4') ADVANCE(148);
      END_STATE();
    case 144:
      if (lookahead == '4') ADVANCE(148);
      if (lookahead == 'f') ADVANCE(1659);
      END_STATE();
    case 145:
      if (lookahead == '5') ADVANCE(148);
      END_STATE();
    case 146:
      if (lookahead == '8') ADVANCE(148);
      END_STATE();
    case 147:
      if (lookahead == ':') ADVANCE(381);
      if (lookahead == '@') ADVANCE(2172);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '/' ||
          lookahead == '=' ||
          lookahead == '?' ||
          ('^' <= lookahead && lookahead <= '`') ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(383);
      if (lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(147);
      END_STATE();
    case 148:
      if (lookahead == ';') ADVANCE(2180);
      END_STATE();
    case 149:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'A') ADVANCE(585);
      if (lookahead == 'B') ADVANCE(575);
      if (lookahead == 'E') ADVANCE(271);
      if (lookahead == 'H') ADVANCE(538);
      if (lookahead == 'a') ADVANCE(810);
      if (lookahead == 'b') ADVANCE(576);
      if (lookahead == 'c') ADVANCE(602);
      if (lookahead == 'd') ADVANCE(794);
      if (lookahead == 'e') ADVANCE(268);
      if (lookahead == 'f') ADVANCE(1252);
      if (lookahead == 'g') ADVANCE(163);
      if (lookahead == 'h') ADVANCE(620);
      if (lookahead == 'j') ADVANCE(745);
      if (lookahead == 'l') ADVANCE(197);
      if (lookahead == 'm') ADVANCE(1235);
      if (lookahead == 'n') ADVANCE(457);
      if (lookahead == 'o') ADVANCE(546);
      if (lookahead == 'p') ADVANCE(624);
      if (lookahead == 'r') ADVANCE(579);
      if (lookahead == 's') ADVANCE(526);
      if (lookahead == 't') ADVANCE(223);
      if (lookahead == 'u') ADVANCE(1769);
      if (lookahead == 'v') ADVANCE(1062);
      END_STATE();
    case 150:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1753);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'q') ADVANCE(2070);
      if (lookahead == 's') ADVANCE(967);
      if (lookahead == 'x') ADVANCE(1294);
      END_STATE();
    case 151:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'A') ADVANCE(1872);
      END_STATE();
    case 152:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'A') ADVANCE(1872);
      if (lookahead == 'V') ADVANCE(1063);
      END_STATE();
    case 153:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'B') ADVANCE(538);
      END_STATE();
    case 154:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'B') ADVANCE(538);
      if (lookahead == 'D') ADVANCE(1643);
      END_STATE();
    case 155:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'B') ADVANCE(538);
      if (lookahead == 'E') ADVANCE(1731);
      END_STATE();
    case 156:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'B') ADVANCE(538);
      if (lookahead == 'L') ADVANCE(1065);
      END_STATE();
    case 157:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'B') ADVANCE(538);
      if (lookahead == 'R') ADVANCE(1316);
      END_STATE();
    case 158:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'B') ADVANCE(538);
      if (lookahead == 'U') ADVANCE(1687);
      END_STATE();
    case 159:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'C') ADVANCE(1654);
      if (lookahead == 'D') ADVANCE(1628);
      if (lookahead == 'E') ADVANCE(1363);
      if (lookahead == 'G') ADVANCE(1888);
      if (lookahead == 'H') ADVANCE(2081);
      if (lookahead == 'L') ADVANCE(1037);
      if (lookahead == 'N') ADVANCE(1004);
      if (lookahead == 'P') ADVANCE(1849);
      if (lookahead == 'R') ADVANCE(1038);
      if (lookahead == 'S') ADVANCE(1732);
      if (lookahead == 'T') ADVANCE(1241);
      if (lookahead == 'V') ADVANCE(1077);
      END_STATE();
    case 160:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'C') ADVANCE(564);
      END_STATE();
    case 161:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'D') ADVANCE(1589);
      if (lookahead == 'E') ADVANCE(1731);
      END_STATE();
    case 162:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'D') ADVANCE(438);
      END_STATE();
    case 163:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(148);
      END_STATE();
    case 164:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 'c') ADVANCE(2059);
      if (lookahead == 'e') ADVANCE(222);
      if (lookahead == 'i') ADVANCE(1490);
      if (lookahead == 'n') ADVANCE(456);
      if (lookahead == 'o') ADVANCE(873);
      if (lookahead == 's') ADVANCE(1246);
      if (lookahead == 'u') ADVANCE(1800);
      END_STATE();
    case 165:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(233);
      if (lookahead == 'm') ADVANCE(2066);
      if (lookahead == 'n') ADVANCE(2150);
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 'r') ADVANCE(575);
      if (lookahead == 's') ADVANCE(1017);
      END_STATE();
    case 166:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'v') ADVANCE(2166);
      END_STATE();
    case 167:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 168:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'i') ADVANCE(872);
      if (lookahead == 'o') ADVANCE(1894);
      if (lookahead == 'p') ADVANCE(1820);
      END_STATE();
    case 169:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(287);
      if (lookahead == 'a') ADVANCE(812);
      if (lookahead == 'b') ADVANCE(1740);
      if (lookahead == 'c') ADVANCE(1282);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(288);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(271);
      if (lookahead == 'i') ADVANCE(1475);
      if (lookahead == 'j') ADVANCE(745);
      if (lookahead == 'l') ADVANCE(363);
      if (lookahead == 'n') ADVANCE(457);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'r') ADVANCE(529);
      if (lookahead == 's') ADVANCE(780);
      if (lookahead == 't') ADVANCE(224);
      if (lookahead == 'v') ADVANCE(1062);
      END_STATE();
    case 170:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(1731);
      END_STATE();
    case 171:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(1731);
      if (lookahead == 'F') ADVANCE(2088);
      if (lookahead == 'G') ADVANCE(1881);
      if (lookahead == 'L') ADVANCE(963);
      if (lookahead == 'S') ADVANCE(1449);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 172:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(1731);
      if (lookahead == 'F') ADVANCE(2088);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 173:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(1731);
      if (lookahead == 'G') ADVANCE(1881);
      if (lookahead == 'L') ADVANCE(963);
      if (lookahead == 'S') ADVANCE(1449);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 174:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(1731);
      if (lookahead == 'S') ADVANCE(1449);
      END_STATE();
    case 175:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E') ADVANCE(1731);
      if (lookahead == 'S') ADVANCE(1449);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 176:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'G') ADVANCE(148);
      END_STATE();
    case 177:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'H') ADVANCE(148);
      END_STATE();
    case 178:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'I') ADVANCE(1571);
      if (lookahead == 'S') ADVANCE(2052);
      if (lookahead == 'U') ADVANCE(1552);
      END_STATE();
    case 179:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'J') ADVANCE(745);
      if (lookahead == 'T' ||
          lookahead == 't') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(811);
      if (lookahead == 'c') ADVANCE(604);
      if (lookahead == 'e') ADVANCE(1094);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'l') ADVANCE(248);
      if (lookahead == 'm') ADVANCE(1234);
      if (lookahead == 'o') ADVANCE(1519);
      if (lookahead == 's') ADVANCE(777);
      END_STATE();
    case 180:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'J') ADVANCE(745);
      if (lookahead == 'T' ||
          lookahead == 'g' ||
          lookahead == 't') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(1491);
      if (lookahead == 'b') ADVANCE(1740);
      if (lookahead == 'c') ADVANCE(971);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'r') ADVANCE(989);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 181:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'L') ADVANCE(963);
      END_STATE();
    case 182:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'N') ADVANCE(148);
      END_STATE();
    case 183:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'P') ADVANCE(148);
      END_STATE();
    case 184:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'P') ADVANCE(1439);
      END_STATE();
    case 185:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'T') ADVANCE(148);
      END_STATE();
    case 186:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 187:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'Y') ADVANCE(148);
      END_STATE();
    case 188:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(775);
      if (lookahead == 'p') ADVANCE(1405);
      END_STATE();
    case 189:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1126);
      if (lookahead == 'o') ADVANCE(2004);
      END_STATE();
    case 190:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(2170);
      END_STATE();
    case 191:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(769);
      if (lookahead == 'l') ADVANCE(148);
      END_STATE();
    case 192:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1741);
      END_STATE();
    case 193:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(783);
      if (lookahead == 'p') ADVANCE(148);
      END_STATE();
    case 194:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(293);
      if (lookahead == 's') ADVANCE(1247);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 195:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 'b') ADVANCE(267);
      if (lookahead == 'c' ||
          lookahead == 'w') ADVANCE(148);
      if (lookahead == 'f') ADVANCE(1894);
      if (lookahead == 'h') ADVANCE(1330);
      if (lookahead == 'l') ADVANCE(1668);
      if (lookahead == 'p') ADVANCE(1349);
      if (lookahead == 's') ADVANCE(1246);
      if (lookahead == 't') ADVANCE(1349);
      END_STATE();
    case 196:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(841);
      if (lookahead == 'b' ||
          lookahead == 'e') ADVANCE(148);
      if (lookahead == 'c') ADVANCE(1224);
      if (lookahead == 'd') ADVANCE(2160);
      if (lookahead == 'm') ADVANCE(297);
      if (lookahead == 's') ADVANCE(1246);
      if (lookahead == 't') ADVANCE(2112);
      END_STATE();
    case 197:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'c') ADVANCE(1640);
      if (lookahead == 'h') ADVANCE(639);
      if (lookahead == 't') ADVANCE(1776);
      END_STATE();
    case 198:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'd') ADVANCE(263);
      if (lookahead == 'i') ADVANCE(1128);
      if (lookahead == 'o') ADVANCE(1741);
      if (lookahead == 's') ADVANCE(1404);
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 199:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1894);
      END_STATE();
    case 200:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1905);
      if (lookahead == 'c') ADVANCE(1224);
      if (lookahead == 'd') ADVANCE(1596);
      END_STATE();
    case 201:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1349);
      END_STATE();
    case 202:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1794);
      if (lookahead == 'e') ADVANCE(912);
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 203:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1354);
      if (lookahead == 'c') ADVANCE(1949);
      if (lookahead == 'g') ADVANCE(148);
      END_STATE();
    case 204:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1494);
      if (lookahead == 'b') ADVANCE(1863);
      if (lookahead == 'c') ADVANCE(568);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 205:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1494);
      if (lookahead == 'd' ||
          lookahead == 'v') ADVANCE(148);
      if (lookahead == 's') ADVANCE(1404);
      END_STATE();
    case 206:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(834);
      END_STATE();
    case 207:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1789);
      if (lookahead == 'c') ADVANCE(1181);
      if (lookahead == 'o') ADVANCE(1828);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 208:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1373);
      END_STATE();
    case 209:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1757);
      if (lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 210:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1703);
      if (lookahead == 'c') ADVANCE(2079);
      if (lookahead == 'e') ADVANCE(1723);
      if (lookahead == 'n') ADVANCE(661);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 211:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1254);
      if (lookahead == 'e') ADVANCE(322);
      END_STATE();
    case 212:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a') ADVANCE(1448);
      if (lookahead == 's') ADVANCE(1349);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 213:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(1589);
      if (lookahead == 'c') ADVANCE(1224);
      if (lookahead == 'f') ADVANCE(306);
      END_STATE();
    case 214:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(148);
      if (lookahead == 'd') ADVANCE(343);
      END_STATE();
    case 215:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(148);
      if (lookahead == 'h') ADVANCE(1941);
      END_STATE();
    case 216:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(192);
      END_STATE();
    case 217:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(192);
      if (lookahead == 'd') ADVANCE(148);
      END_STATE();
    case 218:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(267);
      if (lookahead == 'f') ADVANCE(1894);
      if (lookahead == 'h') ADVANCE(1330);
      if (lookahead == 'l') ADVANCE(1668);
      if (lookahead == 'p') ADVANCE(1349);
      if (lookahead == 's') ADVANCE(1246);
      if (lookahead == 't') ADVANCE(1349);
      END_STATE();
    case 219:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(538);
      if (lookahead == 'e') ADVANCE(1723);
      END_STATE();
    case 220:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b') ADVANCE(1816);
      if (lookahead == 'c') ADVANCE(568);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'o') ADVANCE(1741);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 221:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(148);
      END_STATE();
    case 222:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(210);
      END_STATE();
    case 223:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(754);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'h') ADVANCE(1790);
      if (lookahead == 'i') ADVANCE(1488);
      if (lookahead == 'l') ADVANCE(575);
      if (lookahead == 'q') ADVANCE(2071);
      if (lookahead == 'r') ADVANCE(498);
      END_STATE();
    case 224:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(754);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'l') ADVANCE(497);
      if (lookahead == 'q') ADVANCE(2071);
      if (lookahead == 'r') ADVANCE(563);
      END_STATE();
    case 225:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(250);
      END_STATE();
    case 226:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(753);
      if (lookahead == 'd') ADVANCE(1633);
      if (lookahead == 'l') ADVANCE(258);
      END_STATE();
    case 227:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(753);
      if (lookahead == 'd') ADVANCE(1634);
      if (lookahead == 'g') ADVANCE(258);
      if (lookahead == 's') ADVANCE(660);
      END_STATE();
    case 228:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(591);
      if (lookahead == 'e') ADVANCE(1159);
      if (lookahead == 'l') ADVANCE(646);
      if (lookahead == 'p') ADVANCE(1801);
      END_STATE();
    case 229:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(1224);
      if (lookahead == 'w') ADVANCE(148);
      END_STATE();
    case 230:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(2059);
      if (lookahead == 'e') ADVANCE(225);
      END_STATE();
    case 231:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(2059);
      if (lookahead == 'e' ||
          lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 232:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c') ADVANCE(681);
      if (lookahead == 'f') ADVANCE(1269);
      if (lookahead == 'o') ADVANCE(867);
      if (lookahead == 't') ADVANCE(228);
      END_STATE();
    case 233:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(1589);
      END_STATE();
    case 234:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(313);
      if (lookahead == 'g') ADVANCE(163);
      if (lookahead == 'l') ADVANCE(163);
      if (lookahead == 'n') ADVANCE(917);
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 'r') ADVANCE(575);
      END_STATE();
    case 235:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(148);
      END_STATE();
    case 236:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(917);
      END_STATE();
    case 237:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(1582);
      if (lookahead == 'l') ADVANCE(977);
      if (lookahead == 'r') ADVANCE(1277);
      END_STATE();
    case 238:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(1582);
      if (lookahead == 'l') ADVANCE(977);
      if (lookahead == 'u') ADVANCE(1668);
      END_STATE();
    case 239:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(1582);
      if (lookahead == 'l') ADVANCE(1070);
      if (lookahead == 'q') ADVANCE(148);
      if (lookahead == 'r') ADVANCE(1320);
      END_STATE();
    case 240:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(1254);
      END_STATE();
    case 241:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 242:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(917);
      if (lookahead == 'm') ADVANCE(1924);
      if (lookahead == 'r') ADVANCE(1978);
      if (lookahead == 's') ADVANCE(1691);
      if (lookahead == 'z') ADVANCE(575);
      END_STATE();
    case 243:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 's') ADVANCE(1005);
      END_STATE();
    case 244:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1741);
      END_STATE();
    case 245:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1724);
      if (lookahead == 'm') ADVANCE(1306);
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 's') ADVANCE(1738);
      END_STATE();
    case 246:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1949);
      END_STATE();
    case 247:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1152);
      END_STATE();
    case 248:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1097);
      END_STATE();
    case 249:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 250:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1723);
      END_STATE();
    case 251:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1723);
      if (lookahead == 'l') ADVANCE(937);
      END_STATE();
    case 252:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(322);
      END_STATE();
    case 253:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(843);
      if (lookahead == 'i') ADVANCE(1478);
      if (lookahead == 'o') ADVANCE(896);
      END_STATE();
    case 254:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(309);
      END_STATE();
    case 255:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1728);
      END_STATE();
    case 256:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1728);
      if (lookahead == 'n') ADVANCE(982);
      END_STATE();
    case 257:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(590);
      END_STATE();
    case 258:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1894);
      END_STATE();
    case 259:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1925);
      END_STATE();
    case 260:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1549);
      if (lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 261:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1826);
      if (lookahead == 's') ADVANCE(952);
      END_STATE();
    case 262:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1782);
      if (lookahead == 's') ADVANCE(1668);
      END_STATE();
    case 263:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1792);
      if (lookahead == 'f' ||
          lookahead == 'm') ADVANCE(148);
      END_STATE();
    case 264:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e') ADVANCE(1781);
      END_STATE();
    case 265:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 266:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'f') ADVANCE(148);
      if (lookahead == 'r') ADVANCE(1578);
      if (lookahead == 'y') ADVANCE(323);
      END_STATE();
    case 267:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'f') ADVANCE(1894);
      END_STATE();
    case 268:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'f') ADVANCE(1954);
      if (lookahead == 'g') ADVANCE(148);
      if (lookahead == 'q') ADVANCE(314);
      if (lookahead == 's') ADVANCE(227);
      END_STATE();
    case 269:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'f') ADVANCE(1495);
      if (lookahead == 'l') ADVANCE(938);
      END_STATE();
    case 270:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'f') ADVANCE(1979);
      if (lookahead == 'q') ADVANCE(314);
      if (lookahead == 's') ADVANCE(322);
      END_STATE();
    case 271:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'g') ADVANCE(148);
      END_STATE();
    case 272:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'g') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(1970);
      if (lookahead == 'm') ADVANCE(1702);
      END_STATE();
    case 273:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'g') ADVANCE(1949);
      END_STATE();
    case 274:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'g') ADVANCE(917);
      END_STATE();
    case 275:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'h') ADVANCE(148);
      END_STATE();
    case 276:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'h') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(1620);
      END_STATE();
    case 277:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'h') ADVANCE(1579);
      END_STATE();
    case 278:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(1227);
      if (lookahead == 'n') ADVANCE(1109);
      if (lookahead == 'o') ADVANCE(1970);
      END_STATE();
    case 279:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(891);
      if (lookahead == 'o') ADVANCE(1511);
      END_STATE();
    case 280:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(1771);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 281:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(1529);
      if (lookahead == 'p') ADVANCE(643);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 282:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(2008);
      END_STATE();
    case 283:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(856);
      END_STATE();
    case 284:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(1503);
      if (lookahead == 'n') ADVANCE(1237);
      END_STATE();
    case 285:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(1431);
      END_STATE();
    case 286:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'i') ADVANCE(1568);
      if (lookahead == 'l') ADVANCE(148);
      if (lookahead == 's') ADVANCE(233);
      END_STATE();
    case 287:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'l') ADVANCE(148);
      END_STATE();
    case 288:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'l') ADVANCE(148);
      if (lookahead == 'q') ADVANCE(314);
      if (lookahead == 's') ADVANCE(226);
      END_STATE();
    case 289:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'l') ADVANCE(1949);
      END_STATE();
    case 290:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'l') ADVANCE(1620);
      END_STATE();
    case 291:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'l') ADVANCE(1620);
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 292:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'l') ADVANCE(2011);
      if (lookahead == 'm') ADVANCE(564);
      END_STATE();
    case 293:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'l') ADVANCE(1390);
      END_STATE();
    case 294:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'm') ADVANCE(148);
      END_STATE();
    case 295:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'm') ADVANCE(262);
      END_STATE();
    case 296:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'm') ADVANCE(597);
      END_STATE();
    case 297:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 298:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'n') ADVANCE(616);
      END_STATE();
    case 299:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(148);
      END_STATE();
    case 300:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(318);
      END_STATE();
    case 301:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(287);
      END_STATE();
    case 302:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(1087);
      END_STATE();
    case 303:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(2117);
      END_STATE();
    case 304:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(2107);
      END_STATE();
    case 305:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(841);
      END_STATE();
    case 306:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(1795);
      END_STATE();
    case 307:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(2024);
      END_STATE();
    case 308:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(1534);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 309:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'o') ADVANCE(1559);
      END_STATE();
    case 310:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'p') ADVANCE(148);
      END_STATE();
    case 311:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(284);
      END_STATE();
    case 312:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'p') ADVANCE(1820);
      END_STATE();
    case 313:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'q') ADVANCE(148);
      END_STATE();
    case 314:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'q') ADVANCE(148);
      if (lookahead == 's') ADVANCE(1434);
      END_STATE();
    case 315:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'q') ADVANCE(314);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 316:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'q') ADVANCE(313);
      END_STATE();
    case 317:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'q') ADVANCE(2070);
      END_STATE();
    case 318:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 319:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'r') ADVANCE(556);
      if (lookahead == 's') ADVANCE(233);
      END_STATE();
    case 320:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'r') ADVANCE(1262);
      END_STATE();
    case 321:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'r') ADVANCE(1240);
      END_STATE();
    case 322:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 323:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(1741);
      END_STATE();
    case 324:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(235);
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 325:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(217);
      END_STATE();
    case 326:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(2139);
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 327:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(1454);
      END_STATE();
    case 328:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(1349);
      END_STATE();
    case 329:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(2012);
      END_STATE();
    case 330:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(952);
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 331:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(1007);
      END_STATE();
    case 332:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 's') ADVANCE(2074);
      END_STATE();
    case 333:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 334:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 335:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(1579);
      END_STATE();
    case 336:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(264);
      END_STATE();
    case 337:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(725);
      END_STATE();
    case 338:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(1349);
      END_STATE();
    case 339:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(823);
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 340:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(670);
      END_STATE();
    case 341:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(1603);
      END_STATE();
    case 342:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 't') ADVANCE(1262);
      END_STATE();
    case 343:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 344:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'u') ADVANCE(1232);
      END_STATE();
    case 345:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 346:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'v') ADVANCE(2166);
      END_STATE();
    case 347:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'v') ADVANCE(714);
      END_STATE();
    case 348:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'v') ADVANCE(1019);
      END_STATE();
    case 349:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(841);
      if (lookahead == 'i') ADVANCE(872);
      if (lookahead == 'o') ADVANCE(1894);
      if (lookahead == 'p') ADVANCE(1814);
      END_STATE();
    case 350:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(148);
      if (lookahead == 'c') ADVANCE(251);
      if (lookahead == 'f') ADVANCE(1557);
      if (lookahead == 'm') ADVANCE(1213);
      if (lookahead == 's') ADVANCE(841);
      END_STATE();
    case 351:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(148);
      if (lookahead == 's') ADVANCE(1020);
      END_STATE();
    case 352:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E' ||
          lookahead == 'v') ADVANCE(148);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 's') ADVANCE(345);
      END_STATE();
    case 353:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E' ||
          lookahead == 'y') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(1669);
      if (lookahead == 'c') ADVANCE(2059);
      if (lookahead == 'e') ADVANCE(240);
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'n') ADVANCE(456);
      if (lookahead == 'p') ADVANCE(1664);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 354:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'a' ||
          lookahead == 'h') ADVANCE(148);
      END_STATE();
    case 355:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'b' ||
          lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 356:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'c' ||
          lookahead == 'w') ADVANCE(148);
      END_STATE();
    case 357:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e' ||
          lookahead == 'g') ADVANCE(148);
      END_STATE();
    case 358:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e' ||
          lookahead == 'l') ADVANCE(148);
      END_STATE();
    case 359:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'f' ||
          lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 360:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd' ||
          lookahead == 'e') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(917);
      END_STATE();
    case 361:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e' ||
          lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 362:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'e' ||
          lookahead == 'f') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(2007);
      END_STATE();
    case 363:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E' ||
          lookahead == 'a' ||
          lookahead == 'j') ADVANCE(148);
      END_STATE();
    case 364:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'E' ||
          lookahead == 'd' ||
          lookahead == 'y') ADVANCE(148);
      if (lookahead == 'i') ADVANCE(1771);
      if (lookahead == 'u') ADVANCE(1985);
      END_STATE();
    case 365:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'D' ||
          lookahead == 'U' ||
          lookahead == 'd' ||
          lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 366:
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'H' ||
          lookahead == 'L' ||
          lookahead == 'R' ||
          lookahead == 'h' ||
          lookahead == 'l' ||
          lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 367:
      if (lookahead == ';') ADVANCE(2181);
      END_STATE();
    case 368:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(369);
      END_STATE();
    case 369:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(367);
      END_STATE();
    case 370:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(368);
      END_STATE();
    case 371:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(370);
      END_STATE();
    case 372:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(371);
      END_STATE();
    case 373:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(372);
      END_STATE();
    case 374:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(367);
      END_STATE();
    case 375:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(374);
      END_STATE();
    case 376:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(375);
      END_STATE();
    case 377:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(376);
      END_STATE();
    case 378:
      if (lookahead == ';') ADVANCE(2181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(377);
      END_STATE();
    case 379:
      if (lookahead == '>') ADVANCE(2229);
      END_STATE();
    case 380:
      if (lookahead == '>') ADVANCE(2236);
      END_STATE();
    case 381:
      if (lookahead == '>') ADVANCE(2223);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '<') ADVANCE(381);
      END_STATE();
    case 382:
      if (lookahead == '@') ADVANCE(2172);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '/' ||
          lookahead == '=' ||
          lookahead == '?' ||
          ('^' <= lookahead && lookahead <= '`') ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(383);
      if (lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(147);
      END_STATE();
    case 383:
      if (lookahead == '@') ADVANCE(2172);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          lookahead == '=' ||
          ('?' <= lookahead && lookahead <= 'Z') ||
          ('^' <= lookahead && lookahead <= '~')) ADVANCE(383);
      END_STATE();
    case 384:
      if (lookahead == 'A') ADVANCE(502);
      if (lookahead == 'a') ADVANCE(816);
      if (lookahead == 'c') ADVANCE(1280);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1368);
      if (lookahead == 'o') ADVANCE(1674);
      if (lookahead == 's') ADVANCE(790);
      if (lookahead == 'u') ADVANCE(1467);
      END_STATE();
    case 385:
      if (lookahead == 'A') ADVANCE(585);
      if (lookahead == 'B') ADVANCE(575);
      if (lookahead == 'H') ADVANCE(538);
      if (lookahead == 'a') ADVANCE(763);
      if (lookahead == 'b') ADVANCE(576);
      if (lookahead == 'c') ADVANCE(602);
      if (lookahead == 'd') ADVANCE(793);
      if (lookahead == 'e') ADVANCE(203);
      if (lookahead == 'f') ADVANCE(1252);
      if (lookahead == 'h') ADVANCE(621);
      if (lookahead == 'i') ADVANCE(1142);
      if (lookahead == 'l') ADVANCE(581);
      if (lookahead == 'm') ADVANCE(1652);
      if (lookahead == 'n') ADVANCE(1468);
      if (lookahead == 'o') ADVANCE(547);
      if (lookahead == 'p') ADVANCE(628);
      if (lookahead == 'r') ADVANCE(575);
      if (lookahead == 's') ADVANCE(527);
      if (lookahead == 't') ADVANCE(1208);
      if (lookahead == 'u') ADVANCE(1394);
      if (lookahead == 'x') ADVANCE(148);
      END_STATE();
    case 386:
      if (lookahead == 'A') ADVANCE(520);
      END_STATE();
    case 387:
      if (lookahead == 'A') ADVANCE(745);
      if (lookahead == 'I') ADVANCE(745);
      if (lookahead == 'U') ADVANCE(745);
      if (lookahead == 'a') ADVANCE(803);
      if (lookahead == 'c') ADVANCE(1282);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'u') ADVANCE(1476);
      END_STATE();
    case 388:
      if (lookahead == 'A') ADVANCE(441);
      END_STATE();
    case 389:
      if (lookahead == 'A') ADVANCE(1566);
      if (lookahead == 'C') ADVANCE(1079);
      if (lookahead == 'D') ADVANCE(1584);
      if (lookahead == 'F') ADVANCE(1393);
      if (lookahead == 'R') ADVANCE(1315);
      if (lookahead == 'T') ADVANCE(1024);
      if (lookahead == 'U') ADVANCE(1682);
      if (lookahead == 'V') ADVANCE(1058);
      if (lookahead == 'a') ADVANCE(1872);
      if (lookahead == 'r') ADVANCE(1308);
      END_STATE();
    case 390:
      if (lookahead == 'A') ADVANCE(511);
      END_STATE();
    case 391:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'B') ADVANCE(631);
      if (lookahead == 'D') ADVANCE(571);
      if (lookahead == 'a') ADVANCE(1526);
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'd') ADVANCE(571);
      if (lookahead == 'e') ADVANCE(930);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'l') ADVANCE(2007);
      if (lookahead == 'n') ADVANCE(1923);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'p') ADVANCE(1810);
      if (lookahead == 'r') ADVANCE(2007);
      if (lookahead == 's') ADVANCE(792);
      if (lookahead == 'z') ADVANCE(1255);
      END_STATE();
    case 392:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'd') ADVANCE(1741);
      if (lookahead == 'e') ADVANCE(270);
      if (lookahead == 's') ADVANCE(1246);
      if (lookahead == 't') ADVANCE(321);
      END_STATE();
    case 393:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'H') ADVANCE(538);
      if (lookahead == 'a') ADVANCE(1125);
      if (lookahead == 'b') ADVANCE(1346);
      if (lookahead == 'c') ADVANCE(607);
      if (lookahead == 'd') ADVANCE(189);
      if (lookahead == 'e') ADVANCE(272);
      if (lookahead == 'f') ADVANCE(1253);
      if (lookahead == 'h') ADVANCE(614);
      if (lookahead == 'i') ADVANCE(586);
      if (lookahead == 'j') ADVANCE(745);
      if (lookahead == 'l') ADVANCE(759);
      if (lookahead == 'o') ADVANCE(1397);
      if (lookahead == 'r') ADVANCE(721);
      if (lookahead == 's') ADVANCE(761);
      if (lookahead == 't') ADVANCE(871);
      if (lookahead == 'u') ADVANCE(580);
      if (lookahead == 'w') ADVANCE(589);
      if (lookahead == 'z') ADVANCE(750);
      END_STATE();
    case 394:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'H') ADVANCE(538);
      if (lookahead == 'a') ADVANCE(804);
      if (lookahead == 'b') ADVANCE(1763);
      if (lookahead == 'c') ADVANCE(1261);
      if (lookahead == 'd') ADVANCE(577);
      if (lookahead == 'f') ADVANCE(1253);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'h') ADVANCE(615);
      if (lookahead == 'l') ADVANCE(852);
      if (lookahead == 'm') ADVANCE(191);
      if (lookahead == 'o') ADVANCE(1129);
      if (lookahead == 'p') ADVANCE(686);
      if (lookahead == 'r') ADVANCE(851);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 't') ADVANCE(868);
      if (lookahead == 'u') ADVANCE(582);
      if (lookahead == 'w') ADVANCE(589);
      END_STATE();
    case 395:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1268);
      if (lookahead == 'b') ADVANCE(538);
      if (lookahead == 'c') ADVANCE(1280);
      if (lookahead == 'e') ADVANCE(668);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'k') ADVANCE(1895);
      if (lookahead == 'o') ADVANCE(583);
      if (lookahead == 's') ADVANCE(782);
      if (lookahead == 'y') ADVANCE(723);
      END_STATE();
    case 396:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1760);
      END_STATE();
    case 397:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'p') ADVANCE(538);
      END_STATE();
    case 398:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1753);
      if (lookahead == 'c') ADVANCE(333);
      if (lookahead == 'm') ADVANCE(1214);
      if (lookahead == 's') ADVANCE(2113);
      if (lookahead == 't') ADVANCE(1462);
      if (lookahead == 'x') ADVANCE(1949);
      END_STATE();
    case 399:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1753);
      if (lookahead == 'n') ADVANCE(2113);
      END_STATE();
    case 400:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1753);
      if (lookahead == 'n') ADVANCE(966);
      END_STATE();
    case 401:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'a') ADVANCE(1852);
      if (lookahead == 'i') ADVANCE(1145);
      if (lookahead == 't') ADVANCE(1835);
      END_STATE();
    case 402:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 't') ADVANCE(320);
      END_STATE();
    case 403:
      if (lookahead == 'A') ADVANCE(1760);
      if (lookahead == 't') ADVANCE(1830);
      END_STATE();
    case 404:
      if (lookahead == 'A') ADVANCE(1875);
      if (lookahead == 'D') ADVANCE(1643);
      if (lookahead == 'E') ADVANCE(1734);
      if (lookahead == 'T') ADVANCE(1009);
      if (lookahead == 'a') ADVANCE(1872);
      if (lookahead == 'd') ADVANCE(1650);
      if (lookahead == 'p') ADVANCE(1018);
      if (lookahead == 's') ADVANCE(1231);
      END_STATE();
    case 405:
      if (lookahead == 'A') ADVANCE(809);
      END_STATE();
    case 406:
      if (lookahead == 'A') ADVANCE(809);
      if (lookahead == 'D') ADVANCE(1587);
      if (lookahead == 'G') ADVANCE(1793);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 407:
      if (lookahead == 'A') ADVANCE(1391);
      END_STATE();
    case 408:
      if (lookahead == 'A') ADVANCE(1567);
      if (lookahead == 'C') ADVANCE(1079);
      if (lookahead == 'D') ADVANCE(1584);
      if (lookahead == 'F') ADVANCE(1393);
      if (lookahead == 'T') ADVANCE(1024);
      if (lookahead == 'U') ADVANCE(1682);
      if (lookahead == 'V') ADVANCE(1058);
      if (lookahead == 'a') ADVANCE(1872);
      END_STATE();
    case 409:
      if (lookahead == 'A') ADVANCE(1872);
      END_STATE();
    case 410:
      if (lookahead == 'A') ADVANCE(1872);
      if (lookahead == 'D') ADVANCE(1643);
      END_STATE();
    case 411:
      if (lookahead == 'A') ADVANCE(1872);
      if (lookahead == 'R') ADVANCE(1316);
      END_STATE();
    case 412:
      if (lookahead == 'A') ADVANCE(1872);
      if (lookahead == 'R') ADVANCE(1316);
      if (lookahead == 'T') ADVANCE(994);
      END_STATE();
    case 413:
      if (lookahead == 'A') ADVANCE(1872);
      if (lookahead == 'T') ADVANCE(994);
      END_STATE();
    case 414:
      if (lookahead == 'A') ADVANCE(1872);
      if (lookahead == 'V') ADVANCE(1063);
      END_STATE();
    case 415:
      if (lookahead == 'A') ADVANCE(1876);
      if (lookahead == 'B') ADVANCE(1740);
      if (lookahead == 'L') ADVANCE(1056);
      if (lookahead == 'R') ADVANCE(1314);
      if (lookahead == 'T') ADVANCE(1009);
      if (lookahead == 'a') ADVANCE(1872);
      END_STATE();
    case 416:
      if (lookahead == 'B') ADVANCE(541);
      if (lookahead == 'P') ADVANCE(689);
      END_STATE();
    case 417:
      if (lookahead == 'B') ADVANCE(575);
      if (lookahead == 'E') ADVANCE(176);
      if (lookahead == 'a') ADVANCE(813);
      if (lookahead == 'c') ADVANCE(604);
      if (lookahead == 'e') ADVANCE(348);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(1579);
      if (lookahead == 'i') ADVANCE(1123);
      if (lookahead == 'o') ADVANCE(1677);
      if (lookahead == 'r') ADVANCE(1308);
      if (lookahead == 's') ADVANCE(776);
      if (lookahead == 'u') ADVANCE(1384);
      END_STATE();
    case 418:
      if (lookahead == 'B') ADVANCE(538);
      END_STATE();
    case 419:
      if (lookahead == 'B') ADVANCE(538);
      if (lookahead == 'L') ADVANCE(1263);
      if (lookahead == 'S') ADVANCE(1051);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 420:
      if (lookahead == 'B') ADVANCE(1873);
      END_STATE();
    case 421:
      if (lookahead == 'B') ADVANCE(1865);
      if (lookahead == 'n') ADVANCE(422);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(159);
      END_STATE();
    case 422:
      if (lookahead == 'B') ADVANCE(1870);
      END_STATE();
    case 423:
      if (lookahead == 'C') ADVANCE(475);
      if (lookahead == 'c') ADVANCE(2129);
      END_STATE();
    case 424:
      if (lookahead == 'C') ADVANCE(444);
      END_STATE();
    case 425:
      if (lookahead == 'C') ADVANCE(564);
      END_STATE();
    case 426:
      if (lookahead == 'C') ADVANCE(1644);
      if (lookahead == 'T') ADVANCE(1295);
      END_STATE();
    case 427:
      if (lookahead == 'C') ADVANCE(1321);
      END_STATE();
    case 428:
      if (lookahead == 'C') ADVANCE(1416);
      END_STATE();
    case 429:
      if (lookahead == 'C') ADVANCE(2078);
      END_STATE();
    case 430:
      if (lookahead == 'C') ADVANCE(1660);
      END_STATE();
    case 431:
      if (lookahead == 'C') ADVANCE(1660);
      if (lookahead == 'D') ADVANCE(1586);
      if (lookahead == 'L') ADVANCE(1068);
      if (lookahead == 'R') ADVANCE(1318);
      if (lookahead == 'U') ADVANCE(1683);
      if (lookahead == 'V') ADVANCE(1077);
      END_STATE();
    case 432:
      if (lookahead == 'D') ADVANCE(1589);
      END_STATE();
    case 433:
      if (lookahead == 'D') ADVANCE(1589);
      if (lookahead == 'M') ADVANCE(1306);
      if (lookahead == 'P') ADVANCE(1439);
      if (lookahead == 'T') ADVANCE(1295);
      END_STATE();
    case 434:
      if (lookahead == 'D') ADVANCE(1589);
      if (lookahead == 'a') ADVANCE(1760);
      END_STATE();
    case 435:
      if (lookahead == 'D') ADVANCE(1589);
      if (lookahead == 'o') ADVANCE(1949);
      END_STATE();
    case 436:
      if (lookahead == 'D') ADVANCE(1589);
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 437:
      if (lookahead == 'D') ADVANCE(307);
      if (lookahead == 'J') ADVANCE(745);
      if (lookahead == 'S') ADVANCE(745);
      if (lookahead == 'Z') ADVANCE(745);
      if (lookahead == 'a') ADVANCE(1127);
      if (lookahead == 'c') ADVANCE(607);
      if (lookahead == 'e') ADVANCE(1350);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(550);
      if (lookahead == 'o') ADVANCE(1675);
      if (lookahead == 's') ADVANCE(790);
      END_STATE();
    case 438:
      if (lookahead == 'D') ADVANCE(148);
      END_STATE();
    case 439:
      if (lookahead == 'D') ADVANCE(435);
      if (lookahead == 'a') ADVANCE(807);
      if (lookahead == 'c') ADVANCE(605);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'f') ADVANCE(436);
      if (lookahead == 'g') ADVANCE(319);
      if (lookahead == 'l') ADVANCE(286);
      if (lookahead == 'm') ADVANCE(537);
      if (lookahead == 'n') ADVANCE(1112);
      if (lookahead == 'o') ADVANCE(1129);
      if (lookahead == 'p') ADVANCE(618);
      if (lookahead == 'q') ADVANCE(800);
      if (lookahead == 'r') ADVANCE(434);
      if (lookahead == 's') ADVANCE(770);
      if (lookahead == 't') ADVANCE(354);
      if (lookahead == 'u') ADVANCE(1456);
      if (lookahead == 'x') ADVANCE(828);
      END_STATE();
    case 440:
      if (lookahead == 'D') ADVANCE(432);
      if (lookahead == 'a') ADVANCE(755);
      if (lookahead == 'c') ADVANCE(1645);
      if (lookahead == 'd') ADVANCE(571);
      if (lookahead == 'e') ADVANCE(653);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(1579);
      if (lookahead == 'i') ADVANCE(844);
      if (lookahead == 'l') ADVANCE(808);
      if (lookahead == 'n') ADVANCE(1699);
      if (lookahead == 'o') ADVANCE(908);
      if (lookahead == 'p') ADVANCE(148);
      if (lookahead == 's') ADVANCE(789);
      if (lookahead == 'u') ADVANCE(292);
      END_STATE();
    case 441:
      if (lookahead == 'D') ADVANCE(455);
      END_STATE();
    case 442:
      if (lookahead == 'D') ADVANCE(2167);
      if (lookahead == 'H') ADVANCE(365);
      if (lookahead == 'U') ADVANCE(2167);
      if (lookahead == 'V') ADVANCE(366);
      if (lookahead == 'b') ADVANCE(1594);
      if (lookahead == 'd') ADVANCE(2167);
      if (lookahead == 'h') ADVANCE(365);
      if (lookahead == 'm') ADVANCE(1306);
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 't') ADVANCE(1295);
      if (lookahead == 'u') ADVANCE(2167);
      if (lookahead == 'v') ADVANCE(366);
      END_STATE();
    case 443:
      if (lookahead == 'D') ADVANCE(745);
      END_STATE();
    case 444:
      if (lookahead == 'D') ADVANCE(390);
      END_STATE();
    case 445:
      if (lookahead == 'D') ADVANCE(571);
      if (lookahead == 'H') ADVANCE(575);
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 'd') ADVANCE(571);
      if (lookahead == 'g') ADVANCE(2157);
      if (lookahead == 'i') ADVANCE(1513);
      if (lookahead == 'l') ADVANCE(402);
      if (lookahead == 'r') ADVANCE(403);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 446:
      if (lookahead == 'D') ADVANCE(571);
      if (lookahead == 'b') ADVANCE(538);
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'd') ADVANCE(574);
      if (lookahead == 'e') ADVANCE(920);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'v') ADVANCE(888);
      END_STATE();
    case 447:
      if (lookahead == 'D') ADVANCE(571);
      if (lookahead == 'd') ADVANCE(571);
      END_STATE();
    case 448:
      if (lookahead == 'D') ADVANCE(1643);
      if (lookahead == 'L') ADVANCE(1065);
      if (lookahead == 'R') ADVANCE(1316);
      if (lookahead == 'U') ADVANCE(1687);
      END_STATE();
    case 449:
      if (lookahead == 'D') ADVANCE(1245);
      END_STATE();
    case 450:
      if (lookahead == 'D') ADVANCE(1011);
      END_STATE();
    case 451:
      if (lookahead == 'D') ADVANCE(1651);
      if (lookahead == 'E') ADVANCE(1731);
      END_STATE();
    case 452:
      if (lookahead == 'D') ADVANCE(1655);
      if (lookahead == 'T') ADVANCE(1030);
      if (lookahead == 'V') ADVANCE(1058);
      END_STATE();
    case 453:
      if (lookahead == 'D') ADVANCE(1665);
      if (lookahead == 'Q') ADVANCE(2089);
      END_STATE();
    case 454:
      if (lookahead == 'E') ADVANCE(1389);
      if (lookahead == 'M') ADVANCE(183);
      if (lookahead == 'a') ADVANCE(803);
      if (lookahead == 'b') ADVANCE(1740);
      if (lookahead == 'c') ADVANCE(1261);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'l') ADVANCE(1670);
      if (lookahead == 'm') ADVANCE(533);
      if (lookahead == 'n') ADVANCE(872);
      if (lookahead == 'o') ADVANCE(1129);
      if (lookahead == 'p') ADVANCE(1695);
      if (lookahead == 'r') ADVANCE(1236);
      if (lookahead == 's') ADVANCE(787);
      if (lookahead == 't') ADVANCE(1283);
      if (lookahead == 'u') ADVANCE(1455);
      END_STATE();
    case 455:
      if (lookahead == 'E') ADVANCE(148);
      END_STATE();
    case 456:
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 457:
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(1686);
      if (lookahead == 'e') ADVANCE(316);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 458:
      if (lookahead == 'E') ADVANCE(148);
      if (lookahead == 'e') ADVANCE(315);
      if (lookahead == 's') ADVANCE(1246);
      if (lookahead == 't') ADVANCE(318);
      END_STATE();
    case 459:
      if (lookahead == 'E') ADVANCE(1362);
      if (lookahead == 'U') ADVANCE(1718);
      END_STATE();
    case 460:
      if (lookahead == 'E') ADVANCE(745);
      if (lookahead == 'J') ADVANCE(1395);
      if (lookahead == 'O') ADVANCE(745);
      if (lookahead == 'a') ADVANCE(803);
      if (lookahead == 'c') ADVANCE(1261);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'm') ADVANCE(188);
      if (lookahead == 'n') ADVANCE(1977);
      if (lookahead == 'o') ADVANCE(1130);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 't') ADVANCE(1309);
      if (lookahead == 'u') ADVANCE(1338);
      END_STATE();
    case 461:
      if (lookahead == 'E') ADVANCE(1361);
      END_STATE();
    case 462:
      if (lookahead == 'E') ADVANCE(1395);
      if (lookahead == 'a') ADVANCE(803);
      if (lookahead == 'c') ADVANCE(1261);
      if (lookahead == 'd') ADVANCE(743);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'm') ADVANCE(535);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'p') ADVANCE(981);
      if (lookahead == 'r') ADVANCE(148);
      if (lookahead == 's') ADVANCE(784);
      if (lookahead == 't') ADVANCE(1230);
      if (lookahead == 'u') ADVANCE(1455);
      if (lookahead == 'v') ADVANCE(996);
      END_STATE();
    case 463:
      if (lookahead == 'E') ADVANCE(1734);
      END_STATE();
    case 464:
      if (lookahead == 'E') ADVANCE(1731);
      END_STATE();
    case 465:
      if (lookahead == 'E') ADVANCE(1736);
      if (lookahead == 'F') ADVANCE(2088);
      if (lookahead == 'G') ADVANCE(1881);
      if (lookahead == 'L') ADVANCE(963);
      if (lookahead == 'S') ADVANCE(1449);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 466:
      if (lookahead == 'E') ADVANCE(1737);
      if (lookahead == 'F') ADVANCE(2088);
      if (lookahead == 'G') ADVANCE(1881);
      if (lookahead == 'L') ADVANCE(963);
      if (lookahead == 'S') ADVANCE(1449);
      if (lookahead == 'T') ADVANCE(1309);
      END_STATE();
    case 467:
      if (lookahead == 'F') ADVANCE(510);
      END_STATE();
    case 468:
      if (lookahead == 'F') ADVANCE(2082);
      END_STATE();
    case 469:
      if (lookahead == 'G') ADVANCE(148);
      END_STATE();
    case 470:
      if (lookahead == 'G') ADVANCE(1113);
      if (lookahead == 'L') ADVANCE(1044);
      if (lookahead == 'R') ADVANCE(1308);
      if (lookahead == 'V') ADVANCE(447);
      if (lookahead == 'a') ADVANCE(727);
      if (lookahead == 'b') ADVANCE(1896);
      if (lookahead == 'c') ADVANCE(558);
      if (lookahead == 'd') ADVANCE(571);
      if (lookahead == 'e') ADVANCE(150);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(458);
      if (lookahead == 'h') ADVANCE(397);
      if (lookahead == 'i') ADVANCE(324);
      if (lookahead == 'j') ADVANCE(745);
      if (lookahead == 'l') ADVANCE(392);
      if (lookahead == 'm') ADVANCE(1213);
      if (lookahead == 'o') ADVANCE(311);
      if (lookahead == 'p') ADVANCE(626);
      if (lookahead == 'r') ADVANCE(401);
      if (lookahead == 's') ADVANCE(762);
      if (lookahead == 't') ADVANCE(1133);
      if (lookahead == 'u') ADVANCE(295);
      if (lookahead == 'v') ADVANCE(445);
      if (lookahead == 'w') ADVANCE(400);
      END_STATE();
    case 471:
      if (lookahead == 'G') ADVANCE(1881);
      END_STATE();
    case 472:
      if (lookahead == 'G') ADVANCE(1890);
      if (lookahead == 'L') ADVANCE(1046);
      END_STATE();
    case 473:
      if (lookahead == 'H') ADVANCE(423);
      if (lookahead == 'O') ADVANCE(467);
      if (lookahead == 'a') ADVANCE(809);
      if (lookahead == 'c') ADVANCE(202);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(1646);
      if (lookahead == 'i') ADVANCE(1131);
      if (lookahead == 'm') ADVANCE(651);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'q') ADVANCE(1767);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 't') ADVANCE(538);
      if (lookahead == 'u') ADVANCE(711);
      END_STATE();
    case 474:
      if (lookahead == 'H') ADVANCE(495);
      if (lookahead == 'R') ADVANCE(388);
      if (lookahead == 'S') ADVANCE(479);
      if (lookahead == 'a') ADVANCE(2154);
      if (lookahead == 'c') ADVANCE(604);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(951);
      if (lookahead == 'i') ADVANCE(1377);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'r') ADVANCE(1288);
      if (lookahead == 's') ADVANCE(790);
      END_STATE();
    case 475:
      if (lookahead == 'H') ADVANCE(745);
      END_STATE();
    case 476:
      if (lookahead == 'H') ADVANCE(745);
      if (lookahead == 'J') ADVANCE(745);
      if (lookahead == 'a') ADVANCE(1692);
      if (lookahead == 'c') ADVANCE(972);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 477:
      if (lookahead == 'H') ADVANCE(745);
      if (lookahead == 'O') ADVANCE(496);
      if (lookahead == 'a') ADVANCE(815);
      if (lookahead == 'c') ADVANCE(603);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(905);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(1214);
      if (lookahead == 'i') ADVANCE(1788);
      if (lookahead == 'l') ADVANCE(1593);
      if (lookahead == 'o') ADVANCE(1433);
      if (lookahead == 'r') ADVANCE(1595);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'u') ADVANCE(1678);
      END_STATE();
    case 478:
      if (lookahead == 'H') ADVANCE(745);
      if (lookahead == 'a') ADVANCE(809);
      if (lookahead == 'c') ADVANCE(607);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(1798);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 479:
      if (lookahead == 'H') ADVANCE(745);
      if (lookahead == 'c') ADVANCE(2129);
      END_STATE();
    case 480:
      if (lookahead == 'H') ADVANCE(2090);
      END_STATE();
    case 481:
      if (lookahead == 'I') ADVANCE(148);
      END_STATE();
    case 482:
      if (lookahead == 'I') ADVANCE(1489);
      END_STATE();
    case 483:
      if (lookahead == 'I') ADVANCE(1556);
      END_STATE();
    case 484:
      if (lookahead == 'J') ADVANCE(745);
      if (lookahead == 'a') ADVANCE(809);
      if (lookahead == 'c') ADVANCE(604);
      if (lookahead == 'e') ADVANCE(1134);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(421);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 't') ADVANCE(1283);
      if (lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 485:
      if (lookahead == 'L') ADVANCE(963);
      END_STATE();
    case 486:
      if (lookahead == 'L') ADVANCE(1263);
      END_STATE();
    case 487:
      if (lookahead == 'L') ADVANCE(1061);
      if (lookahead == 'R') ADVANCE(1316);
      END_STATE();
    case 488:
      if (lookahead == 'L') ADVANCE(1061);
      if (lookahead == 'R') ADVANCE(1316);
      if (lookahead == 'l') ADVANCE(1043);
      if (lookahead == 'r') ADVANCE(1308);
      END_STATE();
    case 489:
      if (lookahead == 'L') ADVANCE(1065);
      if (lookahead == 'R') ADVANCE(1316);
      END_STATE();
    case 490:
      if (lookahead == 'M') ADVANCE(1047);
      if (lookahead == 'T') ADVANCE(1196);
      if (lookahead == 'V') ADVANCE(1035);
      END_STATE();
    case 491:
      if (lookahead == 'M') ADVANCE(1306);
      END_STATE();
    case 492:
      if (lookahead == 'N') ADVANCE(1589);
      if (lookahead == 'a') ADVANCE(799);
      if (lookahead == 'b') ADVANCE(1784);
      if (lookahead == 'c') ADVANCE(1610);
      if (lookahead == 'd') ADVANCE(1730);
      if (lookahead == 'e') ADVANCE(864);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1114);
      if (lookahead == 'k') ADVANCE(669);
      if (lookahead == 'l') ADVANCE(551);
      if (lookahead == 'n') ADVANCE(929);
      if (lookahead == 'o') ADVANCE(1676);
      if (lookahead == 'p') ADVANCE(1811);
      if (lookahead == 'r') ADVANCE(927);
      if (lookahead == 's') ADVANCE(771);
      if (lookahead == 'u') ADVANCE(1396);
      END_STATE();
    case 493:
      if (lookahead == 'N') ADVANCE(469);
      if (lookahead == 'T') ADVANCE(177);
      if (lookahead == 'a') ADVANCE(803);
      if (lookahead == 'c') ADVANCE(606);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'l') ADVANCE(1048);
      if (lookahead == 'm') ADVANCE(536);
      if (lookahead == 'o') ADVANCE(1129);
      if (lookahead == 'p') ADVANCE(1945);
      if (lookahead == 'q') ADVANCE(2042);
      if (lookahead == 's') ADVANCE(779);
      if (lookahead == 't') ADVANCE(524);
      if (lookahead == 'u') ADVANCE(1455);
      if (lookahead == 'x') ADVANCE(1239);
      END_STATE();
    case 494:
      if (lookahead == 'O') ADVANCE(185);
      END_STATE();
    case 495:
      if (lookahead == 'O') ADVANCE(501);
      END_STATE();
    case 496:
      if (lookahead == 'P') ADVANCE(187);
      END_STATE();
    case 497:
      if (lookahead == 'P') ADVANCE(538);
      END_STATE();
    case 498:
      if (lookahead == 'P') ADVANCE(538);
      if (lookahead == 'i') ADVANCE(361);
      END_STATE();
    case 499:
      if (lookahead == 'P') ADVANCE(1439);
      END_STATE();
    case 500:
      if (lookahead == 'Q') ADVANCE(2089);
      END_STATE();
    case 501:
      if (lookahead == 'R') ADVANCE(182);
      END_STATE();
    case 502:
      if (lookahead == 'R') ADVANCE(443);
      END_STATE();
    case 503:
      if (lookahead == 'R') ADVANCE(1319);
      if (lookahead == 'T') ADVANCE(1030);
      if (lookahead == 'V') ADVANCE(1058);
      END_STATE();
    case 504:
      if (lookahead == 'S') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(806);
      if (lookahead == 'c') ADVANCE(1261);
      if (lookahead == 'd') ADVANCE(572);
      if (lookahead == 'e') ADVANCE(1395);
      if (lookahead == 'f') ADVANCE(842);
      if (lookahead == 'g') ADVANCE(1621);
      if (lookahead == 'h') ADVANCE(718);
      if (lookahead == 'i') ADVANCE(1507);
      if (lookahead == 'l') ADVANCE(578);
      if (lookahead == 'm') ADVANCE(534);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'p') ADVANCE(539);
      if (lookahead == 'r') ADVANCE(198);
      if (lookahead == 's') ADVANCE(785);
      if (lookahead == 't') ADVANCE(1278);
      if (lookahead == 'u') ADVANCE(1455);
      if (lookahead == 'v') ADVANCE(716);
      END_STATE();
    case 505:
      if (lookahead == 'S') ADVANCE(1493);
      END_STATE();
    case 506:
      if (lookahead == 'S') ADVANCE(1493);
      if (lookahead == 'V') ADVANCE(1033);
      END_STATE();
    case 507:
      if (lookahead == 'S') ADVANCE(1711);
      END_STATE();
    case 508:
      if (lookahead == 'S') ADVANCE(2052);
      END_STATE();
    case 509:
      if (lookahead == 'S') ADVANCE(1738);
      END_STATE();
    case 510:
      if (lookahead == 'T') ADVANCE(745);
      END_STATE();
    case 511:
      if (lookahead == 'T') ADVANCE(386);
      END_STATE();
    case 512:
      if (lookahead == 'T') ADVANCE(1210);
      END_STATE();
    case 513:
      if (lookahead == 'T') ADVANCE(1191);
      END_STATE();
    case 514:
      if (lookahead == 'T') ADVANCE(1030);
      if (lookahead == 'V') ADVANCE(1058);
      END_STATE();
    case 515:
      if (lookahead == 'T') ADVANCE(1892);
      END_STATE();
    case 516:
      if (lookahead == 'U') ADVANCE(494);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 517:
      if (lookahead == 'V') ADVANCE(1077);
      END_STATE();
    case 518:
      if (lookahead == 'V') ADVANCE(1063);
      END_STATE();
    case 519:
      if (lookahead == 'W') ADVANCE(1265);
      END_STATE();
    case 520:
      if (lookahead == '[') ADVANCE(2235);
      END_STATE();
    case 521:
      if (lookahead == 'a') ADVANCE(803);
      if (lookahead == 'b') ADVANCE(1740);
      if (lookahead == 'c') ADVANCE(364);
      if (lookahead == 'e') ADVANCE(1389);
      if (lookahead == 'f') ADVANCE(318);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'l') ADVANCE(928);
      if (lookahead == 'm') ADVANCE(193);
      if (lookahead == 'n') ADVANCE(876);
      if (lookahead == 'o') ADVANCE(1129);
      if (lookahead == 'p') ADVANCE(349);
      if (lookahead == 'r') ADVANCE(1236);
      if (lookahead == 's') ADVANCE(788);
      if (lookahead == 't') ADVANCE(1283);
      if (lookahead == 'u') ADVANCE(1455);
      if (lookahead == 'w') ADVANCE(824);
      END_STATE();
    case 522:
      if (lookahead == 'a') ADVANCE(803);
      if (lookahead == 'c') ADVANCE(280);
      if (lookahead == 'e') ADVANCE(752);
      if (lookahead == 'f') ADVANCE(2158);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'i') ADVANCE(278);
      if (lookahead == 'j') ADVANCE(1395);
      if (lookahead == 'm') ADVANCE(530);
      if (lookahead == 'n') ADVANCE(232);
      if (lookahead == 'o') ADVANCE(749);
      if (lookahead == 'p') ADVANCE(1801);
      if (lookahead == 'q') ADVANCE(2057);
      if (lookahead == 's') ADVANCE(781);
      if (lookahead == 't') ADVANCE(285);
      if (lookahead == 'u') ADVANCE(1338);
      END_STATE();
    case 523:
      if (lookahead == 'a') ADVANCE(795);
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'e') ADVANCE(830);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'r') ADVANCE(926);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'u') ADVANCE(1466);
      END_STATE();
    case 524:
      if (lookahead == 'a') ADVANCE(148);
      END_STATE();
    case 525:
      if (lookahead == 'a') ADVANCE(318);
      END_STATE();
    case 526:
      if (lookahead == 'a') ADVANCE(1730);
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(148);
      if (lookahead == 'i') ADVANCE(1460);
      if (lookahead == 'q') ADVANCE(710);
      if (lookahead == 't') ADVANCE(1812);
      END_STATE();
    case 527:
      if (lookahead == 'a') ADVANCE(1730);
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(148);
      if (lookahead == 'q') ADVANCE(710);
      END_STATE();
    case 528:
      if (lookahead == 'a') ADVANCE(814);
      if (lookahead == 'c') ADVANCE(553);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(898);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(747);
      if (lookahead == 'i') ADVANCE(1745);
      if (lookahead == 'l') ADVANCE(2047);
      if (lookahead == 'o') ADVANCE(1443);
      if (lookahead == 'r') ADVANCE(584);
      if (lookahead == 's') ADVANCE(791);
      if (lookahead == 't') ADVANCE(867);
      if (lookahead == 'u') ADVANCE(915);
      if (lookahead == 'w') ADVANCE(824);
      if (lookahead == 'y') ADVANCE(1386);
      END_STATE();
    case 529:
      if (lookahead == 'a') ADVANCE(2104);
      END_STATE();
    case 530:
      if (lookahead == 'a') ADVANCE(774);
      if (lookahead == 'o') ADVANCE(1087);
      if (lookahead == 'p') ADVANCE(916);
      END_STATE();
    case 531:
      if (lookahead == 'a') ADVANCE(1403);
      if (lookahead == 'e') ADVANCE(1716);
      if (lookahead == 'i') ADVANCE(874);
      if (lookahead == 't') ADVANCE(252);
      END_STATE();
    case 532:
      if (lookahead == 'a') ADVANCE(359);
      END_STATE();
    case 533:
      if (lookahead == 'a') ADVANCE(769);
      END_STATE();
    case 534:
      if (lookahead == 'a') ADVANCE(769);
      if (lookahead == 'e') ADVANCE(1122);
      if (lookahead == 'i') ADVANCE(836);
      END_STATE();
    case 535:
      if (lookahead == 'a') ADVANCE(769);
      if (lookahead == 'e') ADVANCE(1122);
      if (lookahead == 'i') ADVANCE(835);
      END_STATE();
    case 536:
      if (lookahead == 'a') ADVANCE(769);
      if (lookahead == 'p') ADVANCE(1976);
      END_STATE();
    case 537:
      if (lookahead == 'a') ADVANCE(769);
      if (lookahead == 'p') ADVANCE(1984);
      if (lookahead == 's') ADVANCE(1681);
      END_STATE();
    case 538:
      if (lookahead == 'a') ADVANCE(1741);
      END_STATE();
    case 539:
      if (lookahead == 'a') ADVANCE(1741);
      if (lookahead == 'e') ADVANCE(1789);
      if (lookahead == 'l') ADVANCE(2056);
      END_STATE();
    case 540:
      if (lookahead == 'a') ADVANCE(1741);
      if (lookahead == 'f') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(2056);
      END_STATE();
    case 541:
      if (lookahead == 'a') ADVANCE(1741);
      if (lookahead == 'r') ADVANCE(619);
      END_STATE();
    case 542:
      if (lookahead == 'a') ADVANCE(805);
      if (lookahead == 'b') ADVANCE(1763);
      if (lookahead == 'c') ADVANCE(1261);
      if (lookahead == 'd') ADVANCE(743);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(1802);
      if (lookahead == 'm') ADVANCE(533);
      if (lookahead == 'n') ADVANCE(886);
      if (lookahead == 'o') ADVANCE(1129);
      if (lookahead == 'p') ADVANCE(404);
      if (lookahead == 'r') ADVANCE(1251);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 't') ADVANCE(1309);
      if (lookahead == 'u') ADVANCE(1455);
      END_STATE();
    case 543:
      if (lookahead == 'a') ADVANCE(1507);
      END_STATE();
    case 544:
      if (lookahead == 'a') ADVANCE(345);
      END_STATE();
    case 545:
      if (lookahead == 'a') ADVANCE(1866);
      if (lookahead == 'b') ADVANCE(1795);
      if (lookahead == 'c') ADVANCE(604);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(1444);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(958);
      if (lookahead == 'i') ADVANCE(1432);
      if (lookahead == 'o') ADVANCE(949);
      if (lookahead == 'p') ADVANCE(1811);
      if (lookahead == 'r') ADVANCE(656);
      if (lookahead == 's') ADVANCE(760);
      if (lookahead == 'w') ADVANCE(1218);
      END_STATE();
    case 546:
      if (lookahead == 'a') ADVANCE(1517);
      if (lookahead == 'b') ADVANCE(1795);
      if (lookahead == 'n') ADVANCE(1120);
      if (lookahead == 'o') ADVANCE(1717);
      if (lookahead == 'p') ADVANCE(540);
      if (lookahead == 't') ADVANCE(1295);
      if (lookahead == 'w') ADVANCE(588);
      if (lookahead == 'z') ADVANCE(260);
      END_STATE();
    case 547:
      if (lookahead == 'a') ADVANCE(1517);
      if (lookahead == 'b') ADVANCE(1795);
      if (lookahead == 'p') ADVANCE(540);
      if (lookahead == 't') ADVANCE(1295);
      END_STATE();
    case 548:
      if (lookahead == 'a') ADVANCE(1949);
      END_STATE();
    case 549:
      if (lookahead == 'a') ADVANCE(1949);
      if (lookahead == 'l') ADVANCE(1243);
      if (lookahead == 't') ADVANCE(1523);
      END_STATE();
    case 550:
      if (lookahead == 'a') ADVANCE(858);
      if (lookahead == 'f') ADVANCE(1098);
      END_STATE();
    case 551:
      if (lookahead == 'a') ADVANCE(825);
      if (lookahead == 'k') ADVANCE(140);
      if (lookahead == 'o') ADVANCE(818);
      END_STATE();
    case 552:
      if (lookahead == 'a') ADVANCE(235);
      END_STATE();
    case 553:
      if (lookahead == 'a') ADVANCE(1693);
      if (lookahead == 'e') ADVANCE(897);
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'u') ADVANCE(1701);
      END_STATE();
    case 554:
      if (lookahead == 'a') ADVANCE(909);
      END_STATE();
    case 555:
      if (lookahead == 'a') ADVANCE(326);
      END_STATE();
    case 556:
      if (lookahead == 'a') ADVANCE(2102);
      END_STATE();
    case 557:
      if (lookahead == 'a') ADVANCE(765);
      if (lookahead == 'o') ADVANCE(2117);
      END_STATE();
    case 558:
      if (lookahead == 'a') ADVANCE(1669);
      if (lookahead == 'e') ADVANCE(912);
      if (lookahead == 'o') ADVANCE(1530);
      if (lookahead == 'u') ADVANCE(1668);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 559:
      if (lookahead == 'a') ADVANCE(333);
      END_STATE();
    case 560:
      if (lookahead == 'a') ADVANCE(764);
      if (lookahead == 'c') ADVANCE(1282);
      if (lookahead == 'e') ADVANCE(297);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(745);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'u') ADVANCE(751);
      END_STATE();
    case 561:
      if (lookahead == 'a') ADVANCE(1791);
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(1214);
      if (lookahead == 'i') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(2051);
      if (lookahead == 'o') ADVANCE(1279);
      if (lookahead == 'r') ADVANCE(253);
      if (lookahead == 's') ADVANCE(778);
      END_STATE();
    case 562:
      if (lookahead == 'a') ADVANCE(1692);
      END_STATE();
    case 563:
      if (lookahead == 'a') ADVANCE(1704);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(1725);
      if (lookahead == 'l') ADVANCE(963);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 564:
      if (lookahead == 'a') ADVANCE(1668);
      END_STATE();
    case 565:
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'e') ADVANCE(893);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1547);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 566:
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'u') ADVANCE(1668);
      END_STATE();
    case 567:
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 568:
      if (lookahead == 'a') ADVANCE(1668);
      if (lookahead == 'u') ADVANCE(1668);
      END_STATE();
    case 569:
      if (lookahead == 'a') ADVANCE(1111);
      END_STATE();
    case 570:
      if (lookahead == 'a') ADVANCE(1451);
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'e') ADVANCE(1481);
      if (lookahead == 'f') ADVANCE(1276);
      if (lookahead == 'i') ADVANCE(1395);
      if (lookahead == 'j') ADVANCE(1395);
      if (lookahead == 'l') ADVANCE(549);
      if (lookahead == 'n') ADVANCE(1581);
      if (lookahead == 'o') ADVANCE(1672);
      if (lookahead == 'p') ADVANCE(659);
      if (lookahead == 'r') ADVANCE(557);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 571:
      if (lookahead == 'a') ADVANCE(1915);
      END_STATE();
    case 572:
      if (lookahead == 'a') ADVANCE(1915);
      if (lookahead == 'b') ADVANCE(1429);
      if (lookahead == 'i') ADVANCE(2099);
      if (lookahead == 'o') ADVANCE(1949);
      if (lookahead == 's') ADVANCE(1631);
      END_STATE();
    case 573:
      if (lookahead == 'a') ADVANCE(1330);
      END_STATE();
    case 574:
      if (lookahead == 'a') ADVANCE(1918);
      END_STATE();
    case 575:
      if (lookahead == 'a') ADVANCE(1760);
      END_STATE();
    case 576:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'b') ADVANCE(1795);
      if (lookahead == 'r') ADVANCE(609);
      END_STATE();
    case 577:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'b') ADVANCE(1429);
      if (lookahead == 'h') ADVANCE(538);
      END_STATE();
    case 578:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'c') ADVANCE(1225);
      if (lookahead == 'i') ADVANCE(1529);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 579:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'c') ADVANCE(1640);
      if (lookahead == 'h') ADVANCE(640);
      if (lookahead == 'm') ADVANCE(148);
      if (lookahead == 't') ADVANCE(1776);
      END_STATE();
    case 580:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'h') ADVANCE(538);
      END_STATE();
    case 581:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'h') ADVANCE(538);
      if (lookahead == 'm') ADVANCE(148);
      END_STATE();
    case 582:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'm') ADVANCE(287);
      END_STATE();
    case 583:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'm') ADVANCE(1991);
      if (lookahead == 'o') ADVANCE(1333);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 'r') ADVANCE(716);
      END_STATE();
    case 584:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'o') ADVANCE(1920);
      END_STATE();
    case 585:
      if (lookahead == 'a') ADVANCE(1760);
      if (lookahead == 'r') ADVANCE(1741);
      if (lookahead == 't') ADVANCE(670);
      END_STATE();
    case 586:
      if (lookahead == 'a') ADVANCE(1458);
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'g') ADVANCE(652);
      if (lookahead == 's') ADVANCE(1258);
      if (lookahead == 'v') ADVANCE(279);
      END_STATE();
    case 587:
      if (lookahead == 'a') ADVANCE(2140);
      END_STATE();
    case 588:
      if (lookahead == 'a') ADVANCE(1905);
      if (lookahead == 'b') ADVANCE(538);
      END_STATE();
    case 589:
      if (lookahead == 'a') ADVANCE(1528);
      END_STATE();
    case 590:
      if (lookahead == 'a') ADVANCE(1988);
      END_STATE();
    case 591:
      if (lookahead == 'a') ADVANCE(1349);
      END_STATE();
    case 592:
      if (lookahead == 'a') ADVANCE(1747);
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'e') ADVANCE(1748);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(1228);
      if (lookahead == 'i') ADVANCE(339);
      if (lookahead == 'l') ADVANCE(608);
      if (lookahead == 'm') ADVANCE(148);
      if (lookahead == 'o') ADVANCE(1289);
      if (lookahead == 'r') ADVANCE(164);
      if (lookahead == 's') ADVANCE(778);
      if (lookahead == 'u') ADVANCE(1527);
      END_STATE();
    case 593:
      if (lookahead == 'a') ADVANCE(1982);
      if (lookahead == 'e') ADVANCE(1929);
      if (lookahead == 'o') ADVANCE(333);
      END_STATE();
    case 594:
      if (lookahead == 'a') ADVANCE(1173);
      END_STATE();
    case 595:
      if (lookahead == 'a') ADVANCE(1347);
      END_STATE();
    case 596:
      if (lookahead == 'a') ADVANCE(1372);
      if (lookahead == 'l') ADVANCE(1263);
      if (lookahead == 's') ADVANCE(2076);
      END_STATE();
    case 597:
      if (lookahead == 'a') ADVANCE(1795);
      END_STATE();
    case 598:
      if (lookahead == 'a') ADVANCE(1908);
      END_STATE();
    case 599:
      if (lookahead == 'a') ADVANCE(1495);
      END_STATE();
    case 600:
      if (lookahead == 'a') ADVANCE(753);
      END_STATE();
    case 601:
      if (lookahead == 'a') ADVANCE(1529);
      END_STATE();
    case 602:
      if (lookahead == 'a') ADVANCE(1794);
      if (lookahead == 'e') ADVANCE(913);
      if (lookahead == 'u') ADVANCE(709);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 603:
      if (lookahead == 'a') ADVANCE(1794);
      if (lookahead == 'e') ADVANCE(897);
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'o') ADVANCE(1557);
      END_STATE();
    case 604:
      if (lookahead == 'a') ADVANCE(1794);
      if (lookahead == 'e') ADVANCE(912);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 605:
      if (lookahead == 'a') ADVANCE(1794);
      if (lookahead == 'i') ADVANCE(1771);
      if (lookahead == 'o') ADVANCE(1379);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 606:
      if (lookahead == 'a') ADVANCE(1794);
      if (lookahead == 'i') ADVANCE(1771);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 607:
      if (lookahead == 'a') ADVANCE(1794);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 608:
      if (lookahead == 'a') ADVANCE(1501);
      if (lookahead == 'u') ADVANCE(1899);
      END_STATE();
    case 609:
      if (lookahead == 'a') ADVANCE(767);
      if (lookahead == 'k') ADVANCE(921);
      END_STATE();
    case 610:
      if (lookahead == 'a') ADVANCE(1690);
      if (lookahead == 'u') ADVANCE(1690);
      END_STATE();
    case 611:
      if (lookahead == 'a') ADVANCE(878);
      END_STATE();
    case 612:
      if (lookahead == 'a') ADVANCE(1366);
      END_STATE();
    case 613:
      if (lookahead == 'a') ADVANCE(1366);
      if (lookahead == 'i') ADVANCE(1411);
      END_STATE();
    case 614:
      if (lookahead == 'a') ADVANCE(1750);
      END_STATE();
    case 615:
      if (lookahead == 'a') ADVANCE(1750);
      if (lookahead == 'b') ADVANCE(1380);
      END_STATE();
    case 616:
      if (lookahead == 'a') ADVANCE(1385);
      END_STATE();
    case 617:
      if (lookahead == 'a') ADVANCE(1385);
      if (lookahead == 'e') ADVANCE(1905);
      if (lookahead == 'i') ADVANCE(2101);
      END_STATE();
    case 618:
      if (lookahead == 'a') ADVANCE(1785);
      if (lookahead == 'l') ADVANCE(2056);
      if (lookahead == 's') ADVANCE(1221);
      END_STATE();
    case 619:
      if (lookahead == 'a') ADVANCE(768);
      END_STATE();
    case 620:
      if (lookahead == 'a') ADVANCE(1780);
      if (lookahead == 'b') ADVANCE(1380);
      END_STATE();
    case 621:
      if (lookahead == 'a') ADVANCE(1780);
      if (lookahead == 'o') ADVANCE(345);
      END_STATE();
    case 622:
      if (lookahead == 'a') ADVANCE(1712);
      END_STATE();
    case 623:
      if (lookahead == 'a') ADVANCE(853);
      END_STATE();
    case 624:
      if (lookahead == 'a') ADVANCE(1778);
      END_STATE();
    case 625:
      if (lookahead == 'a') ADVANCE(1378);
      END_STATE();
    case 626:
      if (lookahead == 'a') ADVANCE(1770);
      if (lookahead == 'o') ADVANCE(1445);
      if (lookahead == 'r') ADVANCE(230);
      END_STATE();
    case 627:
      if (lookahead == 'a') ADVANCE(1376);
      END_STATE();
    case 628:
      if (lookahead == 'a') ADVANCE(1765);
      if (lookahead == 'p') ADVANCE(1664);
      END_STATE();
    case 629:
      if (lookahead == 'a') ADVANCE(1751);
      if (lookahead == 'r') ADVANCE(700);
      END_STATE();
    case 630:
      if (lookahead == 'a') ADVANCE(1356);
      END_STATE();
    case 631:
      if (lookahead == 'a') ADVANCE(1764);
      END_STATE();
    case 632:
      if (lookahead == 'a') ADVANCE(1364);
      END_STATE();
    case 633:
      if (lookahead == 'a') ADVANCE(1351);
      END_STATE();
    case 634:
      if (lookahead == 'a') ADVANCE(1357);
      END_STATE();
    case 635:
      if (lookahead == 'a') ADVANCE(1352);
      END_STATE();
    case 636:
      if (lookahead == 'a') ADVANCE(1818);
      END_STATE();
    case 637:
      if (lookahead == 'a') ADVANCE(1370);
      END_STATE();
    case 638:
      if (lookahead == 'a') ADVANCE(1358);
      END_STATE();
    case 639:
      if (lookahead == 'a') ADVANCE(1739);
      END_STATE();
    case 640:
      if (lookahead == 'a') ADVANCE(1768);
      END_STATE();
    case 641:
      if (lookahead == 'a') ADVANCE(1744);
      END_STATE();
    case 642:
      if (lookahead == 'a') ADVANCE(1822);
      END_STATE();
    case 643:
      if (lookahead == 'a') ADVANCE(1766);
      END_STATE();
    case 644:
      if (lookahead == 'a') ADVANCE(2006);
      END_STATE();
    case 645:
      if (lookahead == 'a') ADVANCE(1833);
      END_STATE();
    case 646:
      if (lookahead == 'a') ADVANCE(1806);
      END_STATE();
    case 647:
      if (lookahead == 'a') ADVANCE(1797);
      END_STATE();
    case 648:
      if (lookahead == 'a') ADVANCE(1803);
      END_STATE();
    case 649:
      if (lookahead == 'a') ADVANCE(809);
      if (lookahead == 'b') ADVANCE(1730);
      if (lookahead == 'c') ADVANCE(353);
      if (lookahead == 'd') ADVANCE(1618);
      if (lookahead == 'e') ADVANCE(398);
      if (lookahead == 'f') ADVANCE(1761);
      if (lookahead == 'h') ADVANCE(207);
      if (lookahead == 'i') ADVANCE(1150);
      if (lookahead == 'l') ADVANCE(575);
      if (lookahead == 'm') ADVANCE(531);
      if (lookahead == 'o') ADVANCE(1095);
      if (lookahead == 'p') ADVANCE(554);
      if (lookahead == 'q') ADVANCE(797);
      if (lookahead == 'r') ADVANCE(575);
      if (lookahead == 's') ADVANCE(772);
      if (lookahead == 't') ADVANCE(629);
      if (lookahead == 'u') ADVANCE(712);
      if (lookahead == 'w') ADVANCE(399);
      if (lookahead == 'z') ADVANCE(1389);
      END_STATE();
    case 650:
      if (lookahead == 'a') ADVANCE(809);
      if (lookahead == 'c') ADVANCE(607);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(1054);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(745);
      if (lookahead == 'i') ADVANCE(1144);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'w') ADVANCE(1329);
      END_STATE();
    case 651:
      if (lookahead == 'a') ADVANCE(1401);
      END_STATE();
    case 652:
      if (lookahead == 'a') ADVANCE(1470);
      END_STATE();
    case 653:
      if (lookahead == 'a') ADVANCE(1927);
      END_STATE();
    case 654:
      if (lookahead == 'a') ADVANCE(1696);
      if (lookahead == 'c') ADVANCE(972);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(1805);
      if (lookahead == 'h') ADVANCE(745);
      if (lookahead == 'j') ADVANCE(745);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 655:
      if (lookahead == 'a') ADVANCE(847);
      END_STATE();
    case 656:
      if (lookahead == 'a') ADVANCE(894);
      if (lookahead == 'i') ADVANCE(701);
      if (lookahead == 'p') ADVANCE(956);
      END_STATE();
    case 657:
      if (lookahead == 'a') ADVANCE(1854);
      END_STATE();
    case 658:
      if (lookahead == 'a') ADVANCE(2003);
      END_STATE();
    case 659:
      if (lookahead == 'a') ADVANCE(1821);
      END_STATE();
    case 660:
      if (lookahead == 'a') ADVANCE(1703);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(1726);
      if (lookahead == 'g') ADVANCE(1969);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 661:
      if (lookahead == 'a') ADVANCE(1703);
      if (lookahead == 'e') ADVANCE(1729);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 662:
      if (lookahead == 'a') ADVANCE(1703);
      if (lookahead == 's') ADVANCE(1246);
      END_STATE();
    case 663:
      if (lookahead == 'a') ADVANCE(833);
      END_STATE();
    case 664:
      if (lookahead == 'a') ADVANCE(1855);
      if (lookahead == 'l') ADVANCE(2131);
      if (lookahead == 'r') ADVANCE(925);
      if (lookahead == 'v') ADVANCE(1074);
      END_STATE();
    case 665:
      if (lookahead == 'a') ADVANCE(1540);
      END_STATE();
    case 666:
      if (lookahead == 'a') ADVANCE(1391);
      if (lookahead == 'k') ADVANCE(345);
      END_STATE();
    case 667:
      if (lookahead == 'a') ADVANCE(2013);
      END_STATE();
    case 668:
      if (lookahead == 'a') ADVANCE(1867);
      if (lookahead == 'l') ADVANCE(1406);
      if (lookahead == 'r') ADVANCE(817);
      END_STATE();
    case 669:
      if (lookahead == 'a') ADVANCE(1817);
      END_STATE();
    case 670:
      if (lookahead == 'a') ADVANCE(1254);
      END_STATE();
    case 671:
      if (lookahead == 'a') ADVANCE(1254);
      if (lookahead == 'i') ADVANCE(1591);
      END_STATE();
    case 672:
      if (lookahead == 'a') ADVANCE(2067);
      END_STATE();
    case 673:
      if (lookahead == 'a') ADVANCE(1413);
      END_STATE();
    case 674:
      if (lookahead == 'a') ADVANCE(1858);
      END_STATE();
    case 675:
      if (lookahead == 'a') ADVANCE(2069);
      END_STATE();
    case 676:
      if (lookahead == 'a') ADVANCE(2021);
      END_STATE();
    case 677:
      if (lookahead == 'a') ADVANCE(1541);
      END_STATE();
    case 678:
      if (lookahead == 'a') ADVANCE(1860);
      END_STATE();
    case 679:
      if (lookahead == 'a') ADVANCE(1398);
      END_STATE();
    case 680:
      if (lookahead == 'a') ADVANCE(1850);
      END_STATE();
    case 681:
      if (lookahead == 'a') ADVANCE(1809);
      END_STATE();
    case 682:
      if (lookahead == 'a') ADVANCE(1856);
      END_STATE();
    case 683:
      if (lookahead == 'a') ADVANCE(1857);
      END_STATE();
    case 684:
      if (lookahead == 'a') ADVANCE(1448);
      END_STATE();
    case 685:
      if (lookahead == 'a') ADVANCE(1872);
      END_STATE();
    case 686:
      if (lookahead == 'a') ADVANCE(1872);
      if (lookahead == 'd') ADVANCE(1650);
      if (lookahead == 'h') ADVANCE(642);
      if (lookahead == 'l') ADVANCE(2056);
      if (lookahead == 's') ADVANCE(1223);
      if (lookahead == 'u') ADVANCE(1722);
      END_STATE();
    case 687:
      if (lookahead == 'a') ADVANCE(1872);
      if (lookahead == 'd') ADVANCE(1666);
      if (lookahead == 'h') ADVANCE(642);
      END_STATE();
    case 688:
      if (lookahead == 'a') ADVANCE(1872);
      if (lookahead == 'r') ADVANCE(1308);
      END_STATE();
    case 689:
      if (lookahead == 'a') ADVANCE(1883);
      END_STATE();
    case 690:
      if (lookahead == 'a') ADVANCE(2029);
      END_STATE();
    case 691:
      if (lookahead == 'a') ADVANCE(1877);
      if (lookahead == 'h') ADVANCE(702);
      if (lookahead == 'l') ADVANCE(1066);
      if (lookahead == 'r') ADVANCE(1323);
      if (lookahead == 's') ADVANCE(1733);
      if (lookahead == 't') ADVANCE(1211);
      END_STATE();
    case 692:
      if (lookahead == 'a') ADVANCE(1877);
      if (lookahead == 'h') ADVANCE(702);
      if (lookahead == 'l') ADVANCE(1086);
      if (lookahead == 'r') ADVANCE(1317);
      if (lookahead == 't') ADVANCE(1211);
      END_STATE();
    case 693:
      if (lookahead == 'a') ADVANCE(2031);
      END_STATE();
    case 694:
      if (lookahead == 'a') ADVANCE(1878);
      END_STATE();
    case 695:
      if (lookahead == 'a') ADVANCE(1878);
      if (lookahead == 'd') ADVANCE(2163);
      END_STATE();
    case 696:
      if (lookahead == 'a') ADVANCE(1879);
      END_STATE();
    case 697:
      if (lookahead == 'a') ADVANCE(1879);
      if (lookahead == 'h') ADVANCE(704);
      END_STATE();
    case 698:
      if (lookahead == 'a') ADVANCE(2033);
      END_STATE();
    case 699:
      if (lookahead == 'a') ADVANCE(1880);
      if (lookahead == 'h') ADVANCE(704);
      if (lookahead == 's') ADVANCE(1733);
      END_STATE();
    case 700:
      if (lookahead == 'a') ADVANCE(1313);
      if (lookahead == 'n') ADVANCE(1894);
      END_STATE();
    case 701:
      if (lookahead == 'a') ADVANCE(1562);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'm') ADVANCE(1306);
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 's') ADVANCE(709);
      if (lookahead == 't') ADVANCE(1291);
      END_STATE();
    case 702:
      if (lookahead == 'a') ADVANCE(1885);
      END_STATE();
    case 703:
      if (lookahead == 'a') ADVANCE(1569);
      END_STATE();
    case 704:
      if (lookahead == 'a') ADVANCE(1887);
      END_STATE();
    case 705:
      if (lookahead == 'a') ADVANCE(1570);
      END_STATE();
    case 706:
      if (lookahead == 'a') ADVANCE(1572);
      END_STATE();
    case 707:
      if (lookahead == 'a') ADVANCE(1573);
      END_STATE();
    case 708:
      if (lookahead == 'a') ADVANCE(1574);
      END_STATE();
    case 709:
      if (lookahead == 'b') ADVANCE(148);
      END_STATE();
    case 710:
      if (lookahead == 'b') ADVANCE(148);
      if (lookahead == 'u') ADVANCE(1580);
      END_STATE();
    case 711:
      if (lookahead == 'b') ADVANCE(331);
      if (lookahead == 'c') ADVANCE(855);
      if (lookahead == 'm') ADVANCE(148);
      if (lookahead == 'p') ADVANCE(261);
      END_STATE();
    case 712:
      if (lookahead == 'b') ADVANCE(165);
      if (lookahead == 'c') ADVANCE(766);
      if (lookahead == 'm') ADVANCE(148);
      if (lookahead == 'n') ADVANCE(1111);
      if (lookahead == 'p') ADVANCE(2168);
      END_STATE();
    case 713:
      if (lookahead == 'b') ADVANCE(351);
      if (lookahead == 'c') ADVANCE(822);
      if (lookahead == 'p') ADVANCE(351);
      END_STATE();
    case 714:
      if (lookahead == 'b') ADVANCE(235);
      END_STATE();
    case 715:
      if (lookahead == 'b') ADVANCE(243);
      if (lookahead == 'p') ADVANCE(243);
      END_STATE();
    case 716:
      if (lookahead == 'b') ADVANCE(538);
      END_STATE();
    case 717:
      if (lookahead == 'b') ADVANCE(538);
      if (lookahead == 'g') ADVANCE(960);
      END_STATE();
    case 718:
      if (lookahead == 'b') ADVANCE(538);
      if (lookahead == 'm') ADVANCE(148);
      END_STATE();
    case 719:
      if (lookahead == 'b') ADVANCE(538);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 720:
      if (lookahead == 'b') ADVANCE(538);
      if (lookahead == 't') ADVANCE(283);
      if (lookahead == 'y') ADVANCE(512);
      END_STATE();
    case 721:
      if (lookahead == 'b') ADVANCE(1345);
      if (lookahead == 'c') ADVANCE(1639);
      END_STATE();
    case 722:
      if (lookahead == 'b') ADVANCE(241);
      if (lookahead == 'p') ADVANCE(241);
      END_STATE();
    case 723:
      if (lookahead == 'b') ADVANCE(2085);
      if (lookahead == 'p') ADVANCE(1206);
      END_STATE();
    case 724:
      if (lookahead == 'b') ADVANCE(882);
      END_STATE();
    case 725:
      if (lookahead == 'b') ADVANCE(1795);
      END_STATE();
    case 726:
      if (lookahead == 'b') ADVANCE(917);
      if (lookahead == 'p') ADVANCE(917);
      END_STATE();
    case 727:
      if (lookahead == 'b') ADVANCE(1359);
      if (lookahead == 'c') ADVANCE(2086);
      if (lookahead == 'n') ADVANCE(1111);
      if (lookahead == 'p') ADVANCE(168);
      if (lookahead == 't') ADVANCE(2075);
      END_STATE();
    case 728:
      if (lookahead == 'b') ADVANCE(1900);
      END_STATE();
    case 729:
      if (lookahead == 'b') ADVANCE(525);
      END_STATE();
    case 730:
      if (lookahead == 'b') ADVANCE(1069);
      END_STATE();
    case 731:
      if (lookahead == 'b') ADVANCE(1502);
      if (lookahead == 'p') ADVANCE(1502);
      END_STATE();
    case 732:
      if (lookahead == 'b') ADVANCE(1944);
      if (lookahead == 'c') ADVANCE(854);
      if (lookahead == 'p') ADVANCE(1021);
      END_STATE();
    case 733:
      if (lookahead == 'b') ADVANCE(1944);
      if (lookahead == 'p') ADVANCE(1021);
      END_STATE();
    case 734:
      if (lookahead == 'b') ADVANCE(1415);
      END_STATE();
    case 735:
      if (lookahead == 'b') ADVANCE(1418);
      END_STATE();
    case 736:
      if (lookahead == 'b') ADVANCE(1861);
      END_STATE();
    case 737:
      if (lookahead == 'b') ADVANCE(1421);
      END_STATE();
    case 738:
      if (lookahead == 'b') ADVANCE(1422);
      END_STATE();
    case 739:
      if (lookahead == 'b') ADVANCE(1436);
      END_STATE();
    case 740:
      if (lookahead == 'b') ADVANCE(648);
      END_STATE();
    case 741:
      if (lookahead == 'b') ADVANCE(1427);
      END_STATE();
    case 742:
      if (lookahead == 'b') ADVANCE(1428);
      END_STATE();
    case 743:
      if (lookahead == 'b') ADVANCE(1429);
      END_STATE();
    case 744:
      if (lookahead == 'b') ADVANCE(1947);
      if (lookahead == 'p') ADVANCE(1947);
      END_STATE();
    case 745:
      if (lookahead == 'c') ADVANCE(2129);
      END_STATE();
    case 746:
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'e') ADVANCE(2104);
      END_STATE();
    case 747:
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'e') ADVANCE(827);
      if (lookahead == 'i') ADVANCE(148);
      END_STATE();
    case 748:
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1440);
      if (lookahead == 'o') ADVANCE(1673);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 749:
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'g') ADVANCE(1620);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 750:
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'i') ADVANCE(1144);
      END_STATE();
    case 751:
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'm') ADVANCE(287);
      END_STATE();
    case 752:
      if (lookahead == 'c') ADVANCE(2129);
      if (lookahead == 'x') ADVANCE(756);
      END_STATE();
    case 753:
      if (lookahead == 'c') ADVANCE(148);
      END_STATE();
    case 754:
      if (lookahead == 'c') ADVANCE(148);
      if (lookahead == 'i') ADVANCE(1741);
      END_STATE();
    case 755:
      if (lookahead == 'c') ADVANCE(318);
      if (lookahead == 'l') ADVANCE(922);
      if (lookahead == 'p') ADVANCE(329);
      if (lookahead == 'r') ADVANCE(1342);
      END_STATE();
    case 756:
      if (lookahead == 'c') ADVANCE(287);
      END_STATE();
    case 757:
      if (lookahead == 'c') ADVANCE(566);
      if (lookahead == 'd') ADVANCE(2007);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(396);
      if (lookahead == 'i') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(396);
      if (lookahead == 'm') ADVANCE(564);
      if (lookahead == 'n') ADVANCE(1250);
      if (lookahead == 'o') ADVANCE(869);
      if (lookahead == 'r') ADVANCE(396);
      if (lookahead == 's') ADVANCE(786);
      if (lookahead == 'u') ADVANCE(1700);
      if (lookahead == 'v') ADVANCE(994);
      if (lookahead == 'w') ADVANCE(957);
      END_STATE();
    case 758:
      if (lookahead == 'c') ADVANCE(566);
      if (lookahead == 'o') ADVANCE(870);
      if (lookahead == 's') ADVANCE(1735);
      if (lookahead == 't') ADVANCE(1891);
      if (lookahead == 'u') ADVANCE(1699);
      if (lookahead == 'v') ADVANCE(994);
      if (lookahead == 'w') ADVANCE(957);
      END_STATE();
    case 759:
      if (lookahead == 'c') ADVANCE(1639);
      END_STATE();
    case 760:
      if (lookahead == 'c') ADVANCE(2161);
      if (lookahead == 'h') ADVANCE(745);
      if (lookahead == 't') ADVANCE(1812);
      END_STATE();
    case 761:
      if (lookahead == 'c') ADVANCE(2161);
      if (lookahead == 'o') ADVANCE(1349);
      if (lookahead == 't') ADVANCE(1812);
      END_STATE();
    case 762:
      if (lookahead == 'c') ADVANCE(231);
      if (lookahead == 'h') ADVANCE(1657);
      if (lookahead == 'i') ADVANCE(1471);
      if (lookahead == 'm') ADVANCE(1213);
      if (lookahead == 'p') ADVANCE(538);
      if (lookahead == 'q') ADVANCE(1928);
      if (lookahead == 'u') ADVANCE(713);
      END_STATE();
    case 763:
      if (lookahead == 'c') ADVANCE(923);
      if (lookahead == 'd') ADVANCE(1260);
      if (lookahead == 'e') ADVANCE(1472);
      if (lookahead == 'n') ADVANCE(1121);
      if (lookahead == 'q') ADVANCE(2045);
      if (lookahead == 'r') ADVANCE(1754);
      if (lookahead == 't') ADVANCE(671);
      END_STATE();
    case 764:
      if (lookahead == 'c') ADVANCE(2054);
      END_STATE();
    case 765:
      if (lookahead == 'c') ADVANCE(142);
      if (lookahead == 's') ADVANCE(1349);
      END_STATE();
    case 766:
      if (lookahead == 'c') ADVANCE(210);
      END_STATE();
    case 767:
      if (lookahead == 'c') ADVANCE(2156);
      END_STATE();
    case 768:
      if (lookahead == 'c') ADVANCE(918);
      END_STATE();
    case 769:
      if (lookahead == 'c') ADVANCE(1741);
      END_STATE();
    case 770:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'i') ADVANCE(1454);
      END_STATE();
    case 771:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'e') ADVANCE(1463);
      if (lookahead == 'i') ADVANCE(1464);
      if (lookahead == 'o') ADVANCE(1353);
      END_STATE();
    case 772:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'e') ADVANCE(1997);
      if (lookahead == 'm') ADVANCE(1303);
      if (lookahead == 't') ADVANCE(641);
      END_STATE();
    case 773:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'e') ADVANCE(1774);
      END_STATE();
    case 774:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(919);
      if (lookahead == 't') ADVANCE(1174);
      END_STATE();
    case 775:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'g') ADVANCE(1273);
      END_STATE();
    case 776:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(148);
      END_STATE();
    case 777:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'h') ADVANCE(148);
      if (lookahead == 't') ADVANCE(1812);
      END_STATE();
    case 778:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(148);
      END_STATE();
    case 779:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1454);
      END_STATE();
    case 780:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1459);
      END_STATE();
    case 781:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1500);
      END_STATE();
    case 782:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'l') ADVANCE(571);
      if (lookahead == 't') ADVANCE(1812);
      END_STATE();
    case 783:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'l') ADVANCE(1111);
      END_STATE();
    case 784:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'l') ADVANCE(598);
      END_STATE();
    case 785:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'l') ADVANCE(598);
      if (lookahead == 'o') ADVANCE(1349);
      END_STATE();
    case 786:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'q') ADVANCE(838);
      END_STATE();
    case 787:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 's') ADVANCE(1256);
      END_STATE();
    case 788:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 't') ADVANCE(148);
      if (lookahead == 'y') ADVANCE(1479);
      END_STATE();
    case 789:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 't') ADVANCE(1709);
      END_STATE();
    case 790:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 't') ADVANCE(1812);
      END_STATE();
    case 791:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'u') ADVANCE(722);
      END_STATE();
    case 792:
      if (lookahead == 'c') ADVANCE(1741);
      if (lookahead == 'u') ADVANCE(731);
      END_STATE();
    case 793:
      if (lookahead == 'c') ADVANCE(524);
      if (lookahead == 'l') ADVANCE(903);
      if (lookahead == 'q') ADVANCE(2065);
      if (lookahead == 's') ADVANCE(1174);
      END_STATE();
    case 794:
      if (lookahead == 'c') ADVANCE(524);
      if (lookahead == 'q') ADVANCE(2065);
      if (lookahead == 'r') ADVANCE(904);
      if (lookahead == 's') ADVANCE(1174);
      END_STATE();
    case 795:
      if (lookahead == 'c') ADVANCE(1341);
      if (lookahead == 'r') ADVANCE(2100);
      END_STATE();
    case 796:
      if (lookahead == 'c') ADVANCE(1507);
      if (lookahead == 'i') ADVANCE(1578);
      if (lookahead == 'm') ADVANCE(1254);
      if (lookahead == 'p') ADVANCE(148);
      if (lookahead == 't') ADVANCE(1010);
      END_STATE();
    case 797:
      if (lookahead == 'c') ADVANCE(610);
      if (lookahead == 's') ADVANCE(2046);
      if (lookahead == 'u') ADVANCE(209);
      END_STATE();
    case 798:
      if (lookahead == 'c') ADVANCE(1949);
      END_STATE();
    case 799:
      if (lookahead == 'c') ADVANCE(1332);
      if (lookahead == 'r') ADVANCE(2103);
      END_STATE();
    case 800:
      if (lookahead == 'c') ADVANCE(1281);
      if (lookahead == 's') ADVANCE(1248);
      if (lookahead == 'u') ADVANCE(617);
      if (lookahead == 'v') ADVANCE(1716);
      END_STATE();
    case 801:
      if (lookahead == 'c') ADVANCE(1280);
      if (lookahead == 'e') ADVANCE(877);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'p') ADVANCE(148);
      if (lookahead == 'r') ADVANCE(257);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 802:
      if (lookahead == 'c') ADVANCE(1280);
      if (lookahead == 'e') ADVANCE(906);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 803:
      if (lookahead == 'c') ADVANCE(2053);
      END_STATE();
    case 804:
      if (lookahead == 'c') ADVANCE(2053);
      if (lookahead == 'r') ADVANCE(1741);
      END_STATE();
    case 805:
      if (lookahead == 'c') ADVANCE(2053);
      if (lookahead == 'r') ADVANCE(1777);
      END_STATE();
    case 806:
      if (lookahead == 'c') ADVANCE(2053);
      if (lookahead == 's') ADVANCE(1949);
      END_STATE();
    case 807:
      if (lookahead == 'c') ADVANCE(2053);
      if (lookahead == 's') ADVANCE(2003);
      END_STATE();
    case 808:
      if (lookahead == 'c') ADVANCE(1668);
      if (lookahead == 'd') ADVANCE(1741);
      END_STATE();
    case 809:
      if (lookahead == 'c') ADVANCE(2086);
      END_STATE();
    case 810:
      if (lookahead == 'c') ADVANCE(2086);
      if (lookahead == 'e') ADVANCE(1472);
      if (lookahead == 'g') ADVANCE(1859);
      if (lookahead == 'm') ADVANCE(724);
      if (lookahead == 'n') ADVANCE(1119);
      if (lookahead == 'p') ADVANCE(148);
      if (lookahead == 'q') ADVANCE(2045);
      if (lookahead == 'r') ADVANCE(1752);
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 811:
      if (lookahead == 'c') ADVANCE(2086);
      if (lookahead == 'm') ADVANCE(724);
      if (lookahead == 'n') ADVANCE(1111);
      if (lookahead == 'p') ADVANCE(1438);
      if (lookahead == 'r') ADVANCE(1741);
      END_STATE();
    case 812:
      if (lookahead == 'c') ADVANCE(2086);
      if (lookahead == 'm') ADVANCE(1482);
      if (lookahead == 'p') ADVANCE(148);
      END_STATE();
    case 813:
      if (lookahead == 'c') ADVANCE(2086);
      if (lookahead == 'n') ADVANCE(1111);
      if (lookahead == 'r') ADVANCE(1787);
      END_STATE();
    case 814:
      if (lookahead == 'c') ADVANCE(2086);
      if (lookahead == 'p') ADVANCE(204);
      if (lookahead == 'r') ADVANCE(953);
      END_STATE();
    case 815:
      if (lookahead == 'c') ADVANCE(2086);
      if (lookahead == 'p') ADVANCE(282);
      if (lookahead == 'y') ADVANCE(1399);
      END_STATE();
    case 816:
      if (lookahead == 'c') ADVANCE(980);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 817:
      if (lookahead == 'c') ADVANCE(1620);
      END_STATE();
    case 818:
      if (lookahead == 'c') ADVANCE(1330);
      END_STATE();
    case 819:
      if (lookahead == 'c') ADVANCE(1339);
      END_STATE();
    case 820:
      if (lookahead == 'c') ADVANCE(1339);
      if (lookahead == 's') ADVANCE(954);
      END_STATE();
    case 821:
      if (lookahead == 'c') ADVANCE(1331);
      if (lookahead == 'n') ADVANCE(507);
      END_STATE();
    case 822:
      if (lookahead == 'c') ADVANCE(250);
      END_STATE();
    case 823:
      if (lookahead == 'c') ADVANCE(1207);
      END_STATE();
    case 824:
      if (lookahead == 'c') ADVANCE(1600);
      if (lookahead == 'i') ADVANCE(1507);
      END_STATE();
    case 825:
      if (lookahead == 'c') ADVANCE(1334);
      if (lookahead == 'n') ADVANCE(1330);
      END_STATE();
    case 826:
      if (lookahead == 'c') ADVANCE(564);
      END_STATE();
    case 827:
      if (lookahead == 'c') ADVANCE(1335);
      END_STATE();
    case 828:
      if (lookahead == 'c') ADVANCE(1349);
      if (lookahead == 'i') ADVANCE(1905);
      if (lookahead == 'p') ADVANCE(1049);
      END_STATE();
    case 829:
      if (lookahead == 'c') ADVANCE(1344);
      if (lookahead == 'n') ADVANCE(1914);
      END_STATE();
    case 830:
      if (lookahead == 'c') ADVANCE(672);
      if (lookahead == 'r') ADVANCE(1532);
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 831:
      if (lookahead == 'c') ADVANCE(1336);
      if (lookahead == 'k') ADVANCE(2099);
      END_STATE();
    case 832:
      if (lookahead == 'c') ADVANCE(753);
      END_STATE();
    case 833:
      if (lookahead == 'c') ADVANCE(917);
      END_STATE();
    case 834:
      if (lookahead == 'c') ADVANCE(1188);
      END_STATE();
    case 835:
      if (lookahead == 'c') ADVANCE(1794);
      END_STATE();
    case 836:
      if (lookahead == 'c') ADVANCE(1794);
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'n') ADVANCE(2056);
      END_STATE();
    case 837:
      if (lookahead == 'c') ADVANCE(1914);
      END_STATE();
    case 838:
      if (lookahead == 'c') ADVANCE(2049);
      END_STATE();
    case 839:
      if (lookahead == 'c') ADVANCE(1948);
      END_STATE();
    case 840:
      if (lookahead == 'c') ADVANCE(591);
      END_STATE();
    case 841:
      if (lookahead == 'c') ADVANCE(1224);
      END_STATE();
    case 842:
      if (lookahead == 'c') ADVANCE(1224);
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 843:
      if (lookahead == 'c') ADVANCE(1057);
      END_STATE();
    case 844:
      if (lookahead == 'c') ADVANCE(1783);
      if (lookahead == 'd') ADVANCE(200);
      if (lookahead == 'n') ADVANCE(2064);
      END_STATE();
    case 845:
      if (lookahead == 'c') ADVANCE(2035);
      END_STATE();
    case 846:
      if (lookahead == 'c') ADVANCE(2022);
      END_STATE();
    case 847:
      if (lookahead == 'c') ADVANCE(1053);
      END_STATE();
    case 848:
      if (lookahead == 'c') ADVANCE(2006);
      END_STATE();
    case 849:
      if (lookahead == 'c') ADVANCE(1282);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'm') ADVANCE(590);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(773);
      if (lookahead == 'u') ADVANCE(1337);
      END_STATE();
    case 850:
      if (lookahead == 'c') ADVANCE(1282);
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(773);
      if (lookahead == 'u') ADVANCE(1337);
      END_STATE();
    case 851:
      if (lookahead == 'c') ADVANCE(1641);
      if (lookahead == 'i') ADVANCE(1516);
      if (lookahead == 't') ADVANCE(1776);
      END_STATE();
    case 852:
      if (lookahead == 'c') ADVANCE(1641);
      if (lookahead == 't') ADVANCE(1776);
      END_STATE();
    case 853:
      if (lookahead == 'c') ADVANCE(1343);
      END_STATE();
    case 854:
      if (lookahead == 'c') ADVANCE(1023);
      END_STATE();
    case 855:
      if (lookahead == 'c') ADVANCE(1023);
      if (lookahead == 'h') ADVANCE(513);
      END_STATE();
    case 856:
      if (lookahead == 'c') ADVANCE(630);
      END_STATE();
    case 857:
      if (lookahead == 'c') ADVANCE(1414);
      END_STATE();
    case 858:
      if (lookahead == 'c') ADVANCE(1838);
      if (lookahead == 'm') ADVANCE(1626);
      END_STATE();
    case 859:
      if (lookahead == 'c') ADVANCE(634);
      END_STATE();
    case 860:
      if (lookahead == 'c') ADVANCE(2021);
      END_STATE();
    case 861:
      if (lookahead == 'c') ADVANCE(1609);
      if (lookahead == 'e') ADVANCE(1667);
      if (lookahead == 'p') ADVANCE(1811);
      if (lookahead == 's') ADVANCE(1266);
      END_STATE();
    case 862:
      if (lookahead == 'c') ADVANCE(1398);
      END_STATE();
    case 863:
      if (lookahead == 'c') ADVANCE(637);
      END_STATE();
    case 864:
      if (lookahead == 'c') ADVANCE(675);
      if (lookahead == 'm') ADVANCE(1702);
      if (lookahead == 'p') ADVANCE(1909);
      if (lookahead == 'r') ADVANCE(1555);
      if (lookahead == 't') ADVANCE(2152);
      END_STATE();
    case 865:
      if (lookahead == 'c') ADVANCE(682);
      END_STATE();
    case 866:
      if (lookahead == 'c') ADVANCE(1081);
      END_STATE();
    case 867:
      if (lookahead == 'd') ADVANCE(1589);
      END_STATE();
    case 868:
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'i') ADVANCE(1431);
      if (lookahead == 'r') ADVANCE(1220);
      END_STATE();
    case 869:
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'p') ADVANCE(1088);
      if (lookahead == 't') ADVANCE(1291);
      END_STATE();
    case 870:
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 't') ADVANCE(1295);
      END_STATE();
    case 871:
      if (lookahead == 'd') ADVANCE(1589);
      if (lookahead == 'r') ADVANCE(1220);
      END_STATE();
    case 872:
      if (lookahead == 'd') ADVANCE(148);
      END_STATE();
    case 873:
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'f') ADVANCE(596);
      if (lookahead == 'p') ADVANCE(335);
      END_STATE();
    case 874:
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(917);
      END_STATE();
    case 875:
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'u') ADVANCE(287);
      END_STATE();
    case 876:
      if (lookahead == 'd') ADVANCE(205);
      if (lookahead == 'g') ADVANCE(242);
      END_STATE();
    case 877:
      if (lookahead == 'd') ADVANCE(717);
      if (lookahead == 'i') ADVANCE(1012);
      END_STATE();
    case 878:
      if (lookahead == 'd') ADVANCE(1435);
      END_STATE();
    case 879:
      if (lookahead == 'd') ADVANCE(506);
      END_STATE();
    case 880:
      if (lookahead == 'd') ADVANCE(482);
      END_STATE();
    case 881:
      if (lookahead == 'd') ADVANCE(472);
      END_STATE();
    case 882:
      if (lookahead == 'd') ADVANCE(524);
      END_STATE();
    case 883:
      if (lookahead == 'd') ADVANCE(745);
      if (lookahead == 'r') ADVANCE(229);
      END_STATE();
    case 884:
      if (lookahead == 'd') ADVANCE(274);
      END_STATE();
    case 885:
      if (lookahead == 'd') ADVANCE(190);
      END_STATE();
    case 886:
      if (lookahead == 'd') ADVANCE(996);
      if (lookahead == 'i') ADVANCE(1624);
      END_STATE();
    case 887:
      if (lookahead == 'd') ADVANCE(241);
      END_STATE();
    case 888:
      if (lookahead == 'd') ADVANCE(571);
      END_STATE();
    case 889:
      if (lookahead == 'd') ADVANCE(589);
      END_STATE();
    case 890:
      if (lookahead == 'd') ADVANCE(332);
      END_STATE();
    case 891:
      if (lookahead == 'd') ADVANCE(254);
      END_STATE();
    case 892:
      if (lookahead == 'd') ADVANCE(1257);
      END_STATE();
    case 893:
      if (lookahead == 'd') ADVANCE(1257);
      if (lookahead == 'l') ADVANCE(1447);
      END_STATE();
    case 894:
      if (lookahead == 'd') ADVANCE(917);
      END_STATE();
    case 895:
      if (lookahead == 'd') ADVANCE(2061);
      END_STATE();
    case 896:
      if (lookahead == 'd') ADVANCE(2061);
      if (lookahead == 'p') ADVANCE(1663);
      END_STATE();
    case 897:
      if (lookahead == 'd') ADVANCE(1215);
      END_STATE();
    case 898:
      if (lookahead == 'd') ADVANCE(1215);
      if (lookahead == 'm') ADVANCE(1702);
      if (lookahead == 'n') ADVANCE(336);
      END_STATE();
    case 899:
      if (lookahead == 'd') ADVANCE(1940);
      if (lookahead == 'u') ADVANCE(1184);
      END_STATE();
    case 900:
      if (lookahead == 'd') ADVANCE(931);
      END_STATE();
    case 901:
      if (lookahead == 'd') ADVANCE(1903);
      END_STATE();
    case 902:
      if (lookahead == 'd') ADVANCE(1996);
      END_STATE();
    case 903:
      if (lookahead == 'd') ADVANCE(1184);
      END_STATE();
    case 904:
      if (lookahead == 'd') ADVANCE(1184);
      if (lookahead == 'u') ADVANCE(1940);
      END_STATE();
    case 905:
      if (lookahead == 'd') ADVANCE(1290);
      if (lookahead == 'n') ADVANCE(2025);
      END_STATE();
    case 906:
      if (lookahead == 'd') ADVANCE(1136);
      END_STATE();
    case 907:
      if (lookahead == 'd') ADVANCE(1582);
      if (lookahead == 'u') ADVANCE(1668);
      END_STATE();
    case 908:
      if (lookahead == 'd') ADVANCE(1001);
      if (lookahead == 'p') ADVANCE(1087);
      END_STATE();
    case 909:
      if (lookahead == 'd') ADVANCE(997);
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 910:
      if (lookahead == 'd') ADVANCE(1014);
      END_STATE();
    case 911:
      if (lookahead == 'd') ADVANCE(1605);
      END_STATE();
    case 912:
      if (lookahead == 'd') ADVANCE(1254);
      END_STATE();
    case 913:
      if (lookahead == 'd') ADVANCE(1254);
      if (lookahead == 'i') ADVANCE(1349);
      END_STATE();
    case 914:
      if (lookahead == 'd') ADVANCE(1016);
      END_STATE();
    case 915:
      if (lookahead == 'd') ADVANCE(636);
      if (lookahead == 'e') ADVANCE(1684);
      if (lookahead == 'l') ADVANCE(657);
      if (lookahead == 'p') ADVANCE(220);
      if (lookahead == 'r') ADVANCE(664);
      if (lookahead == 'v') ADVANCE(994);
      if (lookahead == 'w') ADVANCE(916);
      END_STATE();
    case 916:
      if (lookahead == 'e') ADVANCE(872);
      END_STATE();
    case 917:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 918:
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'k') ADVANCE(952);
      END_STATE();
    case 919:
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(1263);
      if (lookahead == 'p') ADVANCE(643);
      END_STATE();
    case 920:
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'r') ADVANCE(720);
      END_STATE();
    case 921:
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 's') ADVANCE(1355);
      END_STATE();
    case 922:
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 't') ADVANCE(259);
      END_STATE();
    case 923:
      if (lookahead == 'e') ADVANCE(148);
      if (lookahead == 'u') ADVANCE(1998);
      END_STATE();
    case 924:
      if (lookahead == 'e') ADVANCE(432);
      END_STATE();
    case 925:
      if (lookahead == 'e') ADVANCE(297);
      END_STATE();
    case 926:
      if (lookahead == 'e') ADVANCE(2104);
      END_STATE();
    case 927:
      if (lookahead == 'e') ADVANCE(2104);
      if (lookahead == 'v') ADVANCE(729);
      END_STATE();
    case 928:
      if (lookahead == 'e') ADVANCE(1096);
      if (lookahead == 'p') ADVANCE(1177);
      END_STATE();
    case 929:
      if (lookahead == 'e') ADVANCE(317);
      if (lookahead == 'o') ADVANCE(1949);
      END_STATE();
    case 930:
      if (lookahead == 'e') ADVANCE(219);
      if (lookahead == 'l') ADVANCE(1406);
      if (lookahead == 'r') ADVANCE(719);
      END_STATE();
    case 931:
      if (lookahead == 'e') ADVANCE(172);
      END_STATE();
    case 932:
      if (lookahead == 'e') ADVANCE(151);
      END_STATE();
    case 933:
      if (lookahead == 'e') ADVANCE(144);
      END_STATE();
    case 934:
      if (lookahead == 'e') ADVANCE(433);
      END_STATE();
    case 935:
      if (lookahead == 'e') ADVANCE(431);
      END_STATE();
    case 936:
      if (lookahead == 'e') ADVANCE(178);
      END_STATE();
    case 937:
      if (lookahead == 'e') ADVANCE(695);
      END_STATE();
    case 938:
      if (lookahead == 'e') ADVANCE(1485);
      END_STATE();
    case 939:
      if (lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 940:
      if (lookahead == 'e') ADVANCE(459);
      END_STATE();
    case 941:
      if (lookahead == 'e') ADVANCE(490);
      END_STATE();
    case 942:
      if (lookahead == 'e') ADVANCE(239);
      END_STATE();
    case 943:
      if (lookahead == 'e') ADVANCE(426);
      END_STATE();
    case 944:
      if (lookahead == 'e') ADVANCE(518);
      END_STATE();
    case 945:
      if (lookahead == 'e') ADVANCE(155);
      END_STATE();
    case 946:
      if (lookahead == 'e') ADVANCE(237);
      END_STATE();
    case 947:
      if (lookahead == 'e') ADVANCE(500);
      END_STATE();
    case 948:
      if (lookahead == 'e') ADVANCE(1741);
      END_STATE();
    case 949:
      if (lookahead == 'e') ADVANCE(524);
      if (lookahead == 'p') ADVANCE(213);
      if (lookahead == 's') ADVANCE(524);
      END_STATE();
    case 950:
      if (lookahead == 'e') ADVANCE(1507);
      END_STATE();
    case 951:
      if (lookahead == 'e') ADVANCE(1827);
      if (lookahead == 'i') ADVANCE(821);
      END_STATE();
    case 952:
      if (lookahead == 'e') ADVANCE(1949);
      END_STATE();
    case 953:
      if (lookahead == 'e') ADVANCE(1949);
      if (lookahead == 'o') ADVANCE(1495);
      END_STATE();
    case 954:
      if (lookahead == 'e') ADVANCE(429);
      END_STATE();
    case 955:
      if (lookahead == 'e') ADVANCE(420);
      END_STATE();
    case 956:
      if (lookahead == 'e') ADVANCE(2145);
      END_STATE();
    case 957:
      if (lookahead == 'e') ADVANCE(906);
      END_STATE();
    case 958:
      if (lookahead == 'e') ADVANCE(1843);
      if (lookahead == 'i') ADVANCE(829);
      if (lookahead == 'k') ADVANCE(567);
      if (lookahead == 'o') ADVANCE(1743);
      END_STATE();
    case 959:
      if (lookahead == 'e') ADVANCE(1097);
      END_STATE();
    case 960:
      if (lookahead == 'e') ADVANCE(313);
      END_STATE();
    case 961:
      if (lookahead == 'e') ADVANCE(461);
      END_STATE();
    case 962:
      if (lookahead == 'e') ADVANCE(508);
      END_STATE();
    case 963:
      if (lookahead == 'e') ADVANCE(1920);
      END_STATE();
    case 964:
      if (lookahead == 'e') ADVANCE(1723);
      END_STATE();
    case 965:
      if (lookahead == 'e') ADVANCE(907);
      END_STATE();
    case 966:
      if (lookahead == 'e') ADVANCE(538);
      END_STATE();
    case 967:
      if (lookahead == 'e') ADVANCE(538);
      if (lookahead == 'i') ADVANCE(1454);
      END_STATE();
    case 968:
      if (lookahead == 'e') ADVANCE(450);
      END_STATE();
    case 969:
      if (lookahead == 'e') ADVANCE(1101);
      END_STATE();
    case 970:
      if (lookahead == 'e') ADVANCE(322);
      END_STATE();
    case 971:
      if (lookahead == 'e') ADVANCE(912);
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 972:
      if (lookahead == 'e') ADVANCE(912);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 973:
      if (lookahead == 'e') ADVANCE(2141);
      END_STATE();
    case 974:
      if (lookahead == 'e') ADVANCE(405);
      END_STATE();
    case 975:
      if (lookahead == 'e') ADVANCE(1727);
      if (lookahead == 'v') ADVANCE(994);
      if (lookahead == 'w') ADVANCE(957);
      END_STATE();
    case 976:
      if (lookahead == 'e') ADVANCE(430);
      END_STATE();
    case 977:
      if (lookahead == 'e') ADVANCE(1092);
      END_STATE();
    case 978:
      if (lookahead == 'e') ADVANCE(325);
      END_STATE();
    case 979:
      if (lookahead == 'e') ADVANCE(1729);
      END_STATE();
    case 980:
      if (lookahead == 'e') ADVANCE(1330);
      END_STATE();
    case 981:
      if (lookahead == 'e') ADVANCE(1508);
      END_STATE();
    case 982:
      if (lookahead == 'e') ADVANCE(1728);
      END_STATE();
    case 983:
      if (lookahead == 'e') ADVANCE(1970);
      END_STATE();
    case 984:
      if (lookahead == 'e') ADVANCE(1894);
      END_STATE();
    case 985:
      if (lookahead == 'e') ADVANCE(1905);
      END_STATE();
    case 986:
      if (lookahead == 'e') ADVANCE(1988);
      END_STATE();
    case 987:
      if (lookahead == 'e') ADVANCE(1349);
      END_STATE();
    case 988:
      if (lookahead == 'e') ADVANCE(879);
      END_STATE();
    case 989:
      if (lookahead == 'e') ADVANCE(690);
      END_STATE();
    case 990:
      if (lookahead == 'e') ADVANCE(881);
      END_STATE();
    case 991:
      if (lookahead == 'e') ADVANCE(1495);
      END_STATE();
    case 992:
      if (lookahead == 'e') ADVANCE(753);
      END_STATE();
    case 993:
      if (lookahead == 'e') ADVANCE(884);
      END_STATE();
    case 994:
      if (lookahead == 'e') ADVANCE(917);
      END_STATE();
    case 995:
      if (lookahead == 'e') ADVANCE(901);
      END_STATE();
    case 996:
      if (lookahead == 'e') ADVANCE(1749);
      END_STATE();
    case 997:
      if (lookahead == 'e') ADVANCE(1900);
      END_STATE();
    case 998:
      if (lookahead == 'e') ADVANCE(1667);
      if (lookahead == 'k') ADVANCE(562);
      if (lookahead == 'n') ADVANCE(1635);
      if (lookahead == 'p') ADVANCE(1183);
      if (lookahead == 'r') ADVANCE(277);
      if (lookahead == 's') ADVANCE(1229);
      if (lookahead == 't') ADVANCE(1200);
      END_STATE();
    case 999:
      if (lookahead == 'e') ADVANCE(1667);
      if (lookahead == 'p') ADVANCE(1182);
      END_STATE();
    case 1000:
      if (lookahead == 'e') ADVANCE(1911);
      END_STATE();
    case 1001:
      if (lookahead == 'e') ADVANCE(1385);
      END_STATE();
    case 1002:
      if (lookahead == 'e') ADVANCE(860);
      END_STATE();
    case 1003:
      if (lookahead == 'e') ADVANCE(1549);
      END_STATE();
    case 1004:
      if (lookahead == 'e') ADVANCE(1942);
      END_STATE();
    case 1005:
      if (lookahead == 'e') ADVANCE(1994);
      END_STATE();
    case 1006:
      if (lookahead == 'e') ADVANCE(1913);
      END_STATE();
    case 1007:
      if (lookahead == 'e') ADVANCE(1972);
      END_STATE();
    case 1008:
      if (lookahead == 'e') ADVANCE(573);
      END_STATE();
    case 1009:
      if (lookahead == 'e') ADVANCE(932);
      END_STATE();
    case 1010:
      if (lookahead == 'e') ADVANCE(1521);
      END_STATE();
    case 1011:
      if (lookahead == 'e') ADVANCE(1412);
      END_STATE();
    case 1012:
      if (lookahead == 'e') ADVANCE(1789);
      END_STATE();
    case 1013:
      if (lookahead == 'e') ADVANCE(611);
      END_STATE();
    case 1014:
      if (lookahead == 'e') ADVANCE(1903);
      END_STATE();
    case 1015:
      if (lookahead == 'e') ADVANCE(595);
      END_STATE();
    case 1016:
      if (lookahead == 'e') ADVANCE(1904);
      END_STATE();
    case 1017:
      if (lookahead == 'e') ADVANCE(1959);
      if (lookahead == 'i') ADVANCE(1454);
      if (lookahead == 'u') ADVANCE(2153);
      END_STATE();
    case 1018:
      if (lookahead == 'e') ADVANCE(1755);
      END_STATE();
    case 1019:
      if (lookahead == 'e') ADVANCE(1862);
      END_STATE();
    case 1020:
      if (lookahead == 'e') ADVANCE(1995);
      END_STATE();
    case 1021:
      if (lookahead == 'e') ADVANCE(1826);
      END_STATE();
    case 1022:
      if (lookahead == 'e') ADVANCE(2002);
      END_STATE();
    case 1023:
      if (lookahead == 'e') ADVANCE(995);
      END_STATE();
    case 1024:
      if (lookahead == 'e') ADVANCE(939);
      if (lookahead == 'r') ADVANCE(1326);
      END_STATE();
    case 1025:
      if (lookahead == 'e') ADVANCE(1742);
      END_STATE();
    case 1026:
      if (lookahead == 'e') ADVANCE(1836);
      if (lookahead == 'i') ADVANCE(1507);
      END_STATE();
    case 1027:
      if (lookahead == 'e') ADVANCE(1786);
      END_STATE();
    case 1028:
      if (lookahead == 'e') ADVANCE(1864);
      END_STATE();
    case 1029:
      if (lookahead == 'e') ADVANCE(1884);
      END_STATE();
    case 1030:
      if (lookahead == 'e') ADVANCE(944);
      END_STATE();
    case 1031:
      if (lookahead == 'e') ADVANCE(1799);
      END_STATE();
    case 1032:
      if (lookahead == 'e') ADVANCE(1071);
      END_STATE();
    case 1033:
      if (lookahead == 'e') ADVANCE(1796);
      END_STATE();
    case 1034:
      if (lookahead == 'e') ADVANCE(1759);
      END_STATE();
    case 1035:
      if (lookahead == 'e') ADVANCE(1804);
      END_STATE();
    case 1036:
      if (lookahead == 'e') ADVANCE(1762);
      END_STATE();
    case 1037:
      if (lookahead == 'e') ADVANCE(1102);
      END_STATE();
    case 1038:
      if (lookahead == 'e') ADVANCE(2106);
      if (lookahead == 'i') ADVANCE(1149);
      END_STATE();
    case 1039:
      if (lookahead == 'e') ADVANCE(1419);
      END_STATE();
    case 1040:
      if (lookahead == 'e') ADVANCE(517);
      END_STATE();
    case 1041:
      if (lookahead == 'e') ADVANCE(889);
      END_STATE();
    case 1042:
      if (lookahead == 'e') ADVANCE(669);
      if (lookahead == 'w') ADVANCE(669);
      END_STATE();
    case 1043:
      if (lookahead == 'e') ADVANCE(1099);
      END_STATE();
    case 1044:
      if (lookahead == 'e') ADVANCE(1099);
      if (lookahead == 'l') ADVANCE(148);
      if (lookahead == 't') ADVANCE(345);
      END_STATE();
    case 1045:
      if (lookahead == 'e') ADVANCE(991);
      END_STATE();
    case 1046:
      if (lookahead == 'e') ADVANCE(1931);
      END_STATE();
    case 1047:
      if (lookahead == 'e') ADVANCE(892);
      END_STATE();
    case 1048:
      if (lookahead == 'e') ADVANCE(1484);
      END_STATE();
    case 1049:
      if (lookahead == 'e') ADVANCE(845);
      if (lookahead == 'o') ADVANCE(1565);
      END_STATE();
    case 1050:
      if (lookahead == 'e') ADVANCE(658);
      END_STATE();
    case 1051:
      if (lookahead == 'e') ADVANCE(1720);
      END_STATE();
    case 1052:
      if (lookahead == 'e') ADVANCE(1824);
      END_STATE();
    case 1053:
      if (lookahead == 'e') ADVANCE(2017);
      END_STATE();
    case 1054:
      if (lookahead == 'e') ADVANCE(2017);
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 1055:
      if (lookahead == 'e') ADVANCE(740);
      END_STATE();
    case 1056:
      if (lookahead == 'e') ADVANCE(1103);
      END_STATE();
    case 1057:
      if (lookahead == 'e') ADVANCE(910);
      END_STATE();
    case 1058:
      if (lookahead == 'e') ADVANCE(846);
      END_STATE();
    case 1059:
      if (lookahead == 'e') ADVANCE(1921);
      END_STATE();
    case 1060:
      if (lookahead == 'e') ADVANCE(1707);
      END_STATE();
    case 1061:
      if (lookahead == 'e') ADVANCE(1104);
      END_STATE();
    case 1062:
      if (lookahead == 'e') ADVANCE(1823);
      if (lookahead == 'n') ADVANCE(455);
      END_STATE();
    case 1063:
      if (lookahead == 'e') ADVANCE(848);
      END_STATE();
    case 1064:
      if (lookahead == 'e') ADVANCE(1575);
      END_STATE();
    case 1065:
      if (lookahead == 'e') ADVANCE(1105);
      END_STATE();
    case 1066:
      if (lookahead == 'e') ADVANCE(1106);
      END_STATE();
    case 1067:
      if (lookahead == 'e') ADVANCE(1558);
      END_STATE();
    case 1068:
      if (lookahead == 'e') ADVANCE(1107);
      if (lookahead == 'o') ADVANCE(1535);
      END_STATE();
    case 1069:
      if (lookahead == 'e') ADVANCE(1842);
      END_STATE();
    case 1070:
      if (lookahead == 'e') ADVANCE(1100);
      END_STATE();
    case 1071:
      if (lookahead == 'e') ADVANCE(2036);
      END_STATE();
    case 1072:
      if (lookahead == 'e') ADVANCE(1889);
      END_STATE();
    case 1073:
      if (lookahead == 'e') ADVANCE(1543);
      END_STATE();
    case 1074:
      if (lookahead == 'e') ADVANCE(694);
      END_STATE();
    case 1075:
      if (lookahead == 'e') ADVANCE(1453);
      END_STATE();
    case 1076:
      if (lookahead == 'e') ADVANCE(1151);
      END_STATE();
    case 1077:
      if (lookahead == 'e') ADVANCE(1886);
      END_STATE();
    case 1078:
      if (lookahead == 'e') ADVANCE(2023);
      END_STATE();
    case 1079:
      if (lookahead == 'e') ADVANCE(1302);
      END_STATE();
    case 1080:
      if (lookahead == 'e') ADVANCE(1869);
      END_STATE();
    case 1081:
      if (lookahead == 'e') ADVANCE(914);
      END_STATE();
    case 1082:
      if (lookahead == 'e') ADVANCE(693);
      END_STATE();
    case 1083:
      if (lookahead == 'e') ADVANCE(1518);
      END_STATE();
    case 1084:
      if (lookahead == 'e') ADVANCE(698);
      END_STATE();
    case 1085:
      if (lookahead == 'e') ADVANCE(866);
      END_STATE();
    case 1086:
      if (lookahead == 'e') ADVANCE(1110);
      END_STATE();
    case 1087:
      if (lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 1088:
      if (lookahead == 'f') ADVANCE(148);
      if (lookahead == 'l') ADVANCE(2056);
      END_STATE();
    case 1089:
      if (lookahead == 'f') ADVANCE(148);
      if (lookahead == 'r') ADVANCE(1615);
      END_STATE();
    case 1090:
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(148);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 's') ADVANCE(769);
      END_STATE();
    case 1091:
      if (lookahead == 'f') ADVANCE(1741);
      if (lookahead == 'i') ADVANCE(1507);
      if (lookahead == 'o') ADVANCE(1671);
      if (lookahead == 'p') ADVANCE(1811);
      if (lookahead == 's') ADVANCE(769);
      if (lookahead == 'u') ADVANCE(593);
      END_STATE();
    case 1092:
      if (lookahead == 'f') ADVANCE(1949);
      END_STATE();
    case 1093:
      if (lookahead == 'f') ADVANCE(1098);
      END_STATE();
    case 1094:
      if (lookahead == 'f') ADVANCE(1952);
      if (lookahead == 's') ADVANCE(1897);
      END_STATE();
    case 1095:
      if (lookahead == 'f') ADVANCE(1975);
      if (lookahead == 'l') ADVANCE(216);
      if (lookahead == 'p') ADVANCE(1087);
      END_STATE();
    case 1096:
      if (lookahead == 'f') ADVANCE(1916);
      if (lookahead == 'p') ADVANCE(1174);
      END_STATE();
    case 1097:
      if (lookahead == 'f') ADVANCE(2040);
      END_STATE();
    case 1098:
      if (lookahead == 'f') ADVANCE(1072);
      END_STATE();
    case 1099:
      if (lookahead == 'f') ADVANCE(1979);
      END_STATE();
    case 1100:
      if (lookahead == 'f') ADVANCE(1994);
      END_STATE();
    case 1101:
      if (lookahead == 'f') ADVANCE(1659);
      END_STATE();
    case 1102:
      if (lookahead == 'f') ADVANCE(1986);
      if (lookahead == 's') ADVANCE(1902);
      END_STATE();
    case 1103:
      if (lookahead == 'f') ADVANCE(1961);
      END_STATE();
    case 1104:
      if (lookahead == 'f') ADVANCE(1963);
      END_STATE();
    case 1105:
      if (lookahead == 'f') ADVANCE(1981);
      END_STATE();
    case 1106:
      if (lookahead == 'f') ADVANCE(2019);
      END_STATE();
    case 1107:
      if (lookahead == 'f') ADVANCE(1967);
      END_STATE();
    case 1108:
      if (lookahead == 'f') ADVANCE(1619);
      END_STATE();
    case 1109:
      if (lookahead == 'f') ADVANCE(1258);
      END_STATE();
    case 1110:
      if (lookahead == 'f') ADVANCE(2039);
      END_STATE();
    case 1111:
      if (lookahead == 'g') ADVANCE(148);
      END_STATE();
    case 1112:
      if (lookahead == 'g') ADVANCE(148);
      if (lookahead == 's') ADVANCE(1668);
      END_STATE();
    case 1113:
      if (lookahead == 'g') ADVANCE(148);
      if (lookahead == 't') ADVANCE(345);
      END_STATE();
    case 1114:
      if (lookahead == 'g') ADVANCE(758);
      END_STATE();
    case 1115:
      if (lookahead == 'g') ADVANCE(233);
      END_STATE();
    case 1116:
      if (lookahead == 'g') ADVANCE(233);
      if (lookahead == 'i') ADVANCE(1507);
      END_STATE();
    case 1117:
      if (lookahead == 'g') ADVANCE(488);
      END_STATE();
    case 1118:
      if (lookahead == 'g') ADVANCE(507);
      END_STATE();
    case 1119:
      if (lookahead == 'g') ADVANCE(236);
      END_STATE();
    case 1120:
      if (lookahead == 'g') ADVANCE(1452);
      END_STATE();
    case 1121:
      if (lookahead == 'g') ADVANCE(360);
      END_STATE();
    case 1122:
      if (lookahead == 'g') ADVANCE(524);
      END_STATE();
    case 1123:
      if (lookahead == 'g') ADVANCE(1190);
      END_STATE();
    case 1124:
      if (lookahead == 'g') ADVANCE(2144);
      END_STATE();
    case 1125:
      if (lookahead == 'g') ADVANCE(1137);
      if (lookahead == 'l') ADVANCE(986);
      if (lookahead == 'r') ADVANCE(1741);
      if (lookahead == 's') ADVANCE(1178);
      END_STATE();
    case 1126:
      if (lookahead == 'g') ADVANCE(1137);
      if (lookahead == 'r') ADVANCE(1741);
      END_STATE();
    case 1127:
      if (lookahead == 'g') ADVANCE(1137);
      if (lookahead == 'r') ADVANCE(1741);
      if (lookahead == 's') ADVANCE(1180);
      END_STATE();
    case 1128:
      if (lookahead == 'g') ADVANCE(1581);
      END_STATE();
    case 1129:
      if (lookahead == 'g') ADVANCE(1620);
      if (lookahead == 'p') ADVANCE(1087);
      END_STATE();
    case 1130:
      if (lookahead == 'g') ADVANCE(1620);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 1131:
      if (lookahead == 'g') ADVANCE(1461);
      END_STATE();
    case 1132:
      if (lookahead == 'g') ADVANCE(1179);
      END_STATE();
    case 1133:
      if (lookahead == 'g') ADVANCE(1349);
      if (lookahead == 'i') ADVANCE(1381);
      if (lookahead == 'l') ADVANCE(1111);
      if (lookahead == 'r') ADVANCE(1322);
      END_STATE();
    case 1134:
      if (lookahead == 'g') ADVANCE(667);
      if (lookahead == 's') ADVANCE(2005);
      if (lookahead == 'w') ADVANCE(486);
      END_STATE();
    case 1135:
      if (lookahead == 'g') ADVANCE(1495);
      END_STATE();
    case 1136:
      if (lookahead == 'g') ADVANCE(917);
      END_STATE();
    case 1137:
      if (lookahead == 'g') ADVANCE(948);
      END_STATE();
    case 1138:
      if (lookahead == 'g') ADVANCE(952);
      END_STATE();
    case 1139:
      if (lookahead == 'g') ADVANCE(1868);
      END_STATE();
    case 1140:
      if (lookahead == 'g') ADVANCE(1868);
      if (lookahead == 'i') ADVANCE(1507);
      if (lookahead == 't') ADVANCE(1649);
      END_STATE();
    case 1141:
      if (lookahead == 'g') ADVANCE(1766);
      END_STATE();
    case 1142:
      if (lookahead == 'g') ADVANCE(1193);
      if (lookahead == 'n') ADVANCE(1111);
      if (lookahead == 's') ADVANCE(1292);
      END_STATE();
    case 1143:
      if (lookahead == 'g') ADVANCE(911);
      END_STATE();
    case 1144:
      if (lookahead == 'g') ADVANCE(1775);
      END_STATE();
    case 1145:
      if (lookahead == 'g') ADVANCE(1189);
      END_STATE();
    case 1146:
      if (lookahead == 'g') ADVANCE(1969);
      END_STATE();
    case 1147:
      if (lookahead == 'g') ADVANCE(1969);
      if (lookahead == 'l') ADVANCE(963);
      END_STATE();
    case 1148:
      if (lookahead == 'g') ADVANCE(1969);
      if (lookahead == 'q') ADVANCE(1146);
      END_STATE();
    case 1149:
      if (lookahead == 'g') ADVANCE(1194);
      END_STATE();
    case 1150:
      if (lookahead == 'g') ADVANCE(1487);
      if (lookahead == 'm') ADVANCE(234);
      END_STATE();
    case 1151:
      if (lookahead == 'g') ADVANCE(1819);
      END_STATE();
    case 1152:
      if (lookahead == 'g') ADVANCE(1819);
      if (lookahead == 'r') ADVANCE(1936);
      END_STATE();
    case 1153:
      if (lookahead == 'g') ADVANCE(1195);
      END_STATE();
    case 1154:
      if (lookahead == 'g') ADVANCE(1197);
      END_STATE();
    case 1155:
      if (lookahead == 'g') ADVANCE(1198);
      END_STATE();
    case 1156:
      if (lookahead == 'g') ADVANCE(1199);
      END_STATE();
    case 1157:
      if (lookahead == 'g') ADVANCE(1398);
      END_STATE();
    case 1158:
      if (lookahead == 'g') ADVANCE(1201);
      END_STATE();
    case 1159:
      if (lookahead == 'g') ADVANCE(1031);
      if (lookahead == 'r') ADVANCE(840);
      END_STATE();
    case 1160:
      if (lookahead == 'g') ADVANCE(1202);
      END_STATE();
    case 1161:
      if (lookahead == 'g') ADVANCE(1203);
      END_STATE();
    case 1162:
      if (lookahead == 'g') ADVANCE(1420);
      END_STATE();
    case 1163:
      if (lookahead == 'g') ADVANCE(1192);
      END_STATE();
    case 1164:
      if (lookahead == 'g') ADVANCE(1422);
      END_STATE();
    case 1165:
      if (lookahead == 'g') ADVANCE(1423);
      END_STATE();
    case 1166:
      if (lookahead == 'g') ADVANCE(1424);
      END_STATE();
    case 1167:
      if (lookahead == 'g') ADVANCE(1437);
      END_STATE();
    case 1168:
      if (lookahead == 'g') ADVANCE(1425);
      END_STATE();
    case 1169:
      if (lookahead == 'g') ADVANCE(1426);
      END_STATE();
    case 1170:
      if (lookahead == 'g') ADVANCE(487);
      END_STATE();
    case 1171:
      if (lookahead == 'g') ADVANCE(685);
      END_STATE();
    case 1172:
      if (lookahead == 'g') ADVANCE(1212);
      END_STATE();
    case 1173:
      if (lookahead == 'h') ADVANCE(872);
      END_STATE();
    case 1174:
      if (lookahead == 'h') ADVANCE(148);
      END_STATE();
    case 1175:
      if (lookahead == 'h') ADVANCE(287);
      END_STATE();
    case 1176:
      if (lookahead == 'h') ADVANCE(507);
      END_STATE();
    case 1177:
      if (lookahead == 'h') ADVANCE(524);
      END_STATE();
    case 1178:
      if (lookahead == 'h') ADVANCE(345);
      END_STATE();
    case 1179:
      if (lookahead == 'h') ADVANCE(1949);
      END_STATE();
    case 1180:
      if (lookahead == 'h') ADVANCE(2099);
      END_STATE();
    case 1181:
      if (lookahead == 'h') ADVANCE(745);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 1182:
      if (lookahead == 'h') ADVANCE(1214);
      END_STATE();
    case 1183:
      if (lookahead == 'h') ADVANCE(1214);
      if (lookahead == 'i') ADVANCE(148);
      if (lookahead == 'r') ADVANCE(1648);
      END_STATE();
    case 1184:
      if (lookahead == 'h') ADVANCE(538);
      END_STATE();
    case 1185:
      if (lookahead == 'h') ADVANCE(1668);
      END_STATE();
    case 1186:
      if (lookahead == 'h') ADVANCE(1330);
      END_STATE();
    case 1187:
      if (lookahead == 'h') ADVANCE(1330);
      if (lookahead == 'r') ADVANCE(304);
      END_STATE();
    case 1188:
      if (lookahead == 'h') ADVANCE(917);
      END_STATE();
    case 1189:
      if (lookahead == 'h') ADVANCE(2040);
      END_STATE();
    case 1190:
      if (lookahead == 'h') ADVANCE(1956);
      END_STATE();
    case 1191:
      if (lookahead == 'h') ADVANCE(548);
      END_STATE();
    case 1192:
      if (lookahead == 'h') ADVANCE(1994);
      END_STATE();
    case 1193:
      if (lookahead == 'h') ADVANCE(1958);
      END_STATE();
    case 1194:
      if (lookahead == 'h') ADVANCE(1986);
      END_STATE();
    case 1195:
      if (lookahead == 'h') ADVANCE(1971);
      END_STATE();
    case 1196:
      if (lookahead == 'h') ADVANCE(1217);
      END_STATE();
    case 1197:
      if (lookahead == 'h') ADVANCE(1962);
      END_STATE();
    case 1198:
      if (lookahead == 'h') ADVANCE(1964);
      END_STATE();
    case 1199:
      if (lookahead == 'h') ADVANCE(1981);
      END_STATE();
    case 1200:
      if (lookahead == 'h') ADVANCE(983);
      if (lookahead == 'r') ADVANCE(1325);
      END_STATE();
    case 1201:
      if (lookahead == 'h') ADVANCE(1966);
      END_STATE();
    case 1202:
      if (lookahead == 'h') ADVANCE(1968);
      END_STATE();
    case 1203:
      if (lookahead == 'h') ADVANCE(1965);
      END_STATE();
    case 1204:
      if (lookahead == 'h') ADVANCE(1059);
      END_STATE();
    case 1205:
      if (lookahead == 'h') ADVANCE(1251);
      END_STATE();
    case 1206:
      if (lookahead == 'h') ADVANCE(991);
      END_STATE();
    case 1207:
      if (lookahead == 'h') ADVANCE(1108);
      END_STATE();
    case 1208:
      if (lookahead == 'h') ADVANCE(1790);
      if (lookahead == 'i') ADVANCE(1488);
      if (lookahead == 'r') ADVANCE(1222);
      END_STATE();
    case 1209:
      if (lookahead == 'h') ADVANCE(1013);
      END_STATE();
    case 1210:
      if (lookahead == 'h') ADVANCE(1275);
      END_STATE();
    case 1211:
      if (lookahead == 'h') ADVANCE(1871);
      END_STATE();
    case 1212:
      if (lookahead == 'h') ADVANCE(2039);
      END_STATE();
    case 1213:
      if (lookahead == 'i') ADVANCE(872);
      END_STATE();
    case 1214:
      if (lookahead == 'i') ADVANCE(148);
      END_STATE();
    case 1215:
      if (lookahead == 'i') ADVANCE(287);
      END_STATE();
    case 1216:
      if (lookahead == 'i') ADVANCE(271);
      END_STATE();
    case 1217:
      if (lookahead == 'i') ADVANCE(821);
      END_STATE();
    case 1218:
      if (lookahead == 'i') ADVANCE(2127);
      if (lookahead == 'o') ADVANCE(1209);
      END_STATE();
    case 1219:
      if (lookahead == 'i') ADVANCE(2143);
      END_STATE();
    case 1220:
      if (lookahead == 'i') ADVANCE(265);
      END_STATE();
    case 1221:
      if (lookahead == 'i') ADVANCE(291);
      END_STATE();
    case 1222:
      if (lookahead == 'i') ADVANCE(362);
      END_STATE();
    case 1223:
      if (lookahead == 'i') ADVANCE(276);
      END_STATE();
    case 1224:
      if (lookahead == 'i') ADVANCE(1741);
      END_STATE();
    case 1225:
      if (lookahead == 'i') ADVANCE(1741);
      if (lookahead == 'r') ADVANCE(1595);
      END_STATE();
    case 1226:
      if (lookahead == 'i') ADVANCE(1507);
      END_STATE();
    case 1227:
      if (lookahead == 'i') ADVANCE(1507);
      if (lookahead == 'n') ADVANCE(1949);
      END_STATE();
    case 1228:
      if (lookahead == 'i') ADVANCE(345);
      if (lookahead == 'm') ADVANCE(1486);
      if (lookahead == 'o') ADVANCE(1529);
      END_STATE();
    case 1229:
      if (lookahead == 'i') ADVANCE(1131);
      if (lookahead == 'u') ADVANCE(744);
      END_STATE();
    case 1230:
      if (lookahead == 'i') ADVANCE(1382);
      END_STATE();
    case 1231:
      if (lookahead == 'i') ADVANCE(290);
      END_STATE();
    case 1232:
      if (lookahead == 'i') ADVANCE(1949);
      END_STATE();
    case 1233:
      if (lookahead == 'i') ADVANCE(2099);
      END_STATE();
    case 1234:
      if (lookahead == 'i') ADVANCE(867);
      END_STATE();
    case 1235:
      if (lookahead == 'i') ADVANCE(867);
      if (lookahead == 'o') ADVANCE(2083);
      END_STATE();
    case 1236:
      if (lookahead == 'i') ADVANCE(1496);
      END_STATE();
    case 1237:
      if (lookahead == 'i') ADVANCE(346);
      END_STATE();
    case 1238:
      if (lookahead == 'i') ADVANCE(1943);
      END_STATE();
    case 1239:
      if (lookahead == 'i') ADVANCE(1943);
      if (lookahead == 'p') ADVANCE(1623);
      END_STATE();
    case 1240:
      if (lookahead == 'i') ADVANCE(241);
      END_STATE();
    case 1241:
      if (lookahead == 'i') ADVANCE(1377);
      END_STATE();
    case 1242:
      if (lookahead == 'i') ADVANCE(1668);
      END_STATE();
    case 1243:
      if (lookahead == 'i') ADVANCE(1111);
      END_STATE();
    case 1244:
      if (lookahead == 'i') ADVANCE(1111);
      if (lookahead == 'l') ADVANCE(1243);
      END_STATE();
    case 1245:
      if (lookahead == 'i') ADVANCE(1093);
      END_STATE();
    case 1246:
      if (lookahead == 'i') ADVANCE(1454);
      END_STATE();
    case 1247:
      if (lookahead == 'i') ADVANCE(1454);
      if (lookahead == 'l') ADVANCE(148);
      END_STATE();
    case 1248:
      if (lookahead == 'i') ADVANCE(1454);
      if (lookahead == 'l') ADVANCE(665);
      END_STATE();
    case 1249:
      if (lookahead == 'i') ADVANCE(1620);
      END_STATE();
    case 1250:
      if (lookahead == 'i') ADVANCE(1894);
      END_STATE();
    case 1251:
      if (lookahead == 'i') ADVANCE(1516);
      END_STATE();
    case 1252:
      if (lookahead == 'i') ADVANCE(1919);
      if (lookahead == 'l') ADVANCE(1629);
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 1253:
      if (lookahead == 'i') ADVANCE(1919);
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 1254:
      if (lookahead == 'i') ADVANCE(1349);
      END_STATE();
    case 1255:
      if (lookahead == 'i') ADVANCE(1124);
      END_STATE();
    case 1256:
      if (lookahead == 'i') ADVANCE(1135);
      END_STATE();
    case 1257:
      if (lookahead == 'i') ADVANCE(2060);
      END_STATE();
    case 1258:
      if (lookahead == 'i') ADVANCE(1495);
      END_STATE();
    case 1259:
      if (lookahead == 'i') ADVANCE(1379);
      END_STATE();
    case 1260:
      if (lookahead == 'i') ADVANCE(753);
      END_STATE();
    case 1261:
      if (lookahead == 'i') ADVANCE(1771);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 1262:
      if (lookahead == 'i') ADVANCE(917);
      END_STATE();
    case 1263:
      if (lookahead == 'i') ADVANCE(1529);
      END_STATE();
    case 1264:
      if (lookahead == 'i') ADVANCE(679);
      END_STATE();
    case 1265:
      if (lookahead == 'i') ADVANCE(902);
      END_STATE();
    case 1266:
      if (lookahead == 'i') ADVANCE(1473);
      END_STATE();
    case 1267:
      if (lookahead == 'i') ADVANCE(1171);
      END_STATE();
    case 1268:
      if (lookahead == 'i') ADVANCE(1815);
      if (lookahead == 'l') ADVANCE(1087);
      if (lookahead == 'm') ADVANCE(1270);
      if (lookahead == 'r') ADVANCE(883);
      END_STATE();
    case 1269:
      if (lookahead == 'i') ADVANCE(1520);
      END_STATE();
    case 1270:
      if (lookahead == 'i') ADVANCE(1365);
      END_STATE();
    case 1271:
      if (lookahead == 'i') ADVANCE(984);
      END_STATE();
    case 1272:
      if (lookahead == 'i') ADVANCE(2055);
      END_STATE();
    case 1273:
      if (lookahead == 'i') ADVANCE(1560);
      END_STATE();
    case 1274:
      if (lookahead == 'i') ADVANCE(1553);
      END_STATE();
    case 1275:
      if (lookahead == 'i') ADVANCE(1498);
      END_STATE();
    case 1276:
      if (lookahead == 'i') ADVANCE(1395);
      if (lookahead == 'l') ADVANCE(1244);
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 1277:
      if (lookahead == 'i') ADVANCE(1132);
      END_STATE();
    case 1278:
      if (lookahead == 'i') ADVANCE(1383);
      END_STATE();
    case 1279:
      if (lookahead == 'i') ADVANCE(1531);
      if (lookahead == 'p') ADVANCE(1087);
      END_STATE();
    case 1280:
      if (lookahead == 'i') ADVANCE(1808);
      END_STATE();
    case 1281:
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'o') ADVANCE(1379);
      END_STATE();
    case 1282:
      if (lookahead == 'i') ADVANCE(1808);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 1283:
      if (lookahead == 'i') ADVANCE(1381);
      END_STATE();
    case 1284:
      if (lookahead == 'i') ADVANCE(736);
      END_STATE();
    case 1285:
      if (lookahead == 'i') ADVANCE(627);
      END_STATE();
    case 1286:
      if (lookahead == 'i') ADVANCE(1934);
      END_STATE();
    case 1287:
      if (lookahead == 'i') ADVANCE(2105);
      END_STATE();
    case 1288:
      if (lookahead == 'i') ADVANCE(1714);
      END_STATE();
    case 1289:
      if (lookahead == 'i') ADVANCE(1539);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 'u') ADVANCE(1510);
      END_STATE();
    case 1290:
      if (lookahead == 'i') ADVANCE(1400);
      END_STATE();
    case 1291:
      if (lookahead == 'i') ADVANCE(1478);
      END_STATE();
    case 1292:
      if (lookahead == 'i') ADVANCE(1533);
      END_STATE();
    case 1293:
      if (lookahead == 'i') ADVANCE(1938);
      END_STATE();
    case 1294:
      if (lookahead == 'i') ADVANCE(1933);
      END_STATE();
    case 1295:
      if (lookahead == 'i') ADVANCE(1488);
      END_STATE();
    case 1296:
      if (lookahead == 'i') ADVANCE(1474);
      END_STATE();
    case 1297:
      if (lookahead == 'i') ADVANCE(2014);
      END_STATE();
    case 1298:
      if (lookahead == 'i') ADVANCE(1411);
      END_STATE();
    case 1299:
      if (lookahead == 'i') ADVANCE(1537);
      END_STATE();
    case 1300:
      if (lookahead == 'i') ADVANCE(1028);
      END_STATE();
    case 1301:
      if (lookahead == 'i') ADVANCE(635);
      END_STATE();
    case 1302:
      if (lookahead == 'i') ADVANCE(1430);
      END_STATE();
    case 1303:
      if (lookahead == 'i') ADVANCE(1398);
      END_STATE();
    case 1304:
      if (lookahead == 'i') ADVANCE(1637);
      END_STATE();
    case 1305:
      if (lookahead == 'i') ADVANCE(1616);
      END_STATE();
    case 1306:
      if (lookahead == 'i') ADVANCE(1554);
      END_STATE();
    case 1307:
      if (lookahead == 'i') ADVANCE(1554);
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 1308:
      if (lookahead == 'i') ADVANCE(1145);
      END_STATE();
    case 1309:
      if (lookahead == 'i') ADVANCE(1431);
      END_STATE();
    case 1310:
      if (lookahead == 'i') ADVANCE(859);
      END_STATE();
    case 1311:
      if (lookahead == 'i') ADVANCE(863);
      END_STATE();
    case 1312:
      if (lookahead == 'i') ADVANCE(737);
      END_STATE();
    case 1313:
      if (lookahead == 'i') ADVANCE(1153);
      END_STATE();
    case 1314:
      if (lookahead == 'i') ADVANCE(1154);
      END_STATE();
    case 1315:
      if (lookahead == 'i') ADVANCE(1155);
      END_STATE();
    case 1316:
      if (lookahead == 'i') ADVANCE(1156);
      END_STATE();
    case 1317:
      if (lookahead == 'i') ADVANCE(1158);
      END_STATE();
    case 1318:
      if (lookahead == 'i') ADVANCE(1160);
      END_STATE();
    case 1319:
      if (lookahead == 'i') ADVANCE(1161);
      END_STATE();
    case 1320:
      if (lookahead == 'i') ADVANCE(1163);
      END_STATE();
    case 1321:
      if (lookahead == 'i') ADVANCE(1882);
      END_STATE();
    case 1322:
      if (lookahead == 'i') ADVANCE(703);
      END_STATE();
    case 1323:
      if (lookahead == 'i') ADVANCE(1172);
      END_STATE();
    case 1324:
      if (lookahead == 'i') ADVANCE(705);
      END_STATE();
    case 1325:
      if (lookahead == 'i') ADVANCE(706);
      END_STATE();
    case 1326:
      if (lookahead == 'i') ADVANCE(707);
      END_STATE();
    case 1327:
      if (lookahead == 'i') ADVANCE(708);
      END_STATE();
    case 1328:
      if (lookahead == 'j') ADVANCE(148);
      END_STATE();
    case 1329:
      if (lookahead == 'j') ADVANCE(148);
      if (lookahead == 'n') ADVANCE(1328);
      END_STATE();
    case 1330:
      if (lookahead == 'k') ADVANCE(148);
      END_STATE();
    case 1331:
      if (lookahead == 'k') ADVANCE(507);
      END_STATE();
    case 1332:
      if (lookahead == 'k') ADVANCE(861);
      END_STATE();
    case 1333:
      if (lookahead == 'k') ADVANCE(1435);
      END_STATE();
    case 1334:
      if (lookahead == 'k') ADVANCE(1408);
      END_STATE();
    case 1335:
      if (lookahead == 'k') ADVANCE(296);
      END_STATE();
    case 1336:
      if (lookahead == 'k') ADVANCE(275);
      END_STATE();
    case 1337:
      if (lookahead == 'k') ADVANCE(745);
      END_STATE();
    case 1338:
      if (lookahead == 'k') ADVANCE(745);
      if (lookahead == 'm') ADVANCE(287);
      END_STATE();
    case 1339:
      if (lookahead == 'k') ADVANCE(2121);
      END_STATE();
    case 1340:
      if (lookahead == 'k') ADVANCE(337);
      END_STATE();
    case 1341:
      if (lookahead == 'k') ADVANCE(1930);
      END_STATE();
    case 1342:
      if (lookahead == 'k') ADVANCE(948);
      END_STATE();
    case 1343:
      if (lookahead == 'k') ADVANCE(952);
      END_STATE();
    case 1344:
      if (lookahead == 'k') ADVANCE(662);
      END_STATE();
    case 1345:
      if (lookahead == 'k') ADVANCE(669);
      END_STATE();
    case 1346:
      if (lookahead == 'k') ADVANCE(669);
      if (lookahead == 'l') ADVANCE(600);
      END_STATE();
    case 1347:
      if (lookahead == 'k') ADVANCE(1299);
      END_STATE();
    case 1348:
      if (lookahead == 'l') ADVANCE(872);
      END_STATE();
    case 1349:
      if (lookahead == 'l') ADVANCE(148);
      END_STATE();
    case 1350:
      if (lookahead == 'l') ADVANCE(334);
      END_STATE();
    case 1351:
      if (lookahead == 'l') ADVANCE(486);
      END_STATE();
    case 1352:
      if (lookahead == 'l') ADVANCE(455);
      END_STATE();
    case 1353:
      if (lookahead == 'l') ADVANCE(215);
      END_STATE();
    case 1354:
      if (lookahead == 'l') ADVANCE(281);
      END_STATE();
    case 1355:
      if (lookahead == 'l') ADVANCE(2155);
      END_STATE();
    case 1356:
      if (lookahead == 'l') ADVANCE(419);
      END_STATE();
    case 1357:
      if (lookahead == 'l') ADVANCE(406);
      END_STATE();
    case 1358:
      if (lookahead == 'l') ADVANCE(181);
      END_STATE();
    case 1359:
      if (lookahead == 'l') ADVANCE(524);
      END_STATE();
    case 1360:
      if (lookahead == 'l') ADVANCE(2133);
      END_STATE();
    case 1361:
      if (lookahead == 'l') ADVANCE(1048);
      END_STATE();
    case 1362:
      if (lookahead == 'l') ADVANCE(1048);
      if (lookahead == 'q') ADVANCE(2073);
      END_STATE();
    case 1363:
      if (lookahead == 'l') ADVANCE(1048);
      if (lookahead == 'q') ADVANCE(2072);
      if (lookahead == 'x') ADVANCE(1238);
      END_STATE();
    case 1364:
      if (lookahead == 'l') ADVANCE(471);
      END_STATE();
    case 1365:
      if (lookahead == 'l') ADVANCE(1949);
      END_STATE();
    case 1366:
      if (lookahead == 'l') ADVANCE(186);
      END_STATE();
    case 1367:
      if (lookahead == 'l') ADVANCE(464);
      END_STATE();
    case 1368:
      if (lookahead == 'l') ADVANCE(730);
      END_STATE();
    case 1369:
      if (lookahead == 'l') ADVANCE(427);
      END_STATE();
    case 1370:
      if (lookahead == 'l') ADVANCE(418);
      END_STATE();
    case 1371:
      if (lookahead == 'l') ADVANCE(509);
      END_STATE();
    case 1372:
      if (lookahead == 'l') ADVANCE(538);
      END_STATE();
    case 1373:
      if (lookahead == 'l') ADVANCE(322);
      END_STATE();
    case 1374:
      if (lookahead == 'l') ADVANCE(571);
      END_STATE();
    case 1375:
      if (lookahead == 'l') ADVANCE(246);
      END_STATE();
    case 1376:
      if (lookahead == 'l') ADVANCE(438);
      END_STATE();
    case 1377:
      if (lookahead == 'l') ADVANCE(900);
      END_STATE();
    case 1378:
      if (lookahead == 'l') ADVANCE(449);
      END_STATE();
    case 1379:
      if (lookahead == 'l') ADVANCE(1620);
      END_STATE();
    case 1380:
      if (lookahead == 'l') ADVANCE(1330);
      END_STATE();
    case 1381:
      if (lookahead == 'l') ADVANCE(887);
      END_STATE();
    case 1382:
      if (lookahead == 'l') ADVANCE(887);
      if (lookahead == 'm') ADVANCE(984);
      END_STATE();
    case 1383:
      if (lookahead == 'l') ADVANCE(887);
      if (lookahead == 'm') ADVANCE(1006);
      END_STATE();
    case 1384:
      if (lookahead == 'l') ADVANCE(968);
      END_STATE();
    case 1385:
      if (lookahead == 'l') ADVANCE(1894);
      END_STATE();
    case 1386:
      if (lookahead == 'l') ADVANCE(839);
      END_STATE();
    case 1387:
      if (lookahead == 'l') ADVANCE(1250);
      END_STATE();
    case 1388:
      if (lookahead == 'l') ADVANCE(2132);
      END_STATE();
    case 1389:
      if (lookahead == 'l') ADVANCE(1216);
      END_STATE();
    case 1390:
      if (lookahead == 'l') ADVANCE(987);
      END_STATE();
    case 1391:
      if (lookahead == 'l') ADVANCE(1349);
      END_STATE();
    case 1392:
      if (lookahead == 'l') ADVANCE(2142);
      END_STATE();
    case 1393:
      if (lookahead == 'l') ADVANCE(1629);
      END_STATE();
    case 1394:
      if (lookahead == 'l') ADVANCE(2080);
      END_STATE();
    case 1395:
      if (lookahead == 'l') ADVANCE(1243);
      END_STATE();
    case 1396:
      if (lookahead == 'l') ADVANCE(1375);
      if (lookahead == 'm') ADVANCE(1680);
      END_STATE();
    case 1397:
      if (lookahead == 'l') ADVANCE(1372);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(245);
      if (lookahead == 'u') ADVANCE(735);
      if (lookahead == 'w') ADVANCE(1499);
      END_STATE();
    case 1398:
      if (lookahead == 'l') ADVANCE(917);
      END_STATE();
    case 1399:
      if (lookahead == 'l') ADVANCE(973);
      END_STATE();
    case 1400:
      if (lookahead == 'l') ADVANCE(1359);
      END_STATE();
    case 1401:
      if (lookahead == 'l') ADVANCE(1369);
      END_STATE();
    case 1402:
      if (lookahead == 'l') ADVANCE(988);
      END_STATE();
    case 1403:
      if (lookahead == 'l') ADVANCE(1450);
      if (lookahead == 's') ADVANCE(1185);
      END_STATE();
    case 1404:
      if (lookahead == 'l') ADVANCE(1647);
      END_STATE();
    case 1405:
      if (lookahead == 'l') ADVANCE(1271);
      END_STATE();
    case 1406:
      if (lookahead == 'l') ADVANCE(1242);
      END_STATE();
    case 1407:
      if (lookahead == 'l') ADVANCE(1367);
      END_STATE();
    case 1408:
      if (lookahead == 'l') ADVANCE(1598);
      if (lookahead == 's') ADVANCE(1738);
      if (lookahead == 't') ADVANCE(1893);
      END_STATE();
    case 1409:
      if (lookahead == 'l') ADVANCE(963);
      END_STATE();
    case 1410:
      if (lookahead == 'l') ADVANCE(963);
      if (lookahead == 'q') ADVANCE(1409);
      END_STATE();
    case 1411:
      if (lookahead == 'l') ADVANCE(1284);
      END_STATE();
    case 1412:
      if (lookahead == 'l') ADVANCE(587);
      END_STATE();
    case 1413:
      if (lookahead == 'l') ADVANCE(1371);
      END_STATE();
    case 1414:
      if (lookahead == 'l') ADVANCE(934);
      END_STATE();
    case 1415:
      if (lookahead == 'l') ADVANCE(935);
      END_STATE();
    case 1416:
      if (lookahead == 'l') ADVANCE(1632);
      END_STATE();
    case 1417:
      if (lookahead == 'l') ADVANCE(924);
      END_STATE();
    case 1418:
      if (lookahead == 'l') ADVANCE(1055);
      END_STATE();
    case 1419:
      if (lookahead == 'l') ADVANCE(977);
      if (lookahead == 'r') ADVANCE(1277);
      END_STATE();
    case 1420:
      if (lookahead == 'l') ADVANCE(942);
      END_STATE();
    case 1421:
      if (lookahead == 'l') ADVANCE(943);
      END_STATE();
    case 1422:
      if (lookahead == 'l') ADVANCE(955);
      END_STATE();
    case 1423:
      if (lookahead == 'l') ADVANCE(1075);
      END_STATE();
    case 1424:
      if (lookahead == 'l') ADVANCE(965);
      END_STATE();
    case 1425:
      if (lookahead == 'l') ADVANCE(945);
      END_STATE();
    case 1426:
      if (lookahead == 'l') ADVANCE(946);
      END_STATE();
    case 1427:
      if (lookahead == 'l') ADVANCE(947);
      END_STATE();
    case 1428:
      if (lookahead == 'l') ADVANCE(974);
      END_STATE();
    case 1429:
      if (lookahead == 'l') ADVANCE(600);
      END_STATE();
    case 1430:
      if (lookahead == 'l') ADVANCE(1251);
      END_STATE();
    case 1431:
      if (lookahead == 'l') ADVANCE(894);
      END_STATE();
    case 1432:
      if (lookahead == 'l') ADVANCE(894);
      if (lookahead == 'm') ADVANCE(978);
      if (lookahead == 'n') ADVANCE(1949);
      END_STATE();
    case 1433:
      if (lookahead == 'l') ADVANCE(1622);
      if (lookahead == 'n') ADVANCE(1140);
      if (lookahead == 'p') ADVANCE(1089);
      if (lookahead == 'u') ADVANCE(1561);
      END_STATE();
    case 1434:
      if (lookahead == 'l') ADVANCE(543);
      END_STATE();
    case 1435:
      if (lookahead == 'l') ADVANCE(959);
      if (lookahead == 'r') ADVANCE(1308);
      END_STATE();
    case 1436:
      if (lookahead == 'l') ADVANCE(1040);
      END_STATE();
    case 1437:
      if (lookahead == 'l') ADVANCE(1039);
      END_STATE();
    case 1438:
      if (lookahead == 'l') ADVANCE(655);
      END_STATE();
    case 1439:
      if (lookahead == 'l') ADVANCE(2056);
      END_STATE();
    case 1440:
      if (lookahead == 'l') ADVANCE(1402);
      END_STATE();
    case 1441:
      if (lookahead == 'l') ADVANCE(601);
      END_STATE();
    case 1442:
      if (lookahead == 'l') ADVANCE(1292);
      END_STATE();
    case 1443:
      if (lookahead == 'l') ADVANCE(1627);
      if (lookahead == 'm') ADVANCE(1483);
      if (lookahead == 'n') ADVANCE(1116);
      if (lookahead == 'p') ADVANCE(266);
      END_STATE();
    case 1444:
      if (lookahead == 'l') ADVANCE(1840);
      END_STATE();
    case 1445:
      if (lookahead == 'l') ADVANCE(1226);
      END_STATE();
    case 1446:
      if (lookahead == 'l') ADVANCE(1387);
      END_STATE();
    case 1447:
      if (lookahead == 'l') ADVANCE(1274);
      END_STATE();
    case 1448:
      if (lookahead == 'l') ADVANCE(1390);
      END_STATE();
    case 1449:
      if (lookahead == 'l') ADVANCE(677);
      END_STATE();
    case 1450:
      if (lookahead == 'l') ADVANCE(1946);
      END_STATE();
    case 1451:
      if (lookahead == 'l') ADVANCE(1442);
      END_STATE();
    case 1452:
      if (lookahead == 'l') ADVANCE(1043);
      if (lookahead == 'm') ADVANCE(622);
      if (lookahead == 'r') ADVANCE(1308);
      END_STATE();
    case 1453:
      if (lookahead == 'l') ADVANCE(1070);
      if (lookahead == 'r') ADVANCE(1320);
      END_STATE();
    case 1454:
      if (lookahead == 'm') ADVANCE(148);
      END_STATE();
    case 1455:
      if (lookahead == 'm') ADVANCE(287);
      END_STATE();
    case 1456:
      if (lookahead == 'm') ADVANCE(287);
      if (lookahead == 'r') ADVANCE(1579);
      END_STATE();
    case 1457:
      if (lookahead == 'm') ADVANCE(507);
      END_STATE();
    case 1458:
      if (lookahead == 'm') ADVANCE(308);
      END_STATE();
    case 1459:
      if (lookahead == 'm') ADVANCE(358);
      END_STATE();
    case 1460:
      if (lookahead == 'm') ADVANCE(357);
      END_STATE();
    case 1461:
      if (lookahead == 'm') ADVANCE(524);
      END_STATE();
    case 1462:
      if (lookahead == 'm') ADVANCE(1307);
      END_STATE();
    case 1463:
      if (lookahead == 'm') ADVANCE(1214);
      END_STATE();
    case 1464:
      if (lookahead == 'm') ADVANCE(241);
      END_STATE();
    case 1465:
      if (lookahead == 'm') ADVANCE(1668);
      END_STATE();
    case 1466:
      if (lookahead == 'm') ADVANCE(1698);
      END_STATE();
    case 1467:
      if (lookahead == 'm') ADVANCE(1679);
      END_STATE();
    case 1468:
      if (lookahead == 'm') ADVANCE(1213);
      END_STATE();
    case 1469:
      if (lookahead == 'm') ADVANCE(1213);
      if (lookahead == 'p') ADVANCE(674);
      END_STATE();
    case 1470:
      if (lookahead == 'm') ADVANCE(1461);
      END_STATE();
    case 1471:
      if (lookahead == 'm') ADVANCE(249);
      END_STATE();
    case 1472:
      if (lookahead == 'm') ADVANCE(1702);
      END_STATE();
    case 1473:
      if (lookahead == 'm') ADVANCE(250);
      END_STATE();
    case 1474:
      if (lookahead == 'm') ADVANCE(564);
      END_STATE();
    case 1475:
      if (lookahead == 'm') ADVANCE(987);
      END_STATE();
    case 1476:
      if (lookahead == 'm') ADVANCE(1349);
      END_STATE();
    case 1477:
      if (lookahead == 'm') ADVANCE(1495);
      END_STATE();
    case 1478:
      if (lookahead == 'm') ADVANCE(917);
      END_STATE();
    case 1479:
      if (lookahead == 'm') ADVANCE(1694);
      END_STATE();
    case 1480:
      if (lookahead == 'm') ADVANCE(1689);
      END_STATE();
    case 1481:
      if (lookahead == 'm') ADVANCE(679);
      END_STATE();
    case 1482:
      if (lookahead == 'm') ADVANCE(552);
      END_STATE();
    case 1483:
      if (lookahead == 'm') ADVANCE(559);
      if (lookahead == 'p') ADVANCE(269);
      END_STATE();
    case 1484:
      if (lookahead == 'm') ADVANCE(950);
      END_STATE();
    case 1485:
      if (lookahead == 'm') ADVANCE(950);
      if (lookahead == 'x') ADVANCE(984);
      END_STATE();
    case 1486:
      if (lookahead == 'm') ADVANCE(548);
      END_STATE();
    case 1487:
      if (lookahead == 'm') ADVANCE(532);
      END_STATE();
    case 1488:
      if (lookahead == 'm') ADVANCE(984);
      END_STATE();
    case 1489:
      if (lookahead == 'm') ADVANCE(1710);
      END_STATE();
    case 1490:
      if (lookahead == 'm') ADVANCE(970);
      END_STATE();
    case 1491:
      if (lookahead == 'm') ADVANCE(1482);
      END_STATE();
    case 1492:
      if (lookahead == 'm') ADVANCE(1306);
      END_STATE();
    case 1493:
      if (lookahead == 'm') ADVANCE(673);
      END_STATE();
    case 1494:
      if (lookahead == 'n') ADVANCE(872);
      END_STATE();
    case 1495:
      if (lookahead == 'n') ADVANCE(148);
      END_STATE();
    case 1496:
      if (lookahead == 'n') ADVANCE(271);
      END_STATE();
    case 1497:
      if (lookahead == 'n') ADVANCE(415);
      END_STATE();
    case 1498:
      if (lookahead == 'n') ADVANCE(507);
      END_STATE();
    case 1499:
      if (lookahead == 'n') ADVANCE(687);
      END_STATE();
    case 1500:
      if (lookahead == 'n') ADVANCE(352);
      END_STATE();
    case 1501:
      if (lookahead == 'n') ADVANCE(831);
      END_STATE();
    case 1502:
      if (lookahead == 'n') ADVANCE(2150);
      END_STATE();
    case 1503:
      if (lookahead == 'n') ADVANCE(166);
      END_STATE();
    case 1504:
      if (lookahead == 'n') ADVANCE(514);
      END_STATE();
    case 1505:
      if (lookahead == 'n') ADVANCE(518);
      END_STATE();
    case 1506:
      if (lookahead == 'n') ADVANCE(184);
      END_STATE();
    case 1507:
      if (lookahead == 'n') ADVANCE(1949);
      END_STATE();
    case 1508:
      if (lookahead == 'n') ADVANCE(429);
      END_STATE();
    case 1509:
      if (lookahead == 'n') ADVANCE(480);
      END_STATE();
    case 1510:
      if (lookahead == 'n') ADVANCE(235);
      END_STATE();
    case 1511:
      if (lookahead == 'n') ADVANCE(2126);
      END_STATE();
    case 1512:
      if (lookahead == 'n') ADVANCE(409);
      END_STATE();
    case 1513:
      if (lookahead == 'n') ADVANCE(1109);
      END_STATE();
    case 1514:
      if (lookahead == 'n') ADVANCE(907);
      END_STATE();
    case 1515:
      if (lookahead == 'n') ADVANCE(241);
      END_STATE();
    case 1516:
      if (lookahead == 'n') ADVANCE(1111);
      END_STATE();
    case 1517:
      if (lookahead == 'n') ADVANCE(1111);
      if (lookahead == 'r') ADVANCE(1741);
      END_STATE();
    case 1518:
      if (lookahead == 'n') ADVANCE(2009);
      END_STATE();
    case 1519:
      if (lookahead == 'n') ADVANCE(1117);
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 'w') ADVANCE(1018);
      END_STATE();
    case 1520:
      if (lookahead == 'n') ADVANCE(342);
      END_STATE();
    case 1521:
      if (lookahead == 'n') ADVANCE(1330);
      END_STATE();
    case 1522:
      if (lookahead == 'n') ADVANCE(249);
      END_STATE();
    case 1523:
      if (lookahead == 'n') ADVANCE(1894);
      END_STATE();
    case 1524:
      if (lookahead == 'n') ADVANCE(880);
      END_STATE();
    case 1525:
      if (lookahead == 'n') ADVANCE(244);
      END_STATE();
    case 1526:
      if (lookahead == 'n') ADVANCE(1141);
      if (lookahead == 'r') ADVANCE(998);
      END_STATE();
    case 1527:
      if (lookahead == 'n') ADVANCE(837);
      END_STATE();
    case 1528:
      if (lookahead == 'n') ADVANCE(1157);
      END_STATE();
    case 1529:
      if (lookahead == 'n') ADVANCE(917);
      END_STATE();
    case 1530:
      if (lookahead == 'n') ADVANCE(1115);
      END_STATE();
    case 1531:
      if (lookahead == 'n') ADVANCE(865);
      END_STATE();
    case 1532:
      if (lookahead == 'n') ADVANCE(1625);
      END_STATE();
    case 1533:
      if (lookahead == 'n') ADVANCE(1143);
      END_STATE();
    case 1534:
      if (lookahead == 'n') ADVANCE(890);
      END_STATE();
    case 1535:
      if (lookahead == 'n') ADVANCE(1170);
      END_STATE();
    case 1536:
      if (lookahead == 'n') ADVANCE(948);
      END_STATE();
    case 1537:
      if (lookahead == 'n') ADVANCE(1118);
      END_STATE();
    case 1538:
      if (lookahead == 'n') ADVANCE(860);
      END_STATE();
    case 1539:
      if (lookahead == 'n') ADVANCE(2027);
      END_STATE();
    case 1540:
      if (lookahead == 'n') ADVANCE(1960);
      END_STATE();
    case 1541:
      if (lookahead == 'n') ADVANCE(1974);
      END_STATE();
    case 1542:
      if (lookahead == 'n') ADVANCE(1999);
      END_STATE();
    case 1543:
      if (lookahead == 'n') ADVANCE(2001);
      END_STATE();
    case 1544:
      if (lookahead == 'n') ADVANCE(979);
      END_STATE();
    case 1545:
      if (lookahead == 'n') ADVANCE(982);
      END_STATE();
    case 1546:
      if (lookahead == 'n') ADVANCE(1419);
      END_STATE();
    case 1547:
      if (lookahead == 'n') ADVANCE(2058);
      END_STATE();
    case 1548:
      if (lookahead == 'n') ADVANCE(201);
      END_STATE();
    case 1549:
      if (lookahead == 'n') ADVANCE(1136);
      END_STATE();
    case 1550:
      if (lookahead == 'n') ADVANCE(1139);
      END_STATE();
    case 1551:
      if (lookahead == 'n') ADVANCE(1064);
      END_STATE();
    case 1552:
      if (lookahead == 'n') ADVANCE(1249);
      END_STATE();
    case 1553:
      if (lookahead == 'n') ADVANCE(2017);
      END_STATE();
    case 1554:
      if (lookahead == 'n') ADVANCE(2056);
      END_STATE();
    case 1555:
      if (lookahead == 'n') ADVANCE(1630);
      END_STATE();
    case 1556:
      if (lookahead == 'n') ADVANCE(2018);
      END_STATE();
    case 1557:
      if (lookahead == 'n') ADVANCE(1226);
      END_STATE();
    case 1558:
      if (lookahead == 'n') ADVANCE(2016);
      END_STATE();
    case 1559:
      if (lookahead == 'n') ADVANCE(2036);
      END_STATE();
    case 1560:
      if (lookahead == 'n') ADVANCE(647);
      END_STATE();
    case 1561:
      if (lookahead == 'n') ADVANCE(2028);
      END_STATE();
    case 1562:
      if (lookahead == 'n') ADVANCE(1162);
      END_STATE();
    case 1563:
      if (lookahead == 'n') ADVANCE(2026);
      END_STATE();
    case 1564:
      if (lookahead == 'n') ADVANCE(1305);
      END_STATE();
    case 1565:
      if (lookahead == 'n') ADVANCE(1067);
      END_STATE();
    case 1566:
      if (lookahead == 'n') ADVANCE(1164);
      if (lookahead == 'r') ADVANCE(1844);
      END_STATE();
    case 1567:
      if (lookahead == 'n') ADVANCE(1164);
      if (lookahead == 'r') ADVANCE(1848);
      END_STATE();
    case 1568:
      if (lookahead == 'n') ADVANCE(2030);
      END_STATE();
    case 1569:
      if (lookahead == 'n') ADVANCE(1165);
      END_STATE();
    case 1570:
      if (lookahead == 'n') ADVANCE(1166);
      END_STATE();
    case 1571:
      if (lookahead == 'n') ADVANCE(2032);
      END_STATE();
    case 1572:
      if (lookahead == 'n') ADVANCE(1167);
      END_STATE();
    case 1573:
      if (lookahead == 'n') ADVANCE(1168);
      END_STATE();
    case 1574:
      if (lookahead == 'n') ADVANCE(1169);
      END_STATE();
    case 1575:
      if (lookahead == 'n') ADVANCE(2037);
      END_STATE();
    case 1576:
      if (lookahead == 'n') ADVANCE(696);
      END_STATE();
    case 1577:
      if (lookahead == 'n') ADVANCE(685);
      END_STATE();
    case 1578:
      if (lookahead == 'o') ADVANCE(872);
      END_STATE();
    case 1579:
      if (lookahead == 'o') ADVANCE(148);
      END_STATE();
    case 1580:
      if (lookahead == 'o') ADVANCE(318);
      END_STATE();
    case 1581:
      if (lookahead == 'o') ADVANCE(1087);
      END_STATE();
    case 1582:
      if (lookahead == 'o') ADVANCE(2117);
      END_STATE();
    case 1583:
      if (lookahead == 'o') ADVANCE(519);
      END_STATE();
    case 1584:
      if (lookahead == 'o') ADVANCE(2097);
      END_STATE();
    case 1585:
      if (lookahead == 'o') ADVANCE(238);
      END_STATE();
    case 1586:
      if (lookahead == 'o') ADVANCE(1951);
      END_STATE();
    case 1587:
      if (lookahead == 'o') ADVANCE(1950);
      END_STATE();
    case 1588:
      if (lookahead == 'o') ADVANCE(1741);
      END_STATE();
    case 1589:
      if (lookahead == 'o') ADVANCE(1949);
      END_STATE();
    case 1590:
      if (lookahead == 'o') ADVANCE(1949);
      if (lookahead == 's') ADVANCE(2050);
      END_STATE();
    case 1591:
      if (lookahead == 'o') ADVANCE(298);
      END_STATE();
    case 1592:
      if (lookahead == 'o') ADVANCE(2128);
      END_STATE();
    case 1593:
      if (lookahead == 'o') ADVANCE(820);
      END_STATE();
    case 1594:
      if (lookahead == 'o') ADVANCE(2126);
      END_STATE();
    case 1595:
      if (lookahead == 'o') ADVANCE(1920);
      END_STATE();
    case 1596:
      if (lookahead == 'o') ADVANCE(333);
      END_STATE();
    case 1597:
      if (lookahead == 'o') ADVANCE(2107);
      END_STATE();
    case 1598:
      if (lookahead == 'o') ADVANCE(2146);
      END_STATE();
    case 1599:
      if (lookahead == 'o') ADVANCE(1668);
      END_STATE();
    case 1600:
      if (lookahead == 'o') ADVANCE(1557);
      END_STATE();
    case 1601:
      if (lookahead == 'o') ADVANCE(2108);
      END_STATE();
    case 1602:
      if (lookahead == 'o') ADVANCE(2109);
      END_STATE();
    case 1603:
      if (lookahead == 'o') ADVANCE(1454);
      END_STATE();
    case 1604:
      if (lookahead == 'o') ADVANCE(1330);
      END_STATE();
    case 1605:
      if (lookahead == 'o') ADVANCE(2004);
      END_STATE();
    case 1606:
      if (lookahead == 'o') ADVANCE(2110);
      END_STATE();
    case 1607:
      if (lookahead == 'o') ADVANCE(2122);
      END_STATE();
    case 1608:
      if (lookahead == 'o') ADVANCE(1894);
      END_STATE();
    case 1609:
      if (lookahead == 'o') ADVANCE(1516);
      END_STATE();
    case 1610:
      if (lookahead == 'o') ADVANCE(1516);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 1611:
      if (lookahead == 'o') ADVANCE(2123);
      END_STATE();
    case 1612:
      if (lookahead == 'o') ADVANCE(2116);
      END_STATE();
    case 1613:
      if (lookahead == 'o') ADVANCE(2111);
      END_STATE();
    case 1614:
      if (lookahead == 'o') ADVANCE(1349);
      if (lookahead == 'u') ADVANCE(709);
      END_STATE();
    case 1615:
      if (lookahead == 'o') ADVANCE(895);
      END_STATE();
    case 1616:
      if (lookahead == 'o') ADVANCE(1523);
      END_STATE();
    case 1617:
      if (lookahead == 'o') ADVANCE(2114);
      END_STATE();
    case 1618:
      if (lookahead == 'o') ADVANCE(1955);
      END_STATE();
    case 1619:
      if (lookahead == 'o') ADVANCE(1795);
      END_STATE();
    case 1620:
      if (lookahead == 'o') ADVANCE(1495);
      END_STATE();
    case 1621:
      if (lookahead == 'o') ADVANCE(1495);
      if (lookahead == 'r') ADVANCE(556);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 1622:
      if (lookahead == 'o') ADVANCE(1515);
      END_STATE();
    case 1623:
      if (lookahead == 'o') ADVANCE(1551);
      END_STATE();
    case 1624:
      if (lookahead == 'o') ADVANCE(1506);
      END_STATE();
    case 1625:
      if (lookahead == 'o') ADVANCE(2093);
      END_STATE();
    case 1626:
      if (lookahead == 'o') ADVANCE(1494);
      END_STATE();
    case 1627:
      if (lookahead == 'o') ADVANCE(1522);
      END_STATE();
    case 1628:
      if (lookahead == 'o') ADVANCE(2095);
      END_STATE();
    case 1629:
      if (lookahead == 'o') ADVANCE(1588);
      END_STATE();
    case 1630:
      if (lookahead == 'o') ADVANCE(2041);
      END_STATE();
    case 1631:
      if (lookahead == 'o') ADVANCE(1348);
      END_STATE();
    case 1632:
      if (lookahead == 'o') ADVANCE(819);
      END_STATE();
    case 1633:
      if (lookahead == 'o') ADVANCE(1990);
      END_STATE();
    case 1634:
      if (lookahead == 'o') ADVANCE(1992);
      END_STATE();
    case 1635:
      if (lookahead == 'o') ADVANCE(2034);
      END_STATE();
    case 1636:
      if (lookahead == 'o') ADVANCE(1546);
      END_STATE();
    case 1637:
      if (lookahead == 'o') ADVANCE(1548);
      END_STATE();
    case 1638:
      if (lookahead == 'o') ADVANCE(1514);
      END_STATE();
    case 1639:
      if (lookahead == 'o') ADVANCE(1807);
      if (lookahead == 'r') ADVANCE(1599);
      END_STATE();
    case 1640:
      if (lookahead == 'o') ADVANCE(1832);
      END_STATE();
    case 1641:
      if (lookahead == 'o') ADVANCE(1834);
      if (lookahead == 'r') ADVANCE(1599);
      END_STATE();
    case 1642:
      if (lookahead == 'o') ADVANCE(1758);
      END_STATE();
    case 1643:
      if (lookahead == 'o') ADVANCE(2118);
      END_STATE();
    case 1644:
      if (lookahead == 'o') ADVANCE(1470);
      END_STATE();
    case 1645:
      if (lookahead == 'o') ADVANCE(1470);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 1646:
      if (lookahead == 'o') ADVANCE(1813);
      END_STATE();
    case 1647:
      if (lookahead == 'o') ADVANCE(1697);
      END_STATE();
    case 1648:
      if (lookahead == 'o') ADVANCE(1708);
      END_STATE();
    case 1649:
      if (lookahead == 'o') ADVANCE(2077);
      END_STATE();
    case 1650:
      if (lookahead == 'o') ADVANCE(2124);
      END_STATE();
    case 1651:
      if (lookahead == 'o') ADVANCE(2119);
      END_STATE();
    case 1652:
      if (lookahead == 'o') ADVANCE(2083);
      END_STATE();
    case 1653:
      if (lookahead == 'o') ADVANCE(1998);
      END_STATE();
    case 1654:
      if (lookahead == 'o') ADVANCE(1550);
      if (lookahead == 'u') ADVANCE(1688);
      END_STATE();
    case 1655:
      if (lookahead == 'o') ADVANCE(2120);
      END_STATE();
    case 1656:
      if (lookahead == 'o') ADVANCE(1563);
      END_STATE();
    case 1657:
      if (lookahead == 'o') ADVANCE(1828);
      END_STATE();
    case 1658:
      if (lookahead == 'o') ADVANCE(1636);
      END_STATE();
    case 1659:
      if (lookahead == 'o') ADVANCE(1809);
      END_STATE();
    case 1660:
      if (lookahead == 'o') ADVANCE(1542);
      END_STATE();
    case 1661:
      if (lookahead == 'o') ADVANCE(1616);
      END_STATE();
    case 1662:
      if (lookahead == 'o') ADVANCE(1638);
      END_STATE();
    case 1663:
      if (lookahead == 'o') ADVANCE(1874);
      END_STATE();
    case 1664:
      if (lookahead == 'o') ADVANCE(1445);
      END_STATE();
    case 1665:
      if (lookahead == 'o') ADVANCE(2098);
      END_STATE();
    case 1666:
      if (lookahead == 'o') ADVANCE(2125);
      END_STATE();
    case 1667:
      if (lookahead == 'p') ADVANCE(1945);
      END_STATE();
    case 1668:
      if (lookahead == 'p') ADVANCE(148);
      END_STATE();
    case 1669:
      if (lookahead == 'p') ADVANCE(148);
      if (lookahead == 'r') ADVANCE(1620);
      END_STATE();
    case 1670:
      if (lookahead == 'p') ADVANCE(1177);
      END_STATE();
    case 1671:
      if (lookahead == 'p') ADVANCE(1087);
      END_STATE();
    case 1672:
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 'r') ADVANCE(666);
      END_STATE();
    case 1673:
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 'r') ADVANCE(407);
      if (lookahead == 'u') ADVANCE(1825);
      END_STATE();
    case 1674:
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 'r') ADVANCE(1219);
      END_STATE();
    case 1675:
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(161);
      if (lookahead == 'u') ADVANCE(734);
      if (lookahead == 'w') ADVANCE(1497);
      END_STATE();
    case 1676:
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 't') ADVANCE(341);
      if (lookahead == 'w') ADVANCE(2010);
      if (lookahead == 'x') ADVANCE(442);
      END_STATE();
    case 1677:
      if (lookahead == 'p') ADVANCE(1087);
      if (lookahead == 'u') ADVANCE(1524);
      END_STATE();
    case 1678:
      if (lookahead == 'p') ADVANCE(160);
      END_STATE();
    case 1679:
      if (lookahead == 'p') ADVANCE(451);
      END_STATE();
    case 1680:
      if (lookahead == 'p') ADVANCE(167);
      END_STATE();
    case 1681:
      if (lookahead == 'p') ADVANCE(141);
      END_STATE();
    case 1682:
      if (lookahead == 'p') ADVANCE(452);
      END_STATE();
    case 1683:
      if (lookahead == 'p') ADVANCE(410);
      END_STATE();
    case 1684:
      if (lookahead == 'p') ADVANCE(1741);
      if (lookahead == 's') ADVANCE(753);
      END_STATE();
    case 1685:
      if (lookahead == 'p') ADVANCE(524);
      END_STATE();
    case 1686:
      if (lookahead == 'p') ADVANCE(312);
      END_STATE();
    case 1687:
      if (lookahead == 'p') ADVANCE(409);
      END_STATE();
    case 1688:
      if (lookahead == 'p') ADVANCE(425);
      END_STATE();
    case 1689:
      if (lookahead == 'p') ADVANCE(241);
      END_STATE();
    case 1690:
      if (lookahead == 'p') ADVANCE(322);
      END_STATE();
    case 1691:
      if (lookahead == 'p') ADVANCE(1174);
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 1692:
      if (lookahead == 'p') ADVANCE(1685);
      END_STATE();
    case 1693:
      if (lookahead == 'p') ADVANCE(1894);
      if (lookahead == 'r') ADVANCE(1620);
      END_STATE();
    case 1694:
      if (lookahead == 'p') ADVANCE(250);
      END_STATE();
    case 1695:
      if (lookahead == 'p') ADVANCE(1360);
      END_STATE();
    case 1696:
      if (lookahead == 'p') ADVANCE(1705);
      END_STATE();
    case 1697:
      if (lookahead == 'p') ADVANCE(917);
      END_STATE();
    case 1698:
      if (lookahead == 'p') ADVANCE(964);
      END_STATE();
    case 1699:
      if (lookahead == 'p') ADVANCE(1439);
      END_STATE();
    case 1700:
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 't') ADVANCE(1776);
      END_STATE();
    case 1701:
      if (lookahead == 'p') ADVANCE(1917);
      END_STATE();
    case 1702:
      if (lookahead == 'p') ADVANCE(1989);
      END_STATE();
    case 1703:
      if (lookahead == 'p') ADVANCE(1715);
      END_STATE();
    case 1704:
      if (lookahead == 'p') ADVANCE(1715);
      if (lookahead == 'r') ADVANCE(1741);
      END_STATE();
    case 1705:
      if (lookahead == 'p') ADVANCE(544);
      END_STATE();
    case 1706:
      if (lookahead == 'p') ADVANCE(1658);
      END_STATE();
    case 1707:
      if (lookahead == 'p') ADVANCE(1441);
      END_STATE();
    case 1708:
      if (lookahead == 'p') ADVANCE(1980);
      END_STATE();
    case 1709:
      if (lookahead == 'p') ADVANCE(1608);
      END_STATE();
    case 1710:
      if (lookahead == 'p') ADVANCE(1405);
      END_STATE();
    case 1711:
      if (lookahead == 'p') ADVANCE(663);
      END_STATE();
    case 1712:
      if (lookahead == 'p') ADVANCE(1935);
      END_STATE();
    case 1713:
      if (lookahead == 'p') ADVANCE(1840);
      if (lookahead == 's') ADVANCE(2068);
      END_STATE();
    case 1714:
      if (lookahead == 'p') ADVANCE(1417);
      END_STATE();
    case 1715:
      if (lookahead == 'p') ADVANCE(1820);
      END_STATE();
    case 1716:
      if (lookahead == 'p') ADVANCE(645);
      END_STATE();
    case 1717:
      if (lookahead == 'p') ADVANCE(694);
      END_STATE();
    case 1718:
      if (lookahead == 'p') ADVANCE(463);
      END_STATE();
    case 1719:
      if (lookahead == 'p') ADVANCE(1662);
      END_STATE();
    case 1720:
      if (lookahead == 'p') ADVANCE(678);
      END_STATE();
    case 1721:
      if (lookahead == 'p') ADVANCE(1661);
      END_STATE();
    case 1722:
      if (lookahead == 'p') ADVANCE(696);
      END_STATE();
    case 1723:
      if (lookahead == 'q') ADVANCE(148);
      END_STATE();
    case 1724:
      if (lookahead == 'q') ADVANCE(233);
      END_STATE();
    case 1725:
      if (lookahead == 'q') ADVANCE(1410);
      END_STATE();
    case 1726:
      if (lookahead == 'q') ADVANCE(1148);
      END_STATE();
    case 1727:
      if (lookahead == 'q') ADVANCE(1713);
      END_STATE();
    case 1728:
      if (lookahead == 'q') ADVANCE(313);
      END_STATE();
    case 1729:
      if (lookahead == 'q') ADVANCE(1723);
      END_STATE();
    case 1730:
      if (lookahead == 'q') ADVANCE(2044);
      END_STATE();
    case 1731:
      if (lookahead == 'q') ADVANCE(2063);
      END_STATE();
    case 1732:
      if (lookahead == 'q') ADVANCE(2096);
      if (lookahead == 'u') ADVANCE(732);
      END_STATE();
    case 1733:
      if (lookahead == 'q') ADVANCE(2084);
      END_STATE();
    case 1734:
      if (lookahead == 'q') ADVANCE(2073);
      END_STATE();
    case 1735:
      if (lookahead == 'q') ADVANCE(838);
      if (lookahead == 't') ADVANCE(538);
      END_STATE();
    case 1736:
      if (lookahead == 'q') ADVANCE(2087);
      END_STATE();
    case 1737:
      if (lookahead == 'q') ADVANCE(2091);
      END_STATE();
    case 1738:
      if (lookahead == 'q') ADVANCE(2094);
      END_STATE();
    case 1739:
      if (lookahead == 'r') ADVANCE(872);
      END_STATE();
    case 1740:
      if (lookahead == 'r') ADVANCE(926);
      END_STATE();
    case 1741:
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 1742:
      if (lookahead == 'r') ADVANCE(432);
      END_STATE();
    case 1743:
      if (lookahead == 'r') ADVANCE(297);
      END_STATE();
    case 1744:
      if (lookahead == 'r') ADVANCE(1087);
      END_STATE();
    case 1745:
      if (lookahead == 'r') ADVANCE(350);
      END_STATE();
    case 1746:
      if (lookahead == 'r') ADVANCE(310);
      END_STATE();
    case 1747:
      if (lookahead == 'r') ADVANCE(194);
      END_STATE();
    case 1748:
      if (lookahead == 'r') ADVANCE(796);
      END_STATE();
    case 1749:
      if (lookahead == 'r') ADVANCE(416);
      END_STATE();
    case 1750:
      if (lookahead == 'r') ADVANCE(2159);
      END_STATE();
    case 1751:
      if (lookahead == 'r') ADVANCE(265);
      END_STATE();
    case 1752:
      if (lookahead == 'r') ADVANCE(218);
      END_STATE();
    case 1753:
      if (lookahead == 'r') ADVANCE(1187);
      END_STATE();
    case 1754:
      if (lookahead == 'r') ADVANCE(195);
      END_STATE();
    case 1755:
      if (lookahead == 'r') ADVANCE(489);
      END_STATE();
    case 1756:
      if (lookahead == 'r') ADVANCE(356);
      END_STATE();
    case 1757:
      if (lookahead == 'r') ADVANCE(2164);
      END_STATE();
    case 1758:
      if (lookahead == 'r') ADVANCE(153);
      END_STATE();
    case 1759:
      if (lookahead == 'r') ADVANCE(171);
      END_STATE();
    case 1760:
      if (lookahead == 'r') ADVANCE(1741);
      END_STATE();
    case 1761:
      if (lookahead == 'r') ADVANCE(303);
      END_STATE();
    case 1762:
      if (lookahead == 'r') ADVANCE(471);
      END_STATE();
    case 1763:
      if (lookahead == 'r') ADVANCE(746);
      END_STATE();
    case 1764:
      if (lookahead == 'r') ADVANCE(345);
      END_STATE();
    case 1765:
      if (lookahead == 'r') ADVANCE(273);
      END_STATE();
    case 1766:
      if (lookahead == 'r') ADVANCE(1949);
      END_STATE();
    case 1767:
      if (lookahead == 'r') ADVANCE(1949);
      if (lookahead == 'u') ADVANCE(680);
      END_STATE();
    case 1768:
      if (lookahead == 'r') ADVANCE(235);
      END_STATE();
    case 1769:
      if (lookahead == 'r') ADVANCE(899);
      END_STATE();
    case 1770:
      if (lookahead == 'r') ADVANCE(212);
      END_STATE();
    case 1771:
      if (lookahead == 'r') ADVANCE(221);
      END_STATE();
    case 1772:
      if (lookahead == 'r') ADVANCE(208);
      END_STATE();
    case 1773:
      if (lookahead == 'r') ADVANCE(483);
      END_STATE();
    case 1774:
      if (lookahead == 'r') ADVANCE(745);
      END_STATE();
    case 1775:
      if (lookahead == 'r') ADVANCE(575);
      END_STATE();
    case 1776:
      if (lookahead == 'r') ADVANCE(1214);
      END_STATE();
    case 1777:
      if (lookahead == 'r') ADVANCE(305);
      END_STATE();
    case 1778:
      if (lookahead == 'r') ADVANCE(289);
      END_STATE();
    case 1779:
      if (lookahead == 'r') ADVANCE(294);
      END_STATE();
    case 1780:
      if (lookahead == 'r') ADVANCE(875);
      END_STATE();
    case 1781:
      if (lookahead == 'r') ADVANCE(867);
      END_STATE();
    case 1782:
      if (lookahead == 'r') ADVANCE(1579);
      END_STATE();
    case 1783:
      if (lookahead == 'r') ADVANCE(299);
      END_STATE();
    case 1784:
      if (lookahead == 'r') ADVANCE(1340);
      END_STATE();
    case 1785:
      if (lookahead == 'r') ADVANCE(328);
      END_STATE();
    case 1786:
      if (lookahead == 'r') ADVANCE(428);
      END_STATE();
    case 1787:
      if (lookahead == 'r') ADVANCE(338);
      END_STATE();
    case 1788:
      if (lookahead == 'r') ADVANCE(857);
      END_STATE();
    case 1789:
      if (lookahead == 'r') ADVANCE(1668);
      END_STATE();
    case 1790:
      if (lookahead == 'r') ADVANCE(994);
      END_STATE();
    case 1791:
      if (lookahead == 'r') ADVANCE(2009);
      END_STATE();
    case 1792:
      if (lookahead == 'r') ADVANCE(302);
      END_STATE();
    case 1793:
      if (lookahead == 'r') ADVANCE(529);
      END_STATE();
    case 1794:
      if (lookahead == 'r') ADVANCE(1620);
      END_STATE();
    case 1795:
      if (lookahead == 'r') ADVANCE(1330);
      END_STATE();
    case 1796:
      if (lookahead == 'r') ADVANCE(2136);
      END_STATE();
    case 1797:
      if (lookahead == 'r') ADVANCE(2138);
      END_STATE();
    case 1798:
      if (lookahead == 'r') ADVANCE(1583);
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 1799:
      if (lookahead == 'r') ADVANCE(1894);
      END_STATE();
    case 1800:
      if (lookahead == 'r') ADVANCE(987);
      END_STATE();
    case 1801:
      if (lookahead == 'r') ADVANCE(1578);
      END_STATE();
    case 1802:
      if (lookahead == 'r') ADVANCE(556);
      END_STATE();
    case 1803:
      if (lookahead == 'r') ADVANCE(2115);
      END_STATE();
    case 1804:
      if (lookahead == 'r') ADVANCE(2137);
      END_STATE();
    case 1805:
      if (lookahead == 'r') ADVANCE(1045);
      END_STATE();
    case 1806:
      if (lookahead == 'r') ADVANCE(1186);
      END_STATE();
    case 1807:
      if (lookahead == 'r') ADVANCE(1495);
      END_STATE();
    case 1808:
      if (lookahead == 'r') ADVANCE(753);
      END_STATE();
    case 1809:
      if (lookahead == 'r') ADVANCE(917);
      END_STATE();
    case 1810:
      if (lookahead == 'r') ADVANCE(1599);
      END_STATE();
    case 1811:
      if (lookahead == 'r') ADVANCE(1291);
      END_STATE();
    case 1812:
      if (lookahead == 'r') ADVANCE(1604);
      END_STATE();
    case 1813:
      if (lookahead == 'r') ADVANCE(1957);
      END_STATE();
    case 1814:
      if (lookahead == 'r') ADVANCE(1592);
      END_STATE();
    case 1815:
      if (lookahead == 'r') ADVANCE(1914);
      END_STATE();
    case 1816:
      if (lookahead == 'r') ADVANCE(826);
      END_STATE();
    case 1817:
      if (lookahead == 'r') ADVANCE(1597);
      END_STATE();
    case 1818:
      if (lookahead == 'r') ADVANCE(1750);
      END_STATE();
    case 1819:
      if (lookahead == 'r') ADVANCE(591);
      END_STATE();
    case 1820:
      if (lookahead == 'r') ADVANCE(1594);
      END_STATE();
    case 1821:
      if (lookahead == 'r') ADVANCE(2027);
      END_STATE();
    case 1822:
      if (lookahead == 'r') ADVANCE(1706);
      END_STATE();
    case 1823:
      if (lookahead == 'r') ADVANCE(2020);
      END_STATE();
    case 1824:
      if (lookahead == 'r') ADVANCE(1936);
      END_STATE();
    case 1825:
      if (lookahead == 'r') ADVANCE(1300);
      END_STATE();
    case 1826:
      if (lookahead == 'r') ADVANCE(1944);
      END_STATE();
    case 1827:
      if (lookahead == 'r') ADVANCE(969);
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 1828:
      if (lookahead == 'r') ADVANCE(1973);
      END_STATE();
    case 1829:
      if (lookahead == 'r') ADVANCE(594);
      END_STATE();
    case 1830:
      if (lookahead == 'r') ADVANCE(1262);
      END_STATE();
    case 1831:
      if (lookahead == 'r') ADVANCE(1601);
      END_STATE();
    case 1832:
      if (lookahead == 'r') ADVANCE(1536);
      END_STATE();
    case 1833:
      if (lookahead == 'r') ADVANCE(1922);
      END_STATE();
    case 1834:
      if (lookahead == 'r') ADVANCE(1525);
      END_STATE();
    case 1835:
      if (lookahead == 'r') ADVANCE(1240);
      END_STATE();
    case 1836:
      if (lookahead == 'r') ADVANCE(1564);
      END_STATE();
    case 1837:
      if (lookahead == 'r') ADVANCE(1388);
      END_STATE();
    case 1838:
      if (lookahead == 'r') ADVANCE(1297);
      END_STATE();
    case 1839:
      if (lookahead == 'r') ADVANCE(1392);
      END_STATE();
    case 1840:
      if (lookahead == 'r') ADVANCE(992);
      END_STATE();
    case 1841:
      if (lookahead == 'r') ADVANCE(1602);
      END_STATE();
    case 1842:
      if (lookahead == 'r') ADVANCE(1953);
      END_STATE();
    case 1843:
      if (lookahead == 'r') ADVANCE(933);
      if (lookahead == 't') ADVANCE(555);
      END_STATE();
    case 1844:
      if (lookahead == 'r') ADVANCE(1606);
      END_STATE();
    case 1845:
      if (lookahead == 'r') ADVANCE(1607);
      END_STATE();
    case 1846:
      if (lookahead == 'r') ADVANCE(1611);
      END_STATE();
    case 1847:
      if (lookahead == 'r') ADVANCE(1612);
      END_STATE();
    case 1848:
      if (lookahead == 'r') ADVANCE(1613);
      END_STATE();
    case 1849:
      if (lookahead == 'r') ADVANCE(1085);
      END_STATE();
    case 1850:
      if (lookahead == 'r') ADVANCE(936);
      END_STATE();
    case 1851:
      if (lookahead == 'r') ADVANCE(1617);
      END_STATE();
    case 1852:
      if (lookahead == 'r') ADVANCE(1756);
      END_STATE();
    case 1853:
      if (lookahead == 'r') ADVANCE(1041);
      END_STATE();
    case 1854:
      if (lookahead == 'r') ADVANCE(1746);
      END_STATE();
    case 1855:
      if (lookahead == 'r') ADVANCE(1779);
      END_STATE();
    case 1856:
      if (lookahead == 'r') ADVANCE(1060);
      END_STATE();
    case 1857:
      if (lookahead == 'r') ADVANCE(962);
      END_STATE();
    case 1858:
      if (lookahead == 'r') ADVANCE(684);
      END_STATE();
    case 1859:
      if (lookahead == 'r') ADVANCE(599);
      END_STATE();
    case 1860:
      if (lookahead == 'r') ADVANCE(644);
      END_STATE();
    case 1861:
      if (lookahead == 'r') ADVANCE(1272);
      END_STATE();
    case 1862:
      if (lookahead == 'r') ADVANCE(1937);
      END_STATE();
    case 1863:
      if (lookahead == 'r') ADVANCE(838);
      END_STATE();
    case 1864:
      if (lookahead == 'r') ADVANCE(2017);
      END_STATE();
    case 1865:
      if (lookahead == 'r') ADVANCE(1008);
      END_STATE();
    case 1866:
      if (lookahead == 'r') ADVANCE(1138);
      if (lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 1867:
      if (lookahead == 'r') ADVANCE(2000);
      END_STATE();
    case 1868:
      if (lookahead == 'r') ADVANCE(2062);
      END_STATE();
    case 1869:
      if (lookahead == 'r') ADVANCE(1939);
      END_STATE();
    case 1870:
      if (lookahead == 'r') ADVANCE(1015);
      END_STATE();
    case 1871:
      if (lookahead == 'r') ADVANCE(1032);
      END_STATE();
    case 1872:
      if (lookahead == 'r') ADVANCE(1817);
      END_STATE();
    case 1873:
      if (lookahead == 'r') ADVANCE(623);
      END_STATE();
    case 1874:
      if (lookahead == 'r') ADVANCE(2015);
      END_STATE();
    case 1875:
      if (lookahead == 'r') ADVANCE(1831);
      END_STATE();
    case 1876:
      if (lookahead == 'r') ADVANCE(1841);
      END_STATE();
    case 1877:
      if (lookahead == 'r') ADVANCE(1845);
      END_STATE();
    case 1878:
      if (lookahead == 'r') ADVANCE(1846);
      END_STATE();
    case 1879:
      if (lookahead == 'r') ADVANCE(1847);
      END_STATE();
    case 1880:
      if (lookahead == 'r') ADVANCE(1851);
      END_STATE();
    case 1881:
      if (lookahead == 'r') ADVANCE(1050);
      END_STATE();
    case 1882:
      if (lookahead == 'r') ADVANCE(862);
      END_STATE();
    case 1883:
      if (lookahead == 'r') ADVANCE(1073);
      END_STATE();
    case 1884:
      if (lookahead == 'r') ADVANCE(466);
      END_STATE();
    case 1885:
      if (lookahead == 'r') ADVANCE(1719);
      END_STATE();
    case 1886:
      if (lookahead == 'r') ADVANCE(2038);
      END_STATE();
    case 1887:
      if (lookahead == 'r') ADVANCE(1721);
      END_STATE();
    case 1888:
      if (lookahead == 'r') ADVANCE(1082);
      END_STATE();
    case 1889:
      if (lookahead == 'r') ADVANCE(1083);
      END_STATE();
    case 1890:
      if (lookahead == 'r') ADVANCE(1084);
      END_STATE();
    case 1891:
      if (lookahead == 'r') ADVANCE(1324);
      END_STATE();
    case 1892:
      if (lookahead == 'r') ADVANCE(1326);
      END_STATE();
    case 1893:
      if (lookahead == 'r') ADVANCE(1327);
      END_STATE();
    case 1894:
      if (lookahead == 's') ADVANCE(148);
      END_STATE();
    case 1895:
      if (lookahead == 's') ADVANCE(1042);
      END_STATE();
    case 1896:
      if (lookahead == 's') ADVANCE(310);
      if (lookahead == 'u') ADVANCE(1480);
      END_STATE();
    case 1897:
      if (lookahead == 's') ADVANCE(465);
      END_STATE();
    case 1898:
      if (lookahead == 's') ADVANCE(491);
      END_STATE();
    case 1899:
      if (lookahead == 's') ADVANCE(196);
      END_STATE();
    case 1900:
      if (lookahead == 's') ADVANCE(344);
      END_STATE();
    case 1901:
      if (lookahead == 's') ADVANCE(214);
      END_STATE();
    case 1902:
      if (lookahead == 's') ADVANCE(173);
      END_STATE();
    case 1903:
      if (lookahead == 's') ADVANCE(175);
      END_STATE();
    case 1904:
      if (lookahead == 's') ADVANCE(174);
      END_STATE();
    case 1905:
      if (lookahead == 's') ADVANCE(1949);
      END_STATE();
    case 1906:
      if (lookahead == 's') ADVANCE(485);
      END_STATE();
    case 1907:
      if (lookahead == 's') ADVANCE(1614);
      END_STATE();
    case 1908:
      if (lookahead == 's') ADVANCE(275);
      END_STATE();
    case 1909:
      if (lookahead == 's') ADVANCE(1214);
      END_STATE();
    case 1910:
      if (lookahead == 's') ADVANCE(499);
      END_STATE();
    case 1911:
      if (lookahead == 's') ADVANCE(333);
      END_STATE();
    case 1912:
      if (lookahead == 's') ADVANCE(241);
      END_STATE();
    case 1913:
      if (lookahead == 's') ADVANCE(199);
      END_STATE();
    case 1914:
      if (lookahead == 's') ADVANCE(1668);
      END_STATE();
    case 1915:
      if (lookahead == 's') ADVANCE(1174);
      END_STATE();
    case 1916:
      if (lookahead == 's') ADVANCE(2139);
      END_STATE();
    case 1917:
      if (lookahead == 's') ADVANCE(327);
      END_STATE();
    case 1918:
      if (lookahead == 's') ADVANCE(1175);
      END_STATE();
    case 1919:
      if (lookahead == 's') ADVANCE(1179);
      END_STATE();
    case 1920:
      if (lookahead == 's') ADVANCE(1894);
      END_STATE();
    case 1921:
      if (lookahead == 's') ADVANCE(1250);
      END_STATE();
    case 1922:
      if (lookahead == 's') ADVANCE(1349);
      END_STATE();
    case 1923:
      if (lookahead == 's') ADVANCE(2043);
      END_STATE();
    case 1924:
      if (lookahead == 's') ADVANCE(885);
      END_STATE();
    case 1925:
      if (lookahead == 's') ADVANCE(917);
      END_STATE();
    case 1926:
      if (lookahead == 's') ADVANCE(964);
      END_STATE();
    case 1927:
      if (lookahead == 's') ADVANCE(2092);
      END_STATE();
    case 1928:
      if (lookahead == 's') ADVANCE(2048);
      END_STATE();
    case 1929:
      if (lookahead == 's') ADVANCE(1994);
      END_STATE();
    case 1930:
      if (lookahead == 's') ADVANCE(1374);
      END_STATE();
    case 1931:
      if (lookahead == 's') ADVANCE(1906);
      END_STATE();
    case 1932:
      if (lookahead == 's') ADVANCE(1983);
      END_STATE();
    case 1933:
      if (lookahead == 's') ADVANCE(1987);
      END_STATE();
    case 1934:
      if (lookahead == 's') ADVANCE(1312);
      END_STATE();
    case 1935:
      if (lookahead == 's') ADVANCE(1980);
      END_STATE();
    case 1936:
      if (lookahead == 's') ADVANCE(1002);
      END_STATE();
    case 1937:
      if (lookahead == 's') ADVANCE(940);
      END_STATE();
    case 1938:
      if (lookahead == 's') ADVANCE(976);
      END_STATE();
    case 1939:
      if (lookahead == 's') ADVANCE(961);
      END_STATE();
    case 1940:
      if (lookahead == 's') ADVANCE(1184);
      END_STATE();
    case 1941:
      if (lookahead == 's') ADVANCE(2050);
      END_STATE();
    case 1942:
      if (lookahead == 's') ADVANCE(2005);
      END_STATE();
    case 1943:
      if (lookahead == 's') ADVANCE(1993);
      END_STATE();
    case 1944:
      if (lookahead == 's') ADVANCE(1007);
      END_STATE();
    case 1945:
      if (lookahead == 's') ADVANCE(1259);
      END_STATE();
    case 1946:
      if (lookahead == 's') ADVANCE(1022);
      END_STATE();
    case 1947:
      if (lookahead == 's') ADVANCE(1078);
      END_STATE();
    case 1948:
      if (lookahead == 't') ADVANCE(2129);
      END_STATE();
    case 1949:
      if (lookahead == 't') ADVANCE(148);
      END_STATE();
    case 1950:
      if (lookahead == 't') ADVANCE(148);
      if (lookahead == 'u') ADVANCE(742);
      END_STATE();
    case 1951:
      if (lookahead == 't') ADVANCE(148);
      if (lookahead == 'w') ADVANCE(1512);
      END_STATE();
    case 1952:
      if (lookahead == 't') ADVANCE(389);
      END_STATE();
    case 1953:
      if (lookahead == 't') ADVANCE(507);
      END_STATE();
    case 1954:
      if (lookahead == 't') ADVANCE(692);
      END_STATE();
    case 1955:
      if (lookahead == 't') ADVANCE(355);
      END_STATE();
    case 1956:
      if (lookahead == 't') ADVANCE(408);
      END_STATE();
    case 1957:
      if (lookahead == 't') ADVANCE(448);
      END_STATE();
    case 1958:
      if (lookahead == 't') ADVANCE(691);
      END_STATE();
    case 1959:
      if (lookahead == 't') ADVANCE(256);
      END_STATE();
    case 1960:
      if (lookahead == 't') ADVANCE(1147);
      END_STATE();
    case 1961:
      if (lookahead == 't') ADVANCE(503);
      END_STATE();
    case 1962:
      if (lookahead == 't') ADVANCE(514);
      END_STATE();
    case 1963:
      if (lookahead == 't') ADVANCE(411);
      END_STATE();
    case 1964:
      if (lookahead == 't') ADVANCE(414);
      END_STATE();
    case 1965:
      if (lookahead == 't') ADVANCE(518);
      END_STATE();
    case 1966:
      if (lookahead == 't') ADVANCE(699);
      END_STATE();
    case 1967:
      if (lookahead == 't') ADVANCE(412);
      END_STATE();
    case 1968:
      if (lookahead == 't') ADVANCE(413);
      END_STATE();
    case 1969:
      if (lookahead == 't') ADVANCE(1741);
      END_STATE();
    case 1970:
      if (lookahead == 't') ADVANCE(524);
      END_STATE();
    case 1971:
      if (lookahead == 't') ADVANCE(999);
      END_STATE();
    case 1972:
      if (lookahead == 't') ADVANCE(170);
      END_STATE();
    case 1973:
      if (lookahead == 't') ADVANCE(1469);
      END_STATE();
    case 1974:
      if (lookahead == 't') ADVANCE(464);
      END_STATE();
    case 1975:
      if (lookahead == 't') ADVANCE(745);
      END_STATE();
    case 1976:
      if (lookahead == 't') ADVANCE(2130);
      END_STATE();
    case 1977:
      if (lookahead == 't') ADVANCE(247);
      if (lookahead == 'v') ADVANCE(1286);
      END_STATE();
    case 1978:
      if (lookahead == 't') ADVANCE(347);
      END_STATE();
    case 1979:
      if (lookahead == 't') ADVANCE(688);
      END_STATE();
    case 1980:
      if (lookahead == 't') ADVANCE(1579);
      END_STATE();
    case 1981:
      if (lookahead == 't') ADVANCE(409);
      END_STATE();
    case 1982:
      if (lookahead == 't') ADVANCE(1026);
      END_STATE();
    case 1983:
      if (lookahead == 't') ADVANCE(206);
      END_STATE();
    case 1984:
      if (lookahead == 't') ADVANCE(2134);
      END_STATE();
    case 1985:
      if (lookahead == 't') ADVANCE(241);
      END_STATE();
    case 1986:
      if (lookahead == 't') ADVANCE(515);
      END_STATE();
    case 1987:
      if (lookahead == 't') ADVANCE(322);
      END_STATE();
    case 1988:
      if (lookahead == 't') ADVANCE(1174);
      END_STATE();
    case 1989:
      if (lookahead == 't') ADVANCE(2135);
      END_STATE();
    case 1990:
      if (lookahead == 't') ADVANCE(301);
      END_STATE();
    case 1991:
      if (lookahead == 't') ADVANCE(1179);
      END_STATE();
    case 1992:
      if (lookahead == 't') ADVANCE(300);
      END_STATE();
    case 1993:
      if (lookahead == 't') ADVANCE(1894);
      END_STATE();
    case 1994:
      if (lookahead == 't') ADVANCE(250);
      END_STATE();
    case 1995:
      if (lookahead == 't') ADVANCE(255);
      END_STATE();
    case 1996:
      if (lookahead == 't') ADVANCE(1176);
      END_STATE();
    case 1997:
      if (lookahead == 't') ADVANCE(1477);
      END_STATE();
    case 1998:
      if (lookahead == 't') ADVANCE(917);
      END_STATE();
    case 1999:
      if (lookahead == 't') ADVANCE(1649);
      END_STATE();
    case 2000:
      if (lookahead == 't') ADVANCE(1900);
      END_STATE();
    case 2001:
      if (lookahead == 't') ADVANCE(1204);
      END_STATE();
    case 2002:
      if (lookahead == 't') ADVANCE(1492);
      END_STATE();
    case 2003:
      if (lookahead == 't') ADVANCE(948);
      END_STATE();
    case 2004:
      if (lookahead == 't') ADVANCE(1926);
      END_STATE();
    case 2005:
      if (lookahead == 't') ADVANCE(990);
      END_STATE();
    case 2006:
      if (lookahead == 't') ADVANCE(1588);
      END_STATE();
    case 2007:
      if (lookahead == 't') ADVANCE(1776);
      END_STATE();
    case 2008:
      if (lookahead == 't') ADVANCE(625);
      END_STATE();
    case 2009:
      if (lookahead == 't') ADVANCE(1285);
      END_STATE();
    case 2010:
      if (lookahead == 't') ADVANCE(1262);
      END_STATE();
    case 2011:
      if (lookahead == 't') ADVANCE(1296);
      END_STATE();
    case 2012:
      if (lookahead == 't') ADVANCE(1585);
      END_STATE();
    case 2013:
      if (lookahead == 't') ADVANCE(1287);
      END_STATE();
    case 2014:
      if (lookahead == 't') ADVANCE(1310);
      END_STATE();
    case 2015:
      if (lookahead == 't') ADVANCE(1304);
      END_STATE();
    case 2016:
      if (lookahead == 't') ADVANCE(1264);
      END_STATE();
    case 2017:
      if (lookahead == 't') ADVANCE(1744);
      END_STATE();
    case 2018:
      if (lookahead == 't') ADVANCE(1076);
      END_STATE();
    case 2019:
      if (lookahead == 't') ADVANCE(697);
      END_STATE();
    case 2020:
      if (lookahead == 't') ADVANCE(1544);
      END_STATE();
    case 2021:
      if (lookahead == 't') ADVANCE(1249);
      END_STATE();
    case 2022:
      if (lookahead == 't') ADVANCE(1642);
      END_STATE();
    case 2023:
      if (lookahead == 't') ADVANCE(1545);
      END_STATE();
    case 2024:
      if (lookahead == 't') ADVANCE(1829);
      END_STATE();
    case 2025:
      if (lookahead == 't') ADVANCE(1025);
      END_STATE();
    case 2026:
      if (lookahead == 't') ADVANCE(633);
      END_STATE();
    case 2027:
      if (lookahead == 't') ADVANCE(1226);
      END_STATE();
    case 2028:
      if (lookahead == 't') ADVANCE(1027);
      END_STATE();
    case 2029:
      if (lookahead == 't') ADVANCE(1029);
      END_STATE();
    case 2030:
      if (lookahead == 't') ADVANCE(1031);
      END_STATE();
    case 2031:
      if (lookahead == 't') ADVANCE(1034);
      END_STATE();
    case 2032:
      if (lookahead == 't') ADVANCE(1052);
      END_STATE();
    case 2033:
      if (lookahead == 't') ADVANCE(1036);
      END_STATE();
    case 2034:
      if (lookahead == 't') ADVANCE(1205);
      END_STATE();
    case 2035:
      if (lookahead == 't') ADVANCE(676);
      END_STATE();
    case 2036:
      if (lookahead == 't') ADVANCE(1295);
      END_STATE();
    case 2037:
      if (lookahead == 't') ADVANCE(1301);
      END_STATE();
    case 2038:
      if (lookahead == 't') ADVANCE(1311);
      END_STATE();
    case 2039:
      if (lookahead == 't') ADVANCE(696);
      END_STATE();
    case 2040:
      if (lookahead == 't') ADVANCE(685);
      END_STATE();
    case 2041:
      if (lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 2042:
      if (lookahead == 'u') ADVANCE(613);
      END_STATE();
    case 2043:
      if (lookahead == 'u') ADVANCE(2153);
      END_STATE();
    case 2044:
      if (lookahead == 'u') ADVANCE(1579);
      END_STATE();
    case 2045:
      if (lookahead == 'u') ADVANCE(299);
      END_STATE();
    case 2046:
      if (lookahead == 'u') ADVANCE(715);
      END_STATE();
    case 2047:
      if (lookahead == 'u') ADVANCE(728);
      END_STATE();
    case 2048:
      if (lookahead == 'u') ADVANCE(726);
      END_STATE();
    case 2049:
      if (lookahead == 'u') ADVANCE(1668);
      END_STATE();
    case 2050:
      if (lookahead == 'u') ADVANCE(709);
      END_STATE();
    case 2051:
      if (lookahead == 'u') ADVANCE(1898);
      END_STATE();
    case 2052:
      if (lookahead == 'u') ADVANCE(733);
      END_STATE();
    case 2053:
      if (lookahead == 'u') ADVANCE(1985);
      END_STATE();
    case 2054:
      if (lookahead == 'u') ADVANCE(1985);
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 2055:
      if (lookahead == 'u') ADVANCE(1454);
      END_STATE();
    case 2056:
      if (lookahead == 'u') ADVANCE(1894);
      END_STATE();
    case 2057:
      if (lookahead == 'u') ADVANCE(1000);
      END_STATE();
    case 2058:
      if (lookahead == 'u') ADVANCE(1910);
      END_STATE();
    case 2059:
      if (lookahead == 'u') ADVANCE(917);
      END_STATE();
    case 2060:
      if (lookahead == 'u') ADVANCE(1457);
      END_STATE();
    case 2061:
      if (lookahead == 'u') ADVANCE(798);
      END_STATE();
    case 2062:
      if (lookahead == 'u') ADVANCE(950);
      END_STATE();
    case 2063:
      if (lookahead == 'u') ADVANCE(591);
      END_STATE();
    case 2064:
      if (lookahead == 'u') ADVANCE(1901);
      END_STATE();
    case 2065:
      if (lookahead == 'u') ADVANCE(1580);
      END_STATE();
    case 2066:
      if (lookahead == 'u') ADVANCE(1365);
      END_STATE();
    case 2067:
      if (lookahead == 'u') ADVANCE(1925);
      END_STATE();
    case 2068:
      if (lookahead == 'u') ADVANCE(832);
      END_STATE();
    case 2069:
      if (lookahead == 'u') ADVANCE(1912);
      END_STATE();
    case 2070:
      if (lookahead == 'u') ADVANCE(1233);
      END_STATE();
    case 2071:
      if (lookahead == 'u') ADVANCE(985);
      END_STATE();
    case 2072:
      if (lookahead == 'u') ADVANCE(612);
      END_STATE();
    case 2073:
      if (lookahead == 'u') ADVANCE(1298);
      END_STATE();
    case 2074:
      if (lookahead == 'u') ADVANCE(1232);
      END_STATE();
    case 2075:
      if (lookahead == 'u') ADVANCE(1772);
      END_STATE();
    case 2076:
      if (lookahead == 'u') ADVANCE(1744);
      END_STATE();
    case 2077:
      if (lookahead == 'u') ADVANCE(1773);
      END_STATE();
    case 2078:
      if (lookahead == 'u') ADVANCE(1837);
      END_STATE();
    case 2079:
      if (lookahead == 'u') ADVANCE(1839);
      END_STATE();
    case 2080:
      if (lookahead == 'u') ADVANCE(1184);
      END_STATE();
    case 2081:
      if (lookahead == 'u') ADVANCE(1467);
      END_STATE();
    case 2082:
      if (lookahead == 'u') ADVANCE(1538);
      END_STATE();
    case 2083:
      if (lookahead == 'u') ADVANCE(1932);
      END_STATE();
    case 2084:
      if (lookahead == 'u') ADVANCE(1267);
      END_STATE();
    case 2085:
      if (lookahead == 'u') ADVANCE(1391);
      END_STATE();
    case 2086:
      if (lookahead == 'u') ADVANCE(1998);
      END_STATE();
    case 2087:
      if (lookahead == 'u') ADVANCE(632);
      END_STATE();
    case 2088:
      if (lookahead == 'u') ADVANCE(1407);
      END_STATE();
    case 2089:
      if (lookahead == 'u') ADVANCE(1653);
      END_STATE();
    case 2090:
      if (lookahead == 'u') ADVANCE(1465);
      END_STATE();
    case 2091:
      if (lookahead == 'u') ADVANCE(638);
      END_STATE();
    case 2092:
      if (lookahead == 'u') ADVANCE(1853);
      END_STATE();
    case 2093:
      if (lookahead == 'u') ADVANCE(1446);
      END_STATE();
    case 2094:
      if (lookahead == 'u') ADVANCE(681);
      END_STATE();
    case 2095:
      if (lookahead == 'u') ADVANCE(739);
      END_STATE();
    case 2096:
      if (lookahead == 'u') ADVANCE(683);
      END_STATE();
    case 2097:
      if (lookahead == 'u') ADVANCE(738);
      if (lookahead == 'w') ADVANCE(1504);
      END_STATE();
    case 2098:
      if (lookahead == 'u') ADVANCE(741);
      END_STATE();
    case 2099:
      if (lookahead == 'v') ADVANCE(148);
      END_STATE();
    case 2100:
      if (lookahead == 'v') ADVANCE(148);
      if (lookahead == 'w') ADVANCE(916);
      END_STATE();
    case 2101:
      if (lookahead == 'v') ADVANCE(162);
      END_STATE();
    case 2102:
      if (lookahead == 'v') ADVANCE(241);
      END_STATE();
    case 2103:
      if (lookahead == 'v') ADVANCE(994);
      if (lookahead == 'w') ADVANCE(993);
      END_STATE();
    case 2104:
      if (lookahead == 'v') ADVANCE(917);
      END_STATE();
    case 2105:
      if (lookahead == 'v') ADVANCE(941);
      END_STATE();
    case 2106:
      if (lookahead == 'v') ADVANCE(1080);
      END_STATE();
    case 2107:
      if (lookahead == 'w') ADVANCE(148);
      END_STATE();
    case 2108:
      if (lookahead == 'w') ADVANCE(154);
      END_STATE();
    case 2109:
      if (lookahead == 'w') ADVANCE(158);
      END_STATE();
    case 2110:
      if (lookahead == 'w') ADVANCE(157);
      END_STATE();
    case 2111:
      if (lookahead == 'w') ADVANCE(156);
      END_STATE();
    case 2112:
      if (lookahead == 'w') ADVANCE(1579);
      END_STATE();
    case 2113:
      if (lookahead == 'w') ADVANCE(538);
      END_STATE();
    case 2114:
      if (lookahead == 'w') ADVANCE(322);
      END_STATE();
    case 2115:
      if (lookahead == 'w') ADVANCE(957);
      END_STATE();
    case 2116:
      if (lookahead == 'w') ADVANCE(1894);
      END_STATE();
    case 2117:
      if (lookahead == 'w') ADVANCE(1495);
      END_STATE();
    case 2118:
      if (lookahead == 'w') ADVANCE(1512);
      END_STATE();
    case 2119:
      if (lookahead == 'w') ADVANCE(1509);
      END_STATE();
    case 2120:
      if (lookahead == 'w') ADVANCE(1505);
      END_STATE();
    case 2121:
      if (lookahead == 'w') ADVANCE(1293);
      END_STATE();
    case 2122:
      if (lookahead == 'w') ADVANCE(340);
      END_STATE();
    case 2123:
      if (lookahead == 'w') ADVANCE(1419);
      END_STATE();
    case 2124:
      if (lookahead == 'w') ADVANCE(1577);
      END_STATE();
    case 2125:
      if (lookahead == 'w') ADVANCE(1576);
      END_STATE();
    case 2126:
      if (lookahead == 'x') ADVANCE(148);
      END_STATE();
    case 2127:
      if (lookahead == 'x') ADVANCE(1949);
      END_STATE();
    case 2128:
      if (lookahead == 'x') ADVANCE(250);
      END_STATE();
    case 2129:
      if (lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 2130:
      if (lookahead == 'y') ADVANCE(506);
      END_STATE();
    case 2131:
      if (lookahead == 'y') ADVANCE(975);
      END_STATE();
    case 2132:
      if (lookahead == 'y') ADVANCE(453);
      END_STATE();
    case 2133:
      if (lookahead == 'y') ADVANCE(468);
      END_STATE();
    case 2134:
      if (lookahead == 'y') ADVANCE(330);
      END_STATE();
    case 2135:
      if (lookahead == 'y') ADVANCE(2099);
      END_STATE();
    case 2136:
      if (lookahead == 'y') ADVANCE(505);
      END_STATE();
    case 2137:
      if (lookahead == 'y') ADVANCE(512);
      END_STATE();
    case 2138:
      if (lookahead == 'y') ADVANCE(481);
      END_STATE();
    case 2139:
      if (lookahead == 'y') ADVANCE(1454);
      END_STATE();
    case 2140:
      if (lookahead == 'y') ADVANCE(916);
      END_STATE();
    case 2141:
      if (lookahead == 'y') ADVANCE(1894);
      END_STATE();
    case 2142:
      if (lookahead == 'y') ADVANCE(964);
      END_STATE();
    case 2143:
      if (lookahead == 'z') ADVANCE(1656);
      END_STATE();
    case 2144:
      if (lookahead == 'z') ADVANCE(569);
      END_STATE();
    case 2145:
      if (lookahead == 'z') ADVANCE(1272);
      END_STATE();
    case 2146:
      if (lookahead == 'z') ADVANCE(1003);
      END_STATE();
    case 2147:
      if (lookahead == '2' ||
          lookahead == '4') ADVANCE(148);
      END_STATE();
    case 2148:
      if (lookahead == '3' ||
          lookahead == '5') ADVANCE(148);
      END_STATE();
    case 2149:
      if (lookahead == '6' ||
          lookahead == '8') ADVANCE(148);
      END_STATE();
    case 2150:
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 2151:
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(2171);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(373);
      END_STATE();
    case 2152:
      if (lookahead == 'a' ||
          lookahead == 'h') ADVANCE(148);
      if (lookahead == 'w') ADVANCE(1045);
      END_STATE();
    case 2153:
      if (lookahead == 'b' ||
          lookahead == 'p') ADVANCE(148);
      END_STATE();
    case 2154:
      if (lookahead == 'b' ||
          lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 2155:
      if (lookahead == 'd' ||
          lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 2156:
      if (lookahead == 'e' ||
          lookahead == 'k') ADVANCE(148);
      END_STATE();
    case 2157:
      if (lookahead == 'e' ||
          lookahead == 't') ADVANCE(148);
      END_STATE();
    case 2158:
      if (lookahead == 'f' ||
          lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 2159:
      if (lookahead == 'l' ||
          lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 2160:
      if (lookahead == 'o' ||
          lookahead == 'u') ADVANCE(148);
      END_STATE();
    case 2161:
      if (lookahead == 'r' ||
          lookahead == 'y') ADVANCE(148);
      END_STATE();
    case 2162:
      if (lookahead == '3' ||
          lookahead == '4') ADVANCE(148);
      END_STATE();
    case 2163:
      if (lookahead == 'R' ||
          lookahead == 'S') ADVANCE(148);
      if (lookahead == 'a') ADVANCE(1905);
      if (lookahead == 'c') ADVANCE(1280);
      if (lookahead == 'd') ADVANCE(571);
      END_STATE();
    case 2164:
      if (lookahead == 'e' ||
          lookahead == 'f') ADVANCE(148);
      END_STATE();
    case 2165:
      if (lookahead == '4' ||
          lookahead == '5' ||
          lookahead == '8') ADVANCE(148);
      if (lookahead == ';') ADVANCE(2180);
      END_STATE();
    case 2166:
      if (('a' <= lookahead && lookahead <= 'c')) ADVANCE(148);
      END_STATE();
    case 2167:
      if (lookahead == 'L' ||
          lookahead == 'R' ||
          lookahead == 'l' ||
          lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 2168:
      if (('1' <= lookahead && lookahead <= '3') ||
          lookahead == 'E') ADVANCE(148);
      if (lookahead == ';') ADVANCE(2180);
      if (lookahead == 'd') ADVANCE(1590);
      if (lookahead == 'e') ADVANCE(233);
      if (lookahead == 'h') ADVANCE(1907);
      if (lookahead == 'l') ADVANCE(575);
      if (lookahead == 'm') ADVANCE(2066);
      if (lookahead == 'n') ADVANCE(2150);
      if (lookahead == 'p') ADVANCE(1439);
      if (lookahead == 's') ADVANCE(1017);
      END_STATE();
    case 2169:
      if (('2' <= lookahead && lookahead <= '6') ||
          lookahead == '8') ADVANCE(148);
      if (lookahead == ';') ADVANCE(2180);
      END_STATE();
    case 2170:
      if (('a' <= lookahead && lookahead <= 'h')) ADVANCE(148);
      END_STATE();
    case 2171:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(378);
      END_STATE();
    case 2172:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(15);
      END_STATE();
    case 2173:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(138);
      END_STATE();
    case 2174:
      if (eof) ADVANCE(2178);
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2195);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2201);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2186);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2211);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 2175:
      if (eof) ADVANCE(2178);
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2195);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2186);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2208);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2211);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 2176:
      if (eof) ADVANCE(2178);
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2195);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2186);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2211);
      if (lookahead == ']') ADVANCE(2184);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 2177:
      if (eof) ADVANCE(2178);
      if (lookahead == '\t') ADVANCE(2237);
      if (lookahead == '\n') ADVANCE(2221);
      if (lookahead == '\r') ADVANCE(2222);
      if (lookahead == ' ') ADVANCE(2239);
      if (lookahead == '!') ADVANCE(2189);
      if (lookahead == '"') ADVANCE(2190);
      if (lookahead == '#') ADVANCE(2191);
      if (lookahead == '$') ADVANCE(2192);
      if (lookahead == '%') ADVANCE(2193);
      if (lookahead == '&') ADVANCE(2195);
      if (lookahead == '\'') ADVANCE(2196);
      if (lookahead == '(') ADVANCE(2219);
      if (lookahead == ')') ADVANCE(2220);
      if (lookahead == '*') ADVANCE(2197);
      if (lookahead == '+') ADVANCE(2198);
      if (lookahead == ',') ADVANCE(2199);
      if (lookahead == '-') ADVANCE(2200);
      if (lookahead == '.') ADVANCE(2202);
      if (lookahead == '/') ADVANCE(2203);
      if (lookahead == ':') ADVANCE(2204);
      if (lookahead == ';') ADVANCE(2205);
      if (lookahead == '<') ADVANCE(2186);
      if (lookahead == '=') ADVANCE(2206);
      if (lookahead == '>') ADVANCE(2188);
      if (lookahead == '?') ADVANCE(2207);
      if (lookahead == '@') ADVANCE(2209);
      if (lookahead == '[') ADVANCE(2182);
      if (lookahead == '\\') ADVANCE(2211);
      if (lookahead == ']') ADVANCE(2183);
      if (lookahead == '^') ADVANCE(2212);
      if (lookahead == '_') ADVANCE(2213);
      if (lookahead == '`') ADVANCE(2214);
      if (lookahead == '{') ADVANCE(2215);
      if (lookahead == '|') ADVANCE(2216);
      if (lookahead == '}') ADVANCE(2217);
      if (lookahead == '~') ADVANCE(2218);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      if (lookahead != 0) ADVANCE(2240);
      END_STATE();
    case 2178:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2179:
      ACCEPT_TOKEN(sym__backslash_escape);
      END_STATE();
    case 2180:
      ACCEPT_TOKEN(sym_entity_reference);
      END_STATE();
    case 2181:
      ACCEPT_TOKEN(sym_numeric_character_reference);
      END_STATE();
    case 2182:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 2183:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 2184:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']') ADVANCE(380);
      END_STATE();
    case 2185:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 2186:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '!') ADVANCE(13);
      if (lookahead == '?') ADVANCE(2231);
      if (('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          lookahead == '=' ||
          ('^' <= lookahead && lookahead <= '`') ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(383);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(382);
      END_STATE();
    case 2187:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '!') ADVANCE(16);
      if (lookahead == '?') ADVANCE(2230);
      END_STATE();
    case 2188:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 2189:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 2190:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 2191:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 2192:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 2193:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 2194:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 2195:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '#') ADVANCE(2151);
      if (lookahead == 'A') ADVANCE(454);
      if (lookahead == 'B') ADVANCE(523);
      if (lookahead == 'C') ADVANCE(477);
      if (lookahead == 'D') ADVANCE(437);
      if (lookahead == 'E') ADVANCE(493);
      if (lookahead == 'F') ADVANCE(748);
      if (lookahead == 'G') ADVANCE(180);
      if (lookahead == 'H') ADVANCE(384);
      if (lookahead == 'I') ADVANCE(460);
      if (lookahead == 'J') ADVANCE(850);
      if (lookahead == 'K') ADVANCE(476);
      if (lookahead == 'L') ADVANCE(179);
      if (lookahead == 'M') ADVANCE(565);
      if (lookahead == 'N') ADVANCE(484);
      if (lookahead == 'O') ADVANCE(462);
      if (lookahead == 'P') ADVANCE(561);
      if (lookahead == 'Q') ADVANCE(516);
      if (lookahead == 'R') ADVANCE(417);
      if (lookahead == 'S') ADVANCE(473);
      if (lookahead == 'T') ADVANCE(474);
      if (lookahead == 'U') ADVANCE(542);
      if (lookahead == 'V') ADVANCE(446);
      if (lookahead == 'W') ADVANCE(802);
      if (lookahead == 'X') ADVANCE(1090);
      if (lookahead == 'Y') ADVANCE(387);
      if (lookahead == 'Z') ADVANCE(478);
      if (lookahead == 'a') ADVANCE(521);
      if (lookahead == 'b') ADVANCE(492);
      if (lookahead == 'c') ADVANCE(528);
      if (lookahead == 'd') ADVANCE(393);
      if (lookahead == 'e') ADVANCE(439);
      if (lookahead == 'f') ADVANCE(570);
      if (lookahead == 'g') ADVANCE(169);
      if (lookahead == 'h') ADVANCE(395);
      if (lookahead == 'i') ADVANCE(522);
      if (lookahead == 'j') ADVANCE(849);
      if (lookahead == 'k') ADVANCE(654);
      if (lookahead == 'l') ADVANCE(149);
      if (lookahead == 'm') ADVANCE(440);
      if (lookahead == 'n') ADVANCE(470);
      if (lookahead == 'o') ADVANCE(504);
      if (lookahead == 'p') ADVANCE(592);
      if (lookahead == 'q') ADVANCE(1091);
      if (lookahead == 'r') ADVANCE(385);
      if (lookahead == 's') ADVANCE(649);
      if (lookahead == 't') ADVANCE(545);
      if (lookahead == 'u') ADVANCE(394);
      if (lookahead == 'v') ADVANCE(391);
      if (lookahead == 'w') ADVANCE(801);
      if (lookahead == 'x') ADVANCE(757);
      if (lookahead == 'y') ADVANCE(560);
      if (lookahead == 'z') ADVANCE(650);
      END_STATE();
    case 2196:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 2197:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 2198:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 2199:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 2200:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 2201:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(379);
      END_STATE();
    case 2202:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 2203:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 2204:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 2205:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 2206:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 2207:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 2208:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '>') ADVANCE(2232);
      END_STATE();
    case 2209:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 2210:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      END_STATE();
    case 2211:
      ACCEPT_TOKEN(anon_sym_BSLASH);
      if (('!' <= lookahead && lookahead <= '/') ||
          (':' <= lookahead && lookahead <= '@') ||
          ('[' <= lookahead && lookahead <= '`') ||
          ('{' <= lookahead && lookahead <= '~')) ADVANCE(2179);
      END_STATE();
    case 2212:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 2213:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2214:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 2215:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 2216:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 2217:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 2218:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 2219:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 2220:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 2221:
      ACCEPT_TOKEN(sym__newline_token);
      END_STATE();
    case 2222:
      ACCEPT_TOKEN(sym__newline_token);
      if (lookahead == '\n') ADVANCE(2221);
      END_STATE();
    case 2223:
      ACCEPT_TOKEN(sym_uri_autolink);
      END_STATE();
    case 2224:
      ACCEPT_TOKEN(sym_email_autolink);
      END_STATE();
    case 2225:
      ACCEPT_TOKEN(sym__attribute_name);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= ':') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(2225);
      END_STATE();
    case 2226:
      ACCEPT_TOKEN(aux_sym__attribute_value_token1);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '"' &&
          lookahead != '\'' &&
          (lookahead < '<' || '>' < lookahead) &&
          lookahead != '`') ADVANCE(2226);
      END_STATE();
    case 2227:
      ACCEPT_TOKEN(anon_sym_LT_BANG_DASH_DASH);
      END_STATE();
    case 2228:
      ACCEPT_TOKEN(anon_sym_LT_BANG_DASH_DASH);
      if (lookahead == '@') ADVANCE(2172);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          lookahead == '=' ||
          ('?' <= lookahead && lookahead <= 'Z') ||
          ('^' <= lookahead && lookahead <= '~')) ADVANCE(383);
      END_STATE();
    case 2229:
      ACCEPT_TOKEN(anon_sym_DASH_DASH_GT);
      END_STATE();
    case 2230:
      ACCEPT_TOKEN(anon_sym_LT_QMARK);
      END_STATE();
    case 2231:
      ACCEPT_TOKEN(anon_sym_LT_QMARK);
      if (lookahead == '@') ADVANCE(2172);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          lookahead == '=' ||
          ('?' <= lookahead && lookahead <= 'Z') ||
          ('^' <= lookahead && lookahead <= '~')) ADVANCE(383);
      END_STATE();
    case 2232:
      ACCEPT_TOKEN(anon_sym_QMARK_GT);
      END_STATE();
    case 2233:
      ACCEPT_TOKEN(aux_sym__declaration_token1);
      if (lookahead == '@') ADVANCE(2172);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(2233);
      if (lookahead == '!' ||
          ('#' <= lookahead && lookahead <= '\'') ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('-' <= lookahead && lookahead <= '9') ||
          lookahead == '=' ||
          lookahead == '?' ||
          ('^' <= lookahead && lookahead <= '~')) ADVANCE(383);
      END_STATE();
    case 2234:
      ACCEPT_TOKEN(aux_sym__declaration_token1);
      if (('A' <= lookahead && lookahead <= 'Z')) ADVANCE(2234);
      END_STATE();
    case 2235:
      ACCEPT_TOKEN(anon_sym_LT_BANG_LBRACKCDATA_LBRACK);
      END_STATE();
    case 2236:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK_GT);
      END_STATE();
    case 2237:
      ACCEPT_TOKEN(sym__whitespace_ge_2);
      END_STATE();
    case 2238:
      ACCEPT_TOKEN(sym__whitespace_ge_2);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(2238);
      END_STATE();
    case 2239:
      ACCEPT_TOKEN(aux_sym__whitespace_token1);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(2238);
      END_STATE();
    case 2240:
      ACCEPT_TOKEN(sym__word_no_digit);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '@' < lookahead) &&
          (lookahead < '[' || '`' < lookahead) &&
          (lookahead < '{' || '~' < lookahead)) ADVANCE(2240);
      END_STATE();
    case 2241:
      ACCEPT_TOKEN(sym__digits);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(2241);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 2177, .external_lex_state = 2},
  [2] = {.lex_state = 2177, .external_lex_state = 3},
  [3] = {.lex_state = 2177, .external_lex_state = 4},
  [4] = {.lex_state = 2177, .external_lex_state = 4},
  [5] = {.lex_state = 2177, .external_lex_state = 5},
  [6] = {.lex_state = 2177, .external_lex_state = 4},
  [7] = {.lex_state = 2177, .external_lex_state = 5},
  [8] = {.lex_state = 2177, .external_lex_state = 6},
  [9] = {.lex_state = 2177, .external_lex_state = 3},
  [10] = {.lex_state = 2177, .external_lex_state = 6},
  [11] = {.lex_state = 2177, .external_lex_state = 7},
  [12] = {.lex_state = 2177, .external_lex_state = 4},
  [13] = {.lex_state = 2177, .external_lex_state = 7},
  [14] = {.lex_state = 2177, .external_lex_state = 8},
  [15] = {.lex_state = 2177, .external_lex_state = 9},
  [16] = {.lex_state = 2177, .external_lex_state = 7},
  [17] = {.lex_state = 2177, .external_lex_state = 10},
  [18] = {.lex_state = 2177, .external_lex_state = 8},
  [19] = {.lex_state = 2177, .external_lex_state = 8},
  [20] = {.lex_state = 2177, .external_lex_state = 7},
  [21] = {.lex_state = 2177, .external_lex_state = 8},
  [22] = {.lex_state = 2177, .external_lex_state = 9},
  [23] = {.lex_state = 2177, .external_lex_state = 7},
  [24] = {.lex_state = 2177, .external_lex_state = 7},
  [25] = {.lex_state = 2177, .external_lex_state = 7},
  [26] = {.lex_state = 2177, .external_lex_state = 9},
  [27] = {.lex_state = 2177, .external_lex_state = 9},
  [28] = {.lex_state = 2177, .external_lex_state = 9},
  [29] = {.lex_state = 2177, .external_lex_state = 7},
  [30] = {.lex_state = 2177, .external_lex_state = 8},
  [31] = {.lex_state = 2177, .external_lex_state = 7},
  [32] = {.lex_state = 2177, .external_lex_state = 8},
  [33] = {.lex_state = 2177, .external_lex_state = 9},
  [34] = {.lex_state = 2177, .external_lex_state = 10},
  [35] = {.lex_state = 2177, .external_lex_state = 9},
  [36] = {.lex_state = 2177, .external_lex_state = 8},
  [37] = {.lex_state = 2177, .external_lex_state = 9},
  [38] = {.lex_state = 2177, .external_lex_state = 9},
  [39] = {.lex_state = 2177, .external_lex_state = 4},
  [40] = {.lex_state = 2177, .external_lex_state = 8},
  [41] = {.lex_state = 2177, .external_lex_state = 9},
  [42] = {.lex_state = 2177, .external_lex_state = 7},
  [43] = {.lex_state = 2177, .external_lex_state = 7},
  [44] = {.lex_state = 2177, .external_lex_state = 8},
  [45] = {.lex_state = 2177, .external_lex_state = 4},
  [46] = {.lex_state = 2177, .external_lex_state = 4},
  [47] = {.lex_state = 2177, .external_lex_state = 8},
  [48] = {.lex_state = 2177, .external_lex_state = 10},
  [49] = {.lex_state = 2177, .external_lex_state = 4},
  [50] = {.lex_state = 2177, .external_lex_state = 8},
  [51] = {.lex_state = 2177, .external_lex_state = 4},
  [52] = {.lex_state = 2177, .external_lex_state = 9},
  [53] = {.lex_state = 2177, .external_lex_state = 10},
  [54] = {.lex_state = 2177, .external_lex_state = 10},
  [55] = {.lex_state = 2177, .external_lex_state = 10},
  [56] = {.lex_state = 2177, .external_lex_state = 10},
  [57] = {.lex_state = 2177, .external_lex_state = 10},
  [58] = {.lex_state = 2177, .external_lex_state = 10},
  [59] = {.lex_state = 2177, .external_lex_state = 10},
  [60] = {.lex_state = 2177, .external_lex_state = 10},
  [61] = {.lex_state = 2177, .external_lex_state = 10},
  [62] = {.lex_state = 2177, .external_lex_state = 10},
  [63] = {.lex_state = 2177, .external_lex_state = 10},
  [64] = {.lex_state = 2177, .external_lex_state = 10},
  [65] = {.lex_state = 2177, .external_lex_state = 10},
  [66] = {.lex_state = 2177, .external_lex_state = 10},
  [67] = {.lex_state = 2177, .external_lex_state = 10},
  [68] = {.lex_state = 2177, .external_lex_state = 10},
  [69] = {.lex_state = 2177, .external_lex_state = 10},
  [70] = {.lex_state = 2177, .external_lex_state = 10},
  [71] = {.lex_state = 2177, .external_lex_state = 10},
  [72] = {.lex_state = 2177, .external_lex_state = 10},
  [73] = {.lex_state = 2177, .external_lex_state = 10},
  [74] = {.lex_state = 2177, .external_lex_state = 10},
  [75] = {.lex_state = 2177, .external_lex_state = 10},
  [76] = {.lex_state = 2177, .external_lex_state = 10},
  [77] = {.lex_state = 2177, .external_lex_state = 10},
  [78] = {.lex_state = 2177, .external_lex_state = 10},
  [79] = {.lex_state = 2177, .external_lex_state = 10},
  [80] = {.lex_state = 2177, .external_lex_state = 10},
  [81] = {.lex_state = 2177, .external_lex_state = 10},
  [82] = {.lex_state = 2177, .external_lex_state = 10},
  [83] = {.lex_state = 2177, .external_lex_state = 10},
  [84] = {.lex_state = 2177, .external_lex_state = 10},
  [85] = {.lex_state = 2177, .external_lex_state = 10},
  [86] = {.lex_state = 2177, .external_lex_state = 4},
  [87] = {.lex_state = 2177, .external_lex_state = 3},
  [88] = {.lex_state = 2177, .external_lex_state = 6},
  [89] = {.lex_state = 2177, .external_lex_state = 5},
  [90] = {.lex_state = 2177, .external_lex_state = 4},
  [91] = {.lex_state = 2177, .external_lex_state = 6},
  [92] = {.lex_state = 2177, .external_lex_state = 6},
  [93] = {.lex_state = 2177, .external_lex_state = 3},
  [94] = {.lex_state = 2177, .external_lex_state = 3},
  [95] = {.lex_state = 2177, .external_lex_state = 5},
  [96] = {.lex_state = 2177, .external_lex_state = 5},
  [97] = {.lex_state = 2177, .external_lex_state = 4},
  [98] = {.lex_state = 2177, .external_lex_state = 4},
  [99] = {.lex_state = 2177, .external_lex_state = 4},
  [100] = {.lex_state = 2177, .external_lex_state = 10},
  [101] = {.lex_state = 2177, .external_lex_state = 9},
  [102] = {.lex_state = 2177, .external_lex_state = 10},
  [103] = {.lex_state = 2177, .external_lex_state = 10},
  [104] = {.lex_state = 2177, .external_lex_state = 8},
  [105] = {.lex_state = 2177, .external_lex_state = 7},
  [106] = {.lex_state = 2177, .external_lex_state = 9},
  [107] = {.lex_state = 2177, .external_lex_state = 7},
  [108] = {.lex_state = 2177, .external_lex_state = 7},
  [109] = {.lex_state = 2177, .external_lex_state = 9},
  [110] = {.lex_state = 2177, .external_lex_state = 8},
  [111] = {.lex_state = 2177, .external_lex_state = 8},
  [112] = {.lex_state = 2177, .external_lex_state = 4},
  [113] = {.lex_state = 2177, .external_lex_state = 9},
  [114] = {.lex_state = 2177, .external_lex_state = 7},
  [115] = {.lex_state = 2177, .external_lex_state = 8},
  [116] = {.lex_state = 2177, .external_lex_state = 7},
  [117] = {.lex_state = 2177, .external_lex_state = 7},
  [118] = {.lex_state = 2177, .external_lex_state = 8},
  [119] = {.lex_state = 2177, .external_lex_state = 7},
  [120] = {.lex_state = 2177, .external_lex_state = 4},
  [121] = {.lex_state = 2177, .external_lex_state = 7},
  [122] = {.lex_state = 2177, .external_lex_state = 8},
  [123] = {.lex_state = 2177, .external_lex_state = 8},
  [124] = {.lex_state = 2177, .external_lex_state = 9},
  [125] = {.lex_state = 2177, .external_lex_state = 8},
  [126] = {.lex_state = 2177, .external_lex_state = 9},
  [127] = {.lex_state = 2177, .external_lex_state = 10},
  [128] = {.lex_state = 2177, .external_lex_state = 9},
  [129] = {.lex_state = 2177, .external_lex_state = 4},
  [130] = {.lex_state = 2177, .external_lex_state = 9},
  [131] = {.lex_state = 2177, .external_lex_state = 10},
  [132] = {.lex_state = 2177, .external_lex_state = 7},
  [133] = {.lex_state = 2177, .external_lex_state = 10},
  [134] = {.lex_state = 2177, .external_lex_state = 8},
  [135] = {.lex_state = 2177, .external_lex_state = 9},
  [136] = {.lex_state = 2177, .external_lex_state = 10},
  [137] = {.lex_state = 2177, .external_lex_state = 10},
  [138] = {.lex_state = 2177, .external_lex_state = 10},
  [139] = {.lex_state = 2177, .external_lex_state = 10},
  [140] = {.lex_state = 2177, .external_lex_state = 10},
  [141] = {.lex_state = 2177, .external_lex_state = 10},
  [142] = {.lex_state = 2177, .external_lex_state = 10},
  [143] = {.lex_state = 2177, .external_lex_state = 10},
  [144] = {.lex_state = 2177, .external_lex_state = 10},
  [145] = {.lex_state = 2177, .external_lex_state = 10},
  [146] = {.lex_state = 2177, .external_lex_state = 10},
  [147] = {.lex_state = 2177, .external_lex_state = 10},
  [148] = {.lex_state = 2177, .external_lex_state = 9},
  [149] = {.lex_state = 2177, .external_lex_state = 9},
  [150] = {.lex_state = 2177, .external_lex_state = 7},
  [151] = {.lex_state = 2177, .external_lex_state = 7},
  [152] = {.lex_state = 2177, .external_lex_state = 10},
  [153] = {.lex_state = 2177, .external_lex_state = 8},
  [154] = {.lex_state = 2177, .external_lex_state = 8},
  [155] = {.lex_state = 2177, .external_lex_state = 10},
  [156] = {.lex_state = 2177, .external_lex_state = 10},
  [157] = {.lex_state = 2177, .external_lex_state = 10},
  [158] = {.lex_state = 2177, .external_lex_state = 8},
  [159] = {.lex_state = 2177, .external_lex_state = 7},
  [160] = {.lex_state = 2177, .external_lex_state = 9},
  [161] = {.lex_state = 2177, .external_lex_state = 10},
  [162] = {.lex_state = 2177, .external_lex_state = 10},
  [163] = {.lex_state = 2177, .external_lex_state = 9},
  [164] = {.lex_state = 2177, .external_lex_state = 7},
  [165] = {.lex_state = 2177, .external_lex_state = 8},
  [166] = {.lex_state = 2177, .external_lex_state = 11},
  [167] = {.lex_state = 2177, .external_lex_state = 12},
  [168] = {.lex_state = 2177, .external_lex_state = 11},
  [169] = {.lex_state = 2177, .external_lex_state = 13},
  [170] = {.lex_state = 2177, .external_lex_state = 14},
  [171] = {.lex_state = 2177, .external_lex_state = 13},
  [172] = {.lex_state = 2177, .external_lex_state = 12},
  [173] = {.lex_state = 2177, .external_lex_state = 14},
  [174] = {.lex_state = 2177, .external_lex_state = 14},
  [175] = {.lex_state = 2175, .external_lex_state = 8},
  [176] = {.lex_state = 2175, .external_lex_state = 10},
  [177] = {.lex_state = 2175, .external_lex_state = 9},
  [178] = {.lex_state = 2175, .external_lex_state = 7},
  [179] = {.lex_state = 2176, .external_lex_state = 8},
  [180] = {.lex_state = 2176, .external_lex_state = 10},
  [181] = {.lex_state = 2176, .external_lex_state = 9},
  [182] = {.lex_state = 2176, .external_lex_state = 9},
  [183] = {.lex_state = 2175, .external_lex_state = 7},
  [184] = {.lex_state = 2175, .external_lex_state = 8},
  [185] = {.lex_state = 2175, .external_lex_state = 9},
  [186] = {.lex_state = 2176, .external_lex_state = 7},
  [187] = {.lex_state = 2176, .external_lex_state = 8},
  [188] = {.lex_state = 2176, .external_lex_state = 7},
  [189] = {.lex_state = 2175, .external_lex_state = 10},
  [190] = {.lex_state = 2175, .external_lex_state = 10},
  [191] = {.lex_state = 2174, .external_lex_state = 10},
  [192] = {.lex_state = 2174, .external_lex_state = 7},
  [193] = {.lex_state = 2174, .external_lex_state = 8},
  [194] = {.lex_state = 2176, .external_lex_state = 10},
  [195] = {.lex_state = 2176, .external_lex_state = 10},
  [196] = {.lex_state = 2174, .external_lex_state = 9},
  [197] = {.lex_state = 2174, .external_lex_state = 7},
  [198] = {.lex_state = 2174, .external_lex_state = 9},
  [199] = {.lex_state = 2174, .external_lex_state = 8},
  [200] = {.lex_state = 7, .external_lex_state = 15},
  [201] = {.lex_state = 2174, .external_lex_state = 10},
  [202] = {.lex_state = 7, .external_lex_state = 15},
  [203] = {.lex_state = 7, .external_lex_state = 15},
  [204] = {.lex_state = 7, .external_lex_state = 15},
  [205] = {.lex_state = 2174, .external_lex_state = 10},
  [206] = {.lex_state = 7, .external_lex_state = 15},
  [207] = {.lex_state = 7, .external_lex_state = 15},
  [208] = {.lex_state = 2177, .external_lex_state = 4},
  [209] = {.lex_state = 2177, .external_lex_state = 10},
  [210] = {.lex_state = 1, .external_lex_state = 16},
  [211] = {.lex_state = 2177, .external_lex_state = 9},
  [212] = {.lex_state = 2177, .external_lex_state = 4},
  [213] = {.lex_state = 1, .external_lex_state = 16},
  [214] = {.lex_state = 1, .external_lex_state = 16},
  [215] = {.lex_state = 1, .external_lex_state = 16},
  [216] = {.lex_state = 2177, .external_lex_state = 5},
  [217] = {.lex_state = 2177, .external_lex_state = 6},
  [218] = {.lex_state = 2177, .external_lex_state = 17},
  [219] = {.lex_state = 1, .external_lex_state = 16},
  [220] = {.lex_state = 1, .external_lex_state = 16},
  [221] = {.lex_state = 1, .external_lex_state = 16},
  [222] = {.lex_state = 2177, .external_lex_state = 18},
  [223] = {.lex_state = 1, .external_lex_state = 16},
  [224] = {.lex_state = 1, .external_lex_state = 16},
  [225] = {.lex_state = 1, .external_lex_state = 16},
  [226] = {.lex_state = 2177, .external_lex_state = 8},
  [227] = {.lex_state = 1, .external_lex_state = 16},
  [228] = {.lex_state = 1, .external_lex_state = 16},
  [229] = {.lex_state = 2177, .external_lex_state = 2},
  [230] = {.lex_state = 1, .external_lex_state = 16},
  [231] = {.lex_state = 2177, .external_lex_state = 6},
  [232] = {.lex_state = 2177, .external_lex_state = 5},
  [233] = {.lex_state = 1, .external_lex_state = 16},
  [234] = {.lex_state = 1, .external_lex_state = 16},
  [235] = {.lex_state = 2177, .external_lex_state = 3},
  [236] = {.lex_state = 2177, .external_lex_state = 19},
  [237] = {.lex_state = 2177, .external_lex_state = 7},
  [238] = {.lex_state = 2177, .external_lex_state = 3},
  [239] = {.lex_state = 1, .external_lex_state = 16},
  [240] = {.lex_state = 2177, .external_lex_state = 3},
  [241] = {.lex_state = 2177, .external_lex_state = 17},
  [242] = {.lex_state = 2177, .external_lex_state = 3},
  [243] = {.lex_state = 2177, .external_lex_state = 3},
  [244] = {.lex_state = 2177, .external_lex_state = 17},
  [245] = {.lex_state = 2177, .external_lex_state = 18},
  [246] = {.lex_state = 2177, .external_lex_state = 3},
  [247] = {.lex_state = 2177, .external_lex_state = 6},
  [248] = {.lex_state = 2177, .external_lex_state = 5},
  [249] = {.lex_state = 2177, .external_lex_state = 19},
  [250] = {.lex_state = 2177, .external_lex_state = 2},
  [251] = {.lex_state = 2177, .external_lex_state = 6},
  [252] = {.lex_state = 2177, .external_lex_state = 4},
  [253] = {.lex_state = 2177, .external_lex_state = 5},
  [254] = {.lex_state = 2177, .external_lex_state = 19},
  [255] = {.lex_state = 2177, .external_lex_state = 6},
  [256] = {.lex_state = 2177, .external_lex_state = 2},
  [257] = {.lex_state = 2177, .external_lex_state = 5},
  [258] = {.lex_state = 2177, .external_lex_state = 6},
  [259] = {.lex_state = 2177, .external_lex_state = 4},
  [260] = {.lex_state = 2177, .external_lex_state = 4},
  [261] = {.lex_state = 2177, .external_lex_state = 5},
  [262] = {.lex_state = 2177, .external_lex_state = 5},
  [263] = {.lex_state = 2177, .external_lex_state = 4},
  [264] = {.lex_state = 2177, .external_lex_state = 18},
  [265] = {.lex_state = 2177, .external_lex_state = 6},
  [266] = {.lex_state = 2177, .external_lex_state = 3},
  [267] = {.lex_state = 2177, .external_lex_state = 4},
  [268] = {.lex_state = 2177, .external_lex_state = 4},
  [269] = {.lex_state = 2177, .external_lex_state = 2},
  [270] = {.lex_state = 2177, .external_lex_state = 10},
  [271] = {.lex_state = 2177, .external_lex_state = 9},
  [272] = {.lex_state = 2177, .external_lex_state = 9},
  [273] = {.lex_state = 2177, .external_lex_state = 10},
  [274] = {.lex_state = 2177, .external_lex_state = 9},
  [275] = {.lex_state = 2177, .external_lex_state = 8},
  [276] = {.lex_state = 2177, .external_lex_state = 10},
  [277] = {.lex_state = 2177, .external_lex_state = 10},
  [278] = {.lex_state = 2177, .external_lex_state = 10},
  [279] = {.lex_state = 2177, .external_lex_state = 10},
  [280] = {.lex_state = 2177, .external_lex_state = 10},
  [281] = {.lex_state = 2177, .external_lex_state = 7},
  [282] = {.lex_state = 2177, .external_lex_state = 8},
  [283] = {.lex_state = 2177, .external_lex_state = 10},
  [284] = {.lex_state = 2177, .external_lex_state = 10},
  [285] = {.lex_state = 2177, .external_lex_state = 10},
  [286] = {.lex_state = 2177, .external_lex_state = 4},
  [287] = {.lex_state = 2177, .external_lex_state = 7},
  [288] = {.lex_state = 2177, .external_lex_state = 10},
  [289] = {.lex_state = 2177, .external_lex_state = 10},
  [290] = {.lex_state = 2177, .external_lex_state = 7},
  [291] = {.lex_state = 2177, .external_lex_state = 8},
  [292] = {.lex_state = 2177, .external_lex_state = 10},
  [293] = {.lex_state = 2177, .external_lex_state = 10},
  [294] = {.lex_state = 2177, .external_lex_state = 7},
  [295] = {.lex_state = 2177, .external_lex_state = 10},
  [296] = {.lex_state = 2177, .external_lex_state = 9},
  [297] = {.lex_state = 2177, .external_lex_state = 9},
  [298] = {.lex_state = 2177, .external_lex_state = 9},
  [299] = {.lex_state = 2177, .external_lex_state = 10},
  [300] = {.lex_state = 2177, .external_lex_state = 10},
  [301] = {.lex_state = 2177, .external_lex_state = 10},
  [302] = {.lex_state = 2177, .external_lex_state = 9},
  [303] = {.lex_state = 2177, .external_lex_state = 10},
  [304] = {.lex_state = 2177, .external_lex_state = 9},
  [305] = {.lex_state = 2177, .external_lex_state = 10},
  [306] = {.lex_state = 2177, .external_lex_state = 2},
  [307] = {.lex_state = 2177, .external_lex_state = 10},
  [308] = {.lex_state = 2177, .external_lex_state = 10},
  [309] = {.lex_state = 2177, .external_lex_state = 7},
  [310] = {.lex_state = 2177, .external_lex_state = 2},
  [311] = {.lex_state = 2177, .external_lex_state = 10},
  [312] = {.lex_state = 2177, .external_lex_state = 6},
  [313] = {.lex_state = 2177, .external_lex_state = 10},
  [314] = {.lex_state = 2177, .external_lex_state = 4},
  [315] = {.lex_state = 2177, .external_lex_state = 10},
  [316] = {.lex_state = 2177, .external_lex_state = 8},
  [317] = {.lex_state = 2177, .external_lex_state = 10},
  [318] = {.lex_state = 2177, .external_lex_state = 10},
  [319] = {.lex_state = 2177, .external_lex_state = 10},
  [320] = {.lex_state = 2177, .external_lex_state = 10},
  [321] = {.lex_state = 2177, .external_lex_state = 10},
  [322] = {.lex_state = 2177, .external_lex_state = 9},
  [323] = {.lex_state = 2177, .external_lex_state = 10},
  [324] = {.lex_state = 2177, .external_lex_state = 10},
  [325] = {.lex_state = 2177, .external_lex_state = 10},
  [326] = {.lex_state = 2177, .external_lex_state = 8},
  [327] = {.lex_state = 2177, .external_lex_state = 8},
  [328] = {.lex_state = 2177, .external_lex_state = 7},
  [329] = {.lex_state = 2177, .external_lex_state = 7},
  [330] = {.lex_state = 2177, .external_lex_state = 4},
  [331] = {.lex_state = 2177, .external_lex_state = 8},
  [332] = {.lex_state = 2177, .external_lex_state = 8},
  [333] = {.lex_state = 2177, .external_lex_state = 4},
  [334] = {.lex_state = 2177, .external_lex_state = 9},
  [335] = {.lex_state = 2177, .external_lex_state = 9},
  [336] = {.lex_state = 2177, .external_lex_state = 8},
  [337] = {.lex_state = 2177, .external_lex_state = 8},
  [338] = {.lex_state = 2177, .external_lex_state = 9},
  [339] = {.lex_state = 2177, .external_lex_state = 9},
  [340] = {.lex_state = 2177, .external_lex_state = 8},
  [341] = {.lex_state = 2177, .external_lex_state = 9},
  [342] = {.lex_state = 2177, .external_lex_state = 7},
  [343] = {.lex_state = 2177, .external_lex_state = 7},
  [344] = {.lex_state = 2177, .external_lex_state = 7},
  [345] = {.lex_state = 2177, .external_lex_state = 7},
  [346] = {.lex_state = 2177, .external_lex_state = 9},
  [347] = {.lex_state = 2177, .external_lex_state = 9},
  [348] = {.lex_state = 2177, .external_lex_state = 8},
  [349] = {.lex_state = 2177, .external_lex_state = 7},
  [350] = {.lex_state = 2177, .external_lex_state = 7},
  [351] = {.lex_state = 2177, .external_lex_state = 8},
  [352] = {.lex_state = 2177, .external_lex_state = 9},
  [353] = {.lex_state = 2177, .external_lex_state = 7},
  [354] = {.lex_state = 2177, .external_lex_state = 9},
  [355] = {.lex_state = 2177, .external_lex_state = 9},
  [356] = {.lex_state = 2177, .external_lex_state = 10},
  [357] = {.lex_state = 2177, .external_lex_state = 8},
  [358] = {.lex_state = 2177, .external_lex_state = 8},
  [359] = {.lex_state = 2177, .external_lex_state = 9},
  [360] = {.lex_state = 2177, .external_lex_state = 7},
  [361] = {.lex_state = 2177, .external_lex_state = 7},
  [362] = {.lex_state = 2177, .external_lex_state = 9},
  [363] = {.lex_state = 2177, .external_lex_state = 9},
  [364] = {.lex_state = 2177, .external_lex_state = 7},
  [365] = {.lex_state = 2177, .external_lex_state = 7},
  [366] = {.lex_state = 2177, .external_lex_state = 7},
  [367] = {.lex_state = 2177, .external_lex_state = 7},
  [368] = {.lex_state = 2177, .external_lex_state = 7},
  [369] = {.lex_state = 2177, .external_lex_state = 7},
  [370] = {.lex_state = 2177, .external_lex_state = 7},
  [371] = {.lex_state = 2177, .external_lex_state = 9},
  [372] = {.lex_state = 2177, .external_lex_state = 4},
  [373] = {.lex_state = 2177, .external_lex_state = 9},
  [374] = {.lex_state = 2177, .external_lex_state = 9},
  [375] = {.lex_state = 2177, .external_lex_state = 9},
  [376] = {.lex_state = 2177, .external_lex_state = 9},
  [377] = {.lex_state = 2177, .external_lex_state = 9},
  [378] = {.lex_state = 2177, .external_lex_state = 7},
  [379] = {.lex_state = 2177, .external_lex_state = 7},
  [380] = {.lex_state = 2177, .external_lex_state = 7},
  [381] = {.lex_state = 2177, .external_lex_state = 7},
  [382] = {.lex_state = 2177, .external_lex_state = 7},
  [383] = {.lex_state = 2177, .external_lex_state = 7},
  [384] = {.lex_state = 2177, .external_lex_state = 7},
  [385] = {.lex_state = 2177, .external_lex_state = 9},
  [386] = {.lex_state = 2177, .external_lex_state = 9},
  [387] = {.lex_state = 2177, .external_lex_state = 9},
  [388] = {.lex_state = 2177, .external_lex_state = 8},
  [389] = {.lex_state = 2177, .external_lex_state = 8},
  [390] = {.lex_state = 2177, .external_lex_state = 9},
  [391] = {.lex_state = 2177, .external_lex_state = 8},
  [392] = {.lex_state = 2177, .external_lex_state = 9},
  [393] = {.lex_state = 2177, .external_lex_state = 10},
  [394] = {.lex_state = 2177, .external_lex_state = 9},
  [395] = {.lex_state = 2177, .external_lex_state = 9},
  [396] = {.lex_state = 2177, .external_lex_state = 7},
  [397] = {.lex_state = 2177, .external_lex_state = 7},
  [398] = {.lex_state = 2177, .external_lex_state = 7},
  [399] = {.lex_state = 2177, .external_lex_state = 8},
  [400] = {.lex_state = 2177, .external_lex_state = 8},
  [401] = {.lex_state = 2177, .external_lex_state = 9},
  [402] = {.lex_state = 2177, .external_lex_state = 9},
  [403] = {.lex_state = 2177, .external_lex_state = 9},
  [404] = {.lex_state = 2177, .external_lex_state = 9},
  [405] = {.lex_state = 2177, .external_lex_state = 7},
  [406] = {.lex_state = 2177, .external_lex_state = 7},
  [407] = {.lex_state = 2177, .external_lex_state = 9},
  [408] = {.lex_state = 2177, .external_lex_state = 10},
  [409] = {.lex_state = 2177, .external_lex_state = 7},
  [410] = {.lex_state = 2177, .external_lex_state = 7},
  [411] = {.lex_state = 2177, .external_lex_state = 7},
  [412] = {.lex_state = 2177, .external_lex_state = 7},
  [413] = {.lex_state = 2177, .external_lex_state = 7},
  [414] = {.lex_state = 2177, .external_lex_state = 7},
  [415] = {.lex_state = 2177, .external_lex_state = 10},
  [416] = {.lex_state = 2177, .external_lex_state = 8},
  [417] = {.lex_state = 2177, .external_lex_state = 10},
  [418] = {.lex_state = 2177, .external_lex_state = 3},
  [419] = {.lex_state = 2177, .external_lex_state = 10},
  [420] = {.lex_state = 2177, .external_lex_state = 10},
  [421] = {.lex_state = 2177, .external_lex_state = 9},
  [422] = {.lex_state = 2177, .external_lex_state = 10},
  [423] = {.lex_state = 2177, .external_lex_state = 10},
  [424] = {.lex_state = 2177, .external_lex_state = 10},
  [425] = {.lex_state = 2177, .external_lex_state = 10},
  [426] = {.lex_state = 2177, .external_lex_state = 10},
  [427] = {.lex_state = 2177, .external_lex_state = 10},
  [428] = {.lex_state = 2177, .external_lex_state = 8},
  [429] = {.lex_state = 2177, .external_lex_state = 8},
  [430] = {.lex_state = 2177, .external_lex_state = 8},
  [431] = {.lex_state = 2177, .external_lex_state = 8},
  [432] = {.lex_state = 2177, .external_lex_state = 7},
  [433] = {.lex_state = 2177, .external_lex_state = 10},
  [434] = {.lex_state = 2177, .external_lex_state = 8},
  [435] = {.lex_state = 2177, .external_lex_state = 7},
  [436] = {.lex_state = 2177, .external_lex_state = 8},
  [437] = {.lex_state = 2177, .external_lex_state = 7},
  [438] = {.lex_state = 2177, .external_lex_state = 7},
  [439] = {.lex_state = 2177, .external_lex_state = 7},
  [440] = {.lex_state = 2177, .external_lex_state = 7},
  [441] = {.lex_state = 2177, .external_lex_state = 7},
  [442] = {.lex_state = 2177, .external_lex_state = 8},
  [443] = {.lex_state = 2177, .external_lex_state = 8},
  [444] = {.lex_state = 2177, .external_lex_state = 10},
  [445] = {.lex_state = 2177, .external_lex_state = 8},
  [446] = {.lex_state = 2177, .external_lex_state = 8},
  [447] = {.lex_state = 2177, .external_lex_state = 8},
  [448] = {.lex_state = 2177, .external_lex_state = 8},
  [449] = {.lex_state = 2177, .external_lex_state = 8},
  [450] = {.lex_state = 2177, .external_lex_state = 8},
  [451] = {.lex_state = 2177, .external_lex_state = 8},
  [452] = {.lex_state = 2177, .external_lex_state = 7},
  [453] = {.lex_state = 2177, .external_lex_state = 7},
  [454] = {.lex_state = 2177, .external_lex_state = 7},
  [455] = {.lex_state = 2177, .external_lex_state = 7},
  [456] = {.lex_state = 2177, .external_lex_state = 7},
  [457] = {.lex_state = 2177, .external_lex_state = 8},
  [458] = {.lex_state = 2177, .external_lex_state = 8},
  [459] = {.lex_state = 2177, .external_lex_state = 8},
  [460] = {.lex_state = 2177, .external_lex_state = 8},
  [461] = {.lex_state = 2177, .external_lex_state = 8},
  [462] = {.lex_state = 2177, .external_lex_state = 8},
  [463] = {.lex_state = 2177, .external_lex_state = 8},
  [464] = {.lex_state = 2177, .external_lex_state = 9},
  [465] = {.lex_state = 2177, .external_lex_state = 10},
  [466] = {.lex_state = 2177, .external_lex_state = 9},
  [467] = {.lex_state = 2177, .external_lex_state = 9},
  [468] = {.lex_state = 2177, .external_lex_state = 9},
  [469] = {.lex_state = 2177, .external_lex_state = 7},
  [470] = {.lex_state = 2177, .external_lex_state = 7},
  [471] = {.lex_state = 2177, .external_lex_state = 9},
  [472] = {.lex_state = 2177, .external_lex_state = 10},
  [473] = {.lex_state = 2177, .external_lex_state = 7},
  [474] = {.lex_state = 2177, .external_lex_state = 7},
  [475] = {.lex_state = 2177, .external_lex_state = 8},
  [476] = {.lex_state = 2177, .external_lex_state = 8},
  [477] = {.lex_state = 2177, .external_lex_state = 8},
  [478] = {.lex_state = 2177, .external_lex_state = 9},
  [479] = {.lex_state = 2177, .external_lex_state = 9},
  [480] = {.lex_state = 2177, .external_lex_state = 9},
  [481] = {.lex_state = 2177, .external_lex_state = 7},
  [482] = {.lex_state = 2177, .external_lex_state = 7},
  [483] = {.lex_state = 2177, .external_lex_state = 7},
  [484] = {.lex_state = 2177, .external_lex_state = 8},
  [485] = {.lex_state = 2177, .external_lex_state = 8},
  [486] = {.lex_state = 2177, .external_lex_state = 7},
  [487] = {.lex_state = 2177, .external_lex_state = 7},
  [488] = {.lex_state = 2177, .external_lex_state = 8},
  [489] = {.lex_state = 2177, .external_lex_state = 8},
  [490] = {.lex_state = 2177, .external_lex_state = 8},
  [491] = {.lex_state = 2177, .external_lex_state = 8},
  [492] = {.lex_state = 2177, .external_lex_state = 8},
  [493] = {.lex_state = 2177, .external_lex_state = 8},
  [494] = {.lex_state = 2177, .external_lex_state = 10},
  [495] = {.lex_state = 2177, .external_lex_state = 9},
  [496] = {.lex_state = 2177, .external_lex_state = 5},
  [497] = {.lex_state = 2177, .external_lex_state = 10},
  [498] = {.lex_state = 2177, .external_lex_state = 10},
  [499] = {.lex_state = 2177, .external_lex_state = 10},
  [500] = {.lex_state = 2177, .external_lex_state = 10},
  [501] = {.lex_state = 2177, .external_lex_state = 10},
  [502] = {.lex_state = 2177, .external_lex_state = 9},
  [503] = {.lex_state = 2177, .external_lex_state = 10},
  [504] = {.lex_state = 2177, .external_lex_state = 8},
  [505] = {.lex_state = 2177, .external_lex_state = 10},
  [506] = {.lex_state = 2177, .external_lex_state = 4},
  [507] = {.lex_state = 2177, .external_lex_state = 9},
  [508] = {.lex_state = 2177, .external_lex_state = 9},
  [509] = {.lex_state = 2177, .external_lex_state = 9},
  [510] = {.lex_state = 2177, .external_lex_state = 9},
  [511] = {.lex_state = 2177, .external_lex_state = 8},
  [512] = {.lex_state = 2177, .external_lex_state = 10},
  [513] = {.lex_state = 2177, .external_lex_state = 9},
  [514] = {.lex_state = 2177, .external_lex_state = 8},
  [515] = {.lex_state = 2177, .external_lex_state = 9},
  [516] = {.lex_state = 2177, .external_lex_state = 8},
  [517] = {.lex_state = 2177, .external_lex_state = 8},
  [518] = {.lex_state = 2177, .external_lex_state = 8},
  [519] = {.lex_state = 2177, .external_lex_state = 8},
  [520] = {.lex_state = 2177, .external_lex_state = 8},
  [521] = {.lex_state = 2177, .external_lex_state = 10},
  [522] = {.lex_state = 2177, .external_lex_state = 10},
  [523] = {.lex_state = 2177, .external_lex_state = 10},
  [524] = {.lex_state = 2177, .external_lex_state = 10},
  [525] = {.lex_state = 2177, .external_lex_state = 8},
  [526] = {.lex_state = 2177, .external_lex_state = 10},
  [527] = {.lex_state = 2177, .external_lex_state = 10},
  [528] = {.lex_state = 2177, .external_lex_state = 10},
  [529] = {.lex_state = 2177, .external_lex_state = 10},
  [530] = {.lex_state = 2177, .external_lex_state = 10},
  [531] = {.lex_state = 2177, .external_lex_state = 10},
  [532] = {.lex_state = 2177, .external_lex_state = 10},
  [533] = {.lex_state = 2177, .external_lex_state = 10},
  [534] = {.lex_state = 2177, .external_lex_state = 10},
  [535] = {.lex_state = 2177, .external_lex_state = 10},
  [536] = {.lex_state = 2177, .external_lex_state = 10},
  [537] = {.lex_state = 2177, .external_lex_state = 10},
  [538] = {.lex_state = 2177, .external_lex_state = 10},
  [539] = {.lex_state = 2177, .external_lex_state = 10},
  [540] = {.lex_state = 2177, .external_lex_state = 10},
  [541] = {.lex_state = 2177, .external_lex_state = 10},
  [542] = {.lex_state = 2177, .external_lex_state = 10},
  [543] = {.lex_state = 2177, .external_lex_state = 10},
  [544] = {.lex_state = 2177, .external_lex_state = 10},
  [545] = {.lex_state = 2177, .external_lex_state = 10},
  [546] = {.lex_state = 2177, .external_lex_state = 10},
  [547] = {.lex_state = 2177, .external_lex_state = 10},
  [548] = {.lex_state = 2177, .external_lex_state = 10},
  [549] = {.lex_state = 2177, .external_lex_state = 10},
  [550] = {.lex_state = 2177, .external_lex_state = 10},
  [551] = {.lex_state = 2177, .external_lex_state = 10},
  [552] = {.lex_state = 2177, .external_lex_state = 10},
  [553] = {.lex_state = 2177, .external_lex_state = 7},
  [554] = {.lex_state = 2177, .external_lex_state = 10},
  [555] = {.lex_state = 2177, .external_lex_state = 10},
  [556] = {.lex_state = 2177, .external_lex_state = 10},
  [557] = {.lex_state = 2177, .external_lex_state = 10},
  [558] = {.lex_state = 2177, .external_lex_state = 10},
  [559] = {.lex_state = 2177, .external_lex_state = 10},
  [560] = {.lex_state = 2177, .external_lex_state = 10},
  [561] = {.lex_state = 2177, .external_lex_state = 10},
  [562] = {.lex_state = 2177, .external_lex_state = 10},
  [563] = {.lex_state = 2177, .external_lex_state = 10},
  [564] = {.lex_state = 2177, .external_lex_state = 10},
  [565] = {.lex_state = 2177, .external_lex_state = 10},
  [566] = {.lex_state = 2177, .external_lex_state = 10},
  [567] = {.lex_state = 2177, .external_lex_state = 10},
  [568] = {.lex_state = 2177, .external_lex_state = 10},
  [569] = {.lex_state = 2177, .external_lex_state = 10},
  [570] = {.lex_state = 2177, .external_lex_state = 10},
  [571] = {.lex_state = 2177, .external_lex_state = 10},
  [572] = {.lex_state = 2177, .external_lex_state = 10},
  [573] = {.lex_state = 2177, .external_lex_state = 10},
  [574] = {.lex_state = 2177, .external_lex_state = 10},
  [575] = {.lex_state = 2177, .external_lex_state = 10},
  [576] = {.lex_state = 2177, .external_lex_state = 10},
  [577] = {.lex_state = 2177, .external_lex_state = 10},
  [578] = {.lex_state = 2177, .external_lex_state = 9},
  [579] = {.lex_state = 2177, .external_lex_state = 10},
  [580] = {.lex_state = 2177, .external_lex_state = 10},
  [581] = {.lex_state = 2177, .external_lex_state = 10},
  [582] = {.lex_state = 2177, .external_lex_state = 10},
  [583] = {.lex_state = 2177, .external_lex_state = 7},
  [584] = {.lex_state = 2177, .external_lex_state = 7},
  [585] = {.lex_state = 2177, .external_lex_state = 9},
  [586] = {.lex_state = 2177, .external_lex_state = 9},
  [587] = {.lex_state = 2177, .external_lex_state = 9},
  [588] = {.lex_state = 2177, .external_lex_state = 9},
  [589] = {.lex_state = 2177, .external_lex_state = 9},
  [590] = {.lex_state = 2177, .external_lex_state = 9},
  [591] = {.lex_state = 2177, .external_lex_state = 8},
  [592] = {.lex_state = 2177, .external_lex_state = 9},
  [593] = {.lex_state = 2177, .external_lex_state = 8},
  [594] = {.lex_state = 2177, .external_lex_state = 8},
  [595] = {.lex_state = 2177, .external_lex_state = 8},
  [596] = {.lex_state = 2177, .external_lex_state = 10},
  [597] = {.lex_state = 2177, .external_lex_state = 8},
  [598] = {.lex_state = 2177, .external_lex_state = 8},
  [599] = {.lex_state = 2177, .external_lex_state = 8},
  [600] = {.lex_state = 2177, .external_lex_state = 8},
  [601] = {.lex_state = 2177, .external_lex_state = 10},
  [602] = {.lex_state = 2177, .external_lex_state = 10},
  [603] = {.lex_state = 2177, .external_lex_state = 10},
  [604] = {.lex_state = 2177, .external_lex_state = 7},
  [605] = {.lex_state = 2177, .external_lex_state = 7},
  [606] = {.lex_state = 2177, .external_lex_state = 8},
  [607] = {.lex_state = 2177, .external_lex_state = 7},
  [608] = {.lex_state = 2177, .external_lex_state = 8},
  [609] = {.lex_state = 2177, .external_lex_state = 7},
  [610] = {.lex_state = 2177, .external_lex_state = 7},
  [611] = {.lex_state = 2177, .external_lex_state = 8},
  [612] = {.lex_state = 2177, .external_lex_state = 8},
  [613] = {.lex_state = 2177, .external_lex_state = 9},
  [614] = {.lex_state = 2177, .external_lex_state = 9},
  [615] = {.lex_state = 2177, .external_lex_state = 7},
  [616] = {.lex_state = 2177, .external_lex_state = 7},
  [617] = {.lex_state = 2177, .external_lex_state = 7},
  [618] = {.lex_state = 2177, .external_lex_state = 7},
  [619] = {.lex_state = 2177, .external_lex_state = 7},
  [620] = {.lex_state = 2177, .external_lex_state = 8},
  [621] = {.lex_state = 2177, .external_lex_state = 7},
  [622] = {.lex_state = 2177, .external_lex_state = 10},
  [623] = {.lex_state = 2177, .external_lex_state = 10},
  [624] = {.lex_state = 2177, .external_lex_state = 10},
  [625] = {.lex_state = 2177, .external_lex_state = 10},
  [626] = {.lex_state = 2177, .external_lex_state = 10},
  [627] = {.lex_state = 2177, .external_lex_state = 10},
  [628] = {.lex_state = 2},
  [629] = {.lex_state = 2},
  [630] = {.lex_state = 2},
  [631] = {.lex_state = 2},
  [632] = {.lex_state = 2},
  [633] = {.lex_state = 2},
  [634] = {.lex_state = 2, .external_lex_state = 20},
  [635] = {.lex_state = 2},
  [636] = {.lex_state = 2, .external_lex_state = 20},
  [637] = {.lex_state = 2},
  [638] = {.lex_state = 2},
  [639] = {.lex_state = 2},
  [640] = {.lex_state = 2},
  [641] = {.lex_state = 2},
  [642] = {.lex_state = 2},
  [643] = {.lex_state = 2},
  [644] = {.lex_state = 2},
  [645] = {.lex_state = 2},
  [646] = {.lex_state = 2},
  [647] = {.lex_state = 2},
  [648] = {.lex_state = 2},
  [649] = {.lex_state = 2},
  [650] = {.lex_state = 6, .external_lex_state = 15},
  [651] = {.lex_state = 1, .external_lex_state = 21},
  [652] = {.lex_state = 2},
  [653] = {.lex_state = 1, .external_lex_state = 22},
  [654] = {.lex_state = 1, .external_lex_state = 22},
  [655] = {.lex_state = 5, .external_lex_state = 15},
  [656] = {.lex_state = 3, .external_lex_state = 15},
  [657] = {.lex_state = 1, .external_lex_state = 16},
  [658] = {.lex_state = 1, .external_lex_state = 16},
  [659] = {.lex_state = 1, .external_lex_state = 16},
  [660] = {.lex_state = 1, .external_lex_state = 16},
  [661] = {.lex_state = 2},
  [662] = {.lex_state = 2, .external_lex_state = 20},
  [663] = {.lex_state = 2, .external_lex_state = 20},
  [664] = {.lex_state = 2},
  [665] = {.lex_state = 2},
  [666] = {.lex_state = 2, .external_lex_state = 20},
  [667] = {.lex_state = 2},
  [668] = {.lex_state = 2},
  [669] = {.lex_state = 2},
  [670] = {.lex_state = 2},
  [671] = {.lex_state = 2},
  [672] = {.lex_state = 2},
  [673] = {.lex_state = 2},
  [674] = {.lex_state = 2},
  [675] = {.lex_state = 2},
  [676] = {.lex_state = 7, .external_lex_state = 15},
  [677] = {.lex_state = 2},
  [678] = {.lex_state = 7, .external_lex_state = 23},
  [679] = {.lex_state = 2},
  [680] = {.lex_state = 7, .external_lex_state = 23},
  [681] = {.lex_state = 2177},
  [682] = {.lex_state = 4, .external_lex_state = 20},
  [683] = {.lex_state = 4, .external_lex_state = 20},
  [684] = {.lex_state = 2177},
  [685] = {.lex_state = 4, .external_lex_state = 20},
  [686] = {.lex_state = 4, .external_lex_state = 20},
  [687] = {.lex_state = 7, .external_lex_state = 24},
  [688] = {.lex_state = 4, .external_lex_state = 20},
  [689] = {.lex_state = 4, .external_lex_state = 20},
  [690] = {.lex_state = 4, .external_lex_state = 20},
  [691] = {.lex_state = 2177},
  [692] = {.lex_state = 7, .external_lex_state = 24},
  [693] = {.lex_state = 2},
  [694] = {.lex_state = 4, .external_lex_state = 20},
  [695] = {.lex_state = 4, .external_lex_state = 20},
  [696] = {.lex_state = 4, .external_lex_state = 20},
  [697] = {.lex_state = 4, .external_lex_state = 20},
  [698] = {.lex_state = 4, .external_lex_state = 20},
  [699] = {.lex_state = 4},
  [700] = {.lex_state = 7, .external_lex_state = 15},
  [701] = {.lex_state = 8},
  [702] = {.lex_state = 8},
  [703] = {.lex_state = 4},
  [704] = {.lex_state = 4},
  [705] = {.lex_state = 4},
  [706] = {.lex_state = 4},
  [707] = {.lex_state = 4},
  [708] = {.lex_state = 8},
  [709] = {.lex_state = 4},
  [710] = {.lex_state = 7, .external_lex_state = 15},
  [711] = {.lex_state = 9},
  [712] = {.lex_state = 4},
  [713] = {.lex_state = 4},
  [714] = {.lex_state = 8},
  [715] = {.lex_state = 9},
  [716] = {.lex_state = 7, .external_lex_state = 15},
  [717] = {.lex_state = 4},
  [718] = {.lex_state = 4},
  [719] = {.lex_state = 4},
  [720] = {.lex_state = 4},
  [721] = {.lex_state = 7, .external_lex_state = 15},
  [722] = {.lex_state = 4},
  [723] = {.lex_state = 7, .external_lex_state = 15},
  [724] = {.lex_state = 4},
  [725] = {.lex_state = 4},
  [726] = {.lex_state = 4},
  [727] = {.lex_state = 7, .external_lex_state = 15},
  [728] = {.lex_state = 9},
  [729] = {.lex_state = 7, .external_lex_state = 15},
  [730] = {.lex_state = 7, .external_lex_state = 15},
  [731] = {.lex_state = 4},
  [732] = {.lex_state = 4},
  [733] = {.lex_state = 4},
  [734] = {.lex_state = 7, .external_lex_state = 15},
  [735] = {.lex_state = 7, .external_lex_state = 15},
  [736] = {.lex_state = 4},
  [737] = {.lex_state = 4},
  [738] = {.lex_state = 4},
  [739] = {.lex_state = 4},
  [740] = {.lex_state = 4},
  [741] = {.lex_state = 4},
  [742] = {.lex_state = 4},
  [743] = {.lex_state = 4},
  [744] = {.lex_state = 4},
  [745] = {.lex_state = 4},
  [746] = {.lex_state = 4},
  [747] = {.lex_state = 4},
  [748] = {.lex_state = 9},
  [749] = {.lex_state = 4},
  [750] = {.lex_state = 7, .external_lex_state = 15},
  [751] = {.lex_state = 9},
  [752] = {.lex_state = 7, .external_lex_state = 15},
  [753] = {.lex_state = 7, .external_lex_state = 15},
  [754] = {.lex_state = 8},
  [755] = {.lex_state = 4},
  [756] = {.lex_state = 8},
  [757] = {.lex_state = 7, .external_lex_state = 15},
  [758] = {.lex_state = 9},
  [759] = {.lex_state = 7, .external_lex_state = 15},
  [760] = {.lex_state = 7, .external_lex_state = 15},
  [761] = {.lex_state = 7, .external_lex_state = 15},
  [762] = {.lex_state = 7, .external_lex_state = 15},
  [763] = {.lex_state = 7, .external_lex_state = 15},
  [764] = {.lex_state = 7, .external_lex_state = 15},
  [765] = {.lex_state = 4},
  [766] = {.lex_state = 4},
  [767] = {.lex_state = 9},
  [768] = {.lex_state = 4},
  [769] = {.lex_state = 7, .external_lex_state = 15},
  [770] = {.lex_state = 8},
  [771] = {.lex_state = 2},
  [772] = {.lex_state = 10},
  [773] = {.lex_state = 10},
  [774] = {.lex_state = 10},
  [775] = {.lex_state = 10},
  [776] = {.lex_state = 10},
  [777] = {.lex_state = 10},
  [778] = {.lex_state = 10},
  [779] = {.lex_state = 10},
  [780] = {.lex_state = 2, .external_lex_state = 25},
  [781] = {.lex_state = 2, .external_lex_state = 25},
  [782] = {.lex_state = 10},
  [783] = {.lex_state = 10},
  [784] = {.lex_state = 10},
  [785] = {.lex_state = 10},
  [786] = {.lex_state = 10},
  [787] = {.lex_state = 2, .external_lex_state = 20},
  [788] = {.lex_state = 10},
  [789] = {.lex_state = 2, .external_lex_state = 20},
  [790] = {.lex_state = 2, .external_lex_state = 20},
  [791] = {.lex_state = 2, .external_lex_state = 20},
  [792] = {.lex_state = 2},
  [793] = {.lex_state = 2, .external_lex_state = 20},
  [794] = {.lex_state = 2, .external_lex_state = 20},
  [795] = {.lex_state = 10},
  [796] = {.lex_state = 2},
  [797] = {.lex_state = 2, .external_lex_state = 20},
  [798] = {.lex_state = 10},
  [799] = {.lex_state = 2},
  [800] = {.lex_state = 10},
  [801] = {.lex_state = 10},
  [802] = {.lex_state = 10},
  [803] = {.lex_state = 2},
  [804] = {.lex_state = 2},
  [805] = {.lex_state = 2},
  [806] = {.lex_state = 2},
  [807] = {.lex_state = 2},
  [808] = {.lex_state = 2},
  [809] = {.lex_state = 2},
  [810] = {.lex_state = 2},
  [811] = {.lex_state = 2},
  [812] = {.lex_state = 2},
  [813] = {.lex_state = 2},
  [814] = {.lex_state = 2},
  [815] = {.lex_state = 2},
  [816] = {.lex_state = 2},
  [817] = {.lex_state = 2, .external_lex_state = 20},
  [818] = {.lex_state = 2},
  [819] = {.lex_state = 2},
  [820] = {.lex_state = 2},
  [821] = {.lex_state = 2},
  [822] = {.lex_state = 4},
  [823] = {.lex_state = 4, .external_lex_state = 20},
  [824] = {.lex_state = 9, .external_lex_state = 25},
  [825] = {.lex_state = 8, .external_lex_state = 20},
  [826] = {.lex_state = 2},
  [827] = {.lex_state = 9, .external_lex_state = 25},
  [828] = {.lex_state = 8, .external_lex_state = 25},
  [829] = {.lex_state = 8, .external_lex_state = 25},
  [830] = {.lex_state = 4, .external_lex_state = 25},
  [831] = {.lex_state = 4, .external_lex_state = 25},
  [832] = {.lex_state = 4, .external_lex_state = 20},
  [833] = {.lex_state = 9, .external_lex_state = 20},
  [834] = {.lex_state = 2177, .external_lex_state = 20},
  [835] = {.lex_state = 2},
  [836] = {.lex_state = 4},
  [837] = {.lex_state = 10, .external_lex_state = 20},
  [838] = {.lex_state = 10, .external_lex_state = 20},
  [839] = {.lex_state = 4},
  [840] = {.lex_state = 2177},
  [841] = {.lex_state = 9},
  [842] = {.lex_state = 9},
  [843] = {.lex_state = 4},
  [844] = {.lex_state = 4},
  [845] = {.lex_state = 8},
  [846] = {.lex_state = 8},
  [847] = {.lex_state = 10, .external_lex_state = 25},
  [848] = {.lex_state = 10, .external_lex_state = 25},
  [849] = {.lex_state = 10, .external_lex_state = 20},
  [850] = {.lex_state = 8},
  [851] = {.lex_state = 9},
  [852] = {.lex_state = 10},
  [853] = {.lex_state = 10},
  [854] = {.lex_state = 10},
  [855] = {.lex_state = 10},
  [856] = {.lex_state = 10},
  [857] = {.lex_state = 10},
  [858] = {.lex_state = 10},
  [859] = {.lex_state = 10},
  [860] = {.lex_state = 10},
  [861] = {.lex_state = 10},
  [862] = {.lex_state = 10},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 0},
  [867] = {.lex_state = 0},
  [868] = {.lex_state = 0},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 0},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 0},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 0},
  [875] = {.lex_state = 0},
  [876] = {.lex_state = 0},
  [877] = {.lex_state = 0},
  [878] = {.lex_state = 0},
  [879] = {.lex_state = 0},
  [880] = {.lex_state = 0},
  [881] = {.lex_state = 0},
  [882] = {.lex_state = 0},
  [883] = {.lex_state = 0},
  [884] = {.lex_state = 0},
  [885] = {.lex_state = 0},
  [886] = {.lex_state = 11},
  [887] = {.lex_state = 0},
  [888] = {.lex_state = 11},
  [889] = {.lex_state = 0},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 0},
  [892] = {.lex_state = 0},
  [893] = {.lex_state = 0},
  [894] = {.lex_state = 0},
  [895] = {.lex_state = 0},
  [896] = {.lex_state = 11},
  [897] = {.lex_state = 0},
  [898] = {.lex_state = 0},
  [899] = {.lex_state = 0},
  [900] = {.lex_state = 11},
  [901] = {.lex_state = 12},
  [902] = {.lex_state = 2177},
  [903] = {.lex_state = 12},
  [904] = {.lex_state = 12},
  [905] = {.lex_state = 2177},
  [906] = {.lex_state = 12},
  [907] = {.lex_state = 11},
  [908] = {.lex_state = 12},
  [909] = {.lex_state = 12},
  [910] = {.lex_state = 12},
  [911] = {.lex_state = 2177},
  [912] = {.lex_state = 12},
  [913] = {.lex_state = 12},
  [914] = {.lex_state = 12},
  [915] = {.lex_state = 12},
  [916] = {.lex_state = 12},
  [917] = {.lex_state = 12},
  [918] = {.lex_state = 0},
  [919] = {.lex_state = 0},
  [920] = {.lex_state = 0},
  [921] = {.lex_state = 0},
  [922] = {.lex_state = 0},
  [923] = {.lex_state = 0},
  [924] = {.lex_state = 0},
  [925] = {.lex_state = 0},
  [926] = {.lex_state = 0},
  [927] = {.lex_state = 0},
  [928] = {.lex_state = 0},
  [929] = {.lex_state = 0},
  [930] = {.lex_state = 0},
  [931] = {.lex_state = 0},
  [932] = {.lex_state = 0},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 0},
  [935] = {.lex_state = 0},
  [936] = {.lex_state = 0},
  [937] = {.lex_state = 0},
  [938] = {.lex_state = 0},
  [939] = {.lex_state = 0},
  [940] = {.lex_state = 0},
  [941] = {.lex_state = 0},
  [942] = {.lex_state = 0},
  [943] = {.lex_state = 0},
  [944] = {.lex_state = 0},
  [945] = {.lex_state = 0},
  [946] = {.lex_state = 0},
  [947] = {.lex_state = 0},
  [948] = {.lex_state = 0},
  [949] = {.lex_state = 0},
  [950] = {.lex_state = 0},
  [951] = {.lex_state = 0},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 0},
  [954] = {.lex_state = 0},
  [955] = {.lex_state = 0},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 0},
  [958] = {.lex_state = 0},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 0},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 0},
  [963] = {.lex_state = 0},
  [964] = {.lex_state = 0},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 0},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 0},
  [969] = {.lex_state = 0},
  [970] = {.lex_state = 0},
  [971] = {.lex_state = 0},
  [972] = {.lex_state = 0},
  [973] = {.lex_state = 0},
  [974] = {.lex_state = 0},
  [975] = {.lex_state = 0},
  [976] = {.lex_state = 0},
  [977] = {.lex_state = 0},
  [978] = {.lex_state = 0},
  [979] = {.lex_state = 0},
  [980] = {.lex_state = 0},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 0},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 0},
  [985] = {.lex_state = 0},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 0},
  [988] = {.lex_state = 0},
  [989] = {.lex_state = 0},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 12, .external_lex_state = 25},
  [992] = {.lex_state = 12, .external_lex_state = 25},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 12},
  [995] = {.lex_state = 0},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 0},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 0},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 0},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 0},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 0},
  [1006] = {.lex_state = 0},
  [1007] = {.lex_state = 0},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 0},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 0},
  [1012] = {.lex_state = 0},
  [1013] = {.lex_state = 0},
  [1014] = {.lex_state = 0},
  [1015] = {.lex_state = 0},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 0},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 0},
  [1020] = {.lex_state = 0},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 0},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 0},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 0},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 11, .external_lex_state = 25},
  [1030] = {.lex_state = 0},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 0},
  [1036] = {.lex_state = 11, .external_lex_state = 25},
  [1037] = {.lex_state = 11},
  [1038] = {.lex_state = 11},
  [1039] = {.lex_state = 12},
  [1040] = {.lex_state = 12},
  [1041] = {.lex_state = 0},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 0},
  [1045] = {.lex_state = 0},
  [1046] = {.lex_state = 0},
  [1047] = {.lex_state = 0},
  [1048] = {.lex_state = 0},
  [1049] = {.lex_state = 0},
  [1050] = {.lex_state = 0},
  [1051] = {.lex_state = 0},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 0},
  [1054] = {.lex_state = 0},
  [1055] = {.lex_state = 0},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 0},
  [1058] = {.lex_state = 0},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 0, .external_lex_state = 26},
  [1061] = {.lex_state = 0},
  [1062] = {.lex_state = 0},
  [1063] = {.lex_state = 0},
  [1064] = {.lex_state = 0},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 0},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 0, .external_lex_state = 27},
  [1069] = {.lex_state = 0},
  [1070] = {.lex_state = 0},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 0},
  [1073] = {.lex_state = 0},
  [1074] = {.lex_state = 0},
  [1075] = {.lex_state = 0},
  [1076] = {.lex_state = 0},
  [1077] = {.lex_state = 0, .external_lex_state = 27},
  [1078] = {.lex_state = 0, .external_lex_state = 27},
  [1079] = {.lex_state = 0},
  [1080] = {.lex_state = 0},
  [1081] = {.lex_state = 0},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 0},
  [1084] = {.lex_state = 0},
  [1085] = {.lex_state = 0},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 0},
  [1088] = {.lex_state = 0},
  [1089] = {.lex_state = 0},
  [1090] = {.lex_state = 0, .external_lex_state = 27},
};

enum {
  ts_external_token__error = 0,
  ts_external_token__trigger_error = 1,
  ts_external_token__code_span_start = 2,
  ts_external_token__code_span_close = 3,
  ts_external_token__emphasis_open_star = 4,
  ts_external_token__emphasis_open_underscore = 5,
  ts_external_token__emphasis_close_star = 6,
  ts_external_token__emphasis_close_underscore = 7,
  ts_external_token__last_token_whitespace = 8,
  ts_external_token__last_token_punctuation = 9,
  ts_external_token__strikethrough_open = 10,
  ts_external_token__strikethrough_close = 11,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__error] = sym__error,
  [ts_external_token__trigger_error] = sym__trigger_error,
  [ts_external_token__code_span_start] = sym__code_span_start,
  [ts_external_token__code_span_close] = sym__code_span_close,
  [ts_external_token__emphasis_open_star] = sym__emphasis_open_star,
  [ts_external_token__emphasis_open_underscore] = sym__emphasis_open_underscore,
  [ts_external_token__emphasis_close_star] = sym__emphasis_close_star,
  [ts_external_token__emphasis_close_underscore] = sym__emphasis_close_underscore,
  [ts_external_token__last_token_whitespace] = sym__last_token_whitespace,
  [ts_external_token__last_token_punctuation] = sym__last_token_punctuation,
  [ts_external_token__strikethrough_open] = sym__strikethrough_open,
  [ts_external_token__strikethrough_close] = sym__strikethrough_close,
};

static const bool ts_external_scanner_states[28][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__error] = true,
    [ts_external_token__trigger_error] = true,
    [ts_external_token__code_span_start] = true,
    [ts_external_token__code_span_close] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_star] = true,
    [ts_external_token__emphasis_close_underscore] = true,
    [ts_external_token__last_token_whitespace] = true,
    [ts_external_token__last_token_punctuation] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__strikethrough_close] = true,
  },
  [2] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__last_token_whitespace] = true,
    [ts_external_token__strikethrough_open] = true,
  },
  [3] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_underscore] = true,
    [ts_external_token__last_token_punctuation] = true,
    [ts_external_token__strikethrough_open] = true,
  },
  [4] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__last_token_punctuation] = true,
    [ts_external_token__strikethrough_open] = true,
  },
  [5] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__last_token_punctuation] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__strikethrough_close] = true,
  },
  [6] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_star] = true,
    [ts_external_token__last_token_punctuation] = true,
    [ts_external_token__strikethrough_open] = true,
  },
  [7] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_star] = true,
    [ts_external_token__strikethrough_open] = true,
  },
  [8] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_underscore] = true,
    [ts_external_token__strikethrough_open] = true,
  },
  [9] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__strikethrough_close] = true,
  },
  [10] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__strikethrough_open] = true,
  },
  [11] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__code_span_close] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__strikethrough_close] = true,
  },
  [12] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__code_span_close] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_underscore] = true,
    [ts_external_token__strikethrough_open] = true,
  },
  [13] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__code_span_close] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_star] = true,
    [ts_external_token__strikethrough_open] = true,
  },
  [14] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__code_span_close] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__strikethrough_open] = true,
  },
  [15] = {
    [ts_external_token__code_span_close] = true,
  },
  [16] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
  },
  [17] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_star] = true,
    [ts_external_token__last_token_whitespace] = true,
    [ts_external_token__strikethrough_open] = true,
  },
  [18] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__last_token_whitespace] = true,
    [ts_external_token__strikethrough_open] = true,
    [ts_external_token__strikethrough_close] = true,
  },
  [19] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__emphasis_close_underscore] = true,
    [ts_external_token__last_token_whitespace] = true,
    [ts_external_token__strikethrough_open] = true,
  },
  [20] = {
    [ts_external_token__last_token_punctuation] = true,
  },
  [21] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__last_token_punctuation] = true,
  },
  [22] = {
    [ts_external_token__code_span_start] = true,
    [ts_external_token__emphasis_open_star] = true,
    [ts_external_token__emphasis_open_underscore] = true,
    [ts_external_token__last_token_whitespace] = true,
  },
  [23] = {
    [ts_external_token__code_span_close] = true,
    [ts_external_token__last_token_punctuation] = true,
  },
  [24] = {
    [ts_external_token__code_span_close] = true,
    [ts_external_token__last_token_whitespace] = true,
  },
  [25] = {
    [ts_external_token__last_token_whitespace] = true,
  },
  [26] = {
    [ts_external_token__trigger_error] = true,
    [ts_external_token__last_token_whitespace] = true,
  },
  [27] = {
    [ts_external_token__trigger_error] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__backslash_escape] = ACTIONS(1),
    [sym_entity_reference] = ACTIONS(1),
    [sym_numeric_character_reference] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_BSLASH] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [sym__newline_token] = ACTIONS(1),
    [sym_uri_autolink] = ACTIONS(1),
    [sym_email_autolink] = ACTIONS(1),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1),
    [anon_sym_DASH_DASH_GT] = ACTIONS(1),
    [anon_sym_LT_QMARK] = ACTIONS(1),
    [anon_sym_QMARK_GT] = ACTIONS(1),
    [aux_sym__declaration_token1] = ACTIONS(1),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK_GT] = ACTIONS(1),
    [sym__whitespace_ge_2] = ACTIONS(1),
    [aux_sym__whitespace_token1] = ACTIONS(1),
    [sym__word_no_digit] = ACTIONS(1),
    [sym__digits] = ACTIONS(1),
    [sym__error] = ACTIONS(1),
    [sym__trigger_error] = ACTIONS(1),
    [sym__code_span_start] = ACTIONS(1),
    [sym__code_span_close] = ACTIONS(1),
    [sym__emphasis_open_star] = ACTIONS(1),
    [sym__emphasis_open_underscore] = ACTIONS(1),
    [sym__emphasis_close_star] = ACTIONS(1),
    [sym__emphasis_close_underscore] = ACTIONS(1),
    [sym__last_token_whitespace] = ACTIONS(1),
    [sym__last_token_punctuation] = ACTIONS(1),
    [sym__strikethrough_open] = ACTIONS(1),
    [sym__strikethrough_close] = ACTIONS(1),
  },
  [1] = {
    [sym_inline] = STATE(1071),
    [sym_backslash_escape] = STATE(152),
    [sym_code_span] = STATE(152),
    [sym__link_text] = STATE(1050),
    [sym__link_text_non_empty] = STATE(323),
    [sym_shortcut_link] = STATE(422),
    [sym_full_reference_link] = STATE(422),
    [sym_collapsed_reference_link] = STATE(422),
    [sym_inline_link] = STATE(422),
    [sym_image] = STATE(152),
    [sym__image_inline_link] = STATE(444),
    [sym__image_shortcut_link] = STATE(444),
    [sym__image_full_reference_link] = STATE(444),
    [sym__image_collapsed_reference_link] = STATE(444),
    [sym__image_description] = STATE(1055),
    [sym__image_description_non_empty] = STATE(433),
    [sym__html_tag] = STATE(425),
    [sym__open_tag] = STATE(423),
    [sym__closing_tag] = STATE(423),
    [sym__html_comment] = STATE(423),
    [sym__processing_instruction] = STATE(423),
    [sym__declaration] = STATE(423),
    [sym__cdata_section] = STATE(423),
    [sym_hard_line_break] = STATE(152),
    [sym__whitespace] = STATE(152),
    [sym__word] = STATE(152),
    [sym__soft_line_break] = STATE(152),
    [sym__inline_base] = STATE(422),
    [sym__text_base] = STATE(152),
    [sym__inline_element] = STATE(422),
    [aux_sym__inline] = STATE(34),
    [sym__strikethrough] = STATE(422),
    [sym__emphasis_star] = STATE(415),
    [sym__strong_emphasis_star] = STATE(422),
    [sym__emphasis_underscore] = STATE(415),
    [sym__strong_emphasis_underscore] = STATE(422),
    [aux_sym__inline_base_repeat1] = STATE(152),
    [sym__backslash_escape] = ACTIONS(3),
    [sym_entity_reference] = ACTIONS(5),
    [sym_numeric_character_reference] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(9),
    [anon_sym_LT] = ACTIONS(11),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_POUND] = ACTIONS(13),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_PERCENT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SLASH] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_BSLASH] = ACTIONS(19),
    [anon_sym_CARET] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(13),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(13),
    [sym__newline_token] = ACTIONS(21),
    [sym_uri_autolink] = ACTIONS(5),
    [sym_email_autolink] = ACTIONS(5),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(23),
    [anon_sym_LT_QMARK] = ACTIONS(25),
    [aux_sym__declaration_token1] = ACTIONS(27),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(29),
    [sym__whitespace_ge_2] = ACTIONS(31),
    [aux_sym__whitespace_token1] = ACTIONS(33),
    [sym__word_no_digit] = ACTIONS(5),
    [sym__digits] = ACTIONS(5),
    [sym__code_span_start] = ACTIONS(35),
    [sym__emphasis_open_star] = ACTIONS(37),
    [sym__emphasis_open_underscore] = ACTIONS(39),
    [sym__last_token_whitespace] = ACTIONS(41),
    [sym__strikethrough_open] = ACTIONS(43),
  },
  [2] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(38),
    [sym_full_reference_link] = STATE(38),
    [sym_collapsed_reference_link] = STATE(38),
    [sym_inline_link] = STATE(38),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(38),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(38),
    [aux_sym__inline_no_tilde] = STATE(38),
    [sym__strikethrough] = STATE(38),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(38),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(38),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(45),
    [sym_entity_reference] = ACTIONS(48),
    [sym_numeric_character_reference] = ACTIONS(48),
    [anon_sym_LBRACK] = ACTIONS(51),
    [anon_sym_RBRACK] = ACTIONS(54),
    [anon_sym_LT] = ACTIONS(57),
    [anon_sym_GT] = ACTIONS(60),
    [anon_sym_BANG] = ACTIONS(63),
    [anon_sym_DQUOTE] = ACTIONS(60),
    [anon_sym_POUND] = ACTIONS(60),
    [anon_sym_DOLLAR] = ACTIONS(60),
    [anon_sym_PERCENT] = ACTIONS(60),
    [anon_sym_AMP] = ACTIONS(66),
    [anon_sym_SQUOTE] = ACTIONS(60),
    [anon_sym_STAR] = ACTIONS(60),
    [anon_sym_PLUS] = ACTIONS(60),
    [anon_sym_COMMA] = ACTIONS(60),
    [anon_sym_DASH] = ACTIONS(60),
    [anon_sym_DOT] = ACTIONS(60),
    [anon_sym_SLASH] = ACTIONS(60),
    [anon_sym_COLON] = ACTIONS(60),
    [anon_sym_SEMI] = ACTIONS(60),
    [anon_sym_EQ] = ACTIONS(60),
    [anon_sym_QMARK] = ACTIONS(60),
    [anon_sym_AT] = ACTIONS(60),
    [anon_sym_BSLASH] = ACTIONS(69),
    [anon_sym_CARET] = ACTIONS(60),
    [anon_sym__] = ACTIONS(60),
    [anon_sym_BQUOTE] = ACTIONS(60),
    [anon_sym_LBRACE] = ACTIONS(60),
    [anon_sym_PIPE] = ACTIONS(60),
    [anon_sym_RBRACE] = ACTIONS(60),
    [anon_sym_TILDE] = ACTIONS(60),
    [anon_sym_LPAREN] = ACTIONS(60),
    [anon_sym_RPAREN] = ACTIONS(60),
    [sym__newline_token] = ACTIONS(72),
    [sym_uri_autolink] = ACTIONS(48),
    [sym_email_autolink] = ACTIONS(48),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(75),
    [anon_sym_LT_QMARK] = ACTIONS(78),
    [aux_sym__declaration_token1] = ACTIONS(81),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(84),
    [sym__whitespace_ge_2] = ACTIONS(87),
    [aux_sym__whitespace_token1] = ACTIONS(90),
    [sym__word_no_digit] = ACTIONS(48),
    [sym__digits] = ACTIONS(48),
    [sym__code_span_start] = ACTIONS(93),
    [sym__emphasis_open_star] = ACTIONS(96),
    [sym__emphasis_open_underscore] = ACTIONS(99),
    [sym__emphasis_close_underscore] = ACTIONS(102),
    [sym__last_token_punctuation] = ACTIONS(104),
    [sym__strikethrough_open] = ACTIONS(106),
  },
  [3] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(43),
    [sym_full_reference_link] = STATE(43),
    [sym_collapsed_reference_link] = STATE(43),
    [sym_inline_link] = STATE(43),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(43),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(43),
    [aux_sym__inline_no_star] = STATE(43),
    [sym__strikethrough] = STATE(43),
    [sym__emphasis_star] = STATE(349),
    [sym__strong_emphasis_star] = STATE(43),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(43),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [ts_builtin_sym_end] = ACTIONS(109),
    [sym__backslash_escape] = ACTIONS(111),
    [sym_entity_reference] = ACTIONS(114),
    [sym_numeric_character_reference] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_RBRACK] = ACTIONS(120),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(129),
    [anon_sym_DQUOTE] = ACTIONS(126),
    [anon_sym_POUND] = ACTIONS(126),
    [anon_sym_DOLLAR] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(126),
    [anon_sym_AMP] = ACTIONS(132),
    [anon_sym_SQUOTE] = ACTIONS(126),
    [anon_sym_STAR] = ACTIONS(126),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_COMMA] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_DOT] = ACTIONS(126),
    [anon_sym_SLASH] = ACTIONS(126),
    [anon_sym_COLON] = ACTIONS(126),
    [anon_sym_SEMI] = ACTIONS(126),
    [anon_sym_EQ] = ACTIONS(126),
    [anon_sym_QMARK] = ACTIONS(126),
    [anon_sym_AT] = ACTIONS(126),
    [anon_sym_BSLASH] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(126),
    [anon_sym__] = ACTIONS(126),
    [anon_sym_BQUOTE] = ACTIONS(126),
    [anon_sym_LBRACE] = ACTIONS(126),
    [anon_sym_PIPE] = ACTIONS(126),
    [anon_sym_RBRACE] = ACTIONS(126),
    [anon_sym_TILDE] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(126),
    [anon_sym_RPAREN] = ACTIONS(126),
    [sym__newline_token] = ACTIONS(138),
    [sym_uri_autolink] = ACTIONS(114),
    [sym_email_autolink] = ACTIONS(114),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(141),
    [anon_sym_LT_QMARK] = ACTIONS(144),
    [aux_sym__declaration_token1] = ACTIONS(147),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(150),
    [sym__whitespace_ge_2] = ACTIONS(153),
    [aux_sym__whitespace_token1] = ACTIONS(156),
    [sym__word_no_digit] = ACTIONS(114),
    [sym__digits] = ACTIONS(114),
    [sym__code_span_start] = ACTIONS(159),
    [sym__emphasis_open_star] = ACTIONS(162),
    [sym__emphasis_open_underscore] = ACTIONS(165),
    [sym__last_token_punctuation] = ACTIONS(168),
    [sym__strikethrough_open] = ACTIONS(170),
  },
  [4] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(50),
    [sym_full_reference_link] = STATE(50),
    [sym_collapsed_reference_link] = STATE(50),
    [sym_inline_link] = STATE(50),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(50),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(50),
    [aux_sym__inline_no_underscore] = STATE(50),
    [sym__strikethrough] = STATE(50),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(50),
    [sym__emphasis_underscore] = STATE(326),
    [sym__strong_emphasis_underscore] = STATE(50),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [ts_builtin_sym_end] = ACTIONS(109),
    [sym__backslash_escape] = ACTIONS(173),
    [sym_entity_reference] = ACTIONS(176),
    [sym_numeric_character_reference] = ACTIONS(176),
    [anon_sym_LBRACK] = ACTIONS(179),
    [anon_sym_RBRACK] = ACTIONS(182),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_GT] = ACTIONS(188),
    [anon_sym_BANG] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(188),
    [anon_sym_POUND] = ACTIONS(188),
    [anon_sym_DOLLAR] = ACTIONS(188),
    [anon_sym_PERCENT] = ACTIONS(188),
    [anon_sym_AMP] = ACTIONS(194),
    [anon_sym_SQUOTE] = ACTIONS(188),
    [anon_sym_STAR] = ACTIONS(188),
    [anon_sym_PLUS] = ACTIONS(188),
    [anon_sym_COMMA] = ACTIONS(188),
    [anon_sym_DASH] = ACTIONS(188),
    [anon_sym_DOT] = ACTIONS(188),
    [anon_sym_SLASH] = ACTIONS(188),
    [anon_sym_COLON] = ACTIONS(188),
    [anon_sym_SEMI] = ACTIONS(188),
    [anon_sym_EQ] = ACTIONS(188),
    [anon_sym_QMARK] = ACTIONS(188),
    [anon_sym_AT] = ACTIONS(188),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_CARET] = ACTIONS(188),
    [anon_sym__] = ACTIONS(188),
    [anon_sym_BQUOTE] = ACTIONS(188),
    [anon_sym_LBRACE] = ACTIONS(188),
    [anon_sym_PIPE] = ACTIONS(188),
    [anon_sym_RBRACE] = ACTIONS(188),
    [anon_sym_TILDE] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(188),
    [anon_sym_RPAREN] = ACTIONS(188),
    [sym__newline_token] = ACTIONS(200),
    [sym_uri_autolink] = ACTIONS(176),
    [sym_email_autolink] = ACTIONS(176),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(203),
    [anon_sym_LT_QMARK] = ACTIONS(206),
    [aux_sym__declaration_token1] = ACTIONS(209),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(212),
    [sym__whitespace_ge_2] = ACTIONS(215),
    [aux_sym__whitespace_token1] = ACTIONS(218),
    [sym__word_no_digit] = ACTIONS(176),
    [sym__digits] = ACTIONS(176),
    [sym__code_span_start] = ACTIONS(221),
    [sym__emphasis_open_star] = ACTIONS(224),
    [sym__emphasis_open_underscore] = ACTIONS(227),
    [sym__last_token_punctuation] = ACTIONS(230),
    [sym__strikethrough_open] = ACTIONS(232),
  },
  [5] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(30),
    [sym_full_reference_link] = STATE(30),
    [sym_collapsed_reference_link] = STATE(30),
    [sym_inline_link] = STATE(30),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(30),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(30),
    [aux_sym__inline_no_underscore] = STATE(30),
    [sym__strikethrough] = STATE(30),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(30),
    [sym__emphasis_underscore] = STATE(504),
    [sym__strong_emphasis_underscore] = STATE(30),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(235),
    [sym_entity_reference] = ACTIONS(238),
    [sym_numeric_character_reference] = ACTIONS(238),
    [anon_sym_LBRACK] = ACTIONS(241),
    [anon_sym_RBRACK] = ACTIONS(244),
    [anon_sym_LT] = ACTIONS(247),
    [anon_sym_GT] = ACTIONS(250),
    [anon_sym_BANG] = ACTIONS(253),
    [anon_sym_DQUOTE] = ACTIONS(250),
    [anon_sym_POUND] = ACTIONS(250),
    [anon_sym_DOLLAR] = ACTIONS(250),
    [anon_sym_PERCENT] = ACTIONS(250),
    [anon_sym_AMP] = ACTIONS(256),
    [anon_sym_SQUOTE] = ACTIONS(250),
    [anon_sym_STAR] = ACTIONS(250),
    [anon_sym_PLUS] = ACTIONS(250),
    [anon_sym_COMMA] = ACTIONS(250),
    [anon_sym_DASH] = ACTIONS(250),
    [anon_sym_DOT] = ACTIONS(250),
    [anon_sym_SLASH] = ACTIONS(250),
    [anon_sym_COLON] = ACTIONS(250),
    [anon_sym_SEMI] = ACTIONS(250),
    [anon_sym_EQ] = ACTIONS(250),
    [anon_sym_QMARK] = ACTIONS(250),
    [anon_sym_AT] = ACTIONS(250),
    [anon_sym_BSLASH] = ACTIONS(259),
    [anon_sym_CARET] = ACTIONS(250),
    [anon_sym__] = ACTIONS(250),
    [anon_sym_BQUOTE] = ACTIONS(250),
    [anon_sym_LBRACE] = ACTIONS(250),
    [anon_sym_PIPE] = ACTIONS(250),
    [anon_sym_RBRACE] = ACTIONS(250),
    [anon_sym_TILDE] = ACTIONS(250),
    [anon_sym_LPAREN] = ACTIONS(250),
    [anon_sym_RPAREN] = ACTIONS(250),
    [sym__newline_token] = ACTIONS(262),
    [sym_uri_autolink] = ACTIONS(238),
    [sym_email_autolink] = ACTIONS(238),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(265),
    [anon_sym_LT_QMARK] = ACTIONS(268),
    [aux_sym__declaration_token1] = ACTIONS(271),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(274),
    [sym__whitespace_ge_2] = ACTIONS(277),
    [aux_sym__whitespace_token1] = ACTIONS(280),
    [sym__word_no_digit] = ACTIONS(238),
    [sym__digits] = ACTIONS(238),
    [sym__code_span_start] = ACTIONS(283),
    [sym__emphasis_open_star] = ACTIONS(286),
    [sym__emphasis_open_underscore] = ACTIONS(289),
    [sym__last_token_punctuation] = ACTIONS(292),
    [sym__strikethrough_open] = ACTIONS(294),
    [sym__strikethrough_close] = ACTIONS(297),
  },
  [6] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(41),
    [sym_full_reference_link] = STATE(41),
    [sym_collapsed_reference_link] = STATE(41),
    [sym_inline_link] = STATE(41),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(41),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(41),
    [aux_sym__inline_no_tilde] = STATE(41),
    [sym__strikethrough] = STATE(41),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(41),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(41),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [ts_builtin_sym_end] = ACTIONS(109),
    [sym__backslash_escape] = ACTIONS(299),
    [sym_entity_reference] = ACTIONS(302),
    [sym_numeric_character_reference] = ACTIONS(302),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_RBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_POUND] = ACTIONS(314),
    [anon_sym_DOLLAR] = ACTIONS(314),
    [anon_sym_PERCENT] = ACTIONS(314),
    [anon_sym_AMP] = ACTIONS(320),
    [anon_sym_SQUOTE] = ACTIONS(314),
    [anon_sym_STAR] = ACTIONS(314),
    [anon_sym_PLUS] = ACTIONS(314),
    [anon_sym_COMMA] = ACTIONS(314),
    [anon_sym_DASH] = ACTIONS(314),
    [anon_sym_DOT] = ACTIONS(314),
    [anon_sym_SLASH] = ACTIONS(314),
    [anon_sym_COLON] = ACTIONS(314),
    [anon_sym_SEMI] = ACTIONS(314),
    [anon_sym_EQ] = ACTIONS(314),
    [anon_sym_QMARK] = ACTIONS(314),
    [anon_sym_AT] = ACTIONS(314),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_CARET] = ACTIONS(314),
    [anon_sym__] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(314),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_RBRACE] = ACTIONS(314),
    [anon_sym_TILDE] = ACTIONS(314),
    [anon_sym_LPAREN] = ACTIONS(314),
    [anon_sym_RPAREN] = ACTIONS(314),
    [sym__newline_token] = ACTIONS(326),
    [sym_uri_autolink] = ACTIONS(302),
    [sym_email_autolink] = ACTIONS(302),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(329),
    [anon_sym_LT_QMARK] = ACTIONS(332),
    [aux_sym__declaration_token1] = ACTIONS(335),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(338),
    [sym__whitespace_ge_2] = ACTIONS(341),
    [aux_sym__whitespace_token1] = ACTIONS(344),
    [sym__word_no_digit] = ACTIONS(302),
    [sym__digits] = ACTIONS(302),
    [sym__code_span_start] = ACTIONS(347),
    [sym__emphasis_open_star] = ACTIONS(350),
    [sym__emphasis_open_underscore] = ACTIONS(353),
    [sym__last_token_punctuation] = ACTIONS(356),
    [sym__strikethrough_open] = ACTIONS(358),
  },
  [7] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(23),
    [sym_full_reference_link] = STATE(23),
    [sym_collapsed_reference_link] = STATE(23),
    [sym_inline_link] = STATE(23),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(23),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(23),
    [aux_sym__inline_no_star] = STATE(23),
    [sym__strikethrough] = STATE(23),
    [sym__emphasis_star] = STATE(287),
    [sym__strong_emphasis_star] = STATE(23),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(23),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(361),
    [sym_entity_reference] = ACTIONS(364),
    [sym_numeric_character_reference] = ACTIONS(364),
    [anon_sym_LBRACK] = ACTIONS(367),
    [anon_sym_RBRACK] = ACTIONS(370),
    [anon_sym_LT] = ACTIONS(373),
    [anon_sym_GT] = ACTIONS(376),
    [anon_sym_BANG] = ACTIONS(379),
    [anon_sym_DQUOTE] = ACTIONS(376),
    [anon_sym_POUND] = ACTIONS(376),
    [anon_sym_DOLLAR] = ACTIONS(376),
    [anon_sym_PERCENT] = ACTIONS(376),
    [anon_sym_AMP] = ACTIONS(382),
    [anon_sym_SQUOTE] = ACTIONS(376),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_PLUS] = ACTIONS(376),
    [anon_sym_COMMA] = ACTIONS(376),
    [anon_sym_DASH] = ACTIONS(376),
    [anon_sym_DOT] = ACTIONS(376),
    [anon_sym_SLASH] = ACTIONS(376),
    [anon_sym_COLON] = ACTIONS(376),
    [anon_sym_SEMI] = ACTIONS(376),
    [anon_sym_EQ] = ACTIONS(376),
    [anon_sym_QMARK] = ACTIONS(376),
    [anon_sym_AT] = ACTIONS(376),
    [anon_sym_BSLASH] = ACTIONS(385),
    [anon_sym_CARET] = ACTIONS(376),
    [anon_sym__] = ACTIONS(376),
    [anon_sym_BQUOTE] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(376),
    [anon_sym_PIPE] = ACTIONS(376),
    [anon_sym_RBRACE] = ACTIONS(376),
    [anon_sym_TILDE] = ACTIONS(376),
    [anon_sym_LPAREN] = ACTIONS(376),
    [anon_sym_RPAREN] = ACTIONS(376),
    [sym__newline_token] = ACTIONS(388),
    [sym_uri_autolink] = ACTIONS(364),
    [sym_email_autolink] = ACTIONS(364),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(391),
    [anon_sym_LT_QMARK] = ACTIONS(394),
    [aux_sym__declaration_token1] = ACTIONS(397),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(400),
    [sym__whitespace_ge_2] = ACTIONS(403),
    [aux_sym__whitespace_token1] = ACTIONS(406),
    [sym__word_no_digit] = ACTIONS(364),
    [sym__digits] = ACTIONS(364),
    [sym__code_span_start] = ACTIONS(409),
    [sym__emphasis_open_star] = ACTIONS(412),
    [sym__emphasis_open_underscore] = ACTIONS(415),
    [sym__last_token_punctuation] = ACTIONS(418),
    [sym__strikethrough_open] = ACTIONS(420),
    [sym__strikethrough_close] = ACTIONS(297),
  },
  [8] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(21),
    [sym_full_reference_link] = STATE(21),
    [sym_collapsed_reference_link] = STATE(21),
    [sym_inline_link] = STATE(21),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(21),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(21),
    [aux_sym__inline_no_underscore] = STATE(21),
    [sym__strikethrough] = STATE(21),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(21),
    [sym__emphasis_underscore] = STATE(282),
    [sym__strong_emphasis_underscore] = STATE(21),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(423),
    [sym_entity_reference] = ACTIONS(426),
    [sym_numeric_character_reference] = ACTIONS(426),
    [anon_sym_LBRACK] = ACTIONS(429),
    [anon_sym_RBRACK] = ACTIONS(432),
    [anon_sym_LT] = ACTIONS(435),
    [anon_sym_GT] = ACTIONS(438),
    [anon_sym_BANG] = ACTIONS(441),
    [anon_sym_DQUOTE] = ACTIONS(438),
    [anon_sym_POUND] = ACTIONS(438),
    [anon_sym_DOLLAR] = ACTIONS(438),
    [anon_sym_PERCENT] = ACTIONS(438),
    [anon_sym_AMP] = ACTIONS(444),
    [anon_sym_SQUOTE] = ACTIONS(438),
    [anon_sym_STAR] = ACTIONS(438),
    [anon_sym_PLUS] = ACTIONS(438),
    [anon_sym_COMMA] = ACTIONS(438),
    [anon_sym_DASH] = ACTIONS(438),
    [anon_sym_DOT] = ACTIONS(438),
    [anon_sym_SLASH] = ACTIONS(438),
    [anon_sym_COLON] = ACTIONS(438),
    [anon_sym_SEMI] = ACTIONS(438),
    [anon_sym_EQ] = ACTIONS(438),
    [anon_sym_QMARK] = ACTIONS(438),
    [anon_sym_AT] = ACTIONS(438),
    [anon_sym_BSLASH] = ACTIONS(447),
    [anon_sym_CARET] = ACTIONS(438),
    [anon_sym__] = ACTIONS(438),
    [anon_sym_BQUOTE] = ACTIONS(438),
    [anon_sym_LBRACE] = ACTIONS(438),
    [anon_sym_PIPE] = ACTIONS(438),
    [anon_sym_RBRACE] = ACTIONS(438),
    [anon_sym_TILDE] = ACTIONS(438),
    [anon_sym_LPAREN] = ACTIONS(438),
    [anon_sym_RPAREN] = ACTIONS(438),
    [sym__newline_token] = ACTIONS(450),
    [sym_uri_autolink] = ACTIONS(426),
    [sym_email_autolink] = ACTIONS(426),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(453),
    [anon_sym_LT_QMARK] = ACTIONS(456),
    [aux_sym__declaration_token1] = ACTIONS(459),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(462),
    [sym__whitespace_ge_2] = ACTIONS(465),
    [aux_sym__whitespace_token1] = ACTIONS(468),
    [sym__word_no_digit] = ACTIONS(426),
    [sym__digits] = ACTIONS(426),
    [sym__code_span_start] = ACTIONS(471),
    [sym__emphasis_open_star] = ACTIONS(474),
    [sym__emphasis_open_underscore] = ACTIONS(477),
    [sym__emphasis_close_star] = ACTIONS(480),
    [sym__last_token_punctuation] = ACTIONS(482),
    [sym__strikethrough_open] = ACTIONS(484),
  },
  [9] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(29),
    [sym_full_reference_link] = STATE(29),
    [sym_collapsed_reference_link] = STATE(29),
    [sym_inline_link] = STATE(29),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(29),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(29),
    [aux_sym__inline_no_star] = STATE(29),
    [sym__strikethrough] = STATE(29),
    [sym__emphasis_star] = STATE(309),
    [sym__strong_emphasis_star] = STATE(29),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(29),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(487),
    [sym_entity_reference] = ACTIONS(490),
    [sym_numeric_character_reference] = ACTIONS(490),
    [anon_sym_LBRACK] = ACTIONS(493),
    [anon_sym_RBRACK] = ACTIONS(496),
    [anon_sym_LT] = ACTIONS(499),
    [anon_sym_GT] = ACTIONS(502),
    [anon_sym_BANG] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(502),
    [anon_sym_POUND] = ACTIONS(502),
    [anon_sym_DOLLAR] = ACTIONS(502),
    [anon_sym_PERCENT] = ACTIONS(502),
    [anon_sym_AMP] = ACTIONS(508),
    [anon_sym_SQUOTE] = ACTIONS(502),
    [anon_sym_STAR] = ACTIONS(502),
    [anon_sym_PLUS] = ACTIONS(502),
    [anon_sym_COMMA] = ACTIONS(502),
    [anon_sym_DASH] = ACTIONS(502),
    [anon_sym_DOT] = ACTIONS(502),
    [anon_sym_SLASH] = ACTIONS(502),
    [anon_sym_COLON] = ACTIONS(502),
    [anon_sym_SEMI] = ACTIONS(502),
    [anon_sym_EQ] = ACTIONS(502),
    [anon_sym_QMARK] = ACTIONS(502),
    [anon_sym_AT] = ACTIONS(502),
    [anon_sym_BSLASH] = ACTIONS(511),
    [anon_sym_CARET] = ACTIONS(502),
    [anon_sym__] = ACTIONS(502),
    [anon_sym_BQUOTE] = ACTIONS(502),
    [anon_sym_LBRACE] = ACTIONS(502),
    [anon_sym_PIPE] = ACTIONS(502),
    [anon_sym_RBRACE] = ACTIONS(502),
    [anon_sym_TILDE] = ACTIONS(502),
    [anon_sym_LPAREN] = ACTIONS(502),
    [anon_sym_RPAREN] = ACTIONS(502),
    [sym__newline_token] = ACTIONS(514),
    [sym_uri_autolink] = ACTIONS(490),
    [sym_email_autolink] = ACTIONS(490),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(517),
    [anon_sym_LT_QMARK] = ACTIONS(520),
    [aux_sym__declaration_token1] = ACTIONS(523),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(526),
    [sym__whitespace_ge_2] = ACTIONS(529),
    [aux_sym__whitespace_token1] = ACTIONS(532),
    [sym__word_no_digit] = ACTIONS(490),
    [sym__digits] = ACTIONS(490),
    [sym__code_span_start] = ACTIONS(535),
    [sym__emphasis_open_star] = ACTIONS(538),
    [sym__emphasis_open_underscore] = ACTIONS(541),
    [sym__emphasis_close_underscore] = ACTIONS(102),
    [sym__last_token_punctuation] = ACTIONS(544),
    [sym__strikethrough_open] = ACTIONS(546),
  },
  [10] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(22),
    [sym_full_reference_link] = STATE(22),
    [sym_collapsed_reference_link] = STATE(22),
    [sym_inline_link] = STATE(22),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(22),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(22),
    [aux_sym__inline_no_tilde] = STATE(22),
    [sym__strikethrough] = STATE(22),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(22),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(22),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(549),
    [sym_entity_reference] = ACTIONS(552),
    [sym_numeric_character_reference] = ACTIONS(552),
    [anon_sym_LBRACK] = ACTIONS(555),
    [anon_sym_RBRACK] = ACTIONS(558),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_DQUOTE] = ACTIONS(564),
    [anon_sym_POUND] = ACTIONS(564),
    [anon_sym_DOLLAR] = ACTIONS(564),
    [anon_sym_PERCENT] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(570),
    [anon_sym_SQUOTE] = ACTIONS(564),
    [anon_sym_STAR] = ACTIONS(564),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_COMMA] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(564),
    [anon_sym_SLASH] = ACTIONS(564),
    [anon_sym_COLON] = ACTIONS(564),
    [anon_sym_SEMI] = ACTIONS(564),
    [anon_sym_EQ] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(564),
    [anon_sym_AT] = ACTIONS(564),
    [anon_sym_BSLASH] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(564),
    [anon_sym__] = ACTIONS(564),
    [anon_sym_BQUOTE] = ACTIONS(564),
    [anon_sym_LBRACE] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(564),
    [anon_sym_RBRACE] = ACTIONS(564),
    [anon_sym_TILDE] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(564),
    [anon_sym_RPAREN] = ACTIONS(564),
    [sym__newline_token] = ACTIONS(576),
    [sym_uri_autolink] = ACTIONS(552),
    [sym_email_autolink] = ACTIONS(552),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(579),
    [anon_sym_LT_QMARK] = ACTIONS(582),
    [aux_sym__declaration_token1] = ACTIONS(585),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(588),
    [sym__whitespace_ge_2] = ACTIONS(591),
    [aux_sym__whitespace_token1] = ACTIONS(594),
    [sym__word_no_digit] = ACTIONS(552),
    [sym__digits] = ACTIONS(552),
    [sym__code_span_start] = ACTIONS(597),
    [sym__emphasis_open_star] = ACTIONS(600),
    [sym__emphasis_open_underscore] = ACTIONS(603),
    [sym__emphasis_close_star] = ACTIONS(480),
    [sym__last_token_punctuation] = ACTIONS(606),
    [sym__strikethrough_open] = ACTIONS(608),
  },
  [11] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(11),
    [sym_full_reference_link] = STATE(11),
    [sym_collapsed_reference_link] = STATE(11),
    [sym_inline_link] = STATE(11),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(11),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(11),
    [aux_sym__inline_no_star] = STATE(11),
    [sym__strikethrough] = STATE(11),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(11),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(11),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(611),
    [sym_entity_reference] = ACTIONS(614),
    [sym_numeric_character_reference] = ACTIONS(614),
    [anon_sym_LBRACK] = ACTIONS(617),
    [anon_sym_RBRACK] = ACTIONS(620),
    [anon_sym_LT] = ACTIONS(623),
    [anon_sym_GT] = ACTIONS(626),
    [anon_sym_BANG] = ACTIONS(629),
    [anon_sym_DQUOTE] = ACTIONS(626),
    [anon_sym_POUND] = ACTIONS(626),
    [anon_sym_DOLLAR] = ACTIONS(626),
    [anon_sym_PERCENT] = ACTIONS(626),
    [anon_sym_AMP] = ACTIONS(632),
    [anon_sym_SQUOTE] = ACTIONS(626),
    [anon_sym_STAR] = ACTIONS(626),
    [anon_sym_PLUS] = ACTIONS(626),
    [anon_sym_COMMA] = ACTIONS(626),
    [anon_sym_DASH] = ACTIONS(626),
    [anon_sym_DOT] = ACTIONS(626),
    [anon_sym_SLASH] = ACTIONS(626),
    [anon_sym_COLON] = ACTIONS(626),
    [anon_sym_SEMI] = ACTIONS(626),
    [anon_sym_EQ] = ACTIONS(626),
    [anon_sym_QMARK] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(626),
    [anon_sym_BSLASH] = ACTIONS(635),
    [anon_sym_CARET] = ACTIONS(626),
    [anon_sym__] = ACTIONS(626),
    [anon_sym_BQUOTE] = ACTIONS(626),
    [anon_sym_LBRACE] = ACTIONS(626),
    [anon_sym_PIPE] = ACTIONS(626),
    [anon_sym_RBRACE] = ACTIONS(626),
    [anon_sym_TILDE] = ACTIONS(626),
    [anon_sym_LPAREN] = ACTIONS(626),
    [anon_sym_RPAREN] = ACTIONS(626),
    [sym__newline_token] = ACTIONS(638),
    [sym_uri_autolink] = ACTIONS(614),
    [sym_email_autolink] = ACTIONS(614),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(641),
    [anon_sym_LT_QMARK] = ACTIONS(644),
    [aux_sym__declaration_token1] = ACTIONS(647),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(650),
    [sym__whitespace_ge_2] = ACTIONS(653),
    [aux_sym__whitespace_token1] = ACTIONS(656),
    [sym__word_no_digit] = ACTIONS(614),
    [sym__digits] = ACTIONS(614),
    [sym__code_span_start] = ACTIONS(659),
    [sym__emphasis_open_star] = ACTIONS(662),
    [sym__emphasis_open_underscore] = ACTIONS(665),
    [sym__emphasis_close_star] = ACTIONS(668),
    [sym__strikethrough_open] = ACTIONS(670),
  },
  [12] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(35),
    [sym_full_reference_link] = STATE(35),
    [sym_collapsed_reference_link] = STATE(35),
    [sym_inline_link] = STATE(35),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(35),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(35),
    [aux_sym__inline_no_tilde] = STATE(35),
    [sym__strikethrough] = STATE(35),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(35),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(35),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__last_token_punctuation] = ACTIONS(711),
    [sym__strikethrough_open] = ACTIONS(713),
  },
  [13] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(11),
    [sym_full_reference_link] = STATE(11),
    [sym_collapsed_reference_link] = STATE(11),
    [sym_inline_link] = STATE(11),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(11),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(11),
    [aux_sym__inline_no_star] = STATE(11),
    [sym__strikethrough] = STATE(11),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(11),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(11),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__emphasis_close_star] = ACTIONS(753),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [14] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(44),
    [sym_full_reference_link] = STATE(44),
    [sym_collapsed_reference_link] = STATE(44),
    [sym_inline_link] = STATE(44),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(44),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(44),
    [aux_sym__inline_no_underscore] = STATE(44),
    [sym__strikethrough] = STATE(44),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(44),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(44),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__emphasis_close_underscore] = ACTIONS(795),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [15] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(28),
    [sym_full_reference_link] = STATE(28),
    [sym_collapsed_reference_link] = STATE(28),
    [sym_inline_link] = STATE(28),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(28),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(28),
    [aux_sym__inline_no_tilde] = STATE(28),
    [sym__strikethrough] = STATE(28),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(28),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(28),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
    [sym__strikethrough_close] = ACTIONS(799),
  },
  [16] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(11),
    [sym_full_reference_link] = STATE(11),
    [sym_collapsed_reference_link] = STATE(11),
    [sym_inline_link] = STATE(11),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(11),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(11),
    [aux_sym__inline_no_star] = STATE(11),
    [sym__strikethrough] = STATE(11),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(11),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(11),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__emphasis_close_star] = ACTIONS(801),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [17] = {
    [sym_backslash_escape] = STATE(152),
    [sym_code_span] = STATE(152),
    [sym__link_text] = STATE(1050),
    [sym__link_text_non_empty] = STATE(323),
    [sym_shortcut_link] = STATE(422),
    [sym_full_reference_link] = STATE(422),
    [sym_collapsed_reference_link] = STATE(422),
    [sym_inline_link] = STATE(422),
    [sym_image] = STATE(152),
    [sym__image_inline_link] = STATE(444),
    [sym__image_shortcut_link] = STATE(444),
    [sym__image_full_reference_link] = STATE(444),
    [sym__image_collapsed_reference_link] = STATE(444),
    [sym__image_description] = STATE(1055),
    [sym__image_description_non_empty] = STATE(433),
    [sym__html_tag] = STATE(425),
    [sym__open_tag] = STATE(423),
    [sym__closing_tag] = STATE(423),
    [sym__html_comment] = STATE(423),
    [sym__processing_instruction] = STATE(423),
    [sym__declaration] = STATE(423),
    [sym__cdata_section] = STATE(423),
    [sym_hard_line_break] = STATE(152),
    [sym__whitespace] = STATE(152),
    [sym__word] = STATE(152),
    [sym__soft_line_break] = STATE(152),
    [sym__inline_base] = STATE(422),
    [sym__text_base] = STATE(152),
    [sym__inline_element] = STATE(422),
    [aux_sym__inline] = STATE(17),
    [sym__strikethrough] = STATE(422),
    [sym__emphasis_star] = STATE(415),
    [sym__strong_emphasis_star] = STATE(422),
    [sym__emphasis_underscore] = STATE(415),
    [sym__strong_emphasis_underscore] = STATE(422),
    [aux_sym__inline_base_repeat1] = STATE(152),
    [ts_builtin_sym_end] = ACTIONS(803),
    [sym__backslash_escape] = ACTIONS(805),
    [sym_entity_reference] = ACTIONS(808),
    [sym_numeric_character_reference] = ACTIONS(808),
    [anon_sym_LBRACK] = ACTIONS(811),
    [anon_sym_RBRACK] = ACTIONS(814),
    [anon_sym_LT] = ACTIONS(817),
    [anon_sym_GT] = ACTIONS(820),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(820),
    [anon_sym_POUND] = ACTIONS(820),
    [anon_sym_DOLLAR] = ACTIONS(820),
    [anon_sym_PERCENT] = ACTIONS(820),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_SQUOTE] = ACTIONS(820),
    [anon_sym_STAR] = ACTIONS(820),
    [anon_sym_PLUS] = ACTIONS(820),
    [anon_sym_COMMA] = ACTIONS(820),
    [anon_sym_DASH] = ACTIONS(820),
    [anon_sym_DOT] = ACTIONS(820),
    [anon_sym_SLASH] = ACTIONS(820),
    [anon_sym_COLON] = ACTIONS(820),
    [anon_sym_SEMI] = ACTIONS(820),
    [anon_sym_EQ] = ACTIONS(820),
    [anon_sym_QMARK] = ACTIONS(820),
    [anon_sym_AT] = ACTIONS(820),
    [anon_sym_BSLASH] = ACTIONS(829),
    [anon_sym_CARET] = ACTIONS(820),
    [anon_sym__] = ACTIONS(820),
    [anon_sym_BQUOTE] = ACTIONS(820),
    [anon_sym_LBRACE] = ACTIONS(820),
    [anon_sym_PIPE] = ACTIONS(820),
    [anon_sym_RBRACE] = ACTIONS(820),
    [anon_sym_TILDE] = ACTIONS(820),
    [anon_sym_LPAREN] = ACTIONS(820),
    [anon_sym_RPAREN] = ACTIONS(820),
    [sym__newline_token] = ACTIONS(832),
    [sym_uri_autolink] = ACTIONS(808),
    [sym_email_autolink] = ACTIONS(808),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(835),
    [anon_sym_LT_QMARK] = ACTIONS(838),
    [aux_sym__declaration_token1] = ACTIONS(841),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(844),
    [sym__whitespace_ge_2] = ACTIONS(847),
    [aux_sym__whitespace_token1] = ACTIONS(850),
    [sym__word_no_digit] = ACTIONS(808),
    [sym__digits] = ACTIONS(808),
    [sym__code_span_start] = ACTIONS(853),
    [sym__emphasis_open_star] = ACTIONS(856),
    [sym__emphasis_open_underscore] = ACTIONS(859),
    [sym__strikethrough_open] = ACTIONS(862),
  },
  [18] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(44),
    [sym_full_reference_link] = STATE(44),
    [sym_collapsed_reference_link] = STATE(44),
    [sym_inline_link] = STATE(44),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(44),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(44),
    [aux_sym__inline_no_underscore] = STATE(44),
    [sym__strikethrough] = STATE(44),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(44),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(44),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__emphasis_close_underscore] = ACTIONS(865),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [19] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(44),
    [sym_full_reference_link] = STATE(44),
    [sym_collapsed_reference_link] = STATE(44),
    [sym_inline_link] = STATE(44),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(44),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(44),
    [aux_sym__inline_no_underscore] = STATE(44),
    [sym__strikethrough] = STATE(44),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(44),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(44),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__emphasis_close_underscore] = ACTIONS(867),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [20] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(11),
    [sym_full_reference_link] = STATE(11),
    [sym_collapsed_reference_link] = STATE(11),
    [sym_inline_link] = STATE(11),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(11),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(11),
    [aux_sym__inline_no_star] = STATE(11),
    [sym__strikethrough] = STATE(11),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(11),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(11),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__emphasis_close_star] = ACTIONS(869),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [21] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(44),
    [sym_full_reference_link] = STATE(44),
    [sym_collapsed_reference_link] = STATE(44),
    [sym_inline_link] = STATE(44),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(44),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(44),
    [aux_sym__inline_no_underscore] = STATE(44),
    [sym__strikethrough] = STATE(44),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(44),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(44),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__emphasis_close_underscore] = ACTIONS(871),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [22] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(28),
    [sym_full_reference_link] = STATE(28),
    [sym_collapsed_reference_link] = STATE(28),
    [sym_inline_link] = STATE(28),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(28),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(28),
    [aux_sym__inline_no_tilde] = STATE(28),
    [sym__strikethrough] = STATE(28),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(28),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(28),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
    [sym__strikethrough_close] = ACTIONS(873),
  },
  [23] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(11),
    [sym_full_reference_link] = STATE(11),
    [sym_collapsed_reference_link] = STATE(11),
    [sym_inline_link] = STATE(11),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(11),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(11),
    [aux_sym__inline_no_star] = STATE(11),
    [sym__strikethrough] = STATE(11),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(11),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(11),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__emphasis_close_star] = ACTIONS(875),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [24] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(11),
    [sym_full_reference_link] = STATE(11),
    [sym_collapsed_reference_link] = STATE(11),
    [sym_inline_link] = STATE(11),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(11),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(11),
    [aux_sym__inline_no_star] = STATE(11),
    [sym__strikethrough] = STATE(11),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(11),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(11),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__emphasis_close_star] = ACTIONS(877),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [25] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(11),
    [sym_full_reference_link] = STATE(11),
    [sym_collapsed_reference_link] = STATE(11),
    [sym_inline_link] = STATE(11),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(11),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(11),
    [aux_sym__inline_no_star] = STATE(11),
    [sym__strikethrough] = STATE(11),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(11),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(11),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__emphasis_close_star] = ACTIONS(879),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [26] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(28),
    [sym_full_reference_link] = STATE(28),
    [sym_collapsed_reference_link] = STATE(28),
    [sym_inline_link] = STATE(28),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(28),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(28),
    [aux_sym__inline_no_tilde] = STATE(28),
    [sym__strikethrough] = STATE(28),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(28),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(28),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
    [sym__strikethrough_close] = ACTIONS(881),
  },
  [27] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(28),
    [sym_full_reference_link] = STATE(28),
    [sym_collapsed_reference_link] = STATE(28),
    [sym_inline_link] = STATE(28),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(28),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(28),
    [aux_sym__inline_no_tilde] = STATE(28),
    [sym__strikethrough] = STATE(28),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(28),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(28),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
    [sym__strikethrough_close] = ACTIONS(883),
  },
  [28] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(28),
    [sym_full_reference_link] = STATE(28),
    [sym_collapsed_reference_link] = STATE(28),
    [sym_inline_link] = STATE(28),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(28),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(28),
    [aux_sym__inline_no_tilde] = STATE(28),
    [sym__strikethrough] = STATE(28),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(28),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(28),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(885),
    [sym_entity_reference] = ACTIONS(888),
    [sym_numeric_character_reference] = ACTIONS(888),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_RBRACK] = ACTIONS(894),
    [anon_sym_LT] = ACTIONS(897),
    [anon_sym_GT] = ACTIONS(900),
    [anon_sym_BANG] = ACTIONS(903),
    [anon_sym_DQUOTE] = ACTIONS(900),
    [anon_sym_POUND] = ACTIONS(900),
    [anon_sym_DOLLAR] = ACTIONS(900),
    [anon_sym_PERCENT] = ACTIONS(900),
    [anon_sym_AMP] = ACTIONS(906),
    [anon_sym_SQUOTE] = ACTIONS(900),
    [anon_sym_STAR] = ACTIONS(900),
    [anon_sym_PLUS] = ACTIONS(900),
    [anon_sym_COMMA] = ACTIONS(900),
    [anon_sym_DASH] = ACTIONS(900),
    [anon_sym_DOT] = ACTIONS(900),
    [anon_sym_SLASH] = ACTIONS(900),
    [anon_sym_COLON] = ACTIONS(900),
    [anon_sym_SEMI] = ACTIONS(900),
    [anon_sym_EQ] = ACTIONS(900),
    [anon_sym_QMARK] = ACTIONS(900),
    [anon_sym_AT] = ACTIONS(900),
    [anon_sym_BSLASH] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(900),
    [anon_sym__] = ACTIONS(900),
    [anon_sym_BQUOTE] = ACTIONS(900),
    [anon_sym_LBRACE] = ACTIONS(900),
    [anon_sym_PIPE] = ACTIONS(900),
    [anon_sym_RBRACE] = ACTIONS(900),
    [anon_sym_TILDE] = ACTIONS(900),
    [anon_sym_LPAREN] = ACTIONS(900),
    [anon_sym_RPAREN] = ACTIONS(900),
    [sym__newline_token] = ACTIONS(912),
    [sym_uri_autolink] = ACTIONS(888),
    [sym_email_autolink] = ACTIONS(888),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(915),
    [anon_sym_LT_QMARK] = ACTIONS(918),
    [aux_sym__declaration_token1] = ACTIONS(921),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(924),
    [sym__whitespace_ge_2] = ACTIONS(927),
    [aux_sym__whitespace_token1] = ACTIONS(930),
    [sym__word_no_digit] = ACTIONS(888),
    [sym__digits] = ACTIONS(888),
    [sym__code_span_start] = ACTIONS(933),
    [sym__emphasis_open_star] = ACTIONS(936),
    [sym__emphasis_open_underscore] = ACTIONS(939),
    [sym__strikethrough_open] = ACTIONS(942),
    [sym__strikethrough_close] = ACTIONS(945),
  },
  [29] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(11),
    [sym_full_reference_link] = STATE(11),
    [sym_collapsed_reference_link] = STATE(11),
    [sym_inline_link] = STATE(11),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(11),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(11),
    [aux_sym__inline_no_star] = STATE(11),
    [sym__strikethrough] = STATE(11),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(11),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(11),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__emphasis_close_star] = ACTIONS(947),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [30] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(44),
    [sym_full_reference_link] = STATE(44),
    [sym_collapsed_reference_link] = STATE(44),
    [sym_inline_link] = STATE(44),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(44),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(44),
    [aux_sym__inline_no_underscore] = STATE(44),
    [sym__strikethrough] = STATE(44),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(44),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(44),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__emphasis_close_underscore] = ACTIONS(949),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [31] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(11),
    [sym_full_reference_link] = STATE(11),
    [sym_collapsed_reference_link] = STATE(11),
    [sym_inline_link] = STATE(11),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(11),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(11),
    [aux_sym__inline_no_star] = STATE(11),
    [sym__strikethrough] = STATE(11),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(11),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(11),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__emphasis_close_star] = ACTIONS(951),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [32] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(44),
    [sym_full_reference_link] = STATE(44),
    [sym_collapsed_reference_link] = STATE(44),
    [sym_inline_link] = STATE(44),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(44),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(44),
    [aux_sym__inline_no_underscore] = STATE(44),
    [sym__strikethrough] = STATE(44),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(44),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(44),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__emphasis_close_underscore] = ACTIONS(953),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [33] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(28),
    [sym_full_reference_link] = STATE(28),
    [sym_collapsed_reference_link] = STATE(28),
    [sym_inline_link] = STATE(28),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(28),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(28),
    [aux_sym__inline_no_tilde] = STATE(28),
    [sym__strikethrough] = STATE(28),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(28),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(28),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
    [sym__strikethrough_close] = ACTIONS(955),
  },
  [34] = {
    [sym_backslash_escape] = STATE(152),
    [sym_code_span] = STATE(152),
    [sym__link_text] = STATE(1050),
    [sym__link_text_non_empty] = STATE(323),
    [sym_shortcut_link] = STATE(422),
    [sym_full_reference_link] = STATE(422),
    [sym_collapsed_reference_link] = STATE(422),
    [sym_inline_link] = STATE(422),
    [sym_image] = STATE(152),
    [sym__image_inline_link] = STATE(444),
    [sym__image_shortcut_link] = STATE(444),
    [sym__image_full_reference_link] = STATE(444),
    [sym__image_collapsed_reference_link] = STATE(444),
    [sym__image_description] = STATE(1055),
    [sym__image_description_non_empty] = STATE(433),
    [sym__html_tag] = STATE(425),
    [sym__open_tag] = STATE(423),
    [sym__closing_tag] = STATE(423),
    [sym__html_comment] = STATE(423),
    [sym__processing_instruction] = STATE(423),
    [sym__declaration] = STATE(423),
    [sym__cdata_section] = STATE(423),
    [sym_hard_line_break] = STATE(152),
    [sym__whitespace] = STATE(152),
    [sym__word] = STATE(152),
    [sym__soft_line_break] = STATE(152),
    [sym__inline_base] = STATE(422),
    [sym__text_base] = STATE(152),
    [sym__inline_element] = STATE(422),
    [aux_sym__inline] = STATE(17),
    [sym__strikethrough] = STATE(422),
    [sym__emphasis_star] = STATE(415),
    [sym__strong_emphasis_star] = STATE(422),
    [sym__emphasis_underscore] = STATE(415),
    [sym__strong_emphasis_underscore] = STATE(422),
    [aux_sym__inline_base_repeat1] = STATE(152),
    [ts_builtin_sym_end] = ACTIONS(957),
    [sym__backslash_escape] = ACTIONS(3),
    [sym_entity_reference] = ACTIONS(5),
    [sym_numeric_character_reference] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(9),
    [anon_sym_LT] = ACTIONS(11),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_POUND] = ACTIONS(13),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_PERCENT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SLASH] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_BSLASH] = ACTIONS(19),
    [anon_sym_CARET] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(13),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(13),
    [sym__newline_token] = ACTIONS(21),
    [sym_uri_autolink] = ACTIONS(5),
    [sym_email_autolink] = ACTIONS(5),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(23),
    [anon_sym_LT_QMARK] = ACTIONS(25),
    [aux_sym__declaration_token1] = ACTIONS(27),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(29),
    [sym__whitespace_ge_2] = ACTIONS(31),
    [aux_sym__whitespace_token1] = ACTIONS(33),
    [sym__word_no_digit] = ACTIONS(5),
    [sym__digits] = ACTIONS(5),
    [sym__code_span_start] = ACTIONS(35),
    [sym__emphasis_open_star] = ACTIONS(37),
    [sym__emphasis_open_underscore] = ACTIONS(39),
    [sym__strikethrough_open] = ACTIONS(43),
  },
  [35] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(28),
    [sym_full_reference_link] = STATE(28),
    [sym_collapsed_reference_link] = STATE(28),
    [sym_inline_link] = STATE(28),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(28),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(28),
    [aux_sym__inline_no_tilde] = STATE(28),
    [sym__strikethrough] = STATE(28),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(28),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(28),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
    [sym__strikethrough_close] = ACTIONS(959),
  },
  [36] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(44),
    [sym_full_reference_link] = STATE(44),
    [sym_collapsed_reference_link] = STATE(44),
    [sym_inline_link] = STATE(44),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(44),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(44),
    [aux_sym__inline_no_underscore] = STATE(44),
    [sym__strikethrough] = STATE(44),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(44),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(44),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__emphasis_close_underscore] = ACTIONS(961),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [37] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(28),
    [sym_full_reference_link] = STATE(28),
    [sym_collapsed_reference_link] = STATE(28),
    [sym_inline_link] = STATE(28),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(28),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(28),
    [aux_sym__inline_no_tilde] = STATE(28),
    [sym__strikethrough] = STATE(28),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(28),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(28),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
    [sym__strikethrough_close] = ACTIONS(963),
  },
  [38] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(28),
    [sym_full_reference_link] = STATE(28),
    [sym_collapsed_reference_link] = STATE(28),
    [sym_inline_link] = STATE(28),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(28),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(28),
    [aux_sym__inline_no_tilde] = STATE(28),
    [sym__strikethrough] = STATE(28),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(28),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(28),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
    [sym__strikethrough_close] = ACTIONS(965),
  },
  [39] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(20),
    [sym_full_reference_link] = STATE(20),
    [sym_collapsed_reference_link] = STATE(20),
    [sym_inline_link] = STATE(20),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(20),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(20),
    [aux_sym__inline_no_star] = STATE(20),
    [sym__strikethrough] = STATE(20),
    [sym__emphasis_star] = STATE(281),
    [sym__strong_emphasis_star] = STATE(20),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(20),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__last_token_punctuation] = ACTIONS(967),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [40] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(44),
    [sym_full_reference_link] = STATE(44),
    [sym_collapsed_reference_link] = STATE(44),
    [sym_inline_link] = STATE(44),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(44),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(44),
    [aux_sym__inline_no_underscore] = STATE(44),
    [sym__strikethrough] = STATE(44),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(44),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(44),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__emphasis_close_underscore] = ACTIONS(969),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [41] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(28),
    [sym_full_reference_link] = STATE(28),
    [sym_collapsed_reference_link] = STATE(28),
    [sym_inline_link] = STATE(28),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(28),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(28),
    [aux_sym__inline_no_tilde] = STATE(28),
    [sym__strikethrough] = STATE(28),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(28),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(28),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
    [sym__strikethrough_close] = ACTIONS(971),
  },
  [42] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(11),
    [sym_full_reference_link] = STATE(11),
    [sym_collapsed_reference_link] = STATE(11),
    [sym_inline_link] = STATE(11),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(11),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(11),
    [aux_sym__inline_no_star] = STATE(11),
    [sym__strikethrough] = STATE(11),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(11),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(11),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__emphasis_close_star] = ACTIONS(973),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [43] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(11),
    [sym_full_reference_link] = STATE(11),
    [sym_collapsed_reference_link] = STATE(11),
    [sym_inline_link] = STATE(11),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(11),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(11),
    [aux_sym__inline_no_star] = STATE(11),
    [sym__strikethrough] = STATE(11),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(11),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(11),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__emphasis_close_star] = ACTIONS(975),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [44] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(44),
    [sym_full_reference_link] = STATE(44),
    [sym_collapsed_reference_link] = STATE(44),
    [sym_inline_link] = STATE(44),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(44),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(44),
    [aux_sym__inline_no_underscore] = STATE(44),
    [sym__strikethrough] = STATE(44),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(44),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(44),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(977),
    [sym_entity_reference] = ACTIONS(980),
    [sym_numeric_character_reference] = ACTIONS(980),
    [anon_sym_LBRACK] = ACTIONS(983),
    [anon_sym_RBRACK] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_GT] = ACTIONS(992),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_DQUOTE] = ACTIONS(992),
    [anon_sym_POUND] = ACTIONS(992),
    [anon_sym_DOLLAR] = ACTIONS(992),
    [anon_sym_PERCENT] = ACTIONS(992),
    [anon_sym_AMP] = ACTIONS(998),
    [anon_sym_SQUOTE] = ACTIONS(992),
    [anon_sym_STAR] = ACTIONS(992),
    [anon_sym_PLUS] = ACTIONS(992),
    [anon_sym_COMMA] = ACTIONS(992),
    [anon_sym_DASH] = ACTIONS(992),
    [anon_sym_DOT] = ACTIONS(992),
    [anon_sym_SLASH] = ACTIONS(992),
    [anon_sym_COLON] = ACTIONS(992),
    [anon_sym_SEMI] = ACTIONS(992),
    [anon_sym_EQ] = ACTIONS(992),
    [anon_sym_QMARK] = ACTIONS(992),
    [anon_sym_AT] = ACTIONS(992),
    [anon_sym_BSLASH] = ACTIONS(1001),
    [anon_sym_CARET] = ACTIONS(992),
    [anon_sym__] = ACTIONS(992),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [anon_sym_LBRACE] = ACTIONS(992),
    [anon_sym_PIPE] = ACTIONS(992),
    [anon_sym_RBRACE] = ACTIONS(992),
    [anon_sym_TILDE] = ACTIONS(992),
    [anon_sym_LPAREN] = ACTIONS(992),
    [anon_sym_RPAREN] = ACTIONS(992),
    [sym__newline_token] = ACTIONS(1004),
    [sym_uri_autolink] = ACTIONS(980),
    [sym_email_autolink] = ACTIONS(980),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1007),
    [anon_sym_LT_QMARK] = ACTIONS(1010),
    [aux_sym__declaration_token1] = ACTIONS(1013),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1016),
    [sym__whitespace_ge_2] = ACTIONS(1019),
    [aux_sym__whitespace_token1] = ACTIONS(1022),
    [sym__word_no_digit] = ACTIONS(980),
    [sym__digits] = ACTIONS(980),
    [sym__code_span_start] = ACTIONS(1025),
    [sym__emphasis_open_star] = ACTIONS(1028),
    [sym__emphasis_open_underscore] = ACTIONS(1031),
    [sym__emphasis_close_underscore] = ACTIONS(1034),
    [sym__strikethrough_open] = ACTIONS(1036),
  },
  [45] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(15),
    [sym_full_reference_link] = STATE(15),
    [sym_collapsed_reference_link] = STATE(15),
    [sym_inline_link] = STATE(15),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(15),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(15),
    [aux_sym__inline_no_tilde] = STATE(15),
    [sym__strikethrough] = STATE(15),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(15),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(15),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(299),
    [sym_entity_reference] = ACTIONS(302),
    [sym_numeric_character_reference] = ACTIONS(302),
    [anon_sym_LBRACK] = ACTIONS(305),
    [anon_sym_RBRACK] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(314),
    [anon_sym_BANG] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_POUND] = ACTIONS(314),
    [anon_sym_DOLLAR] = ACTIONS(314),
    [anon_sym_PERCENT] = ACTIONS(314),
    [anon_sym_AMP] = ACTIONS(320),
    [anon_sym_SQUOTE] = ACTIONS(314),
    [anon_sym_STAR] = ACTIONS(314),
    [anon_sym_PLUS] = ACTIONS(314),
    [anon_sym_COMMA] = ACTIONS(314),
    [anon_sym_DASH] = ACTIONS(314),
    [anon_sym_DOT] = ACTIONS(314),
    [anon_sym_SLASH] = ACTIONS(314),
    [anon_sym_COLON] = ACTIONS(314),
    [anon_sym_SEMI] = ACTIONS(314),
    [anon_sym_EQ] = ACTIONS(314),
    [anon_sym_QMARK] = ACTIONS(314),
    [anon_sym_AT] = ACTIONS(314),
    [anon_sym_BSLASH] = ACTIONS(323),
    [anon_sym_CARET] = ACTIONS(314),
    [anon_sym__] = ACTIONS(314),
    [anon_sym_BQUOTE] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(314),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_RBRACE] = ACTIONS(314),
    [anon_sym_TILDE] = ACTIONS(314),
    [anon_sym_LPAREN] = ACTIONS(314),
    [anon_sym_RPAREN] = ACTIONS(314),
    [sym__newline_token] = ACTIONS(326),
    [sym_uri_autolink] = ACTIONS(302),
    [sym_email_autolink] = ACTIONS(302),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(329),
    [anon_sym_LT_QMARK] = ACTIONS(332),
    [aux_sym__declaration_token1] = ACTIONS(335),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(338),
    [sym__whitespace_ge_2] = ACTIONS(341),
    [aux_sym__whitespace_token1] = ACTIONS(344),
    [sym__word_no_digit] = ACTIONS(302),
    [sym__digits] = ACTIONS(302),
    [sym__code_span_start] = ACTIONS(347),
    [sym__emphasis_open_star] = ACTIONS(350),
    [sym__emphasis_open_underscore] = ACTIONS(353),
    [sym__last_token_punctuation] = ACTIONS(1039),
    [sym__strikethrough_open] = ACTIONS(358),
  },
  [46] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(36),
    [sym_full_reference_link] = STATE(36),
    [sym_collapsed_reference_link] = STATE(36),
    [sym_inline_link] = STATE(36),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(36),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(36),
    [aux_sym__inline_no_underscore] = STATE(36),
    [sym__strikethrough] = STATE(36),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(36),
    [sym__emphasis_underscore] = STATE(316),
    [sym__strong_emphasis_underscore] = STATE(36),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__last_token_punctuation] = ACTIONS(1041),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [47] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(44),
    [sym_full_reference_link] = STATE(44),
    [sym_collapsed_reference_link] = STATE(44),
    [sym_inline_link] = STATE(44),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(44),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(44),
    [aux_sym__inline_no_underscore] = STATE(44),
    [sym__strikethrough] = STATE(44),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(44),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(44),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__emphasis_close_underscore] = ACTIONS(1043),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [48] = {
    [sym_backslash_escape] = STATE(152),
    [sym_code_span] = STATE(152),
    [sym__link_text] = STATE(1050),
    [sym__link_text_non_empty] = STATE(323),
    [sym_shortcut_link] = STATE(422),
    [sym_full_reference_link] = STATE(422),
    [sym_collapsed_reference_link] = STATE(422),
    [sym_inline_link] = STATE(422),
    [sym_image] = STATE(152),
    [sym__image_inline_link] = STATE(444),
    [sym__image_shortcut_link] = STATE(444),
    [sym__image_full_reference_link] = STATE(444),
    [sym__image_collapsed_reference_link] = STATE(444),
    [sym__image_description] = STATE(1055),
    [sym__image_description_non_empty] = STATE(433),
    [sym__html_tag] = STATE(425),
    [sym__open_tag] = STATE(423),
    [sym__closing_tag] = STATE(423),
    [sym__html_comment] = STATE(423),
    [sym__processing_instruction] = STATE(423),
    [sym__declaration] = STATE(423),
    [sym__cdata_section] = STATE(423),
    [sym_hard_line_break] = STATE(152),
    [sym__whitespace] = STATE(152),
    [sym__word] = STATE(152),
    [sym__soft_line_break] = STATE(152),
    [sym__inline_base] = STATE(422),
    [sym__text_base] = STATE(152),
    [sym__inline_element] = STATE(422),
    [aux_sym__inline] = STATE(17),
    [sym__strikethrough] = STATE(422),
    [sym__emphasis_star] = STATE(415),
    [sym__strong_emphasis_star] = STATE(422),
    [sym__emphasis_underscore] = STATE(415),
    [sym__strong_emphasis_underscore] = STATE(422),
    [aux_sym__inline_base_repeat1] = STATE(152),
    [ts_builtin_sym_end] = ACTIONS(1045),
    [sym__backslash_escape] = ACTIONS(3),
    [sym_entity_reference] = ACTIONS(5),
    [sym_numeric_character_reference] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(9),
    [anon_sym_LT] = ACTIONS(11),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_POUND] = ACTIONS(13),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_PERCENT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SLASH] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_BSLASH] = ACTIONS(19),
    [anon_sym_CARET] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(13),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(13),
    [sym__newline_token] = ACTIONS(21),
    [sym_uri_autolink] = ACTIONS(5),
    [sym_email_autolink] = ACTIONS(5),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(23),
    [anon_sym_LT_QMARK] = ACTIONS(25),
    [aux_sym__declaration_token1] = ACTIONS(27),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(29),
    [sym__whitespace_ge_2] = ACTIONS(31),
    [aux_sym__whitespace_token1] = ACTIONS(33),
    [sym__word_no_digit] = ACTIONS(5),
    [sym__digits] = ACTIONS(5),
    [sym__code_span_start] = ACTIONS(35),
    [sym__emphasis_open_star] = ACTIONS(37),
    [sym__emphasis_open_underscore] = ACTIONS(39),
    [sym__strikethrough_open] = ACTIONS(43),
  },
  [49] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(18),
    [sym_full_reference_link] = STATE(18),
    [sym_collapsed_reference_link] = STATE(18),
    [sym_inline_link] = STATE(18),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(18),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(18),
    [aux_sym__inline_no_underscore] = STATE(18),
    [sym__strikethrough] = STATE(18),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(18),
    [sym__emphasis_underscore] = STATE(291),
    [sym__strong_emphasis_underscore] = STATE(18),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(173),
    [sym_entity_reference] = ACTIONS(176),
    [sym_numeric_character_reference] = ACTIONS(176),
    [anon_sym_LBRACK] = ACTIONS(179),
    [anon_sym_RBRACK] = ACTIONS(182),
    [anon_sym_LT] = ACTIONS(185),
    [anon_sym_GT] = ACTIONS(188),
    [anon_sym_BANG] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(188),
    [anon_sym_POUND] = ACTIONS(188),
    [anon_sym_DOLLAR] = ACTIONS(188),
    [anon_sym_PERCENT] = ACTIONS(188),
    [anon_sym_AMP] = ACTIONS(194),
    [anon_sym_SQUOTE] = ACTIONS(188),
    [anon_sym_STAR] = ACTIONS(188),
    [anon_sym_PLUS] = ACTIONS(188),
    [anon_sym_COMMA] = ACTIONS(188),
    [anon_sym_DASH] = ACTIONS(188),
    [anon_sym_DOT] = ACTIONS(188),
    [anon_sym_SLASH] = ACTIONS(188),
    [anon_sym_COLON] = ACTIONS(188),
    [anon_sym_SEMI] = ACTIONS(188),
    [anon_sym_EQ] = ACTIONS(188),
    [anon_sym_QMARK] = ACTIONS(188),
    [anon_sym_AT] = ACTIONS(188),
    [anon_sym_BSLASH] = ACTIONS(197),
    [anon_sym_CARET] = ACTIONS(188),
    [anon_sym__] = ACTIONS(188),
    [anon_sym_BQUOTE] = ACTIONS(188),
    [anon_sym_LBRACE] = ACTIONS(188),
    [anon_sym_PIPE] = ACTIONS(188),
    [anon_sym_RBRACE] = ACTIONS(188),
    [anon_sym_TILDE] = ACTIONS(188),
    [anon_sym_LPAREN] = ACTIONS(188),
    [anon_sym_RPAREN] = ACTIONS(188),
    [sym__newline_token] = ACTIONS(200),
    [sym_uri_autolink] = ACTIONS(176),
    [sym_email_autolink] = ACTIONS(176),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(203),
    [anon_sym_LT_QMARK] = ACTIONS(206),
    [aux_sym__declaration_token1] = ACTIONS(209),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(212),
    [sym__whitespace_ge_2] = ACTIONS(215),
    [aux_sym__whitespace_token1] = ACTIONS(218),
    [sym__word_no_digit] = ACTIONS(176),
    [sym__digits] = ACTIONS(176),
    [sym__code_span_start] = ACTIONS(221),
    [sym__emphasis_open_star] = ACTIONS(224),
    [sym__emphasis_open_underscore] = ACTIONS(227),
    [sym__last_token_punctuation] = ACTIONS(1047),
    [sym__strikethrough_open] = ACTIONS(232),
  },
  [50] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(44),
    [sym_full_reference_link] = STATE(44),
    [sym_collapsed_reference_link] = STATE(44),
    [sym_inline_link] = STATE(44),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(44),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(44),
    [aux_sym__inline_no_underscore] = STATE(44),
    [sym__strikethrough] = STATE(44),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(44),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(44),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__emphasis_close_underscore] = ACTIONS(1049),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [51] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(24),
    [sym_full_reference_link] = STATE(24),
    [sym_collapsed_reference_link] = STATE(24),
    [sym_inline_link] = STATE(24),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(24),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(24),
    [aux_sym__inline_no_star] = STATE(24),
    [sym__strikethrough] = STATE(24),
    [sym__emphasis_star] = STATE(294),
    [sym__strong_emphasis_star] = STATE(24),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(24),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(111),
    [sym_entity_reference] = ACTIONS(114),
    [sym_numeric_character_reference] = ACTIONS(114),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_RBRACK] = ACTIONS(120),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_GT] = ACTIONS(126),
    [anon_sym_BANG] = ACTIONS(129),
    [anon_sym_DQUOTE] = ACTIONS(126),
    [anon_sym_POUND] = ACTIONS(126),
    [anon_sym_DOLLAR] = ACTIONS(126),
    [anon_sym_PERCENT] = ACTIONS(126),
    [anon_sym_AMP] = ACTIONS(132),
    [anon_sym_SQUOTE] = ACTIONS(126),
    [anon_sym_STAR] = ACTIONS(126),
    [anon_sym_PLUS] = ACTIONS(126),
    [anon_sym_COMMA] = ACTIONS(126),
    [anon_sym_DASH] = ACTIONS(126),
    [anon_sym_DOT] = ACTIONS(126),
    [anon_sym_SLASH] = ACTIONS(126),
    [anon_sym_COLON] = ACTIONS(126),
    [anon_sym_SEMI] = ACTIONS(126),
    [anon_sym_EQ] = ACTIONS(126),
    [anon_sym_QMARK] = ACTIONS(126),
    [anon_sym_AT] = ACTIONS(126),
    [anon_sym_BSLASH] = ACTIONS(135),
    [anon_sym_CARET] = ACTIONS(126),
    [anon_sym__] = ACTIONS(126),
    [anon_sym_BQUOTE] = ACTIONS(126),
    [anon_sym_LBRACE] = ACTIONS(126),
    [anon_sym_PIPE] = ACTIONS(126),
    [anon_sym_RBRACE] = ACTIONS(126),
    [anon_sym_TILDE] = ACTIONS(126),
    [anon_sym_LPAREN] = ACTIONS(126),
    [anon_sym_RPAREN] = ACTIONS(126),
    [sym__newline_token] = ACTIONS(138),
    [sym_uri_autolink] = ACTIONS(114),
    [sym_email_autolink] = ACTIONS(114),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(141),
    [anon_sym_LT_QMARK] = ACTIONS(144),
    [aux_sym__declaration_token1] = ACTIONS(147),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(150),
    [sym__whitespace_ge_2] = ACTIONS(153),
    [aux_sym__whitespace_token1] = ACTIONS(156),
    [sym__word_no_digit] = ACTIONS(114),
    [sym__digits] = ACTIONS(114),
    [sym__code_span_start] = ACTIONS(159),
    [sym__emphasis_open_star] = ACTIONS(162),
    [sym__emphasis_open_underscore] = ACTIONS(165),
    [sym__last_token_punctuation] = ACTIONS(1051),
    [sym__strikethrough_open] = ACTIONS(170),
  },
  [52] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(28),
    [sym_full_reference_link] = STATE(28),
    [sym_collapsed_reference_link] = STATE(28),
    [sym_inline_link] = STATE(28),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(28),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(28),
    [aux_sym__inline_no_tilde] = STATE(28),
    [sym__strikethrough] = STATE(28),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(28),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(28),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
    [sym__strikethrough_close] = ACTIONS(1053),
  },
  [53] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(37),
    [sym_full_reference_link] = STATE(37),
    [sym_collapsed_reference_link] = STATE(37),
    [sym_inline_link] = STATE(37),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(37),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(37),
    [aux_sym__inline_no_tilde] = STATE(37),
    [sym__strikethrough] = STATE(37),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(37),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(37),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
  },
  [54] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(52),
    [sym_full_reference_link] = STATE(52),
    [sym_collapsed_reference_link] = STATE(52),
    [sym_inline_link] = STATE(52),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(52),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(52),
    [aux_sym__inline_no_tilde] = STATE(52),
    [sym__strikethrough] = STATE(52),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(52),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(52),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
  },
  [55] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(69),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1061),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [56] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(26),
    [sym_full_reference_link] = STATE(26),
    [sym_collapsed_reference_link] = STATE(26),
    [sym_inline_link] = STATE(26),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(26),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(26),
    [aux_sym__inline_no_tilde] = STATE(26),
    [sym__strikethrough] = STATE(26),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(26),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(26),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
  },
  [57] = {
    [sym_backslash_escape] = STATE(152),
    [sym_code_span] = STATE(152),
    [sym__link_text] = STATE(1050),
    [sym__link_text_non_empty] = STATE(323),
    [sym_shortcut_link] = STATE(422),
    [sym_full_reference_link] = STATE(422),
    [sym_collapsed_reference_link] = STATE(422),
    [sym_inline_link] = STATE(422),
    [sym_image] = STATE(152),
    [sym__image_inline_link] = STATE(444),
    [sym__image_shortcut_link] = STATE(444),
    [sym__image_full_reference_link] = STATE(444),
    [sym__image_collapsed_reference_link] = STATE(444),
    [sym__image_description] = STATE(1055),
    [sym__image_description_non_empty] = STATE(433),
    [sym__html_tag] = STATE(425),
    [sym__open_tag] = STATE(423),
    [sym__closing_tag] = STATE(423),
    [sym__html_comment] = STATE(423),
    [sym__processing_instruction] = STATE(423),
    [sym__declaration] = STATE(423),
    [sym__cdata_section] = STATE(423),
    [sym_hard_line_break] = STATE(152),
    [sym__whitespace] = STATE(152),
    [sym__word] = STATE(152),
    [sym__soft_line_break] = STATE(152),
    [sym__inline_base] = STATE(422),
    [sym__text_base] = STATE(152),
    [sym__inline_element] = STATE(422),
    [aux_sym__inline] = STATE(48),
    [sym__strikethrough] = STATE(422),
    [sym__emphasis_star] = STATE(415),
    [sym__strong_emphasis_star] = STATE(422),
    [sym__emphasis_underscore] = STATE(415),
    [sym__strong_emphasis_underscore] = STATE(422),
    [aux_sym__inline_base_repeat1] = STATE(152),
    [sym__backslash_escape] = ACTIONS(3),
    [sym_entity_reference] = ACTIONS(5),
    [sym_numeric_character_reference] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(7),
    [anon_sym_RBRACK] = ACTIONS(9),
    [anon_sym_LT] = ACTIONS(11),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_POUND] = ACTIONS(13),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_PERCENT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SLASH] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_BSLASH] = ACTIONS(19),
    [anon_sym_CARET] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(13),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(13),
    [sym__newline_token] = ACTIONS(21),
    [sym_uri_autolink] = ACTIONS(5),
    [sym_email_autolink] = ACTIONS(5),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(23),
    [anon_sym_LT_QMARK] = ACTIONS(25),
    [aux_sym__declaration_token1] = ACTIONS(27),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(29),
    [sym__whitespace_ge_2] = ACTIONS(31),
    [aux_sym__whitespace_token1] = ACTIONS(33),
    [sym__word_no_digit] = ACTIONS(5),
    [sym__digits] = ACTIONS(5),
    [sym__code_span_start] = ACTIONS(35),
    [sym__emphasis_open_star] = ACTIONS(37),
    [sym__emphasis_open_underscore] = ACTIONS(39),
    [sym__strikethrough_open] = ACTIONS(43),
  },
  [58] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(69),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [59] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(58),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [60] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(69),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [61] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(13),
    [sym_full_reference_link] = STATE(13),
    [sym_collapsed_reference_link] = STATE(13),
    [sym_inline_link] = STATE(13),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(13),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(13),
    [aux_sym__inline_no_star] = STATE(13),
    [sym__strikethrough] = STATE(13),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(13),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(13),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [62] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(69),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1101),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [63] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(31),
    [sym_full_reference_link] = STATE(31),
    [sym_collapsed_reference_link] = STATE(31),
    [sym_inline_link] = STATE(31),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(31),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(31),
    [aux_sym__inline_no_star] = STATE(31),
    [sym__strikethrough] = STATE(31),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(31),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(31),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [64] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(69),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [65] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(33),
    [sym_full_reference_link] = STATE(33),
    [sym_collapsed_reference_link] = STATE(33),
    [sym_inline_link] = STATE(33),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(33),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(33),
    [aux_sym__inline_no_tilde] = STATE(33),
    [sym__strikethrough] = STATE(33),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(33),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(33),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
  },
  [66] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(79),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [67] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(42),
    [sym_full_reference_link] = STATE(42),
    [sym_collapsed_reference_link] = STATE(42),
    [sym_inline_link] = STATE(42),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(42),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(42),
    [aux_sym__inline_no_star] = STATE(42),
    [sym__strikethrough] = STATE(42),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(42),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(42),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [68] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(40),
    [sym_full_reference_link] = STATE(40),
    [sym_collapsed_reference_link] = STATE(40),
    [sym_inline_link] = STATE(40),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(40),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(40),
    [aux_sym__inline_no_underscore] = STATE(40),
    [sym__strikethrough] = STATE(40),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(40),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(40),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [69] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(69),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1105),
    [sym_entity_reference] = ACTIONS(1108),
    [sym_numeric_character_reference] = ACTIONS(1108),
    [anon_sym_LBRACK] = ACTIONS(1111),
    [anon_sym_RBRACK] = ACTIONS(1114),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1120),
    [anon_sym_BANG] = ACTIONS(1123),
    [anon_sym_DQUOTE] = ACTIONS(1120),
    [anon_sym_POUND] = ACTIONS(1120),
    [anon_sym_DOLLAR] = ACTIONS(1120),
    [anon_sym_PERCENT] = ACTIONS(1120),
    [anon_sym_AMP] = ACTIONS(1126),
    [anon_sym_SQUOTE] = ACTIONS(1120),
    [anon_sym_STAR] = ACTIONS(1120),
    [anon_sym_PLUS] = ACTIONS(1120),
    [anon_sym_COMMA] = ACTIONS(1120),
    [anon_sym_DASH] = ACTIONS(1120),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_SLASH] = ACTIONS(1120),
    [anon_sym_COLON] = ACTIONS(1120),
    [anon_sym_SEMI] = ACTIONS(1120),
    [anon_sym_EQ] = ACTIONS(1120),
    [anon_sym_QMARK] = ACTIONS(1120),
    [anon_sym_AT] = ACTIONS(1120),
    [anon_sym_BSLASH] = ACTIONS(1129),
    [anon_sym_CARET] = ACTIONS(1120),
    [anon_sym__] = ACTIONS(1120),
    [anon_sym_BQUOTE] = ACTIONS(1120),
    [anon_sym_LBRACE] = ACTIONS(1120),
    [anon_sym_PIPE] = ACTIONS(1120),
    [anon_sym_RBRACE] = ACTIONS(1120),
    [anon_sym_TILDE] = ACTIONS(1120),
    [anon_sym_LPAREN] = ACTIONS(1120),
    [anon_sym_RPAREN] = ACTIONS(1120),
    [sym__newline_token] = ACTIONS(1132),
    [sym_uri_autolink] = ACTIONS(1108),
    [sym_email_autolink] = ACTIONS(1108),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1135),
    [anon_sym_LT_QMARK] = ACTIONS(1138),
    [aux_sym__declaration_token1] = ACTIONS(1141),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1144),
    [sym__whitespace_ge_2] = ACTIONS(1147),
    [aux_sym__whitespace_token1] = ACTIONS(1150),
    [sym__word_no_digit] = ACTIONS(1108),
    [sym__digits] = ACTIONS(1108),
    [sym__code_span_start] = ACTIONS(1153),
    [sym__emphasis_open_star] = ACTIONS(1156),
    [sym__emphasis_open_underscore] = ACTIONS(1159),
    [sym__strikethrough_open] = ACTIONS(1162),
  },
  [70] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(71),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [71] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(69),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [72] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(19),
    [sym_full_reference_link] = STATE(19),
    [sym_collapsed_reference_link] = STATE(19),
    [sym_inline_link] = STATE(19),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(19),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(19),
    [aux_sym__inline_no_underscore] = STATE(19),
    [sym__strikethrough] = STATE(19),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(19),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(19),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [73] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(16),
    [sym_full_reference_link] = STATE(16),
    [sym_collapsed_reference_link] = STATE(16),
    [sym_inline_link] = STATE(16),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(16),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(16),
    [aux_sym__inline_no_star] = STATE(16),
    [sym__strikethrough] = STATE(16),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(16),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(16),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [74] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(64),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [75] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(32),
    [sym_full_reference_link] = STATE(32),
    [sym_collapsed_reference_link] = STATE(32),
    [sym_inline_link] = STATE(32),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(32),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(32),
    [aux_sym__inline_no_underscore] = STATE(32),
    [sym__strikethrough] = STATE(32),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(32),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(32),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [76] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(55),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [77] = {
    [sym_backslash_escape] = STATE(149),
    [sym_code_span] = STATE(149),
    [sym__link_text] = STATE(1059),
    [sym__link_text_non_empty] = STATE(507),
    [sym_shortcut_link] = STATE(27),
    [sym_full_reference_link] = STATE(27),
    [sym_collapsed_reference_link] = STATE(27),
    [sym_inline_link] = STATE(27),
    [sym_image] = STATE(149),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(149),
    [sym__whitespace] = STATE(149),
    [sym__word] = STATE(149),
    [sym__soft_line_break] = STATE(149),
    [sym__inline_base] = STATE(27),
    [sym__text_base] = STATE(149),
    [sym__inline_element_no_tilde] = STATE(27),
    [aux_sym__inline_no_tilde] = STATE(27),
    [sym__strikethrough] = STATE(27),
    [sym__emphasis_star] = STATE(272),
    [sym__strong_emphasis_star] = STATE(27),
    [sym__emphasis_underscore] = STATE(272),
    [sym__strong_emphasis_underscore] = STATE(27),
    [aux_sym__inline_base_repeat1] = STATE(149),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(675),
    [sym_numeric_character_reference] = ACTIONS(675),
    [anon_sym_LBRACK] = ACTIONS(677),
    [anon_sym_RBRACK] = ACTIONS(679),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(675),
    [sym_email_autolink] = ACTIONS(675),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(675),
    [sym__digits] = ACTIONS(675),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(707),
    [sym__emphasis_open_underscore] = ACTIONS(709),
    [sym__strikethrough_open] = ACTIONS(713),
  },
  [78] = {
    [sym_backslash_escape] = STATE(150),
    [sym_code_span] = STATE(150),
    [sym__link_text] = STATE(1057),
    [sym__link_text_non_empty] = STATE(342),
    [sym_shortcut_link] = STATE(25),
    [sym_full_reference_link] = STATE(25),
    [sym_collapsed_reference_link] = STATE(25),
    [sym_inline_link] = STATE(25),
    [sym_image] = STATE(150),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(150),
    [sym__whitespace] = STATE(150),
    [sym__word] = STATE(150),
    [sym__soft_line_break] = STATE(150),
    [sym__inline_base] = STATE(25),
    [sym__text_base] = STATE(150),
    [sym__inline_element_no_star] = STATE(25),
    [aux_sym__inline_no_star] = STATE(25),
    [sym__strikethrough] = STATE(25),
    [sym__emphasis_star] = STATE(329),
    [sym__strong_emphasis_star] = STATE(25),
    [sym__emphasis_underscore] = STATE(329),
    [sym__strong_emphasis_underscore] = STATE(25),
    [aux_sym__inline_base_repeat1] = STATE(150),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(717),
    [sym_numeric_character_reference] = ACTIONS(717),
    [anon_sym_LBRACK] = ACTIONS(719),
    [anon_sym_RBRACK] = ACTIONS(721),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(717),
    [sym_email_autolink] = ACTIONS(717),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(717),
    [sym__digits] = ACTIONS(717),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(749),
    [sym__emphasis_open_underscore] = ACTIONS(751),
    [sym__strikethrough_open] = ACTIONS(755),
  },
  [79] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(69),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1167),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [80] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(69),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [81] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(62),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [82] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(60),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [83] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(47),
    [sym_full_reference_link] = STATE(47),
    [sym_collapsed_reference_link] = STATE(47),
    [sym_inline_link] = STATE(47),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(47),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(47),
    [aux_sym__inline_no_underscore] = STATE(47),
    [sym__strikethrough] = STATE(47),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(47),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(47),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [84] = {
    [sym_backslash_escape] = STATE(157),
    [sym_code_span] = STATE(157),
    [sym__link_text] = STATE(1052),
    [sym__link_text_non_empty] = STATE(551),
    [sym_shortcut_link] = STATE(549),
    [sym_full_reference_link] = STATE(549),
    [sym_collapsed_reference_link] = STATE(549),
    [sym_inline_link] = STATE(549),
    [sym_image] = STATE(157),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(157),
    [sym__whitespace] = STATE(157),
    [sym__word] = STATE(157),
    [sym__soft_line_break] = STATE(157),
    [sym__inline_base] = STATE(549),
    [sym__text_base] = STATE(157),
    [sym__inline_element] = STATE(549),
    [aux_sym__inline] = STATE(80),
    [sym__strikethrough] = STATE(549),
    [sym__emphasis_star] = STATE(548),
    [sym__strong_emphasis_star] = STATE(549),
    [sym__emphasis_underscore] = STATE(548),
    [sym__strong_emphasis_underscore] = STATE(549),
    [aux_sym__inline_base_repeat1] = STATE(157),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1057),
    [sym_numeric_character_reference] = ACTIONS(1057),
    [anon_sym_LBRACK] = ACTIONS(1059),
    [anon_sym_RBRACK] = ACTIONS(1097),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1057),
    [sym_email_autolink] = ACTIONS(1057),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1057),
    [sym__digits] = ACTIONS(1057),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(1089),
    [sym__emphasis_open_underscore] = ACTIONS(1091),
    [sym__strikethrough_open] = ACTIONS(1093),
  },
  [85] = {
    [sym_backslash_escape] = STATE(153),
    [sym_code_span] = STATE(153),
    [sym__link_text] = STATE(1053),
    [sym__link_text_non_empty] = STATE(428),
    [sym_shortcut_link] = STATE(14),
    [sym_full_reference_link] = STATE(14),
    [sym_collapsed_reference_link] = STATE(14),
    [sym_inline_link] = STATE(14),
    [sym_image] = STATE(153),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(153),
    [sym__whitespace] = STATE(153),
    [sym__word] = STATE(153),
    [sym__soft_line_break] = STATE(153),
    [sym__inline_base] = STATE(14),
    [sym__text_base] = STATE(153),
    [sym__inline_element_no_underscore] = STATE(14),
    [aux_sym__inline_no_underscore] = STATE(14),
    [sym__strikethrough] = STATE(14),
    [sym__emphasis_star] = STATE(327),
    [sym__strong_emphasis_star] = STATE(14),
    [sym__emphasis_underscore] = STATE(327),
    [sym__strong_emphasis_underscore] = STATE(14),
    [aux_sym__inline_base_repeat1] = STATE(153),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(759),
    [sym_numeric_character_reference] = ACTIONS(759),
    [anon_sym_LBRACK] = ACTIONS(761),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(759),
    [sym_email_autolink] = ACTIONS(759),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(759),
    [sym__digits] = ACTIONS(759),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(791),
    [sym__emphasis_open_underscore] = ACTIONS(793),
    [sym__strikethrough_open] = ACTIONS(797),
  },
  [86] = {
    [sym_backslash_escape] = STATE(161),
    [sym_code_span] = STATE(161),
    [sym_image] = STATE(161),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(580),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(161),
    [sym__whitespace] = STATE(161),
    [sym__word] = STATE(161),
    [sym__soft_line_break] = STATE(161),
    [sym__inline_base] = STATE(622),
    [sym__text_base] = STATE(161),
    [sym__inline_element_no_link] = STATE(622),
    [aux_sym__inline_no_link] = STATE(131),
    [sym__strikethrough_no_link] = STATE(622),
    [sym__emphasis_star_no_link] = STATE(601),
    [sym__strong_emphasis_star_no_link] = STATE(622),
    [sym__emphasis_underscore_no_link] = STATE(601),
    [sym__strong_emphasis_underscore_no_link] = STATE(622),
    [aux_sym__inline_base_repeat1] = STATE(161),
    [ts_builtin_sym_end] = ACTIONS(109),
    [sym__backslash_escape] = ACTIONS(1171),
    [sym_entity_reference] = ACTIONS(1174),
    [sym_numeric_character_reference] = ACTIONS(1174),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(1177),
    [anon_sym_LT] = ACTIONS(1180),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(1186),
    [anon_sym_DQUOTE] = ACTIONS(1183),
    [anon_sym_POUND] = ACTIONS(1183),
    [anon_sym_DOLLAR] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1183),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_SQUOTE] = ACTIONS(1183),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1183),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_QMARK] = ACTIONS(1183),
    [anon_sym_AT] = ACTIONS(1183),
    [anon_sym_BSLASH] = ACTIONS(1192),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym__] = ACTIONS(1183),
    [anon_sym_BQUOTE] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1183),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_RBRACE] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1183),
    [anon_sym_RPAREN] = ACTIONS(1183),
    [sym__newline_token] = ACTIONS(1195),
    [sym_uri_autolink] = ACTIONS(1174),
    [sym_email_autolink] = ACTIONS(1174),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1198),
    [anon_sym_LT_QMARK] = ACTIONS(1201),
    [aux_sym__declaration_token1] = ACTIONS(1204),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1207),
    [sym__whitespace_ge_2] = ACTIONS(1210),
    [aux_sym__whitespace_token1] = ACTIONS(1213),
    [sym__word_no_digit] = ACTIONS(1174),
    [sym__digits] = ACTIONS(1174),
    [sym__code_span_start] = ACTIONS(1216),
    [sym__emphasis_open_star] = ACTIONS(1219),
    [sym__emphasis_open_underscore] = ACTIONS(1222),
    [sym__last_token_punctuation] = ACTIONS(1225),
    [sym__strikethrough_open] = ACTIONS(1227),
  },
  [87] = {
    [sym_backslash_escape] = STATE(161),
    [sym_code_span] = STATE(161),
    [sym_image] = STATE(161),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(580),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(161),
    [sym__whitespace] = STATE(161),
    [sym__word] = STATE(161),
    [sym__soft_line_break] = STATE(161),
    [sym__inline_base] = STATE(622),
    [sym__text_base] = STATE(161),
    [sym__inline_element_no_link] = STATE(622),
    [aux_sym__inline_no_link] = STATE(127),
    [sym__strikethrough_no_link] = STATE(622),
    [sym__emphasis_star_no_link] = STATE(601),
    [sym__strong_emphasis_star_no_link] = STATE(622),
    [sym__emphasis_underscore_no_link] = STATE(601),
    [sym__strong_emphasis_underscore_no_link] = STATE(622),
    [aux_sym__inline_base_repeat1] = STATE(161),
    [sym__backslash_escape] = ACTIONS(1230),
    [sym_entity_reference] = ACTIONS(1233),
    [sym_numeric_character_reference] = ACTIONS(1233),
    [anon_sym_LBRACK] = ACTIONS(102),
    [anon_sym_RBRACK] = ACTIONS(1236),
    [anon_sym_LT] = ACTIONS(1239),
    [anon_sym_GT] = ACTIONS(1242),
    [anon_sym_BANG] = ACTIONS(1245),
    [anon_sym_DQUOTE] = ACTIONS(1242),
    [anon_sym_POUND] = ACTIONS(1242),
    [anon_sym_DOLLAR] = ACTIONS(1242),
    [anon_sym_PERCENT] = ACTIONS(1242),
    [anon_sym_AMP] = ACTIONS(1248),
    [anon_sym_SQUOTE] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1242),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_COMMA] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_DOT] = ACTIONS(1242),
    [anon_sym_SLASH] = ACTIONS(1242),
    [anon_sym_COLON] = ACTIONS(1242),
    [anon_sym_SEMI] = ACTIONS(1242),
    [anon_sym_EQ] = ACTIONS(1242),
    [anon_sym_QMARK] = ACTIONS(1242),
    [anon_sym_AT] = ACTIONS(1242),
    [anon_sym_BSLASH] = ACTIONS(1251),
    [anon_sym_CARET] = ACTIONS(1242),
    [anon_sym__] = ACTIONS(1242),
    [anon_sym_BQUOTE] = ACTIONS(1242),
    [anon_sym_LBRACE] = ACTIONS(1242),
    [anon_sym_PIPE] = ACTIONS(1242),
    [anon_sym_RBRACE] = ACTIONS(1242),
    [anon_sym_TILDE] = ACTIONS(1242),
    [anon_sym_LPAREN] = ACTIONS(1242),
    [anon_sym_RPAREN] = ACTIONS(1242),
    [sym__newline_token] = ACTIONS(1254),
    [sym_uri_autolink] = ACTIONS(1233),
    [sym_email_autolink] = ACTIONS(1233),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1257),
    [anon_sym_LT_QMARK] = ACTIONS(1260),
    [aux_sym__declaration_token1] = ACTIONS(1263),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1266),
    [sym__whitespace_ge_2] = ACTIONS(1269),
    [aux_sym__whitespace_token1] = ACTIONS(1272),
    [sym__word_no_digit] = ACTIONS(1233),
    [sym__digits] = ACTIONS(1233),
    [sym__code_span_start] = ACTIONS(1275),
    [sym__emphasis_open_star] = ACTIONS(1278),
    [sym__emphasis_open_underscore] = ACTIONS(1281),
    [sym__emphasis_close_underscore] = ACTIONS(102),
    [sym__last_token_punctuation] = ACTIONS(1284),
    [sym__strikethrough_open] = ACTIONS(1286),
  },
  [88] = {
    [sym_backslash_escape] = STATE(161),
    [sym_code_span] = STATE(161),
    [sym_image] = STATE(161),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(580),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(161),
    [sym__whitespace] = STATE(161),
    [sym__word] = STATE(161),
    [sym__soft_line_break] = STATE(161),
    [sym__inline_base] = STATE(622),
    [sym__text_base] = STATE(161),
    [sym__inline_element_no_link] = STATE(622),
    [aux_sym__inline_no_link] = STATE(102),
    [sym__strikethrough_no_link] = STATE(622),
    [sym__emphasis_star_no_link] = STATE(601),
    [sym__strong_emphasis_star_no_link] = STATE(622),
    [sym__emphasis_underscore_no_link] = STATE(601),
    [sym__strong_emphasis_underscore_no_link] = STATE(622),
    [aux_sym__inline_base_repeat1] = STATE(161),
    [sym__backslash_escape] = ACTIONS(1289),
    [sym_entity_reference] = ACTIONS(1292),
    [sym_numeric_character_reference] = ACTIONS(1292),
    [anon_sym_LBRACK] = ACTIONS(480),
    [anon_sym_RBRACK] = ACTIONS(1295),
    [anon_sym_LT] = ACTIONS(1298),
    [anon_sym_GT] = ACTIONS(1301),
    [anon_sym_BANG] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1301),
    [anon_sym_POUND] = ACTIONS(1301),
    [anon_sym_DOLLAR] = ACTIONS(1301),
    [anon_sym_PERCENT] = ACTIONS(1301),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym_SQUOTE] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_COMMA] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_SLASH] = ACTIONS(1301),
    [anon_sym_COLON] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(1301),
    [anon_sym_EQ] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1301),
    [anon_sym_AT] = ACTIONS(1301),
    [anon_sym_BSLASH] = ACTIONS(1310),
    [anon_sym_CARET] = ACTIONS(1301),
    [anon_sym__] = ACTIONS(1301),
    [anon_sym_BQUOTE] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1301),
    [anon_sym_PIPE] = ACTIONS(1301),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [anon_sym_TILDE] = ACTIONS(1301),
    [anon_sym_LPAREN] = ACTIONS(1301),
    [anon_sym_RPAREN] = ACTIONS(1301),
    [sym__newline_token] = ACTIONS(1313),
    [sym_uri_autolink] = ACTIONS(1292),
    [sym_email_autolink] = ACTIONS(1292),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1316),
    [anon_sym_LT_QMARK] = ACTIONS(1319),
    [aux_sym__declaration_token1] = ACTIONS(1322),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1325),
    [sym__whitespace_ge_2] = ACTIONS(1328),
    [aux_sym__whitespace_token1] = ACTIONS(1331),
    [sym__word_no_digit] = ACTIONS(1292),
    [sym__digits] = ACTIONS(1292),
    [sym__code_span_start] = ACTIONS(1334),
    [sym__emphasis_open_star] = ACTIONS(1337),
    [sym__emphasis_open_underscore] = ACTIONS(1340),
    [sym__emphasis_close_star] = ACTIONS(480),
    [sym__last_token_punctuation] = ACTIONS(1343),
    [sym__strikethrough_open] = ACTIONS(1345),
  },
  [89] = {
    [sym_backslash_escape] = STATE(161),
    [sym_code_span] = STATE(161),
    [sym_image] = STATE(161),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(580),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(161),
    [sym__whitespace] = STATE(161),
    [sym__word] = STATE(161),
    [sym__soft_line_break] = STATE(161),
    [sym__inline_base] = STATE(622),
    [sym__text_base] = STATE(161),
    [sym__inline_element_no_link] = STATE(622),
    [aux_sym__inline_no_link] = STATE(100),
    [sym__strikethrough_no_link] = STATE(622),
    [sym__emphasis_star_no_link] = STATE(601),
    [sym__strong_emphasis_star_no_link] = STATE(622),
    [sym__emphasis_underscore_no_link] = STATE(601),
    [sym__strong_emphasis_underscore_no_link] = STATE(622),
    [aux_sym__inline_base_repeat1] = STATE(161),
    [sym__backslash_escape] = ACTIONS(1348),
    [sym_entity_reference] = ACTIONS(1351),
    [sym_numeric_character_reference] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(297),
    [anon_sym_RBRACK] = ACTIONS(1354),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_GT] = ACTIONS(1360),
    [anon_sym_BANG] = ACTIONS(1363),
    [anon_sym_DQUOTE] = ACTIONS(1360),
    [anon_sym_POUND] = ACTIONS(1360),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_PERCENT] = ACTIONS(1360),
    [anon_sym_AMP] = ACTIONS(1366),
    [anon_sym_SQUOTE] = ACTIONS(1360),
    [anon_sym_STAR] = ACTIONS(1360),
    [anon_sym_PLUS] = ACTIONS(1360),
    [anon_sym_COMMA] = ACTIONS(1360),
    [anon_sym_DASH] = ACTIONS(1360),
    [anon_sym_DOT] = ACTIONS(1360),
    [anon_sym_SLASH] = ACTIONS(1360),
    [anon_sym_COLON] = ACTIONS(1360),
    [anon_sym_SEMI] = ACTIONS(1360),
    [anon_sym_EQ] = ACTIONS(1360),
    [anon_sym_QMARK] = ACTIONS(1360),
    [anon_sym_AT] = ACTIONS(1360),
    [anon_sym_BSLASH] = ACTIONS(1369),
    [anon_sym_CARET] = ACTIONS(1360),
    [anon_sym__] = ACTIONS(1360),
    [anon_sym_BQUOTE] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(1360),
    [anon_sym_PIPE] = ACTIONS(1360),
    [anon_sym_RBRACE] = ACTIONS(1360),
    [anon_sym_TILDE] = ACTIONS(1360),
    [anon_sym_LPAREN] = ACTIONS(1360),
    [anon_sym_RPAREN] = ACTIONS(1360),
    [sym__newline_token] = ACTIONS(1372),
    [sym_uri_autolink] = ACTIONS(1351),
    [sym_email_autolink] = ACTIONS(1351),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1375),
    [anon_sym_LT_QMARK] = ACTIONS(1378),
    [aux_sym__declaration_token1] = ACTIONS(1381),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1384),
    [sym__whitespace_ge_2] = ACTIONS(1387),
    [aux_sym__whitespace_token1] = ACTIONS(1390),
    [sym__word_no_digit] = ACTIONS(1351),
    [sym__digits] = ACTIONS(1351),
    [sym__code_span_start] = ACTIONS(1393),
    [sym__emphasis_open_star] = ACTIONS(1396),
    [sym__emphasis_open_underscore] = ACTIONS(1399),
    [sym__last_token_punctuation] = ACTIONS(1402),
    [sym__strikethrough_open] = ACTIONS(1404),
    [sym__strikethrough_close] = ACTIONS(297),
  },
  [90] = {
    [sym_backslash_escape] = STATE(161),
    [sym_code_span] = STATE(161),
    [sym_image] = STATE(161),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(580),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(161),
    [sym__whitespace] = STATE(161),
    [sym__word] = STATE(161),
    [sym__soft_line_break] = STATE(161),
    [sym__inline_base] = STATE(622),
    [sym__text_base] = STATE(161),
    [sym__inline_element_no_link] = STATE(622),
    [aux_sym__inline_no_link] = STATE(103),
    [sym__strikethrough_no_link] = STATE(622),
    [sym__emphasis_star_no_link] = STATE(601),
    [sym__strong_emphasis_star_no_link] = STATE(622),
    [sym__emphasis_underscore_no_link] = STATE(601),
    [sym__strong_emphasis_underscore_no_link] = STATE(622),
    [aux_sym__inline_base_repeat1] = STATE(161),
    [sym__backslash_escape] = ACTIONS(1171),
    [sym_entity_reference] = ACTIONS(1174),
    [sym_numeric_character_reference] = ACTIONS(1174),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(1177),
    [anon_sym_LT] = ACTIONS(1180),
    [anon_sym_GT] = ACTIONS(1183),
    [anon_sym_BANG] = ACTIONS(1186),
    [anon_sym_DQUOTE] = ACTIONS(1183),
    [anon_sym_POUND] = ACTIONS(1183),
    [anon_sym_DOLLAR] = ACTIONS(1183),
    [anon_sym_PERCENT] = ACTIONS(1183),
    [anon_sym_AMP] = ACTIONS(1189),
    [anon_sym_SQUOTE] = ACTIONS(1183),
    [anon_sym_STAR] = ACTIONS(1183),
    [anon_sym_PLUS] = ACTIONS(1183),
    [anon_sym_COMMA] = ACTIONS(1183),
    [anon_sym_DASH] = ACTIONS(1183),
    [anon_sym_DOT] = ACTIONS(1183),
    [anon_sym_SLASH] = ACTIONS(1183),
    [anon_sym_COLON] = ACTIONS(1183),
    [anon_sym_SEMI] = ACTIONS(1183),
    [anon_sym_EQ] = ACTIONS(1183),
    [anon_sym_QMARK] = ACTIONS(1183),
    [anon_sym_AT] = ACTIONS(1183),
    [anon_sym_BSLASH] = ACTIONS(1192),
    [anon_sym_CARET] = ACTIONS(1183),
    [anon_sym__] = ACTIONS(1183),
    [anon_sym_BQUOTE] = ACTIONS(1183),
    [anon_sym_LBRACE] = ACTIONS(1183),
    [anon_sym_PIPE] = ACTIONS(1183),
    [anon_sym_RBRACE] = ACTIONS(1183),
    [anon_sym_TILDE] = ACTIONS(1183),
    [anon_sym_LPAREN] = ACTIONS(1183),
    [anon_sym_RPAREN] = ACTIONS(1183),
    [sym__newline_token] = ACTIONS(1195),
    [sym_uri_autolink] = ACTIONS(1174),
    [sym_email_autolink] = ACTIONS(1174),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1198),
    [anon_sym_LT_QMARK] = ACTIONS(1201),
    [aux_sym__declaration_token1] = ACTIONS(1204),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1207),
    [sym__whitespace_ge_2] = ACTIONS(1210),
    [aux_sym__whitespace_token1] = ACTIONS(1213),
    [sym__word_no_digit] = ACTIONS(1174),
    [sym__digits] = ACTIONS(1174),
    [sym__code_span_start] = ACTIONS(1216),
    [sym__emphasis_open_star] = ACTIONS(1219),
    [sym__emphasis_open_underscore] = ACTIONS(1222),
    [sym__last_token_punctuation] = ACTIONS(1407),
    [sym__strikethrough_open] = ACTIONS(1227),
  },
  [91] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(111),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(111),
    [aux_sym__inline_no_underscore_no_link] = STATE(111),
    [sym__strikethrough_no_link] = STATE(111),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(111),
    [sym__emphasis_underscore_no_link] = STATE(620),
    [sym__strong_emphasis_underscore_no_link] = STATE(111),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(1409),
    [sym_entity_reference] = ACTIONS(1412),
    [sym_numeric_character_reference] = ACTIONS(1412),
    [anon_sym_LT] = ACTIONS(1415),
    [anon_sym_GT] = ACTIONS(1418),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_DQUOTE] = ACTIONS(1418),
    [anon_sym_POUND] = ACTIONS(1418),
    [anon_sym_DOLLAR] = ACTIONS(1418),
    [anon_sym_PERCENT] = ACTIONS(1418),
    [anon_sym_AMP] = ACTIONS(1424),
    [anon_sym_SQUOTE] = ACTIONS(1418),
    [anon_sym_STAR] = ACTIONS(1418),
    [anon_sym_PLUS] = ACTIONS(1418),
    [anon_sym_COMMA] = ACTIONS(1418),
    [anon_sym_DASH] = ACTIONS(1418),
    [anon_sym_DOT] = ACTIONS(1418),
    [anon_sym_SLASH] = ACTIONS(1418),
    [anon_sym_COLON] = ACTIONS(1418),
    [anon_sym_SEMI] = ACTIONS(1418),
    [anon_sym_EQ] = ACTIONS(1418),
    [anon_sym_QMARK] = ACTIONS(1418),
    [anon_sym_AT] = ACTIONS(1418),
    [anon_sym_BSLASH] = ACTIONS(1427),
    [anon_sym_CARET] = ACTIONS(1418),
    [anon_sym__] = ACTIONS(1418),
    [anon_sym_BQUOTE] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(1418),
    [anon_sym_PIPE] = ACTIONS(1418),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [anon_sym_TILDE] = ACTIONS(1418),
    [anon_sym_LPAREN] = ACTIONS(1418),
    [anon_sym_RPAREN] = ACTIONS(1418),
    [sym__newline_token] = ACTIONS(1430),
    [sym_uri_autolink] = ACTIONS(1412),
    [sym_email_autolink] = ACTIONS(1412),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1433),
    [anon_sym_LT_QMARK] = ACTIONS(1436),
    [aux_sym__declaration_token1] = ACTIONS(1439),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1442),
    [sym__whitespace_ge_2] = ACTIONS(1445),
    [aux_sym__whitespace_token1] = ACTIONS(1448),
    [sym__word_no_digit] = ACTIONS(1412),
    [sym__digits] = ACTIONS(1412),
    [sym__code_span_start] = ACTIONS(1451),
    [sym__emphasis_open_star] = ACTIONS(1454),
    [sym__emphasis_open_underscore] = ACTIONS(1457),
    [sym__emphasis_close_star] = ACTIONS(1460),
    [sym__last_token_punctuation] = ACTIONS(1462),
    [sym__strikethrough_open] = ACTIONS(1464),
  },
  [92] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(101),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(101),
    [aux_sym__inline_no_tilde_no_link] = STATE(101),
    [sym__strikethrough_no_link] = STATE(101),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(101),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(101),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(1467),
    [sym_entity_reference] = ACTIONS(1470),
    [sym_numeric_character_reference] = ACTIONS(1470),
    [anon_sym_LT] = ACTIONS(1473),
    [anon_sym_GT] = ACTIONS(1476),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_DQUOTE] = ACTIONS(1476),
    [anon_sym_POUND] = ACTIONS(1476),
    [anon_sym_DOLLAR] = ACTIONS(1476),
    [anon_sym_PERCENT] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1482),
    [anon_sym_SQUOTE] = ACTIONS(1476),
    [anon_sym_STAR] = ACTIONS(1476),
    [anon_sym_PLUS] = ACTIONS(1476),
    [anon_sym_COMMA] = ACTIONS(1476),
    [anon_sym_DASH] = ACTIONS(1476),
    [anon_sym_DOT] = ACTIONS(1476),
    [anon_sym_SLASH] = ACTIONS(1476),
    [anon_sym_COLON] = ACTIONS(1476),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_EQ] = ACTIONS(1476),
    [anon_sym_QMARK] = ACTIONS(1476),
    [anon_sym_AT] = ACTIONS(1476),
    [anon_sym_BSLASH] = ACTIONS(1485),
    [anon_sym_CARET] = ACTIONS(1476),
    [anon_sym__] = ACTIONS(1476),
    [anon_sym_BQUOTE] = ACTIONS(1476),
    [anon_sym_LBRACE] = ACTIONS(1476),
    [anon_sym_PIPE] = ACTIONS(1476),
    [anon_sym_RBRACE] = ACTIONS(1476),
    [anon_sym_TILDE] = ACTIONS(1476),
    [anon_sym_LPAREN] = ACTIONS(1476),
    [anon_sym_RPAREN] = ACTIONS(1476),
    [sym__newline_token] = ACTIONS(1488),
    [sym_uri_autolink] = ACTIONS(1470),
    [sym_email_autolink] = ACTIONS(1470),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1491),
    [anon_sym_LT_QMARK] = ACTIONS(1494),
    [aux_sym__declaration_token1] = ACTIONS(1497),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1500),
    [sym__whitespace_ge_2] = ACTIONS(1503),
    [aux_sym__whitespace_token1] = ACTIONS(1506),
    [sym__word_no_digit] = ACTIONS(1470),
    [sym__digits] = ACTIONS(1470),
    [sym__code_span_start] = ACTIONS(1509),
    [sym__emphasis_open_star] = ACTIONS(1512),
    [sym__emphasis_open_underscore] = ACTIONS(1515),
    [sym__emphasis_close_star] = ACTIONS(1460),
    [sym__last_token_punctuation] = ACTIONS(1518),
    [sym__strikethrough_open] = ACTIONS(1520),
  },
  [93] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(107),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(107),
    [aux_sym__inline_no_star_no_link] = STATE(107),
    [sym__strikethrough_no_link] = STATE(107),
    [sym__emphasis_star_no_link] = STATE(584),
    [sym__strong_emphasis_star_no_link] = STATE(107),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(107),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(1523),
    [sym_entity_reference] = ACTIONS(1526),
    [sym_numeric_character_reference] = ACTIONS(1526),
    [anon_sym_LT] = ACTIONS(1529),
    [anon_sym_GT] = ACTIONS(1532),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_DQUOTE] = ACTIONS(1532),
    [anon_sym_POUND] = ACTIONS(1532),
    [anon_sym_DOLLAR] = ACTIONS(1532),
    [anon_sym_PERCENT] = ACTIONS(1532),
    [anon_sym_AMP] = ACTIONS(1538),
    [anon_sym_SQUOTE] = ACTIONS(1532),
    [anon_sym_STAR] = ACTIONS(1532),
    [anon_sym_PLUS] = ACTIONS(1532),
    [anon_sym_COMMA] = ACTIONS(1532),
    [anon_sym_DASH] = ACTIONS(1532),
    [anon_sym_DOT] = ACTIONS(1532),
    [anon_sym_SLASH] = ACTIONS(1532),
    [anon_sym_COLON] = ACTIONS(1532),
    [anon_sym_SEMI] = ACTIONS(1532),
    [anon_sym_EQ] = ACTIONS(1532),
    [anon_sym_QMARK] = ACTIONS(1532),
    [anon_sym_AT] = ACTIONS(1532),
    [anon_sym_BSLASH] = ACTIONS(1541),
    [anon_sym_CARET] = ACTIONS(1532),
    [anon_sym__] = ACTIONS(1532),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LBRACE] = ACTIONS(1532),
    [anon_sym_PIPE] = ACTIONS(1532),
    [anon_sym_RBRACE] = ACTIONS(1532),
    [anon_sym_TILDE] = ACTIONS(1532),
    [anon_sym_LPAREN] = ACTIONS(1532),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [sym__newline_token] = ACTIONS(1544),
    [sym_uri_autolink] = ACTIONS(1526),
    [sym_email_autolink] = ACTIONS(1526),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1547),
    [anon_sym_LT_QMARK] = ACTIONS(1550),
    [aux_sym__declaration_token1] = ACTIONS(1553),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1556),
    [sym__whitespace_ge_2] = ACTIONS(1559),
    [aux_sym__whitespace_token1] = ACTIONS(1562),
    [sym__word_no_digit] = ACTIONS(1526),
    [sym__digits] = ACTIONS(1526),
    [sym__code_span_start] = ACTIONS(1565),
    [sym__emphasis_open_star] = ACTIONS(1568),
    [sym__emphasis_open_underscore] = ACTIONS(1571),
    [sym__emphasis_close_underscore] = ACTIONS(1574),
    [sym__last_token_punctuation] = ACTIONS(1576),
    [sym__strikethrough_open] = ACTIONS(1578),
  },
  [94] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(106),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(106),
    [aux_sym__inline_no_tilde_no_link] = STATE(106),
    [sym__strikethrough_no_link] = STATE(106),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(106),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(106),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(1581),
    [sym_entity_reference] = ACTIONS(1584),
    [sym_numeric_character_reference] = ACTIONS(1584),
    [anon_sym_LT] = ACTIONS(1587),
    [anon_sym_GT] = ACTIONS(1590),
    [anon_sym_BANG] = ACTIONS(1593),
    [anon_sym_DQUOTE] = ACTIONS(1590),
    [anon_sym_POUND] = ACTIONS(1590),
    [anon_sym_DOLLAR] = ACTIONS(1590),
    [anon_sym_PERCENT] = ACTIONS(1590),
    [anon_sym_AMP] = ACTIONS(1596),
    [anon_sym_SQUOTE] = ACTIONS(1590),
    [anon_sym_STAR] = ACTIONS(1590),
    [anon_sym_PLUS] = ACTIONS(1590),
    [anon_sym_COMMA] = ACTIONS(1590),
    [anon_sym_DASH] = ACTIONS(1590),
    [anon_sym_DOT] = ACTIONS(1590),
    [anon_sym_SLASH] = ACTIONS(1590),
    [anon_sym_COLON] = ACTIONS(1590),
    [anon_sym_SEMI] = ACTIONS(1590),
    [anon_sym_EQ] = ACTIONS(1590),
    [anon_sym_QMARK] = ACTIONS(1590),
    [anon_sym_AT] = ACTIONS(1590),
    [anon_sym_BSLASH] = ACTIONS(1599),
    [anon_sym_CARET] = ACTIONS(1590),
    [anon_sym__] = ACTIONS(1590),
    [anon_sym_BQUOTE] = ACTIONS(1590),
    [anon_sym_LBRACE] = ACTIONS(1590),
    [anon_sym_PIPE] = ACTIONS(1590),
    [anon_sym_RBRACE] = ACTIONS(1590),
    [anon_sym_TILDE] = ACTIONS(1590),
    [anon_sym_LPAREN] = ACTIONS(1590),
    [anon_sym_RPAREN] = ACTIONS(1590),
    [sym__newline_token] = ACTIONS(1602),
    [sym_uri_autolink] = ACTIONS(1584),
    [sym_email_autolink] = ACTIONS(1584),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1605),
    [anon_sym_LT_QMARK] = ACTIONS(1608),
    [aux_sym__declaration_token1] = ACTIONS(1611),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1614),
    [sym__whitespace_ge_2] = ACTIONS(1617),
    [aux_sym__whitespace_token1] = ACTIONS(1620),
    [sym__word_no_digit] = ACTIONS(1584),
    [sym__digits] = ACTIONS(1584),
    [sym__code_span_start] = ACTIONS(1623),
    [sym__emphasis_open_star] = ACTIONS(1626),
    [sym__emphasis_open_underscore] = ACTIONS(1629),
    [sym__emphasis_close_underscore] = ACTIONS(1574),
    [sym__last_token_punctuation] = ACTIONS(1632),
    [sym__strikethrough_open] = ACTIONS(1634),
  },
  [95] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(132),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(132),
    [aux_sym__inline_no_star_no_link] = STATE(132),
    [sym__strikethrough_no_link] = STATE(132),
    [sym__emphasis_star_no_link] = STATE(610),
    [sym__strong_emphasis_star_no_link] = STATE(132),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(132),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(1637),
    [sym_entity_reference] = ACTIONS(1640),
    [sym_numeric_character_reference] = ACTIONS(1640),
    [anon_sym_LT] = ACTIONS(1643),
    [anon_sym_GT] = ACTIONS(1646),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_DQUOTE] = ACTIONS(1646),
    [anon_sym_POUND] = ACTIONS(1646),
    [anon_sym_DOLLAR] = ACTIONS(1646),
    [anon_sym_PERCENT] = ACTIONS(1646),
    [anon_sym_AMP] = ACTIONS(1652),
    [anon_sym_SQUOTE] = ACTIONS(1646),
    [anon_sym_STAR] = ACTIONS(1646),
    [anon_sym_PLUS] = ACTIONS(1646),
    [anon_sym_COMMA] = ACTIONS(1646),
    [anon_sym_DASH] = ACTIONS(1646),
    [anon_sym_DOT] = ACTIONS(1646),
    [anon_sym_SLASH] = ACTIONS(1646),
    [anon_sym_COLON] = ACTIONS(1646),
    [anon_sym_SEMI] = ACTIONS(1646),
    [anon_sym_EQ] = ACTIONS(1646),
    [anon_sym_QMARK] = ACTIONS(1646),
    [anon_sym_AT] = ACTIONS(1646),
    [anon_sym_BSLASH] = ACTIONS(1655),
    [anon_sym_CARET] = ACTIONS(1646),
    [anon_sym__] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(1646),
    [anon_sym_LBRACE] = ACTIONS(1646),
    [anon_sym_PIPE] = ACTIONS(1646),
    [anon_sym_RBRACE] = ACTIONS(1646),
    [anon_sym_TILDE] = ACTIONS(1646),
    [anon_sym_LPAREN] = ACTIONS(1646),
    [anon_sym_RPAREN] = ACTIONS(1646),
    [sym__newline_token] = ACTIONS(1658),
    [sym_uri_autolink] = ACTIONS(1640),
    [sym_email_autolink] = ACTIONS(1640),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1661),
    [anon_sym_LT_QMARK] = ACTIONS(1664),
    [aux_sym__declaration_token1] = ACTIONS(1667),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1670),
    [sym__whitespace_ge_2] = ACTIONS(1673),
    [aux_sym__whitespace_token1] = ACTIONS(1676),
    [sym__word_no_digit] = ACTIONS(1640),
    [sym__digits] = ACTIONS(1640),
    [sym__code_span_start] = ACTIONS(1679),
    [sym__emphasis_open_star] = ACTIONS(1682),
    [sym__emphasis_open_underscore] = ACTIONS(1685),
    [sym__last_token_punctuation] = ACTIONS(1688),
    [sym__strikethrough_open] = ACTIONS(1690),
    [sym__strikethrough_close] = ACTIONS(1693),
  },
  [96] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(134),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(134),
    [aux_sym__inline_no_underscore_no_link] = STATE(134),
    [sym__strikethrough_no_link] = STATE(134),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(134),
    [sym__emphasis_underscore_no_link] = STATE(606),
    [sym__strong_emphasis_underscore_no_link] = STATE(134),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(1695),
    [sym_entity_reference] = ACTIONS(1698),
    [sym_numeric_character_reference] = ACTIONS(1698),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1704),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_DQUOTE] = ACTIONS(1704),
    [anon_sym_POUND] = ACTIONS(1704),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_PERCENT] = ACTIONS(1704),
    [anon_sym_AMP] = ACTIONS(1710),
    [anon_sym_SQUOTE] = ACTIONS(1704),
    [anon_sym_STAR] = ACTIONS(1704),
    [anon_sym_PLUS] = ACTIONS(1704),
    [anon_sym_COMMA] = ACTIONS(1704),
    [anon_sym_DASH] = ACTIONS(1704),
    [anon_sym_DOT] = ACTIONS(1704),
    [anon_sym_SLASH] = ACTIONS(1704),
    [anon_sym_COLON] = ACTIONS(1704),
    [anon_sym_SEMI] = ACTIONS(1704),
    [anon_sym_EQ] = ACTIONS(1704),
    [anon_sym_QMARK] = ACTIONS(1704),
    [anon_sym_AT] = ACTIONS(1704),
    [anon_sym_BSLASH] = ACTIONS(1713),
    [anon_sym_CARET] = ACTIONS(1704),
    [anon_sym__] = ACTIONS(1704),
    [anon_sym_BQUOTE] = ACTIONS(1704),
    [anon_sym_LBRACE] = ACTIONS(1704),
    [anon_sym_PIPE] = ACTIONS(1704),
    [anon_sym_RBRACE] = ACTIONS(1704),
    [anon_sym_TILDE] = ACTIONS(1704),
    [anon_sym_LPAREN] = ACTIONS(1704),
    [anon_sym_RPAREN] = ACTIONS(1704),
    [sym__newline_token] = ACTIONS(1716),
    [sym_uri_autolink] = ACTIONS(1698),
    [sym_email_autolink] = ACTIONS(1698),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1719),
    [anon_sym_LT_QMARK] = ACTIONS(1722),
    [aux_sym__declaration_token1] = ACTIONS(1725),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1728),
    [sym__whitespace_ge_2] = ACTIONS(1731),
    [aux_sym__whitespace_token1] = ACTIONS(1734),
    [sym__word_no_digit] = ACTIONS(1698),
    [sym__digits] = ACTIONS(1698),
    [sym__code_span_start] = ACTIONS(1737),
    [sym__emphasis_open_star] = ACTIONS(1740),
    [sym__emphasis_open_underscore] = ACTIONS(1743),
    [sym__last_token_punctuation] = ACTIONS(1746),
    [sym__strikethrough_open] = ACTIONS(1748),
    [sym__strikethrough_close] = ACTIONS(1693),
  },
  [97] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(130),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(130),
    [aux_sym__inline_no_tilde_no_link] = STATE(130),
    [sym__strikethrough_no_link] = STATE(130),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(130),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(130),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(1751),
    [sym_entity_reference] = ACTIONS(1754),
    [sym_numeric_character_reference] = ACTIONS(1754),
    [anon_sym_RBRACK] = ACTIONS(1757),
    [anon_sym_LT] = ACTIONS(1759),
    [anon_sym_GT] = ACTIONS(1762),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_DQUOTE] = ACTIONS(1762),
    [anon_sym_POUND] = ACTIONS(1762),
    [anon_sym_DOLLAR] = ACTIONS(1762),
    [anon_sym_PERCENT] = ACTIONS(1762),
    [anon_sym_AMP] = ACTIONS(1768),
    [anon_sym_SQUOTE] = ACTIONS(1762),
    [anon_sym_STAR] = ACTIONS(1762),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_COMMA] = ACTIONS(1762),
    [anon_sym_DASH] = ACTIONS(1762),
    [anon_sym_DOT] = ACTIONS(1762),
    [anon_sym_SLASH] = ACTIONS(1762),
    [anon_sym_COLON] = ACTIONS(1762),
    [anon_sym_SEMI] = ACTIONS(1762),
    [anon_sym_EQ] = ACTIONS(1762),
    [anon_sym_QMARK] = ACTIONS(1762),
    [anon_sym_AT] = ACTIONS(1762),
    [anon_sym_BSLASH] = ACTIONS(1771),
    [anon_sym_CARET] = ACTIONS(1762),
    [anon_sym__] = ACTIONS(1762),
    [anon_sym_BQUOTE] = ACTIONS(1762),
    [anon_sym_LBRACE] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1762),
    [anon_sym_RBRACE] = ACTIONS(1762),
    [anon_sym_TILDE] = ACTIONS(1762),
    [anon_sym_LPAREN] = ACTIONS(1762),
    [anon_sym_RPAREN] = ACTIONS(1762),
    [sym__newline_token] = ACTIONS(1774),
    [sym_uri_autolink] = ACTIONS(1754),
    [sym_email_autolink] = ACTIONS(1754),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1777),
    [anon_sym_LT_QMARK] = ACTIONS(1780),
    [aux_sym__declaration_token1] = ACTIONS(1783),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1786),
    [sym__whitespace_ge_2] = ACTIONS(1789),
    [aux_sym__whitespace_token1] = ACTIONS(1792),
    [sym__word_no_digit] = ACTIONS(1754),
    [sym__digits] = ACTIONS(1754),
    [sym__code_span_start] = ACTIONS(1795),
    [sym__emphasis_open_star] = ACTIONS(1798),
    [sym__emphasis_open_underscore] = ACTIONS(1801),
    [sym__last_token_punctuation] = ACTIONS(1804),
    [sym__strikethrough_open] = ACTIONS(1806),
  },
  [98] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(123),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(123),
    [aux_sym__inline_no_underscore_no_link] = STATE(123),
    [sym__strikethrough_no_link] = STATE(123),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(123),
    [sym__emphasis_underscore_no_link] = STATE(612),
    [sym__strong_emphasis_underscore_no_link] = STATE(123),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(1809),
    [sym_entity_reference] = ACTIONS(1812),
    [sym_numeric_character_reference] = ACTIONS(1812),
    [anon_sym_RBRACK] = ACTIONS(1757),
    [anon_sym_LT] = ACTIONS(1815),
    [anon_sym_GT] = ACTIONS(1818),
    [anon_sym_BANG] = ACTIONS(1821),
    [anon_sym_DQUOTE] = ACTIONS(1818),
    [anon_sym_POUND] = ACTIONS(1818),
    [anon_sym_DOLLAR] = ACTIONS(1818),
    [anon_sym_PERCENT] = ACTIONS(1818),
    [anon_sym_AMP] = ACTIONS(1824),
    [anon_sym_SQUOTE] = ACTIONS(1818),
    [anon_sym_STAR] = ACTIONS(1818),
    [anon_sym_PLUS] = ACTIONS(1818),
    [anon_sym_COMMA] = ACTIONS(1818),
    [anon_sym_DASH] = ACTIONS(1818),
    [anon_sym_DOT] = ACTIONS(1818),
    [anon_sym_SLASH] = ACTIONS(1818),
    [anon_sym_COLON] = ACTIONS(1818),
    [anon_sym_SEMI] = ACTIONS(1818),
    [anon_sym_EQ] = ACTIONS(1818),
    [anon_sym_QMARK] = ACTIONS(1818),
    [anon_sym_AT] = ACTIONS(1818),
    [anon_sym_BSLASH] = ACTIONS(1827),
    [anon_sym_CARET] = ACTIONS(1818),
    [anon_sym__] = ACTIONS(1818),
    [anon_sym_BQUOTE] = ACTIONS(1818),
    [anon_sym_LBRACE] = ACTIONS(1818),
    [anon_sym_PIPE] = ACTIONS(1818),
    [anon_sym_RBRACE] = ACTIONS(1818),
    [anon_sym_TILDE] = ACTIONS(1818),
    [anon_sym_LPAREN] = ACTIONS(1818),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [sym__newline_token] = ACTIONS(1830),
    [sym_uri_autolink] = ACTIONS(1812),
    [sym_email_autolink] = ACTIONS(1812),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1833),
    [anon_sym_LT_QMARK] = ACTIONS(1836),
    [aux_sym__declaration_token1] = ACTIONS(1839),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1842),
    [sym__whitespace_ge_2] = ACTIONS(1845),
    [aux_sym__whitespace_token1] = ACTIONS(1848),
    [sym__word_no_digit] = ACTIONS(1812),
    [sym__digits] = ACTIONS(1812),
    [sym__code_span_start] = ACTIONS(1851),
    [sym__emphasis_open_star] = ACTIONS(1854),
    [sym__emphasis_open_underscore] = ACTIONS(1857),
    [sym__last_token_punctuation] = ACTIONS(1860),
    [sym__strikethrough_open] = ACTIONS(1862),
  },
  [99] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(116),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(116),
    [aux_sym__inline_no_star_no_link] = STATE(116),
    [sym__strikethrough_no_link] = STATE(116),
    [sym__emphasis_star_no_link] = STATE(604),
    [sym__strong_emphasis_star_no_link] = STATE(116),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(116),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(1865),
    [sym_entity_reference] = ACTIONS(1868),
    [sym_numeric_character_reference] = ACTIONS(1868),
    [anon_sym_RBRACK] = ACTIONS(1757),
    [anon_sym_LT] = ACTIONS(1871),
    [anon_sym_GT] = ACTIONS(1874),
    [anon_sym_BANG] = ACTIONS(1877),
    [anon_sym_DQUOTE] = ACTIONS(1874),
    [anon_sym_POUND] = ACTIONS(1874),
    [anon_sym_DOLLAR] = ACTIONS(1874),
    [anon_sym_PERCENT] = ACTIONS(1874),
    [anon_sym_AMP] = ACTIONS(1880),
    [anon_sym_SQUOTE] = ACTIONS(1874),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_PLUS] = ACTIONS(1874),
    [anon_sym_COMMA] = ACTIONS(1874),
    [anon_sym_DASH] = ACTIONS(1874),
    [anon_sym_DOT] = ACTIONS(1874),
    [anon_sym_SLASH] = ACTIONS(1874),
    [anon_sym_COLON] = ACTIONS(1874),
    [anon_sym_SEMI] = ACTIONS(1874),
    [anon_sym_EQ] = ACTIONS(1874),
    [anon_sym_QMARK] = ACTIONS(1874),
    [anon_sym_AT] = ACTIONS(1874),
    [anon_sym_BSLASH] = ACTIONS(1883),
    [anon_sym_CARET] = ACTIONS(1874),
    [anon_sym__] = ACTIONS(1874),
    [anon_sym_BQUOTE] = ACTIONS(1874),
    [anon_sym_LBRACE] = ACTIONS(1874),
    [anon_sym_PIPE] = ACTIONS(1874),
    [anon_sym_RBRACE] = ACTIONS(1874),
    [anon_sym_TILDE] = ACTIONS(1874),
    [anon_sym_LPAREN] = ACTIONS(1874),
    [anon_sym_RPAREN] = ACTIONS(1874),
    [sym__newline_token] = ACTIONS(1886),
    [sym_uri_autolink] = ACTIONS(1868),
    [sym_email_autolink] = ACTIONS(1868),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1889),
    [anon_sym_LT_QMARK] = ACTIONS(1892),
    [aux_sym__declaration_token1] = ACTIONS(1895),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1898),
    [sym__whitespace_ge_2] = ACTIONS(1901),
    [aux_sym__whitespace_token1] = ACTIONS(1904),
    [sym__word_no_digit] = ACTIONS(1868),
    [sym__digits] = ACTIONS(1868),
    [sym__code_span_start] = ACTIONS(1907),
    [sym__emphasis_open_star] = ACTIONS(1910),
    [sym__emphasis_open_underscore] = ACTIONS(1913),
    [sym__last_token_punctuation] = ACTIONS(1916),
    [sym__strikethrough_open] = ACTIONS(1918),
  },
  [100] = {
    [sym_backslash_escape] = STATE(161),
    [sym_code_span] = STATE(161),
    [sym_image] = STATE(161),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(580),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(161),
    [sym__whitespace] = STATE(161),
    [sym__word] = STATE(161),
    [sym__soft_line_break] = STATE(161),
    [sym__inline_base] = STATE(622),
    [sym__text_base] = STATE(161),
    [sym__inline_element_no_link] = STATE(622),
    [aux_sym__inline_no_link] = STATE(133),
    [sym__strikethrough_no_link] = STATE(622),
    [sym__emphasis_star_no_link] = STATE(601),
    [sym__strong_emphasis_star_no_link] = STATE(622),
    [sym__emphasis_underscore_no_link] = STATE(601),
    [sym__strong_emphasis_underscore_no_link] = STATE(622),
    [aux_sym__inline_base_repeat1] = STATE(161),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1921),
    [sym_numeric_character_reference] = ACTIONS(1921),
    [anon_sym_RBRACK] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1921),
    [sym_email_autolink] = ACTIONS(1921),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1927),
    [anon_sym_LT_QMARK] = ACTIONS(1929),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1931),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1921),
    [sym__digits] = ACTIONS(1921),
    [sym__code_span_start] = ACTIONS(1933),
    [sym__emphasis_open_star] = ACTIONS(1935),
    [sym__emphasis_open_underscore] = ACTIONS(1937),
    [sym__strikethrough_open] = ACTIONS(1939),
  },
  [101] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(128),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(128),
    [aux_sym__inline_no_tilde_no_link] = STATE(128),
    [sym__strikethrough_no_link] = STATE(128),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(128),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(128),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(1941),
    [sym_numeric_character_reference] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(1941),
    [sym_email_autolink] = ACTIONS(1941),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1945),
    [anon_sym_LT_QMARK] = ACTIONS(1947),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1949),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(1941),
    [sym__digits] = ACTIONS(1941),
    [sym__code_span_start] = ACTIONS(1951),
    [sym__emphasis_open_star] = ACTIONS(1953),
    [sym__emphasis_open_underscore] = ACTIONS(1955),
    [sym__strikethrough_open] = ACTIONS(1957),
    [sym__strikethrough_close] = ACTIONS(1959),
  },
  [102] = {
    [sym_backslash_escape] = STATE(161),
    [sym_code_span] = STATE(161),
    [sym_image] = STATE(161),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(580),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(161),
    [sym__whitespace] = STATE(161),
    [sym__word] = STATE(161),
    [sym__soft_line_break] = STATE(161),
    [sym__inline_base] = STATE(622),
    [sym__text_base] = STATE(161),
    [sym__inline_element_no_link] = STATE(622),
    [aux_sym__inline_no_link] = STATE(133),
    [sym__strikethrough_no_link] = STATE(622),
    [sym__emphasis_star_no_link] = STATE(601),
    [sym__strong_emphasis_star_no_link] = STATE(622),
    [sym__emphasis_underscore_no_link] = STATE(601),
    [sym__strong_emphasis_underscore_no_link] = STATE(622),
    [aux_sym__inline_base_repeat1] = STATE(161),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1921),
    [sym_numeric_character_reference] = ACTIONS(1921),
    [anon_sym_RBRACK] = ACTIONS(1961),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1921),
    [sym_email_autolink] = ACTIONS(1921),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1927),
    [anon_sym_LT_QMARK] = ACTIONS(1929),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1931),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1921),
    [sym__digits] = ACTIONS(1921),
    [sym__code_span_start] = ACTIONS(1933),
    [sym__emphasis_open_star] = ACTIONS(1935),
    [sym__emphasis_open_underscore] = ACTIONS(1937),
    [sym__strikethrough_open] = ACTIONS(1939),
  },
  [103] = {
    [sym_backslash_escape] = STATE(161),
    [sym_code_span] = STATE(161),
    [sym_image] = STATE(161),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(580),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(161),
    [sym__whitespace] = STATE(161),
    [sym__word] = STATE(161),
    [sym__soft_line_break] = STATE(161),
    [sym__inline_base] = STATE(622),
    [sym__text_base] = STATE(161),
    [sym__inline_element_no_link] = STATE(622),
    [aux_sym__inline_no_link] = STATE(133),
    [sym__strikethrough_no_link] = STATE(622),
    [sym__emphasis_star_no_link] = STATE(601),
    [sym__strong_emphasis_star_no_link] = STATE(622),
    [sym__emphasis_underscore_no_link] = STATE(601),
    [sym__strong_emphasis_underscore_no_link] = STATE(622),
    [aux_sym__inline_base_repeat1] = STATE(161),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1921),
    [sym_numeric_character_reference] = ACTIONS(1921),
    [anon_sym_RBRACK] = ACTIONS(1963),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1921),
    [sym_email_autolink] = ACTIONS(1921),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1927),
    [anon_sym_LT_QMARK] = ACTIONS(1929),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1931),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1921),
    [sym__digits] = ACTIONS(1921),
    [sym__code_span_start] = ACTIONS(1933),
    [sym__emphasis_open_star] = ACTIONS(1935),
    [sym__emphasis_open_underscore] = ACTIONS(1937),
    [sym__strikethrough_open] = ACTIONS(1939),
  },
  [104] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(125),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(125),
    [aux_sym__inline_no_underscore_no_link] = STATE(125),
    [sym__strikethrough_no_link] = STATE(125),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(125),
    [sym__emphasis_underscore_no_link] = STATE(608),
    [sym__strong_emphasis_underscore_no_link] = STATE(125),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(1965),
    [sym_numeric_character_reference] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(1965),
    [sym_email_autolink] = ACTIONS(1965),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1969),
    [anon_sym_LT_QMARK] = ACTIONS(1971),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1973),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(1965),
    [sym__digits] = ACTIONS(1965),
    [sym__code_span_start] = ACTIONS(1975),
    [sym__emphasis_open_star] = ACTIONS(1977),
    [sym__emphasis_open_underscore] = ACTIONS(1979),
    [sym__emphasis_close_underscore] = ACTIONS(1981),
    [sym__strikethrough_open] = ACTIONS(1983),
  },
  [105] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(121),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(121),
    [aux_sym__inline_no_star_no_link] = STATE(121),
    [sym__strikethrough_no_link] = STATE(121),
    [sym__emphasis_star_no_link] = STATE(605),
    [sym__strong_emphasis_star_no_link] = STATE(121),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(121),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(1985),
    [sym_numeric_character_reference] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(1985),
    [sym_email_autolink] = ACTIONS(1985),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1989),
    [anon_sym_LT_QMARK] = ACTIONS(1991),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1993),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(1985),
    [sym__digits] = ACTIONS(1985),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(1997),
    [sym__emphasis_open_underscore] = ACTIONS(1999),
    [sym__emphasis_close_star] = ACTIONS(2001),
    [sym__strikethrough_open] = ACTIONS(2003),
  },
  [106] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(128),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(128),
    [aux_sym__inline_no_tilde_no_link] = STATE(128),
    [sym__strikethrough_no_link] = STATE(128),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(128),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(128),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(1941),
    [sym_numeric_character_reference] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(1941),
    [sym_email_autolink] = ACTIONS(1941),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1945),
    [anon_sym_LT_QMARK] = ACTIONS(1947),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1949),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(1941),
    [sym__digits] = ACTIONS(1941),
    [sym__code_span_start] = ACTIONS(1951),
    [sym__emphasis_open_star] = ACTIONS(1953),
    [sym__emphasis_open_underscore] = ACTIONS(1955),
    [sym__strikethrough_open] = ACTIONS(1957),
    [sym__strikethrough_close] = ACTIONS(2005),
  },
  [107] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(121),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(121),
    [aux_sym__inline_no_star_no_link] = STATE(121),
    [sym__strikethrough_no_link] = STATE(121),
    [sym__emphasis_star_no_link] = STATE(605),
    [sym__strong_emphasis_star_no_link] = STATE(121),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(121),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(1985),
    [sym_numeric_character_reference] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(1985),
    [sym_email_autolink] = ACTIONS(1985),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1989),
    [anon_sym_LT_QMARK] = ACTIONS(1991),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1993),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(1985),
    [sym__digits] = ACTIONS(1985),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(1997),
    [sym__emphasis_open_underscore] = ACTIONS(1999),
    [sym__emphasis_close_star] = ACTIONS(2007),
    [sym__strikethrough_open] = ACTIONS(2003),
  },
  [108] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(121),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(121),
    [aux_sym__inline_no_star_no_link] = STATE(121),
    [sym__strikethrough_no_link] = STATE(121),
    [sym__emphasis_star_no_link] = STATE(605),
    [sym__strong_emphasis_star_no_link] = STATE(121),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(121),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(1985),
    [sym_numeric_character_reference] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(1985),
    [sym_email_autolink] = ACTIONS(1985),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1989),
    [anon_sym_LT_QMARK] = ACTIONS(1991),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1993),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(1985),
    [sym__digits] = ACTIONS(1985),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(1997),
    [sym__emphasis_open_underscore] = ACTIONS(1999),
    [sym__emphasis_close_star] = ACTIONS(2009),
    [sym__strikethrough_open] = ACTIONS(2003),
  },
  [109] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(128),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(128),
    [aux_sym__inline_no_tilde_no_link] = STATE(128),
    [sym__strikethrough_no_link] = STATE(128),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(128),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(128),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(1941),
    [sym_numeric_character_reference] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(1941),
    [sym_email_autolink] = ACTIONS(1941),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1945),
    [anon_sym_LT_QMARK] = ACTIONS(1947),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1949),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(1941),
    [sym__digits] = ACTIONS(1941),
    [sym__code_span_start] = ACTIONS(1951),
    [sym__emphasis_open_star] = ACTIONS(1953),
    [sym__emphasis_open_underscore] = ACTIONS(1955),
    [sym__strikethrough_open] = ACTIONS(1957),
    [sym__strikethrough_close] = ACTIONS(2011),
  },
  [110] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(125),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(125),
    [aux_sym__inline_no_underscore_no_link] = STATE(125),
    [sym__strikethrough_no_link] = STATE(125),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(125),
    [sym__emphasis_underscore_no_link] = STATE(608),
    [sym__strong_emphasis_underscore_no_link] = STATE(125),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(1965),
    [sym_numeric_character_reference] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(1965),
    [sym_email_autolink] = ACTIONS(1965),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1969),
    [anon_sym_LT_QMARK] = ACTIONS(1971),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1973),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(1965),
    [sym__digits] = ACTIONS(1965),
    [sym__code_span_start] = ACTIONS(1975),
    [sym__emphasis_open_star] = ACTIONS(1977),
    [sym__emphasis_open_underscore] = ACTIONS(1979),
    [sym__emphasis_close_underscore] = ACTIONS(2013),
    [sym__strikethrough_open] = ACTIONS(1983),
  },
  [111] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(125),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(125),
    [aux_sym__inline_no_underscore_no_link] = STATE(125),
    [sym__strikethrough_no_link] = STATE(125),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(125),
    [sym__emphasis_underscore_no_link] = STATE(608),
    [sym__strong_emphasis_underscore_no_link] = STATE(125),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(1965),
    [sym_numeric_character_reference] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(1965),
    [sym_email_autolink] = ACTIONS(1965),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1969),
    [anon_sym_LT_QMARK] = ACTIONS(1971),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1973),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(1965),
    [sym__digits] = ACTIONS(1965),
    [sym__code_span_start] = ACTIONS(1975),
    [sym__emphasis_open_star] = ACTIONS(1977),
    [sym__emphasis_open_underscore] = ACTIONS(1979),
    [sym__emphasis_close_underscore] = ACTIONS(2015),
    [sym__strikethrough_open] = ACTIONS(1983),
  },
  [112] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(108),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(108),
    [aux_sym__inline_no_star_no_link] = STATE(108),
    [sym__strikethrough_no_link] = STATE(108),
    [sym__emphasis_star_no_link] = STATE(621),
    [sym__strong_emphasis_star_no_link] = STATE(108),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(108),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(1985),
    [sym_numeric_character_reference] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(1985),
    [sym_email_autolink] = ACTIONS(1985),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1989),
    [anon_sym_LT_QMARK] = ACTIONS(1991),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1993),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(1985),
    [sym__digits] = ACTIONS(1985),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(1997),
    [sym__emphasis_open_underscore] = ACTIONS(1999),
    [sym__last_token_punctuation] = ACTIONS(2017),
    [sym__strikethrough_open] = ACTIONS(2003),
  },
  [113] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(128),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(128),
    [aux_sym__inline_no_tilde_no_link] = STATE(128),
    [sym__strikethrough_no_link] = STATE(128),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(128),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(128),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(1941),
    [sym_numeric_character_reference] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(1941),
    [sym_email_autolink] = ACTIONS(1941),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1945),
    [anon_sym_LT_QMARK] = ACTIONS(1947),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1949),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(1941),
    [sym__digits] = ACTIONS(1941),
    [sym__code_span_start] = ACTIONS(1951),
    [sym__emphasis_open_star] = ACTIONS(1953),
    [sym__emphasis_open_underscore] = ACTIONS(1955),
    [sym__strikethrough_open] = ACTIONS(1957),
    [sym__strikethrough_close] = ACTIONS(2019),
  },
  [114] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(121),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(121),
    [aux_sym__inline_no_star_no_link] = STATE(121),
    [sym__strikethrough_no_link] = STATE(121),
    [sym__emphasis_star_no_link] = STATE(605),
    [sym__strong_emphasis_star_no_link] = STATE(121),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(121),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(1985),
    [sym_numeric_character_reference] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(1985),
    [sym_email_autolink] = ACTIONS(1985),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1989),
    [anon_sym_LT_QMARK] = ACTIONS(1991),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1993),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(1985),
    [sym__digits] = ACTIONS(1985),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(1997),
    [sym__emphasis_open_underscore] = ACTIONS(1999),
    [sym__emphasis_close_star] = ACTIONS(2021),
    [sym__strikethrough_open] = ACTIONS(2003),
  },
  [115] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(125),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(125),
    [aux_sym__inline_no_underscore_no_link] = STATE(125),
    [sym__strikethrough_no_link] = STATE(125),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(125),
    [sym__emphasis_underscore_no_link] = STATE(608),
    [sym__strong_emphasis_underscore_no_link] = STATE(125),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(1965),
    [sym_numeric_character_reference] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(1965),
    [sym_email_autolink] = ACTIONS(1965),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1969),
    [anon_sym_LT_QMARK] = ACTIONS(1971),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1973),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(1965),
    [sym__digits] = ACTIONS(1965),
    [sym__code_span_start] = ACTIONS(1975),
    [sym__emphasis_open_star] = ACTIONS(1977),
    [sym__emphasis_open_underscore] = ACTIONS(1979),
    [sym__emphasis_close_underscore] = ACTIONS(2023),
    [sym__strikethrough_open] = ACTIONS(1983),
  },
  [116] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(121),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(121),
    [aux_sym__inline_no_star_no_link] = STATE(121),
    [sym__strikethrough_no_link] = STATE(121),
    [sym__emphasis_star_no_link] = STATE(605),
    [sym__strong_emphasis_star_no_link] = STATE(121),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(121),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(1985),
    [sym_numeric_character_reference] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(1985),
    [sym_email_autolink] = ACTIONS(1985),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1989),
    [anon_sym_LT_QMARK] = ACTIONS(1991),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1993),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(1985),
    [sym__digits] = ACTIONS(1985),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(1997),
    [sym__emphasis_open_underscore] = ACTIONS(1999),
    [sym__emphasis_close_star] = ACTIONS(2025),
    [sym__strikethrough_open] = ACTIONS(2003),
  },
  [117] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(121),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(121),
    [aux_sym__inline_no_star_no_link] = STATE(121),
    [sym__strikethrough_no_link] = STATE(121),
    [sym__emphasis_star_no_link] = STATE(605),
    [sym__strong_emphasis_star_no_link] = STATE(121),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(121),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(1985),
    [sym_numeric_character_reference] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(1985),
    [sym_email_autolink] = ACTIONS(1985),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1989),
    [anon_sym_LT_QMARK] = ACTIONS(1991),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1993),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(1985),
    [sym__digits] = ACTIONS(1985),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(1997),
    [sym__emphasis_open_underscore] = ACTIONS(1999),
    [sym__emphasis_close_star] = ACTIONS(2027),
    [sym__strikethrough_open] = ACTIONS(2003),
  },
  [118] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(125),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(125),
    [aux_sym__inline_no_underscore_no_link] = STATE(125),
    [sym__strikethrough_no_link] = STATE(125),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(125),
    [sym__emphasis_underscore_no_link] = STATE(608),
    [sym__strong_emphasis_underscore_no_link] = STATE(125),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(1965),
    [sym_numeric_character_reference] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(1965),
    [sym_email_autolink] = ACTIONS(1965),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1969),
    [anon_sym_LT_QMARK] = ACTIONS(1971),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1973),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(1965),
    [sym__digits] = ACTIONS(1965),
    [sym__code_span_start] = ACTIONS(1975),
    [sym__emphasis_open_star] = ACTIONS(1977),
    [sym__emphasis_open_underscore] = ACTIONS(1979),
    [sym__emphasis_close_underscore] = ACTIONS(2029),
    [sym__strikethrough_open] = ACTIONS(1983),
  },
  [119] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(121),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(121),
    [aux_sym__inline_no_star_no_link] = STATE(121),
    [sym__strikethrough_no_link] = STATE(121),
    [sym__emphasis_star_no_link] = STATE(605),
    [sym__strong_emphasis_star_no_link] = STATE(121),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(121),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(1985),
    [sym_numeric_character_reference] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(1985),
    [sym_email_autolink] = ACTIONS(1985),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1989),
    [anon_sym_LT_QMARK] = ACTIONS(1991),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1993),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(1985),
    [sym__digits] = ACTIONS(1985),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(1997),
    [sym__emphasis_open_underscore] = ACTIONS(1999),
    [sym__emphasis_close_star] = ACTIONS(2031),
    [sym__strikethrough_open] = ACTIONS(2003),
  },
  [120] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(110),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(110),
    [aux_sym__inline_no_underscore_no_link] = STATE(110),
    [sym__strikethrough_no_link] = STATE(110),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(110),
    [sym__emphasis_underscore_no_link] = STATE(611),
    [sym__strong_emphasis_underscore_no_link] = STATE(110),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(1965),
    [sym_numeric_character_reference] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(1965),
    [sym_email_autolink] = ACTIONS(1965),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1969),
    [anon_sym_LT_QMARK] = ACTIONS(1971),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1973),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(1965),
    [sym__digits] = ACTIONS(1965),
    [sym__code_span_start] = ACTIONS(1975),
    [sym__emphasis_open_star] = ACTIONS(1977),
    [sym__emphasis_open_underscore] = ACTIONS(1979),
    [sym__last_token_punctuation] = ACTIONS(2033),
    [sym__strikethrough_open] = ACTIONS(1983),
  },
  [121] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(121),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(121),
    [aux_sym__inline_no_star_no_link] = STATE(121),
    [sym__strikethrough_no_link] = STATE(121),
    [sym__emphasis_star_no_link] = STATE(605),
    [sym__strong_emphasis_star_no_link] = STATE(121),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(121),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(2035),
    [sym_entity_reference] = ACTIONS(2038),
    [sym_numeric_character_reference] = ACTIONS(2038),
    [anon_sym_LT] = ACTIONS(2041),
    [anon_sym_GT] = ACTIONS(2044),
    [anon_sym_BANG] = ACTIONS(2047),
    [anon_sym_DQUOTE] = ACTIONS(2044),
    [anon_sym_POUND] = ACTIONS(2044),
    [anon_sym_DOLLAR] = ACTIONS(2044),
    [anon_sym_PERCENT] = ACTIONS(2044),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_SQUOTE] = ACTIONS(2044),
    [anon_sym_STAR] = ACTIONS(2044),
    [anon_sym_PLUS] = ACTIONS(2044),
    [anon_sym_COMMA] = ACTIONS(2044),
    [anon_sym_DASH] = ACTIONS(2044),
    [anon_sym_DOT] = ACTIONS(2044),
    [anon_sym_SLASH] = ACTIONS(2044),
    [anon_sym_COLON] = ACTIONS(2044),
    [anon_sym_SEMI] = ACTIONS(2044),
    [anon_sym_EQ] = ACTIONS(2044),
    [anon_sym_QMARK] = ACTIONS(2044),
    [anon_sym_AT] = ACTIONS(2044),
    [anon_sym_BSLASH] = ACTIONS(2053),
    [anon_sym_CARET] = ACTIONS(2044),
    [anon_sym__] = ACTIONS(2044),
    [anon_sym_BQUOTE] = ACTIONS(2044),
    [anon_sym_LBRACE] = ACTIONS(2044),
    [anon_sym_PIPE] = ACTIONS(2044),
    [anon_sym_RBRACE] = ACTIONS(2044),
    [anon_sym_TILDE] = ACTIONS(2044),
    [anon_sym_LPAREN] = ACTIONS(2044),
    [anon_sym_RPAREN] = ACTIONS(2044),
    [sym__newline_token] = ACTIONS(2056),
    [sym_uri_autolink] = ACTIONS(2038),
    [sym_email_autolink] = ACTIONS(2038),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2059),
    [anon_sym_LT_QMARK] = ACTIONS(2062),
    [aux_sym__declaration_token1] = ACTIONS(2065),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2068),
    [sym__whitespace_ge_2] = ACTIONS(2071),
    [aux_sym__whitespace_token1] = ACTIONS(2074),
    [sym__word_no_digit] = ACTIONS(2038),
    [sym__digits] = ACTIONS(2038),
    [sym__code_span_start] = ACTIONS(2077),
    [sym__emphasis_open_star] = ACTIONS(2080),
    [sym__emphasis_open_underscore] = ACTIONS(2083),
    [sym__emphasis_close_star] = ACTIONS(2086),
    [sym__strikethrough_open] = ACTIONS(2088),
  },
  [122] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(125),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(125),
    [aux_sym__inline_no_underscore_no_link] = STATE(125),
    [sym__strikethrough_no_link] = STATE(125),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(125),
    [sym__emphasis_underscore_no_link] = STATE(608),
    [sym__strong_emphasis_underscore_no_link] = STATE(125),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(1965),
    [sym_numeric_character_reference] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(1965),
    [sym_email_autolink] = ACTIONS(1965),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1969),
    [anon_sym_LT_QMARK] = ACTIONS(1971),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1973),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(1965),
    [sym__digits] = ACTIONS(1965),
    [sym__code_span_start] = ACTIONS(1975),
    [sym__emphasis_open_star] = ACTIONS(1977),
    [sym__emphasis_open_underscore] = ACTIONS(1979),
    [sym__emphasis_close_underscore] = ACTIONS(2091),
    [sym__strikethrough_open] = ACTIONS(1983),
  },
  [123] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(125),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(125),
    [aux_sym__inline_no_underscore_no_link] = STATE(125),
    [sym__strikethrough_no_link] = STATE(125),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(125),
    [sym__emphasis_underscore_no_link] = STATE(608),
    [sym__strong_emphasis_underscore_no_link] = STATE(125),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(1965),
    [sym_numeric_character_reference] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(1965),
    [sym_email_autolink] = ACTIONS(1965),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1969),
    [anon_sym_LT_QMARK] = ACTIONS(1971),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1973),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(1965),
    [sym__digits] = ACTIONS(1965),
    [sym__code_span_start] = ACTIONS(1975),
    [sym__emphasis_open_star] = ACTIONS(1977),
    [sym__emphasis_open_underscore] = ACTIONS(1979),
    [sym__emphasis_close_underscore] = ACTIONS(2093),
    [sym__strikethrough_open] = ACTIONS(1983),
  },
  [124] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(128),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(128),
    [aux_sym__inline_no_tilde_no_link] = STATE(128),
    [sym__strikethrough_no_link] = STATE(128),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(128),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(128),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(1941),
    [sym_numeric_character_reference] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(1941),
    [sym_email_autolink] = ACTIONS(1941),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1945),
    [anon_sym_LT_QMARK] = ACTIONS(1947),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1949),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(1941),
    [sym__digits] = ACTIONS(1941),
    [sym__code_span_start] = ACTIONS(1951),
    [sym__emphasis_open_star] = ACTIONS(1953),
    [sym__emphasis_open_underscore] = ACTIONS(1955),
    [sym__strikethrough_open] = ACTIONS(1957),
    [sym__strikethrough_close] = ACTIONS(2095),
  },
  [125] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(125),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(125),
    [aux_sym__inline_no_underscore_no_link] = STATE(125),
    [sym__strikethrough_no_link] = STATE(125),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(125),
    [sym__emphasis_underscore_no_link] = STATE(608),
    [sym__strong_emphasis_underscore_no_link] = STATE(125),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(2097),
    [sym_entity_reference] = ACTIONS(2100),
    [sym_numeric_character_reference] = ACTIONS(2100),
    [anon_sym_LT] = ACTIONS(2103),
    [anon_sym_GT] = ACTIONS(2106),
    [anon_sym_BANG] = ACTIONS(2109),
    [anon_sym_DQUOTE] = ACTIONS(2106),
    [anon_sym_POUND] = ACTIONS(2106),
    [anon_sym_DOLLAR] = ACTIONS(2106),
    [anon_sym_PERCENT] = ACTIONS(2106),
    [anon_sym_AMP] = ACTIONS(2112),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [anon_sym_STAR] = ACTIONS(2106),
    [anon_sym_PLUS] = ACTIONS(2106),
    [anon_sym_COMMA] = ACTIONS(2106),
    [anon_sym_DASH] = ACTIONS(2106),
    [anon_sym_DOT] = ACTIONS(2106),
    [anon_sym_SLASH] = ACTIONS(2106),
    [anon_sym_COLON] = ACTIONS(2106),
    [anon_sym_SEMI] = ACTIONS(2106),
    [anon_sym_EQ] = ACTIONS(2106),
    [anon_sym_QMARK] = ACTIONS(2106),
    [anon_sym_AT] = ACTIONS(2106),
    [anon_sym_BSLASH] = ACTIONS(2115),
    [anon_sym_CARET] = ACTIONS(2106),
    [anon_sym__] = ACTIONS(2106),
    [anon_sym_BQUOTE] = ACTIONS(2106),
    [anon_sym_LBRACE] = ACTIONS(2106),
    [anon_sym_PIPE] = ACTIONS(2106),
    [anon_sym_RBRACE] = ACTIONS(2106),
    [anon_sym_TILDE] = ACTIONS(2106),
    [anon_sym_LPAREN] = ACTIONS(2106),
    [anon_sym_RPAREN] = ACTIONS(2106),
    [sym__newline_token] = ACTIONS(2118),
    [sym_uri_autolink] = ACTIONS(2100),
    [sym_email_autolink] = ACTIONS(2100),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2121),
    [anon_sym_LT_QMARK] = ACTIONS(2124),
    [aux_sym__declaration_token1] = ACTIONS(2127),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2130),
    [sym__whitespace_ge_2] = ACTIONS(2133),
    [aux_sym__whitespace_token1] = ACTIONS(2136),
    [sym__word_no_digit] = ACTIONS(2100),
    [sym__digits] = ACTIONS(2100),
    [sym__code_span_start] = ACTIONS(2139),
    [sym__emphasis_open_star] = ACTIONS(2142),
    [sym__emphasis_open_underscore] = ACTIONS(2145),
    [sym__emphasis_close_underscore] = ACTIONS(2148),
    [sym__strikethrough_open] = ACTIONS(2150),
  },
  [126] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(128),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(128),
    [aux_sym__inline_no_tilde_no_link] = STATE(128),
    [sym__strikethrough_no_link] = STATE(128),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(128),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(128),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(1941),
    [sym_numeric_character_reference] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(1941),
    [sym_email_autolink] = ACTIONS(1941),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1945),
    [anon_sym_LT_QMARK] = ACTIONS(1947),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1949),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(1941),
    [sym__digits] = ACTIONS(1941),
    [sym__code_span_start] = ACTIONS(1951),
    [sym__emphasis_open_star] = ACTIONS(1953),
    [sym__emphasis_open_underscore] = ACTIONS(1955),
    [sym__strikethrough_open] = ACTIONS(1957),
    [sym__strikethrough_close] = ACTIONS(2153),
  },
  [127] = {
    [sym_backslash_escape] = STATE(161),
    [sym_code_span] = STATE(161),
    [sym_image] = STATE(161),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(580),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(161),
    [sym__whitespace] = STATE(161),
    [sym__word] = STATE(161),
    [sym__soft_line_break] = STATE(161),
    [sym__inline_base] = STATE(622),
    [sym__text_base] = STATE(161),
    [sym__inline_element_no_link] = STATE(622),
    [aux_sym__inline_no_link] = STATE(133),
    [sym__strikethrough_no_link] = STATE(622),
    [sym__emphasis_star_no_link] = STATE(601),
    [sym__strong_emphasis_star_no_link] = STATE(622),
    [sym__emphasis_underscore_no_link] = STATE(601),
    [sym__strong_emphasis_underscore_no_link] = STATE(622),
    [aux_sym__inline_base_repeat1] = STATE(161),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1921),
    [sym_numeric_character_reference] = ACTIONS(1921),
    [anon_sym_RBRACK] = ACTIONS(2155),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1921),
    [sym_email_autolink] = ACTIONS(1921),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1927),
    [anon_sym_LT_QMARK] = ACTIONS(1929),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1931),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1921),
    [sym__digits] = ACTIONS(1921),
    [sym__code_span_start] = ACTIONS(1933),
    [sym__emphasis_open_star] = ACTIONS(1935),
    [sym__emphasis_open_underscore] = ACTIONS(1937),
    [sym__strikethrough_open] = ACTIONS(1939),
  },
  [128] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(128),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(128),
    [aux_sym__inline_no_tilde_no_link] = STATE(128),
    [sym__strikethrough_no_link] = STATE(128),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(128),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(128),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(2157),
    [sym_entity_reference] = ACTIONS(2160),
    [sym_numeric_character_reference] = ACTIONS(2160),
    [anon_sym_LT] = ACTIONS(2163),
    [anon_sym_GT] = ACTIONS(2166),
    [anon_sym_BANG] = ACTIONS(2169),
    [anon_sym_DQUOTE] = ACTIONS(2166),
    [anon_sym_POUND] = ACTIONS(2166),
    [anon_sym_DOLLAR] = ACTIONS(2166),
    [anon_sym_PERCENT] = ACTIONS(2166),
    [anon_sym_AMP] = ACTIONS(2172),
    [anon_sym_SQUOTE] = ACTIONS(2166),
    [anon_sym_STAR] = ACTIONS(2166),
    [anon_sym_PLUS] = ACTIONS(2166),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_DASH] = ACTIONS(2166),
    [anon_sym_DOT] = ACTIONS(2166),
    [anon_sym_SLASH] = ACTIONS(2166),
    [anon_sym_COLON] = ACTIONS(2166),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_EQ] = ACTIONS(2166),
    [anon_sym_QMARK] = ACTIONS(2166),
    [anon_sym_AT] = ACTIONS(2166),
    [anon_sym_BSLASH] = ACTIONS(2175),
    [anon_sym_CARET] = ACTIONS(2166),
    [anon_sym__] = ACTIONS(2166),
    [anon_sym_BQUOTE] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2166),
    [anon_sym_PIPE] = ACTIONS(2166),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_TILDE] = ACTIONS(2166),
    [anon_sym_LPAREN] = ACTIONS(2166),
    [anon_sym_RPAREN] = ACTIONS(2166),
    [sym__newline_token] = ACTIONS(2178),
    [sym_uri_autolink] = ACTIONS(2160),
    [sym_email_autolink] = ACTIONS(2160),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2181),
    [anon_sym_LT_QMARK] = ACTIONS(2184),
    [aux_sym__declaration_token1] = ACTIONS(2187),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2190),
    [sym__whitespace_ge_2] = ACTIONS(2193),
    [aux_sym__whitespace_token1] = ACTIONS(2196),
    [sym__word_no_digit] = ACTIONS(2160),
    [sym__digits] = ACTIONS(2160),
    [sym__code_span_start] = ACTIONS(2199),
    [sym__emphasis_open_star] = ACTIONS(2202),
    [sym__emphasis_open_underscore] = ACTIONS(2205),
    [sym__strikethrough_open] = ACTIONS(2208),
    [sym__strikethrough_close] = ACTIONS(2211),
  },
  [129] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(135),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(135),
    [aux_sym__inline_no_tilde_no_link] = STATE(135),
    [sym__strikethrough_no_link] = STATE(135),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(135),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(135),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(1941),
    [sym_numeric_character_reference] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(1941),
    [sym_email_autolink] = ACTIONS(1941),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1945),
    [anon_sym_LT_QMARK] = ACTIONS(1947),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1949),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(1941),
    [sym__digits] = ACTIONS(1941),
    [sym__code_span_start] = ACTIONS(1951),
    [sym__emphasis_open_star] = ACTIONS(1953),
    [sym__emphasis_open_underscore] = ACTIONS(1955),
    [sym__last_token_punctuation] = ACTIONS(2213),
    [sym__strikethrough_open] = ACTIONS(1957),
  },
  [130] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(128),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(128),
    [aux_sym__inline_no_tilde_no_link] = STATE(128),
    [sym__strikethrough_no_link] = STATE(128),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(128),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(128),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(1941),
    [sym_numeric_character_reference] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(1941),
    [sym_email_autolink] = ACTIONS(1941),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1945),
    [anon_sym_LT_QMARK] = ACTIONS(1947),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1949),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(1941),
    [sym__digits] = ACTIONS(1941),
    [sym__code_span_start] = ACTIONS(1951),
    [sym__emphasis_open_star] = ACTIONS(1953),
    [sym__emphasis_open_underscore] = ACTIONS(1955),
    [sym__strikethrough_open] = ACTIONS(1957),
    [sym__strikethrough_close] = ACTIONS(2215),
  },
  [131] = {
    [sym_backslash_escape] = STATE(161),
    [sym_code_span] = STATE(161),
    [sym_image] = STATE(161),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(580),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(161),
    [sym__whitespace] = STATE(161),
    [sym__word] = STATE(161),
    [sym__soft_line_break] = STATE(161),
    [sym__inline_base] = STATE(622),
    [sym__text_base] = STATE(161),
    [sym__inline_element_no_link] = STATE(622),
    [aux_sym__inline_no_link] = STATE(133),
    [sym__strikethrough_no_link] = STATE(622),
    [sym__emphasis_star_no_link] = STATE(601),
    [sym__strong_emphasis_star_no_link] = STATE(622),
    [sym__emphasis_underscore_no_link] = STATE(601),
    [sym__strong_emphasis_underscore_no_link] = STATE(622),
    [aux_sym__inline_base_repeat1] = STATE(161),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(1921),
    [sym_numeric_character_reference] = ACTIONS(1921),
    [anon_sym_RBRACK] = ACTIONS(2217),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(1921),
    [sym_email_autolink] = ACTIONS(1921),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1927),
    [anon_sym_LT_QMARK] = ACTIONS(1929),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1931),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(1921),
    [sym__digits] = ACTIONS(1921),
    [sym__code_span_start] = ACTIONS(1933),
    [sym__emphasis_open_star] = ACTIONS(1935),
    [sym__emphasis_open_underscore] = ACTIONS(1937),
    [sym__strikethrough_open] = ACTIONS(1939),
  },
  [132] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(121),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(121),
    [aux_sym__inline_no_star_no_link] = STATE(121),
    [sym__strikethrough_no_link] = STATE(121),
    [sym__emphasis_star_no_link] = STATE(605),
    [sym__strong_emphasis_star_no_link] = STATE(121),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(121),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(1985),
    [sym_numeric_character_reference] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(1985),
    [sym_email_autolink] = ACTIONS(1985),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1989),
    [anon_sym_LT_QMARK] = ACTIONS(1991),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1993),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(1985),
    [sym__digits] = ACTIONS(1985),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(1997),
    [sym__emphasis_open_underscore] = ACTIONS(1999),
    [sym__emphasis_close_star] = ACTIONS(2219),
    [sym__strikethrough_open] = ACTIONS(2003),
  },
  [133] = {
    [sym_backslash_escape] = STATE(161),
    [sym_code_span] = STATE(161),
    [sym_image] = STATE(161),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(580),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(161),
    [sym__whitespace] = STATE(161),
    [sym__word] = STATE(161),
    [sym__soft_line_break] = STATE(161),
    [sym__inline_base] = STATE(622),
    [sym__text_base] = STATE(161),
    [sym__inline_element_no_link] = STATE(622),
    [aux_sym__inline_no_link] = STATE(133),
    [sym__strikethrough_no_link] = STATE(622),
    [sym__emphasis_star_no_link] = STATE(601),
    [sym__strong_emphasis_star_no_link] = STATE(622),
    [sym__emphasis_underscore_no_link] = STATE(601),
    [sym__strong_emphasis_underscore_no_link] = STATE(622),
    [aux_sym__inline_base_repeat1] = STATE(161),
    [sym__backslash_escape] = ACTIONS(2221),
    [sym_entity_reference] = ACTIONS(2224),
    [sym_numeric_character_reference] = ACTIONS(2224),
    [anon_sym_RBRACK] = ACTIONS(2227),
    [anon_sym_LT] = ACTIONS(2229),
    [anon_sym_GT] = ACTIONS(2232),
    [anon_sym_BANG] = ACTIONS(2235),
    [anon_sym_DQUOTE] = ACTIONS(2232),
    [anon_sym_POUND] = ACTIONS(2232),
    [anon_sym_DOLLAR] = ACTIONS(2232),
    [anon_sym_PERCENT] = ACTIONS(2232),
    [anon_sym_AMP] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2232),
    [anon_sym_STAR] = ACTIONS(2232),
    [anon_sym_PLUS] = ACTIONS(2232),
    [anon_sym_COMMA] = ACTIONS(2232),
    [anon_sym_DASH] = ACTIONS(2232),
    [anon_sym_DOT] = ACTIONS(2232),
    [anon_sym_SLASH] = ACTIONS(2232),
    [anon_sym_COLON] = ACTIONS(2232),
    [anon_sym_SEMI] = ACTIONS(2232),
    [anon_sym_EQ] = ACTIONS(2232),
    [anon_sym_QMARK] = ACTIONS(2232),
    [anon_sym_AT] = ACTIONS(2232),
    [anon_sym_BSLASH] = ACTIONS(2241),
    [anon_sym_CARET] = ACTIONS(2232),
    [anon_sym__] = ACTIONS(2232),
    [anon_sym_BQUOTE] = ACTIONS(2232),
    [anon_sym_LBRACE] = ACTIONS(2232),
    [anon_sym_PIPE] = ACTIONS(2232),
    [anon_sym_RBRACE] = ACTIONS(2232),
    [anon_sym_TILDE] = ACTIONS(2232),
    [anon_sym_LPAREN] = ACTIONS(2232),
    [anon_sym_RPAREN] = ACTIONS(2232),
    [sym__newline_token] = ACTIONS(2244),
    [sym_uri_autolink] = ACTIONS(2224),
    [sym_email_autolink] = ACTIONS(2224),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2247),
    [anon_sym_LT_QMARK] = ACTIONS(2250),
    [aux_sym__declaration_token1] = ACTIONS(2253),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2256),
    [sym__whitespace_ge_2] = ACTIONS(2259),
    [aux_sym__whitespace_token1] = ACTIONS(2262),
    [sym__word_no_digit] = ACTIONS(2224),
    [sym__digits] = ACTIONS(2224),
    [sym__code_span_start] = ACTIONS(2265),
    [sym__emphasis_open_star] = ACTIONS(2268),
    [sym__emphasis_open_underscore] = ACTIONS(2271),
    [sym__strikethrough_open] = ACTIONS(2274),
  },
  [134] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(125),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(125),
    [aux_sym__inline_no_underscore_no_link] = STATE(125),
    [sym__strikethrough_no_link] = STATE(125),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(125),
    [sym__emphasis_underscore_no_link] = STATE(608),
    [sym__strong_emphasis_underscore_no_link] = STATE(125),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(1965),
    [sym_numeric_character_reference] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(1965),
    [sym_email_autolink] = ACTIONS(1965),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1969),
    [anon_sym_LT_QMARK] = ACTIONS(1971),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1973),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(1965),
    [sym__digits] = ACTIONS(1965),
    [sym__code_span_start] = ACTIONS(1975),
    [sym__emphasis_open_star] = ACTIONS(1977),
    [sym__emphasis_open_underscore] = ACTIONS(1979),
    [sym__emphasis_close_underscore] = ACTIONS(2277),
    [sym__strikethrough_open] = ACTIONS(1983),
  },
  [135] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(128),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(128),
    [aux_sym__inline_no_tilde_no_link] = STATE(128),
    [sym__strikethrough_no_link] = STATE(128),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(128),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(128),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(1941),
    [sym_numeric_character_reference] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(1941),
    [sym_email_autolink] = ACTIONS(1941),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1945),
    [anon_sym_LT_QMARK] = ACTIONS(1947),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1949),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(1941),
    [sym__digits] = ACTIONS(1941),
    [sym__code_span_start] = ACTIONS(1951),
    [sym__emphasis_open_star] = ACTIONS(1953),
    [sym__emphasis_open_underscore] = ACTIONS(1955),
    [sym__strikethrough_open] = ACTIONS(1957),
    [sym__strikethrough_close] = ACTIONS(2279),
  },
  [136] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(105),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(105),
    [aux_sym__inline_no_star_no_link] = STATE(105),
    [sym__strikethrough_no_link] = STATE(105),
    [sym__emphasis_star_no_link] = STATE(605),
    [sym__strong_emphasis_star_no_link] = STATE(105),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(105),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(1985),
    [sym_numeric_character_reference] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(1985),
    [sym_email_autolink] = ACTIONS(1985),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1989),
    [anon_sym_LT_QMARK] = ACTIONS(1991),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1993),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(1985),
    [sym__digits] = ACTIONS(1985),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(1997),
    [sym__emphasis_open_underscore] = ACTIONS(1999),
    [sym__strikethrough_open] = ACTIONS(2003),
  },
  [137] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(119),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(119),
    [aux_sym__inline_no_star_no_link] = STATE(119),
    [sym__strikethrough_no_link] = STATE(119),
    [sym__emphasis_star_no_link] = STATE(605),
    [sym__strong_emphasis_star_no_link] = STATE(119),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(119),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(1985),
    [sym_numeric_character_reference] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(1985),
    [sym_email_autolink] = ACTIONS(1985),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1989),
    [anon_sym_LT_QMARK] = ACTIONS(1991),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1993),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(1985),
    [sym__digits] = ACTIONS(1985),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(1997),
    [sym__emphasis_open_underscore] = ACTIONS(1999),
    [sym__strikethrough_open] = ACTIONS(2003),
  },
  [138] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(109),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(109),
    [aux_sym__inline_no_tilde_no_link] = STATE(109),
    [sym__strikethrough_no_link] = STATE(109),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(109),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(109),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(1941),
    [sym_numeric_character_reference] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(1941),
    [sym_email_autolink] = ACTIONS(1941),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1945),
    [anon_sym_LT_QMARK] = ACTIONS(1947),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1949),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(1941),
    [sym__digits] = ACTIONS(1941),
    [sym__code_span_start] = ACTIONS(1951),
    [sym__emphasis_open_star] = ACTIONS(1953),
    [sym__emphasis_open_underscore] = ACTIONS(1955),
    [sym__strikethrough_open] = ACTIONS(1957),
  },
  [139] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(113),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(113),
    [aux_sym__inline_no_tilde_no_link] = STATE(113),
    [sym__strikethrough_no_link] = STATE(113),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(113),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(113),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(1941),
    [sym_numeric_character_reference] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(1941),
    [sym_email_autolink] = ACTIONS(1941),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1945),
    [anon_sym_LT_QMARK] = ACTIONS(1947),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1949),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(1941),
    [sym__digits] = ACTIONS(1941),
    [sym__code_span_start] = ACTIONS(1951),
    [sym__emphasis_open_star] = ACTIONS(1953),
    [sym__emphasis_open_underscore] = ACTIONS(1955),
    [sym__strikethrough_open] = ACTIONS(1957),
  },
  [140] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(126),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(126),
    [aux_sym__inline_no_tilde_no_link] = STATE(126),
    [sym__strikethrough_no_link] = STATE(126),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(126),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(126),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(1941),
    [sym_numeric_character_reference] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(1941),
    [sym_email_autolink] = ACTIONS(1941),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1945),
    [anon_sym_LT_QMARK] = ACTIONS(1947),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1949),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(1941),
    [sym__digits] = ACTIONS(1941),
    [sym__code_span_start] = ACTIONS(1951),
    [sym__emphasis_open_star] = ACTIONS(1953),
    [sym__emphasis_open_underscore] = ACTIONS(1955),
    [sym__strikethrough_open] = ACTIONS(1957),
  },
  [141] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(115),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(115),
    [aux_sym__inline_no_underscore_no_link] = STATE(115),
    [sym__strikethrough_no_link] = STATE(115),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(115),
    [sym__emphasis_underscore_no_link] = STATE(608),
    [sym__strong_emphasis_underscore_no_link] = STATE(115),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(1965),
    [sym_numeric_character_reference] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(1965),
    [sym_email_autolink] = ACTIONS(1965),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1969),
    [anon_sym_LT_QMARK] = ACTIONS(1971),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1973),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(1965),
    [sym__digits] = ACTIONS(1965),
    [sym__code_span_start] = ACTIONS(1975),
    [sym__emphasis_open_star] = ACTIONS(1977),
    [sym__emphasis_open_underscore] = ACTIONS(1979),
    [sym__strikethrough_open] = ACTIONS(1983),
  },
  [142] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(117),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(117),
    [aux_sym__inline_no_star_no_link] = STATE(117),
    [sym__strikethrough_no_link] = STATE(117),
    [sym__emphasis_star_no_link] = STATE(605),
    [sym__strong_emphasis_star_no_link] = STATE(117),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(117),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(1985),
    [sym_numeric_character_reference] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(1985),
    [sym_email_autolink] = ACTIONS(1985),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1989),
    [anon_sym_LT_QMARK] = ACTIONS(1991),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1993),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(1985),
    [sym__digits] = ACTIONS(1985),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(1997),
    [sym__emphasis_open_underscore] = ACTIONS(1999),
    [sym__strikethrough_open] = ACTIONS(2003),
  },
  [143] = {
    [sym_backslash_escape] = STATE(160),
    [sym_code_span] = STATE(160),
    [sym_image] = STATE(160),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(160),
    [sym__whitespace] = STATE(160),
    [sym__word] = STATE(160),
    [sym__soft_line_break] = STATE(160),
    [sym__inline_base] = STATE(124),
    [sym__text_base] = STATE(160),
    [sym__inline_element_no_tilde_no_link] = STATE(124),
    [aux_sym__inline_no_tilde_no_link] = STATE(124),
    [sym__strikethrough_no_link] = STATE(124),
    [sym__emphasis_star_no_link] = STATE(613),
    [sym__strong_emphasis_star_no_link] = STATE(124),
    [sym__emphasis_underscore_no_link] = STATE(613),
    [sym__strong_emphasis_underscore_no_link] = STATE(124),
    [aux_sym__inline_base_repeat1] = STATE(160),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(1941),
    [sym_numeric_character_reference] = ACTIONS(1941),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(1941),
    [sym_email_autolink] = ACTIONS(1941),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1945),
    [anon_sym_LT_QMARK] = ACTIONS(1947),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1949),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(1941),
    [sym__digits] = ACTIONS(1941),
    [sym__code_span_start] = ACTIONS(1951),
    [sym__emphasis_open_star] = ACTIONS(1953),
    [sym__emphasis_open_underscore] = ACTIONS(1955),
    [sym__strikethrough_open] = ACTIONS(1957),
  },
  [144] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(104),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(104),
    [aux_sym__inline_no_underscore_no_link] = STATE(104),
    [sym__strikethrough_no_link] = STATE(104),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(104),
    [sym__emphasis_underscore_no_link] = STATE(608),
    [sym__strong_emphasis_underscore_no_link] = STATE(104),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(1965),
    [sym_numeric_character_reference] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(1965),
    [sym_email_autolink] = ACTIONS(1965),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1969),
    [anon_sym_LT_QMARK] = ACTIONS(1971),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1973),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(1965),
    [sym__digits] = ACTIONS(1965),
    [sym__code_span_start] = ACTIONS(1975),
    [sym__emphasis_open_star] = ACTIONS(1977),
    [sym__emphasis_open_underscore] = ACTIONS(1979),
    [sym__strikethrough_open] = ACTIONS(1983),
  },
  [145] = {
    [sym_backslash_escape] = STATE(159),
    [sym_code_span] = STATE(159),
    [sym_image] = STATE(159),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(159),
    [sym__whitespace] = STATE(159),
    [sym__word] = STATE(159),
    [sym__soft_line_break] = STATE(159),
    [sym__inline_base] = STATE(114),
    [sym__text_base] = STATE(159),
    [sym__inline_element_no_star_no_link] = STATE(114),
    [aux_sym__inline_no_star_no_link] = STATE(114),
    [sym__strikethrough_no_link] = STATE(114),
    [sym__emphasis_star_no_link] = STATE(605),
    [sym__strong_emphasis_star_no_link] = STATE(114),
    [sym__emphasis_underscore_no_link] = STATE(605),
    [sym__strong_emphasis_underscore_no_link] = STATE(114),
    [aux_sym__inline_base_repeat1] = STATE(159),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(1985),
    [sym_numeric_character_reference] = ACTIONS(1985),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(1985),
    [sym_email_autolink] = ACTIONS(1985),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1989),
    [anon_sym_LT_QMARK] = ACTIONS(1991),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1993),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(1985),
    [sym__digits] = ACTIONS(1985),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(1997),
    [sym__emphasis_open_underscore] = ACTIONS(1999),
    [sym__strikethrough_open] = ACTIONS(2003),
  },
  [146] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(122),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(122),
    [aux_sym__inline_no_underscore_no_link] = STATE(122),
    [sym__strikethrough_no_link] = STATE(122),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(122),
    [sym__emphasis_underscore_no_link] = STATE(608),
    [sym__strong_emphasis_underscore_no_link] = STATE(122),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(1965),
    [sym_numeric_character_reference] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(1965),
    [sym_email_autolink] = ACTIONS(1965),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1969),
    [anon_sym_LT_QMARK] = ACTIONS(1971),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1973),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(1965),
    [sym__digits] = ACTIONS(1965),
    [sym__code_span_start] = ACTIONS(1975),
    [sym__emphasis_open_star] = ACTIONS(1977),
    [sym__emphasis_open_underscore] = ACTIONS(1979),
    [sym__strikethrough_open] = ACTIONS(1983),
  },
  [147] = {
    [sym_backslash_escape] = STATE(165),
    [sym_code_span] = STATE(165),
    [sym_image] = STATE(165),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(165),
    [sym__whitespace] = STATE(165),
    [sym__word] = STATE(165),
    [sym__soft_line_break] = STATE(165),
    [sym__inline_base] = STATE(118),
    [sym__text_base] = STATE(165),
    [sym__inline_element_no_underscore_no_link] = STATE(118),
    [aux_sym__inline_no_underscore_no_link] = STATE(118),
    [sym__strikethrough_no_link] = STATE(118),
    [sym__emphasis_star_no_link] = STATE(608),
    [sym__strong_emphasis_star_no_link] = STATE(118),
    [sym__emphasis_underscore_no_link] = STATE(608),
    [sym__strong_emphasis_underscore_no_link] = STATE(118),
    [aux_sym__inline_base_repeat1] = STATE(165),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(1965),
    [sym_numeric_character_reference] = ACTIONS(1965),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(1965),
    [sym_email_autolink] = ACTIONS(1965),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1969),
    [anon_sym_LT_QMARK] = ACTIONS(1971),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1973),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(1965),
    [sym__digits] = ACTIONS(1965),
    [sym__code_span_start] = ACTIONS(1975),
    [sym__emphasis_open_star] = ACTIONS(1977),
    [sym__emphasis_open_underscore] = ACTIONS(1979),
    [sym__strikethrough_open] = ACTIONS(1983),
  },
  [148] = {
    [sym_backslash_escape] = STATE(148),
    [sym_code_span] = STATE(148),
    [sym_image] = STATE(148),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(148),
    [sym__whitespace] = STATE(148),
    [sym__word] = STATE(148),
    [sym__soft_line_break] = STATE(148),
    [sym__text_base] = STATE(148),
    [aux_sym__inline_base_repeat1] = STATE(148),
    [sym__backslash_escape] = ACTIONS(2281),
    [sym_entity_reference] = ACTIONS(2284),
    [sym_numeric_character_reference] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2287),
    [anon_sym_RBRACK] = ACTIONS(2287),
    [anon_sym_LT] = ACTIONS(2289),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2295),
    [anon_sym_DQUOTE] = ACTIONS(2292),
    [anon_sym_POUND] = ACTIONS(2292),
    [anon_sym_DOLLAR] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_COMMA] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2292),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(2292),
    [anon_sym_BSLASH] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym__] = ACTIONS(2292),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2292),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2292),
    [anon_sym_RPAREN] = ACTIONS(2292),
    [sym__newline_token] = ACTIONS(2304),
    [sym_uri_autolink] = ACTIONS(2284),
    [sym_email_autolink] = ACTIONS(2284),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2307),
    [anon_sym_LT_QMARK] = ACTIONS(2310),
    [aux_sym__declaration_token1] = ACTIONS(2313),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2316),
    [sym__whitespace_ge_2] = ACTIONS(2319),
    [aux_sym__whitespace_token1] = ACTIONS(2322),
    [sym__word_no_digit] = ACTIONS(2284),
    [sym__digits] = ACTIONS(2284),
    [sym__code_span_start] = ACTIONS(2325),
    [sym__emphasis_open_star] = ACTIONS(2287),
    [sym__emphasis_open_underscore] = ACTIONS(2287),
    [sym__strikethrough_open] = ACTIONS(2287),
    [sym__strikethrough_close] = ACTIONS(2287),
  },
  [149] = {
    [sym_backslash_escape] = STATE(148),
    [sym_code_span] = STATE(148),
    [sym_image] = STATE(148),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(509),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(148),
    [sym__whitespace] = STATE(148),
    [sym__word] = STATE(148),
    [sym__soft_line_break] = STATE(148),
    [sym__text_base] = STATE(148),
    [aux_sym__inline_base_repeat1] = STATE(148),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(2328),
    [sym_numeric_character_reference] = ACTIONS(2328),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_RBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(685),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(2328),
    [sym_email_autolink] = ACTIONS(2328),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(693),
    [anon_sym_LT_QMARK] = ACTIONS(695),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(699),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(2328),
    [sym__digits] = ACTIONS(2328),
    [sym__code_span_start] = ACTIONS(705),
    [sym__emphasis_open_star] = ACTIONS(2330),
    [sym__emphasis_open_underscore] = ACTIONS(2330),
    [sym__strikethrough_open] = ACTIONS(2330),
    [sym__strikethrough_close] = ACTIONS(2330),
  },
  [150] = {
    [sym_backslash_escape] = STATE(151),
    [sym_code_span] = STATE(151),
    [sym_image] = STATE(151),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(151),
    [sym__whitespace] = STATE(151),
    [sym__word] = STATE(151),
    [sym__soft_line_break] = STATE(151),
    [sym__text_base] = STATE(151),
    [aux_sym__inline_base_repeat1] = STATE(151),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(2332),
    [sym_numeric_character_reference] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_RBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(727),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(2332),
    [sym_email_autolink] = ACTIONS(2332),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(735),
    [anon_sym_LT_QMARK] = ACTIONS(737),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(741),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(2332),
    [sym__digits] = ACTIONS(2332),
    [sym__code_span_start] = ACTIONS(747),
    [sym__emphasis_open_star] = ACTIONS(2330),
    [sym__emphasis_open_underscore] = ACTIONS(2330),
    [sym__emphasis_close_star] = ACTIONS(2330),
    [sym__strikethrough_open] = ACTIONS(2330),
  },
  [151] = {
    [sym_backslash_escape] = STATE(151),
    [sym_code_span] = STATE(151),
    [sym_image] = STATE(151),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(344),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(151),
    [sym__whitespace] = STATE(151),
    [sym__word] = STATE(151),
    [sym__soft_line_break] = STATE(151),
    [sym__text_base] = STATE(151),
    [aux_sym__inline_base_repeat1] = STATE(151),
    [sym__backslash_escape] = ACTIONS(2334),
    [sym_entity_reference] = ACTIONS(2337),
    [sym_numeric_character_reference] = ACTIONS(2337),
    [anon_sym_LBRACK] = ACTIONS(2287),
    [anon_sym_RBRACK] = ACTIONS(2287),
    [anon_sym_LT] = ACTIONS(2340),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2343),
    [anon_sym_POUND] = ACTIONS(2343),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_AMP] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(2343),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_COMMA] = ACTIONS(2343),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_COLON] = ACTIONS(2343),
    [anon_sym_SEMI] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_QMARK] = ACTIONS(2343),
    [anon_sym_AT] = ACTIONS(2343),
    [anon_sym_BSLASH] = ACTIONS(2352),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym__] = ACTIONS(2343),
    [anon_sym_BQUOTE] = ACTIONS(2343),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_RBRACE] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_LPAREN] = ACTIONS(2343),
    [anon_sym_RPAREN] = ACTIONS(2343),
    [sym__newline_token] = ACTIONS(2355),
    [sym_uri_autolink] = ACTIONS(2337),
    [sym_email_autolink] = ACTIONS(2337),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2358),
    [anon_sym_LT_QMARK] = ACTIONS(2361),
    [aux_sym__declaration_token1] = ACTIONS(2364),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2367),
    [sym__whitespace_ge_2] = ACTIONS(2370),
    [aux_sym__whitespace_token1] = ACTIONS(2373),
    [sym__word_no_digit] = ACTIONS(2337),
    [sym__digits] = ACTIONS(2337),
    [sym__code_span_start] = ACTIONS(2376),
    [sym__emphasis_open_star] = ACTIONS(2287),
    [sym__emphasis_open_underscore] = ACTIONS(2287),
    [sym__emphasis_close_star] = ACTIONS(2287),
    [sym__strikethrough_open] = ACTIONS(2287),
  },
  [152] = {
    [sym_backslash_escape] = STATE(155),
    [sym_code_span] = STATE(155),
    [sym_image] = STATE(155),
    [sym__image_inline_link] = STATE(444),
    [sym__image_shortcut_link] = STATE(444),
    [sym__image_full_reference_link] = STATE(444),
    [sym__image_collapsed_reference_link] = STATE(444),
    [sym__image_description] = STATE(1055),
    [sym__image_description_non_empty] = STATE(433),
    [sym__html_tag] = STATE(425),
    [sym__open_tag] = STATE(423),
    [sym__closing_tag] = STATE(423),
    [sym__html_comment] = STATE(423),
    [sym__processing_instruction] = STATE(423),
    [sym__declaration] = STATE(423),
    [sym__cdata_section] = STATE(423),
    [sym_hard_line_break] = STATE(155),
    [sym__whitespace] = STATE(155),
    [sym__word] = STATE(155),
    [sym__soft_line_break] = STATE(155),
    [sym__text_base] = STATE(155),
    [aux_sym__inline_base_repeat1] = STATE(155),
    [ts_builtin_sym_end] = ACTIONS(2330),
    [sym__backslash_escape] = ACTIONS(3),
    [sym_entity_reference] = ACTIONS(2379),
    [sym_numeric_character_reference] = ACTIONS(2379),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_RBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(11),
    [anon_sym_GT] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(13),
    [anon_sym_POUND] = ACTIONS(13),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_PERCENT] = ACTIONS(13),
    [anon_sym_AMP] = ACTIONS(17),
    [anon_sym_SQUOTE] = ACTIONS(13),
    [anon_sym_STAR] = ACTIONS(13),
    [anon_sym_PLUS] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(13),
    [anon_sym_DOT] = ACTIONS(13),
    [anon_sym_SLASH] = ACTIONS(13),
    [anon_sym_COLON] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(13),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_BSLASH] = ACTIONS(19),
    [anon_sym_CARET] = ACTIONS(13),
    [anon_sym__] = ACTIONS(13),
    [anon_sym_BQUOTE] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(13),
    [anon_sym_TILDE] = ACTIONS(13),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(13),
    [sym__newline_token] = ACTIONS(21),
    [sym_uri_autolink] = ACTIONS(2379),
    [sym_email_autolink] = ACTIONS(2379),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(23),
    [anon_sym_LT_QMARK] = ACTIONS(25),
    [aux_sym__declaration_token1] = ACTIONS(27),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(29),
    [sym__whitespace_ge_2] = ACTIONS(31),
    [aux_sym__whitespace_token1] = ACTIONS(33),
    [sym__word_no_digit] = ACTIONS(2379),
    [sym__digits] = ACTIONS(2379),
    [sym__code_span_start] = ACTIONS(35),
    [sym__emphasis_open_star] = ACTIONS(2330),
    [sym__emphasis_open_underscore] = ACTIONS(2330),
    [sym__strikethrough_open] = ACTIONS(2330),
  },
  [153] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__text_base] = STATE(154),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(2381),
    [sym_numeric_character_reference] = ACTIONS(2381),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_RBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(2381),
    [sym_email_autolink] = ACTIONS(2381),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(777),
    [anon_sym_LT_QMARK] = ACTIONS(779),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(783),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(2381),
    [sym__digits] = ACTIONS(2381),
    [sym__code_span_start] = ACTIONS(789),
    [sym__emphasis_open_star] = ACTIONS(2330),
    [sym__emphasis_open_underscore] = ACTIONS(2330),
    [sym__emphasis_close_underscore] = ACTIONS(2330),
    [sym__strikethrough_open] = ACTIONS(2330),
  },
  [154] = {
    [sym_backslash_escape] = STATE(154),
    [sym_code_span] = STATE(154),
    [sym_image] = STATE(154),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(430),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(154),
    [sym__whitespace] = STATE(154),
    [sym__word] = STATE(154),
    [sym__soft_line_break] = STATE(154),
    [sym__text_base] = STATE(154),
    [aux_sym__inline_base_repeat1] = STATE(154),
    [sym__backslash_escape] = ACTIONS(2383),
    [sym_entity_reference] = ACTIONS(2386),
    [sym_numeric_character_reference] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2287),
    [anon_sym_RBRACK] = ACTIONS(2287),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2395),
    [anon_sym_DQUOTE] = ACTIONS(2392),
    [anon_sym_POUND] = ACTIONS(2392),
    [anon_sym_DOLLAR] = ACTIONS(2392),
    [anon_sym_PERCENT] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2392),
    [anon_sym_STAR] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2392),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2392),
    [anon_sym_DOT] = ACTIONS(2392),
    [anon_sym_SLASH] = ACTIONS(2392),
    [anon_sym_COLON] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym_EQ] = ACTIONS(2392),
    [anon_sym_QMARK] = ACTIONS(2392),
    [anon_sym_AT] = ACTIONS(2392),
    [anon_sym_BSLASH] = ACTIONS(2401),
    [anon_sym_CARET] = ACTIONS(2392),
    [anon_sym__] = ACTIONS(2392),
    [anon_sym_BQUOTE] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_TILDE] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_RPAREN] = ACTIONS(2392),
    [sym__newline_token] = ACTIONS(2404),
    [sym_uri_autolink] = ACTIONS(2386),
    [sym_email_autolink] = ACTIONS(2386),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2407),
    [anon_sym_LT_QMARK] = ACTIONS(2410),
    [aux_sym__declaration_token1] = ACTIONS(2413),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2416),
    [sym__whitespace_ge_2] = ACTIONS(2419),
    [aux_sym__whitespace_token1] = ACTIONS(2422),
    [sym__word_no_digit] = ACTIONS(2386),
    [sym__digits] = ACTIONS(2386),
    [sym__code_span_start] = ACTIONS(2425),
    [sym__emphasis_open_star] = ACTIONS(2287),
    [sym__emphasis_open_underscore] = ACTIONS(2287),
    [sym__emphasis_close_underscore] = ACTIONS(2287),
    [sym__strikethrough_open] = ACTIONS(2287),
  },
  [155] = {
    [sym_backslash_escape] = STATE(155),
    [sym_code_span] = STATE(155),
    [sym_image] = STATE(155),
    [sym__image_inline_link] = STATE(444),
    [sym__image_shortcut_link] = STATE(444),
    [sym__image_full_reference_link] = STATE(444),
    [sym__image_collapsed_reference_link] = STATE(444),
    [sym__image_description] = STATE(1055),
    [sym__image_description_non_empty] = STATE(433),
    [sym__html_tag] = STATE(425),
    [sym__open_tag] = STATE(423),
    [sym__closing_tag] = STATE(423),
    [sym__html_comment] = STATE(423),
    [sym__processing_instruction] = STATE(423),
    [sym__declaration] = STATE(423),
    [sym__cdata_section] = STATE(423),
    [sym_hard_line_break] = STATE(155),
    [sym__whitespace] = STATE(155),
    [sym__word] = STATE(155),
    [sym__soft_line_break] = STATE(155),
    [sym__text_base] = STATE(155),
    [aux_sym__inline_base_repeat1] = STATE(155),
    [ts_builtin_sym_end] = ACTIONS(2287),
    [sym__backslash_escape] = ACTIONS(2428),
    [sym_entity_reference] = ACTIONS(2431),
    [sym_numeric_character_reference] = ACTIONS(2431),
    [anon_sym_LBRACK] = ACTIONS(2287),
    [anon_sym_RBRACK] = ACTIONS(2287),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_GT] = ACTIONS(2437),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_DQUOTE] = ACTIONS(2437),
    [anon_sym_POUND] = ACTIONS(2437),
    [anon_sym_DOLLAR] = ACTIONS(2437),
    [anon_sym_PERCENT] = ACTIONS(2437),
    [anon_sym_AMP] = ACTIONS(2443),
    [anon_sym_SQUOTE] = ACTIONS(2437),
    [anon_sym_STAR] = ACTIONS(2437),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_COMMA] = ACTIONS(2437),
    [anon_sym_DASH] = ACTIONS(2437),
    [anon_sym_DOT] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2437),
    [anon_sym_COLON] = ACTIONS(2437),
    [anon_sym_SEMI] = ACTIONS(2437),
    [anon_sym_EQ] = ACTIONS(2437),
    [anon_sym_QMARK] = ACTIONS(2437),
    [anon_sym_AT] = ACTIONS(2437),
    [anon_sym_BSLASH] = ACTIONS(2446),
    [anon_sym_CARET] = ACTIONS(2437),
    [anon_sym__] = ACTIONS(2437),
    [anon_sym_BQUOTE] = ACTIONS(2437),
    [anon_sym_LBRACE] = ACTIONS(2437),
    [anon_sym_PIPE] = ACTIONS(2437),
    [anon_sym_RBRACE] = ACTIONS(2437),
    [anon_sym_TILDE] = ACTIONS(2437),
    [anon_sym_LPAREN] = ACTIONS(2437),
    [anon_sym_RPAREN] = ACTIONS(2437),
    [sym__newline_token] = ACTIONS(2449),
    [sym_uri_autolink] = ACTIONS(2431),
    [sym_email_autolink] = ACTIONS(2431),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2452),
    [anon_sym_LT_QMARK] = ACTIONS(2455),
    [aux_sym__declaration_token1] = ACTIONS(2458),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2461),
    [sym__whitespace_ge_2] = ACTIONS(2464),
    [aux_sym__whitespace_token1] = ACTIONS(2467),
    [sym__word_no_digit] = ACTIONS(2431),
    [sym__digits] = ACTIONS(2431),
    [sym__code_span_start] = ACTIONS(2470),
    [sym__emphasis_open_star] = ACTIONS(2287),
    [sym__emphasis_open_underscore] = ACTIONS(2287),
    [sym__strikethrough_open] = ACTIONS(2287),
  },
  [156] = {
    [sym_backslash_escape] = STATE(156),
    [sym_code_span] = STATE(156),
    [sym_image] = STATE(156),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(156),
    [sym__whitespace] = STATE(156),
    [sym__word] = STATE(156),
    [sym__soft_line_break] = STATE(156),
    [sym__text_base] = STATE(156),
    [aux_sym__inline_base_repeat1] = STATE(156),
    [sym__backslash_escape] = ACTIONS(2473),
    [sym_entity_reference] = ACTIONS(2476),
    [sym_numeric_character_reference] = ACTIONS(2476),
    [anon_sym_LBRACK] = ACTIONS(2287),
    [anon_sym_RBRACK] = ACTIONS(2287),
    [anon_sym_LT] = ACTIONS(2479),
    [anon_sym_GT] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2485),
    [anon_sym_DQUOTE] = ACTIONS(2482),
    [anon_sym_POUND] = ACTIONS(2482),
    [anon_sym_DOLLAR] = ACTIONS(2482),
    [anon_sym_PERCENT] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_SQUOTE] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_DOT] = ACTIONS(2482),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_COLON] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(2482),
    [anon_sym_QMARK] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2482),
    [anon_sym_BSLASH] = ACTIONS(2491),
    [anon_sym_CARET] = ACTIONS(2482),
    [anon_sym__] = ACTIONS(2482),
    [anon_sym_BQUOTE] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2482),
    [anon_sym_PIPE] = ACTIONS(2482),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2482),
    [anon_sym_RPAREN] = ACTIONS(2482),
    [sym__newline_token] = ACTIONS(2494),
    [sym_uri_autolink] = ACTIONS(2476),
    [sym_email_autolink] = ACTIONS(2476),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2497),
    [anon_sym_LT_QMARK] = ACTIONS(2500),
    [aux_sym__declaration_token1] = ACTIONS(2503),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2506),
    [sym__whitespace_ge_2] = ACTIONS(2509),
    [aux_sym__whitespace_token1] = ACTIONS(2512),
    [sym__word_no_digit] = ACTIONS(2476),
    [sym__digits] = ACTIONS(2476),
    [sym__code_span_start] = ACTIONS(2515),
    [sym__emphasis_open_star] = ACTIONS(2287),
    [sym__emphasis_open_underscore] = ACTIONS(2287),
    [sym__strikethrough_open] = ACTIONS(2287),
  },
  [157] = {
    [sym_backslash_escape] = STATE(156),
    [sym_code_span] = STATE(156),
    [sym_image] = STATE(156),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(568),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(156),
    [sym__whitespace] = STATE(156),
    [sym__word] = STATE(156),
    [sym__soft_line_break] = STATE(156),
    [sym__text_base] = STATE(156),
    [aux_sym__inline_base_repeat1] = STATE(156),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(2518),
    [sym_numeric_character_reference] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_RBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1067),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(2518),
    [sym_email_autolink] = ACTIONS(2518),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1075),
    [anon_sym_LT_QMARK] = ACTIONS(1077),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1081),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(2518),
    [sym__digits] = ACTIONS(2518),
    [sym__code_span_start] = ACTIONS(1087),
    [sym__emphasis_open_star] = ACTIONS(2330),
    [sym__emphasis_open_underscore] = ACTIONS(2330),
    [sym__strikethrough_open] = ACTIONS(2330),
  },
  [158] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__text_base] = STATE(158),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(2383),
    [sym_entity_reference] = ACTIONS(2520),
    [sym_numeric_character_reference] = ACTIONS(2520),
    [anon_sym_LT] = ACTIONS(2389),
    [anon_sym_GT] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2523),
    [anon_sym_DQUOTE] = ACTIONS(2392),
    [anon_sym_POUND] = ACTIONS(2392),
    [anon_sym_DOLLAR] = ACTIONS(2392),
    [anon_sym_PERCENT] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2398),
    [anon_sym_SQUOTE] = ACTIONS(2392),
    [anon_sym_STAR] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2392),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2392),
    [anon_sym_DOT] = ACTIONS(2392),
    [anon_sym_SLASH] = ACTIONS(2392),
    [anon_sym_COLON] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym_EQ] = ACTIONS(2392),
    [anon_sym_QMARK] = ACTIONS(2392),
    [anon_sym_AT] = ACTIONS(2392),
    [anon_sym_BSLASH] = ACTIONS(2401),
    [anon_sym_CARET] = ACTIONS(2392),
    [anon_sym__] = ACTIONS(2392),
    [anon_sym_BQUOTE] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_TILDE] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_RPAREN] = ACTIONS(2392),
    [sym__newline_token] = ACTIONS(2404),
    [sym_uri_autolink] = ACTIONS(2520),
    [sym_email_autolink] = ACTIONS(2520),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2526),
    [anon_sym_LT_QMARK] = ACTIONS(2529),
    [aux_sym__declaration_token1] = ACTIONS(2413),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2532),
    [sym__whitespace_ge_2] = ACTIONS(2419),
    [aux_sym__whitespace_token1] = ACTIONS(2422),
    [sym__word_no_digit] = ACTIONS(2520),
    [sym__digits] = ACTIONS(2520),
    [sym__code_span_start] = ACTIONS(2535),
    [sym__emphasis_open_star] = ACTIONS(2287),
    [sym__emphasis_open_underscore] = ACTIONS(2287),
    [sym__emphasis_close_underscore] = ACTIONS(2287),
    [sym__strikethrough_open] = ACTIONS(2287),
  },
  [159] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__text_base] = STATE(164),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(715),
    [sym_entity_reference] = ACTIONS(2538),
    [sym_numeric_character_reference] = ACTIONS(2538),
    [anon_sym_LT] = ACTIONS(723),
    [anon_sym_GT] = ACTIONS(725),
    [anon_sym_BANG] = ACTIONS(1987),
    [anon_sym_DQUOTE] = ACTIONS(725),
    [anon_sym_POUND] = ACTIONS(725),
    [anon_sym_DOLLAR] = ACTIONS(725),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(729),
    [anon_sym_SQUOTE] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(725),
    [anon_sym_QMARK] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_BSLASH] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym__] = ACTIONS(725),
    [anon_sym_BQUOTE] = ACTIONS(725),
    [anon_sym_LBRACE] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(725),
    [anon_sym_RPAREN] = ACTIONS(725),
    [sym__newline_token] = ACTIONS(733),
    [sym_uri_autolink] = ACTIONS(2538),
    [sym_email_autolink] = ACTIONS(2538),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1989),
    [anon_sym_LT_QMARK] = ACTIONS(1991),
    [aux_sym__declaration_token1] = ACTIONS(739),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1993),
    [sym__whitespace_ge_2] = ACTIONS(743),
    [aux_sym__whitespace_token1] = ACTIONS(745),
    [sym__word_no_digit] = ACTIONS(2538),
    [sym__digits] = ACTIONS(2538),
    [sym__code_span_start] = ACTIONS(1995),
    [sym__emphasis_open_star] = ACTIONS(2330),
    [sym__emphasis_open_underscore] = ACTIONS(2330),
    [sym__emphasis_close_star] = ACTIONS(2330),
    [sym__strikethrough_open] = ACTIONS(2330),
  },
  [160] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__text_base] = STATE(163),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(673),
    [sym_entity_reference] = ACTIONS(2540),
    [sym_numeric_character_reference] = ACTIONS(2540),
    [anon_sym_LT] = ACTIONS(681),
    [anon_sym_GT] = ACTIONS(683),
    [anon_sym_BANG] = ACTIONS(1943),
    [anon_sym_DQUOTE] = ACTIONS(683),
    [anon_sym_POUND] = ACTIONS(683),
    [anon_sym_DOLLAR] = ACTIONS(683),
    [anon_sym_PERCENT] = ACTIONS(683),
    [anon_sym_AMP] = ACTIONS(687),
    [anon_sym_SQUOTE] = ACTIONS(683),
    [anon_sym_STAR] = ACTIONS(683),
    [anon_sym_PLUS] = ACTIONS(683),
    [anon_sym_COMMA] = ACTIONS(683),
    [anon_sym_DASH] = ACTIONS(683),
    [anon_sym_DOT] = ACTIONS(683),
    [anon_sym_SLASH] = ACTIONS(683),
    [anon_sym_COLON] = ACTIONS(683),
    [anon_sym_SEMI] = ACTIONS(683),
    [anon_sym_EQ] = ACTIONS(683),
    [anon_sym_QMARK] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(683),
    [anon_sym_BSLASH] = ACTIONS(689),
    [anon_sym_CARET] = ACTIONS(683),
    [anon_sym__] = ACTIONS(683),
    [anon_sym_BQUOTE] = ACTIONS(683),
    [anon_sym_LBRACE] = ACTIONS(683),
    [anon_sym_PIPE] = ACTIONS(683),
    [anon_sym_RBRACE] = ACTIONS(683),
    [anon_sym_TILDE] = ACTIONS(683),
    [anon_sym_LPAREN] = ACTIONS(683),
    [anon_sym_RPAREN] = ACTIONS(683),
    [sym__newline_token] = ACTIONS(691),
    [sym_uri_autolink] = ACTIONS(2540),
    [sym_email_autolink] = ACTIONS(2540),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1945),
    [anon_sym_LT_QMARK] = ACTIONS(1947),
    [aux_sym__declaration_token1] = ACTIONS(697),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1949),
    [sym__whitespace_ge_2] = ACTIONS(701),
    [aux_sym__whitespace_token1] = ACTIONS(703),
    [sym__word_no_digit] = ACTIONS(2540),
    [sym__digits] = ACTIONS(2540),
    [sym__code_span_start] = ACTIONS(1951),
    [sym__emphasis_open_star] = ACTIONS(2330),
    [sym__emphasis_open_underscore] = ACTIONS(2330),
    [sym__strikethrough_open] = ACTIONS(2330),
    [sym__strikethrough_close] = ACTIONS(2330),
  },
  [161] = {
    [sym_backslash_escape] = STATE(162),
    [sym_code_span] = STATE(162),
    [sym_image] = STATE(162),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(580),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(162),
    [sym__whitespace] = STATE(162),
    [sym__word] = STATE(162),
    [sym__soft_line_break] = STATE(162),
    [sym__text_base] = STATE(162),
    [aux_sym__inline_base_repeat1] = STATE(162),
    [sym__backslash_escape] = ACTIONS(1055),
    [sym_entity_reference] = ACTIONS(2542),
    [sym_numeric_character_reference] = ACTIONS(2542),
    [anon_sym_RBRACK] = ACTIONS(2330),
    [anon_sym_LT] = ACTIONS(1063),
    [anon_sym_GT] = ACTIONS(1065),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_DQUOTE] = ACTIONS(1065),
    [anon_sym_POUND] = ACTIONS(1065),
    [anon_sym_DOLLAR] = ACTIONS(1065),
    [anon_sym_PERCENT] = ACTIONS(1065),
    [anon_sym_AMP] = ACTIONS(1069),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [anon_sym_STAR] = ACTIONS(1065),
    [anon_sym_PLUS] = ACTIONS(1065),
    [anon_sym_COMMA] = ACTIONS(1065),
    [anon_sym_DASH] = ACTIONS(1065),
    [anon_sym_DOT] = ACTIONS(1065),
    [anon_sym_SLASH] = ACTIONS(1065),
    [anon_sym_COLON] = ACTIONS(1065),
    [anon_sym_SEMI] = ACTIONS(1065),
    [anon_sym_EQ] = ACTIONS(1065),
    [anon_sym_QMARK] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(1065),
    [anon_sym_BSLASH] = ACTIONS(1071),
    [anon_sym_CARET] = ACTIONS(1065),
    [anon_sym__] = ACTIONS(1065),
    [anon_sym_BQUOTE] = ACTIONS(1065),
    [anon_sym_LBRACE] = ACTIONS(1065),
    [anon_sym_PIPE] = ACTIONS(1065),
    [anon_sym_RBRACE] = ACTIONS(1065),
    [anon_sym_TILDE] = ACTIONS(1065),
    [anon_sym_LPAREN] = ACTIONS(1065),
    [anon_sym_RPAREN] = ACTIONS(1065),
    [sym__newline_token] = ACTIONS(1073),
    [sym_uri_autolink] = ACTIONS(2542),
    [sym_email_autolink] = ACTIONS(2542),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1927),
    [anon_sym_LT_QMARK] = ACTIONS(1929),
    [aux_sym__declaration_token1] = ACTIONS(1079),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1931),
    [sym__whitespace_ge_2] = ACTIONS(1083),
    [aux_sym__whitespace_token1] = ACTIONS(1085),
    [sym__word_no_digit] = ACTIONS(2542),
    [sym__digits] = ACTIONS(2542),
    [sym__code_span_start] = ACTIONS(1933),
    [sym__emphasis_open_star] = ACTIONS(2330),
    [sym__emphasis_open_underscore] = ACTIONS(2330),
    [sym__strikethrough_open] = ACTIONS(2330),
  },
  [162] = {
    [sym_backslash_escape] = STATE(162),
    [sym_code_span] = STATE(162),
    [sym_image] = STATE(162),
    [sym__image_inline_link] = STATE(579),
    [sym__image_shortcut_link] = STATE(579),
    [sym__image_full_reference_link] = STATE(579),
    [sym__image_collapsed_reference_link] = STATE(579),
    [sym__image_description] = STATE(1051),
    [sym__image_description_non_empty] = STATE(580),
    [sym__html_tag] = STATE(581),
    [sym__open_tag] = STATE(561),
    [sym__closing_tag] = STATE(561),
    [sym__html_comment] = STATE(561),
    [sym__processing_instruction] = STATE(561),
    [sym__declaration] = STATE(561),
    [sym__cdata_section] = STATE(561),
    [sym_hard_line_break] = STATE(162),
    [sym__whitespace] = STATE(162),
    [sym__word] = STATE(162),
    [sym__soft_line_break] = STATE(162),
    [sym__text_base] = STATE(162),
    [aux_sym__inline_base_repeat1] = STATE(162),
    [sym__backslash_escape] = ACTIONS(2473),
    [sym_entity_reference] = ACTIONS(2544),
    [sym_numeric_character_reference] = ACTIONS(2544),
    [anon_sym_RBRACK] = ACTIONS(2287),
    [anon_sym_LT] = ACTIONS(2479),
    [anon_sym_GT] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2547),
    [anon_sym_DQUOTE] = ACTIONS(2482),
    [anon_sym_POUND] = ACTIONS(2482),
    [anon_sym_DOLLAR] = ACTIONS(2482),
    [anon_sym_PERCENT] = ACTIONS(2482),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_SQUOTE] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_COMMA] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_DOT] = ACTIONS(2482),
    [anon_sym_SLASH] = ACTIONS(2482),
    [anon_sym_COLON] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2482),
    [anon_sym_EQ] = ACTIONS(2482),
    [anon_sym_QMARK] = ACTIONS(2482),
    [anon_sym_AT] = ACTIONS(2482),
    [anon_sym_BSLASH] = ACTIONS(2491),
    [anon_sym_CARET] = ACTIONS(2482),
    [anon_sym__] = ACTIONS(2482),
    [anon_sym_BQUOTE] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2482),
    [anon_sym_PIPE] = ACTIONS(2482),
    [anon_sym_RBRACE] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2482),
    [anon_sym_RPAREN] = ACTIONS(2482),
    [sym__newline_token] = ACTIONS(2494),
    [sym_uri_autolink] = ACTIONS(2544),
    [sym_email_autolink] = ACTIONS(2544),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2550),
    [anon_sym_LT_QMARK] = ACTIONS(2553),
    [aux_sym__declaration_token1] = ACTIONS(2503),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2556),
    [sym__whitespace_ge_2] = ACTIONS(2509),
    [aux_sym__whitespace_token1] = ACTIONS(2512),
    [sym__word_no_digit] = ACTIONS(2544),
    [sym__digits] = ACTIONS(2544),
    [sym__code_span_start] = ACTIONS(2559),
    [sym__emphasis_open_star] = ACTIONS(2287),
    [sym__emphasis_open_underscore] = ACTIONS(2287),
    [sym__strikethrough_open] = ACTIONS(2287),
  },
  [163] = {
    [sym_backslash_escape] = STATE(163),
    [sym_code_span] = STATE(163),
    [sym_image] = STATE(163),
    [sym__image_inline_link] = STATE(508),
    [sym__image_shortcut_link] = STATE(508),
    [sym__image_full_reference_link] = STATE(508),
    [sym__image_collapsed_reference_link] = STATE(508),
    [sym__image_description] = STATE(1058),
    [sym__image_description_non_empty] = STATE(578),
    [sym__html_tag] = STATE(510),
    [sym__open_tag] = STATE(274),
    [sym__closing_tag] = STATE(274),
    [sym__html_comment] = STATE(274),
    [sym__processing_instruction] = STATE(274),
    [sym__declaration] = STATE(274),
    [sym__cdata_section] = STATE(274),
    [sym_hard_line_break] = STATE(163),
    [sym__whitespace] = STATE(163),
    [sym__word] = STATE(163),
    [sym__soft_line_break] = STATE(163),
    [sym__text_base] = STATE(163),
    [aux_sym__inline_base_repeat1] = STATE(163),
    [sym__backslash_escape] = ACTIONS(2281),
    [sym_entity_reference] = ACTIONS(2562),
    [sym_numeric_character_reference] = ACTIONS(2562),
    [anon_sym_LT] = ACTIONS(2289),
    [anon_sym_GT] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2565),
    [anon_sym_DQUOTE] = ACTIONS(2292),
    [anon_sym_POUND] = ACTIONS(2292),
    [anon_sym_DOLLAR] = ACTIONS(2292),
    [anon_sym_PERCENT] = ACTIONS(2292),
    [anon_sym_AMP] = ACTIONS(2298),
    [anon_sym_SQUOTE] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_COMMA] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_DOT] = ACTIONS(2292),
    [anon_sym_SLASH] = ACTIONS(2292),
    [anon_sym_COLON] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2292),
    [anon_sym_EQ] = ACTIONS(2292),
    [anon_sym_QMARK] = ACTIONS(2292),
    [anon_sym_AT] = ACTIONS(2292),
    [anon_sym_BSLASH] = ACTIONS(2301),
    [anon_sym_CARET] = ACTIONS(2292),
    [anon_sym__] = ACTIONS(2292),
    [anon_sym_BQUOTE] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2292),
    [anon_sym_PIPE] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2292),
    [anon_sym_TILDE] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2292),
    [anon_sym_RPAREN] = ACTIONS(2292),
    [sym__newline_token] = ACTIONS(2304),
    [sym_uri_autolink] = ACTIONS(2562),
    [sym_email_autolink] = ACTIONS(2562),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2568),
    [anon_sym_LT_QMARK] = ACTIONS(2571),
    [aux_sym__declaration_token1] = ACTIONS(2313),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2574),
    [sym__whitespace_ge_2] = ACTIONS(2319),
    [aux_sym__whitespace_token1] = ACTIONS(2322),
    [sym__word_no_digit] = ACTIONS(2562),
    [sym__digits] = ACTIONS(2562),
    [sym__code_span_start] = ACTIONS(2577),
    [sym__emphasis_open_star] = ACTIONS(2287),
    [sym__emphasis_open_underscore] = ACTIONS(2287),
    [sym__strikethrough_open] = ACTIONS(2287),
    [sym__strikethrough_close] = ACTIONS(2287),
  },
  [164] = {
    [sym_backslash_escape] = STATE(164),
    [sym_code_span] = STATE(164),
    [sym_image] = STATE(164),
    [sym__image_inline_link] = STATE(343),
    [sym__image_shortcut_link] = STATE(343),
    [sym__image_full_reference_link] = STATE(343),
    [sym__image_collapsed_reference_link] = STATE(343),
    [sym__image_description] = STATE(1056),
    [sym__image_description_non_empty] = STATE(553),
    [sym__html_tag] = STATE(345),
    [sym__open_tag] = STATE(432),
    [sym__closing_tag] = STATE(432),
    [sym__html_comment] = STATE(432),
    [sym__processing_instruction] = STATE(432),
    [sym__declaration] = STATE(432),
    [sym__cdata_section] = STATE(432),
    [sym_hard_line_break] = STATE(164),
    [sym__whitespace] = STATE(164),
    [sym__word] = STATE(164),
    [sym__soft_line_break] = STATE(164),
    [sym__text_base] = STATE(164),
    [aux_sym__inline_base_repeat1] = STATE(164),
    [sym__backslash_escape] = ACTIONS(2334),
    [sym_entity_reference] = ACTIONS(2580),
    [sym_numeric_character_reference] = ACTIONS(2580),
    [anon_sym_LT] = ACTIONS(2340),
    [anon_sym_GT] = ACTIONS(2343),
    [anon_sym_BANG] = ACTIONS(2583),
    [anon_sym_DQUOTE] = ACTIONS(2343),
    [anon_sym_POUND] = ACTIONS(2343),
    [anon_sym_DOLLAR] = ACTIONS(2343),
    [anon_sym_PERCENT] = ACTIONS(2343),
    [anon_sym_AMP] = ACTIONS(2349),
    [anon_sym_SQUOTE] = ACTIONS(2343),
    [anon_sym_STAR] = ACTIONS(2343),
    [anon_sym_PLUS] = ACTIONS(2343),
    [anon_sym_COMMA] = ACTIONS(2343),
    [anon_sym_DASH] = ACTIONS(2343),
    [anon_sym_DOT] = ACTIONS(2343),
    [anon_sym_SLASH] = ACTIONS(2343),
    [anon_sym_COLON] = ACTIONS(2343),
    [anon_sym_SEMI] = ACTIONS(2343),
    [anon_sym_EQ] = ACTIONS(2343),
    [anon_sym_QMARK] = ACTIONS(2343),
    [anon_sym_AT] = ACTIONS(2343),
    [anon_sym_BSLASH] = ACTIONS(2352),
    [anon_sym_CARET] = ACTIONS(2343),
    [anon_sym__] = ACTIONS(2343),
    [anon_sym_BQUOTE] = ACTIONS(2343),
    [anon_sym_LBRACE] = ACTIONS(2343),
    [anon_sym_PIPE] = ACTIONS(2343),
    [anon_sym_RBRACE] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [anon_sym_LPAREN] = ACTIONS(2343),
    [anon_sym_RPAREN] = ACTIONS(2343),
    [sym__newline_token] = ACTIONS(2355),
    [sym_uri_autolink] = ACTIONS(2580),
    [sym_email_autolink] = ACTIONS(2580),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(2586),
    [anon_sym_LT_QMARK] = ACTIONS(2589),
    [aux_sym__declaration_token1] = ACTIONS(2364),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(2592),
    [sym__whitespace_ge_2] = ACTIONS(2370),
    [aux_sym__whitespace_token1] = ACTIONS(2373),
    [sym__word_no_digit] = ACTIONS(2580),
    [sym__digits] = ACTIONS(2580),
    [sym__code_span_start] = ACTIONS(2595),
    [sym__emphasis_open_star] = ACTIONS(2287),
    [sym__emphasis_open_underscore] = ACTIONS(2287),
    [sym__emphasis_close_star] = ACTIONS(2287),
    [sym__strikethrough_open] = ACTIONS(2287),
  },
  [165] = {
    [sym_backslash_escape] = STATE(158),
    [sym_code_span] = STATE(158),
    [sym_image] = STATE(158),
    [sym__image_inline_link] = STATE(429),
    [sym__image_shortcut_link] = STATE(429),
    [sym__image_full_reference_link] = STATE(429),
    [sym__image_collapsed_reference_link] = STATE(429),
    [sym__image_description] = STATE(1054),
    [sym__image_description_non_empty] = STATE(525),
    [sym__html_tag] = STATE(431),
    [sym__open_tag] = STATE(511),
    [sym__closing_tag] = STATE(511),
    [sym__html_comment] = STATE(511),
    [sym__processing_instruction] = STATE(511),
    [sym__declaration] = STATE(511),
    [sym__cdata_section] = STATE(511),
    [sym_hard_line_break] = STATE(158),
    [sym__whitespace] = STATE(158),
    [sym__word] = STATE(158),
    [sym__soft_line_break] = STATE(158),
    [sym__text_base] = STATE(158),
    [aux_sym__inline_base_repeat1] = STATE(158),
    [sym__backslash_escape] = ACTIONS(757),
    [sym_entity_reference] = ACTIONS(2598),
    [sym_numeric_character_reference] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(765),
    [anon_sym_GT] = ACTIONS(767),
    [anon_sym_BANG] = ACTIONS(1967),
    [anon_sym_DQUOTE] = ACTIONS(767),
    [anon_sym_POUND] = ACTIONS(767),
    [anon_sym_DOLLAR] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(767),
    [anon_sym_AMP] = ACTIONS(771),
    [anon_sym_SQUOTE] = ACTIONS(767),
    [anon_sym_STAR] = ACTIONS(767),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(767),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_EQ] = ACTIONS(767),
    [anon_sym_QMARK] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(767),
    [anon_sym_BSLASH] = ACTIONS(773),
    [anon_sym_CARET] = ACTIONS(767),
    [anon_sym__] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(767),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(767),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LPAREN] = ACTIONS(767),
    [anon_sym_RPAREN] = ACTIONS(767),
    [sym__newline_token] = ACTIONS(775),
    [sym_uri_autolink] = ACTIONS(2598),
    [sym_email_autolink] = ACTIONS(2598),
    [anon_sym_LT_BANG_DASH_DASH] = ACTIONS(1969),
    [anon_sym_LT_QMARK] = ACTIONS(1971),
    [aux_sym__declaration_token1] = ACTIONS(781),
    [anon_sym_LT_BANG_LBRACKCDATA_LBRACK] = ACTIONS(1973),
    [sym__whitespace_ge_2] = ACTIONS(785),
    [aux_sym__whitespace_token1] = ACTIONS(787),
    [sym__word_no_digit] = ACTIONS(2598),
    [sym__digits] = ACTIONS(2598),
    [sym__code_span_start] = ACTIONS(1975),
    [sym__emphasis_open_star] = ACTIONS(2330),
    [sym__emphasis_open_underscore] = ACTIONS(2330),
    [sym__emphasis_close_underscore] = ACTIONS(2330),
    [sym__strikethrough_open] = ACTIONS(2330),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 15,
    ACTIONS(2605), 1,
      anon_sym_LT,
    ACTIONS(2614), 1,
      sym__newline_token,
    ACTIONS(2617), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2620), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2623), 1,
      aux_sym__declaration_token1,
    ACTIONS(2626), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2629), 1,
      sym__whitespace_ge_2,
    ACTIONS(2632), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2635), 1,
      sym__code_span_close,
    ACTIONS(2611), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2602), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(206), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2600), 10,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
    ACTIONS(2608), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [95] = 16,
    ACTIONS(2605), 1,
      anon_sym_LT,
    ACTIONS(2614), 1,
      sym__newline_token,
    ACTIONS(2617), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2620), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2623), 1,
      aux_sym__declaration_token1,
    ACTIONS(2626), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2629), 1,
      sym__whitespace_ge_2,
    ACTIONS(2632), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2642), 1,
      sym__code_span_close,
    ACTIONS(2611), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2637), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2639), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(204), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2600), 10,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
    ACTIONS(2608), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [192] = 16,
    ACTIONS(2605), 1,
      anon_sym_LT,
    ACTIONS(2614), 1,
      sym__newline_token,
    ACTIONS(2617), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2620), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2623), 1,
      aux_sym__declaration_token1,
    ACTIONS(2626), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2629), 1,
      sym__whitespace_ge_2,
    ACTIONS(2632), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2635), 1,
      sym__code_span_close,
    ACTIONS(2602), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2611), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2644), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    STATE(206), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2600), 10,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
    ACTIONS(2608), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [289] = 16,
    ACTIONS(2605), 1,
      anon_sym_LT,
    ACTIONS(2614), 1,
      sym__newline_token,
    ACTIONS(2617), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2620), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2623), 1,
      aux_sym__declaration_token1,
    ACTIONS(2626), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2629), 1,
      sym__whitespace_ge_2,
    ACTIONS(2632), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2651), 1,
      sym__code_span_close,
    ACTIONS(2611), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2646), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2648), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(207), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2600), 10,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
    ACTIONS(2608), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [386] = 15,
    ACTIONS(2605), 1,
      anon_sym_LT,
    ACTIONS(2614), 1,
      sym__newline_token,
    ACTIONS(2617), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2620), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2623), 1,
      aux_sym__declaration_token1,
    ACTIONS(2626), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2629), 1,
      sym__whitespace_ge_2,
    ACTIONS(2632), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2656), 1,
      sym__code_span_close,
    ACTIONS(2611), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2653), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(203), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2600), 10,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
    ACTIONS(2608), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [481] = 15,
    ACTIONS(2605), 1,
      anon_sym_LT,
    ACTIONS(2614), 1,
      sym__newline_token,
    ACTIONS(2617), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2620), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2623), 1,
      aux_sym__declaration_token1,
    ACTIONS(2626), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2629), 1,
      sym__whitespace_ge_2,
    ACTIONS(2632), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2651), 1,
      sym__code_span_close,
    ACTIONS(2611), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2648), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(207), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2600), 10,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
    ACTIONS(2608), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [576] = 15,
    ACTIONS(2605), 1,
      anon_sym_LT,
    ACTIONS(2614), 1,
      sym__newline_token,
    ACTIONS(2617), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2620), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2623), 1,
      aux_sym__declaration_token1,
    ACTIONS(2626), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2629), 1,
      sym__whitespace_ge_2,
    ACTIONS(2632), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2642), 1,
      sym__code_span_close,
    ACTIONS(2611), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2639), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(204), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2600), 10,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
    ACTIONS(2608), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [671] = 16,
    ACTIONS(2605), 1,
      anon_sym_LT,
    ACTIONS(2614), 1,
      sym__newline_token,
    ACTIONS(2617), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2620), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2623), 1,
      aux_sym__declaration_token1,
    ACTIONS(2626), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2629), 1,
      sym__whitespace_ge_2,
    ACTIONS(2632), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2658), 1,
      anon_sym_LBRACK,
    ACTIONS(2663), 1,
      sym__code_span_close,
    ACTIONS(2611), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2660), 3,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(200), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2600), 9,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
    ACTIONS(2608), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [767] = 15,
    ACTIONS(2605), 1,
      anon_sym_LT,
    ACTIONS(2614), 1,
      sym__newline_token,
    ACTIONS(2617), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2620), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2623), 1,
      aux_sym__declaration_token1,
    ACTIONS(2626), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2629), 1,
      sym__whitespace_ge_2,
    ACTIONS(2632), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2663), 1,
      sym__code_span_close,
    ACTIONS(2611), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(2660), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(200), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2600), 9,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
    ACTIONS(2608), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [861] = 11,
    ACTIONS(2675), 1,
      sym__newline_token,
    ACTIONS(2680), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2682), 1,
      sym__whitespace_ge_2,
    ACTIONS(2685), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2667), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2688), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2669), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(702), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2672), 26,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [940] = 10,
    ACTIONS(2675), 1,
      sym__newline_token,
    ACTIONS(2682), 1,
      sym__whitespace_ge_2,
    ACTIONS(2685), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2691), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2693), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2669), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(714), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2672), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1017] = 10,
    ACTIONS(2675), 1,
      sym__newline_token,
    ACTIONS(2682), 1,
      sym__whitespace_ge_2,
    ACTIONS(2685), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2696), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2698), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2669), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(754), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2672), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1094] = 11,
    ACTIONS(2675), 1,
      sym__newline_token,
    ACTIONS(2682), 1,
      sym__whitespace_ge_2,
    ACTIONS(2685), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2701), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2667), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2703), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2669), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(701), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2672), 26,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1173] = 12,
    ACTIONS(2706), 1,
      anon_sym_LBRACK,
    ACTIONS(2708), 1,
      anon_sym_RBRACK,
    ACTIONS(2716), 1,
      sym__newline_token,
    ACTIONS(2719), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2721), 1,
      sym__whitespace_ge_2,
    ACTIONS(2724), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2727), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2710), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(751), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2713), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1254] = 10,
    ACTIONS(2716), 1,
      sym__newline_token,
    ACTIONS(2721), 1,
      sym__whitespace_ge_2,
    ACTIONS(2724), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2730), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2732), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2710), 4,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(715), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2713), 28,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1331] = 10,
    ACTIONS(2716), 1,
      sym__newline_token,
    ACTIONS(2721), 1,
      sym__whitespace_ge_2,
    ACTIONS(2724), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2735), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2737), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2710), 4,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(748), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2713), 28,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1408] = 12,
    ACTIONS(2706), 1,
      anon_sym_LBRACK,
    ACTIONS(2708), 1,
      anon_sym_RBRACK,
    ACTIONS(2716), 1,
      sym__newline_token,
    ACTIONS(2721), 1,
      sym__whitespace_ge_2,
    ACTIONS(2724), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2735), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2737), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2710), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(748), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2713), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1489] = 10,
    ACTIONS(2675), 1,
      sym__newline_token,
    ACTIONS(2682), 1,
      sym__whitespace_ge_2,
    ACTIONS(2685), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2701), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2703), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2669), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(701), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2672), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1566] = 10,
    ACTIONS(2675), 1,
      sym__newline_token,
    ACTIONS(2680), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2682), 1,
      sym__whitespace_ge_2,
    ACTIONS(2685), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2688), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2669), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(702), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2672), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1643] = 11,
    ACTIONS(2675), 1,
      sym__newline_token,
    ACTIONS(2682), 1,
      sym__whitespace_ge_2,
    ACTIONS(2685), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2696), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2667), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2698), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2669), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(754), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2672), 26,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1722] = 12,
    ACTIONS(2706), 1,
      anon_sym_LBRACK,
    ACTIONS(2708), 1,
      anon_sym_RBRACK,
    ACTIONS(2716), 1,
      sym__newline_token,
    ACTIONS(2721), 1,
      sym__whitespace_ge_2,
    ACTIONS(2724), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2740), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2742), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2710), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(728), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2713), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1803] = 10,
    ACTIONS(2716), 1,
      sym__newline_token,
    ACTIONS(2719), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2721), 1,
      sym__whitespace_ge_2,
    ACTIONS(2724), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2727), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2710), 4,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(751), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2713), 28,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1880] = 10,
    ACTIONS(2716), 1,
      sym__newline_token,
    ACTIONS(2721), 1,
      sym__whitespace_ge_2,
    ACTIONS(2724), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2740), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2742), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2710), 4,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(728), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2713), 28,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [1957] = 10,
    ACTIONS(2675), 1,
      sym__newline_token,
    ACTIONS(2682), 1,
      sym__whitespace_ge_2,
    ACTIONS(2685), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2745), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2747), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2669), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(708), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 10,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2672), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2033] = 11,
    ACTIONS(2667), 1,
      anon_sym_LBRACK,
    ACTIONS(2675), 1,
      sym__newline_token,
    ACTIONS(2682), 1,
      sym__whitespace_ge_2,
    ACTIONS(2685), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2745), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2747), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2669), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_QMARK,
      anon_sym_BSLASH,
    STATE(708), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 10,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2672), 27,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2111] = 11,
    ACTIONS(2756), 1,
      anon_sym_DASH,
    ACTIONS(2759), 1,
      sym__newline_token,
    ACTIONS(2762), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2764), 1,
      sym__whitespace_ge_2,
    ACTIONS(2767), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2770), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2753), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(712), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2665), 12,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2750), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2189] = 11,
    ACTIONS(2759), 1,
      sym__newline_token,
    ACTIONS(2764), 1,
      sym__whitespace_ge_2,
    ACTIONS(2767), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2779), 1,
      anon_sym_DASH,
    ACTIONS(2782), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2784), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2776), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(705), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2665), 12,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2773), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2267] = 12,
    ACTIONS(2759), 1,
      sym__newline_token,
    ACTIONS(2764), 1,
      sym__whitespace_ge_2,
    ACTIONS(2767), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2795), 1,
      anon_sym_DASH,
    ACTIONS(2798), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2787), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2800), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2789), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(703), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2665), 12,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2792), 25,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2347] = 11,
    ACTIONS(2706), 1,
      anon_sym_LBRACK,
    ACTIONS(2716), 1,
      sym__newline_token,
    ACTIONS(2721), 1,
      sym__whitespace_ge_2,
    ACTIONS(2724), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2803), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2805), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2710), 4,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(711), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 10,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2713), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2425] = 10,
    ACTIONS(2716), 1,
      sym__newline_token,
    ACTIONS(2721), 1,
      sym__whitespace_ge_2,
    ACTIONS(2724), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2803), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2805), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2710), 4,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(711), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 10,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2713), 28,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2501] = 12,
    ACTIONS(2759), 1,
      sym__newline_token,
    ACTIONS(2764), 1,
      sym__whitespace_ge_2,
    ACTIONS(2767), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2816), 1,
      anon_sym_DASH,
    ACTIONS(2819), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2808), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2821), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2810), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(765), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2665), 12,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2813), 25,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2581] = 12,
    ACTIONS(2759), 1,
      sym__newline_token,
    ACTIONS(2764), 1,
      sym__whitespace_ge_2,
    ACTIONS(2767), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2779), 1,
      anon_sym_DASH,
    ACTIONS(2782), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2784), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2824), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2776), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(705), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2665), 12,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2773), 25,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2661] = 11,
    ACTIONS(2759), 1,
      sym__newline_token,
    ACTIONS(2764), 1,
      sym__whitespace_ge_2,
    ACTIONS(2767), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2816), 1,
      anon_sym_DASH,
    ACTIONS(2819), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2821), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2810), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(765), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2665), 12,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2813), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2739] = 11,
    ACTIONS(2759), 1,
      sym__newline_token,
    ACTIONS(2764), 1,
      sym__whitespace_ge_2,
    ACTIONS(2767), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2795), 1,
      anon_sym_DASH,
    ACTIONS(2798), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2800), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2789), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(703), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2665), 12,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2792), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2817] = 13,
    ACTIONS(2828), 1,
      anon_sym_LT,
    ACTIONS(2832), 1,
      sym__newline_token,
    ACTIONS(2834), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2836), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2838), 1,
      aux_sym__declaration_token1,
    ACTIONS(2840), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2842), 1,
      sym__whitespace_ge_2,
    ACTIONS(2844), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2846), 1,
      sym__code_span_close,
    ACTIONS(2826), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(202), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2830), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2898] = 11,
    ACTIONS(2759), 1,
      sym__newline_token,
    ACTIONS(2764), 1,
      sym__whitespace_ge_2,
    ACTIONS(2767), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2854), 1,
      anon_sym_DASH,
    ACTIONS(2857), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2859), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2851), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(707), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2848), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [2975] = 13,
    ACTIONS(2865), 1,
      anon_sym_LT,
    ACTIONS(2871), 1,
      sym__newline_token,
    ACTIONS(2874), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2877), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2880), 1,
      aux_sym__declaration_token1,
    ACTIONS(2883), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2886), 1,
      sym__whitespace_ge_2,
    ACTIONS(2889), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2892), 1,
      sym__code_span_close,
    ACTIONS(2862), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(202), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2868), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3056] = 13,
    ACTIONS(2828), 1,
      anon_sym_LT,
    ACTIONS(2832), 1,
      sym__newline_token,
    ACTIONS(2834), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2836), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2838), 1,
      aux_sym__declaration_token1,
    ACTIONS(2840), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2842), 1,
      sym__whitespace_ge_2,
    ACTIONS(2844), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2894), 1,
      sym__code_span_close,
    ACTIONS(2826), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(202), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2830), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3137] = 13,
    ACTIONS(2828), 1,
      anon_sym_LT,
    ACTIONS(2832), 1,
      sym__newline_token,
    ACTIONS(2834), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2836), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2838), 1,
      aux_sym__declaration_token1,
    ACTIONS(2840), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2842), 1,
      sym__whitespace_ge_2,
    ACTIONS(2844), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2896), 1,
      sym__code_span_close,
    ACTIONS(2826), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(202), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2830), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3218] = 12,
    ACTIONS(2759), 1,
      sym__newline_token,
    ACTIONS(2764), 1,
      sym__whitespace_ge_2,
    ACTIONS(2767), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2854), 1,
      anon_sym_DASH,
    ACTIONS(2857), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(2898), 1,
      anon_sym_LBRACK,
    ACTIONS(2859), 2,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2678), 3,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2851), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(707), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2665), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2848), 26,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3297] = 13,
    ACTIONS(2828), 1,
      anon_sym_LT,
    ACTIONS(2832), 1,
      sym__newline_token,
    ACTIONS(2834), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2836), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2838), 1,
      aux_sym__declaration_token1,
    ACTIONS(2840), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2842), 1,
      sym__whitespace_ge_2,
    ACTIONS(2844), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2900), 1,
      sym__code_span_close,
    ACTIONS(2826), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(202), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2830), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3378] = 13,
    ACTIONS(2828), 1,
      anon_sym_LT,
    ACTIONS(2832), 1,
      sym__newline_token,
    ACTIONS(2834), 1,
      anon_sym_LT_BANG_DASH_DASH,
    ACTIONS(2836), 1,
      anon_sym_LT_QMARK,
    ACTIONS(2838), 1,
      aux_sym__declaration_token1,
    ACTIONS(2840), 1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2842), 1,
      sym__whitespace_ge_2,
    ACTIONS(2844), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2902), 1,
      sym__code_span_close,
    ACTIONS(2826), 4,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      sym__word_no_digit,
      sym__digits,
    STATE(202), 6,
      sym__html_tag,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      aux_sym_code_span_repeat1,
    STATE(750), 6,
      sym__open_tag,
      sym__closing_tag,
      sym__html_comment,
      sym__processing_instruction,
      sym__declaration,
      sym__cdata_section,
    ACTIONS(2830), 29,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3459] = 5,
    ACTIONS(21), 1,
      sym__newline_token,
    ACTIONS(2904), 1,
      sym__last_token_punctuation,
    STATE(319), 1,
      sym__soft_line_break,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [3523] = 6,
    ACTIONS(2906), 1,
      sym__newline_token,
    ACTIONS(2909), 1,
      sym__whitespace_ge_2,
    ACTIONS(2912), 1,
      aux_sym__whitespace_token1,
    STATE(795), 2,
      sym__whitespace,
      sym__soft_line_break,
    ACTIONS(2678), 6,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
  [3589] = 9,
    ACTIONS(2915), 1,
      sym__backslash_escape,
    ACTIONS(2921), 1,
      anon_sym_RBRACK,
    ACTIONS(2929), 1,
      sym__newline_token,
    ACTIONS(2932), 1,
      sym__whitespace_ge_2,
    ACTIONS(2935), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2923), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(210), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2918), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2926), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3661] = 6,
    ACTIONS(2906), 1,
      sym__newline_token,
    ACTIONS(2909), 1,
      sym__whitespace_ge_2,
    ACTIONS(2912), 1,
      aux_sym__whitespace_token1,
    STATE(775), 2,
      sym__whitespace,
      sym__soft_line_break,
    ACTIONS(2678), 6,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
  [3727] = 6,
    ACTIONS(2904), 1,
      sym__last_token_punctuation,
    ACTIONS(2938), 1,
      anon_sym_SLASH,
    ACTIONS(2941), 1,
      sym__word_no_digit,
    STATE(899), 1,
      sym__tag_name,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__digits,
  [3793] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2948), 1,
      anon_sym_RBRACK,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(230), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2946), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3865] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2962), 1,
      anon_sym_RBRACK,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(228), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2960), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [3937] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2966), 1,
      anon_sym_RBRACK,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(210), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2964), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4009] = 6,
    ACTIONS(2941), 1,
      sym__word_no_digit,
    ACTIONS(2968), 1,
      anon_sym_SLASH,
    ACTIONS(2971), 1,
      sym__last_token_punctuation,
    STATE(885), 1,
      sym__tag_name,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__digits,
  [4075] = 5,
    ACTIONS(733), 1,
      sym__newline_token,
    ACTIONS(2973), 1,
      sym__last_token_punctuation,
    STATE(353), 1,
      sym__soft_line_break,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [4139] = 5,
    ACTIONS(733), 1,
      sym__newline_token,
    ACTIONS(2979), 1,
      sym__last_token_whitespace,
    STATE(353), 1,
      sym__soft_line_break,
    ACTIONS(2977), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [4203] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2983), 1,
      anon_sym_RBRACK,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(220), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2981), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4275] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2985), 1,
      anon_sym_RBRACK,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(210), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2964), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4347] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2989), 1,
      anon_sym_RBRACK,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(215), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2987), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4419] = 5,
    ACTIONS(691), 1,
      sym__newline_token,
    ACTIONS(2991), 1,
      sym__last_token_whitespace,
    STATE(515), 1,
      sym__soft_line_break,
    ACTIONS(2977), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [4483] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2993), 1,
      anon_sym_RBRACK,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(230), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2946), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4555] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2995), 1,
      anon_sym_RBRACK,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(215), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2987), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4627] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(2999), 1,
      anon_sym_RBRACK,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(239), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2997), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4699] = 6,
    ACTIONS(2906), 1,
      sym__newline_token,
    ACTIONS(2909), 1,
      sym__whitespace_ge_2,
    ACTIONS(2912), 1,
      aux_sym__whitespace_token1,
    STATE(802), 2,
      sym__whitespace,
      sym__soft_line_break,
    ACTIONS(2678), 6,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
  [4765] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3001), 1,
      anon_sym_RBRACK,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(239), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2997), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4837] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3003), 1,
      anon_sym_RBRACK,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(210), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2964), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [4909] = 5,
    ACTIONS(21), 1,
      sym__newline_token,
    ACTIONS(3005), 1,
      sym__last_token_whitespace,
    STATE(319), 1,
      sym__soft_line_break,
    ACTIONS(2977), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [4973] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3007), 1,
      anon_sym_RBRACK,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(210), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2964), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5045] = 6,
    ACTIONS(2941), 1,
      sym__word_no_digit,
    ACTIONS(2973), 1,
      sym__last_token_punctuation,
    ACTIONS(3009), 1,
      anon_sym_SLASH,
    STATE(891), 1,
      sym__tag_name,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__digits,
  [5111] = 5,
    ACTIONS(691), 1,
      sym__newline_token,
    ACTIONS(2971), 1,
      sym__last_token_punctuation,
    STATE(515), 1,
      sym__soft_line_break,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5175] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3012), 1,
      anon_sym_RBRACK,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(220), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2981), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5247] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3014), 1,
      anon_sym_RBRACK,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(228), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2960), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5319] = 6,
    ACTIONS(2941), 1,
      sym__word_no_digit,
    ACTIONS(3016), 1,
      anon_sym_SLASH,
    ACTIONS(3019), 1,
      sym__last_token_punctuation,
    STATE(898), 1,
      sym__tag_name,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__digits,
  [5385] = 5,
    ACTIONS(775), 1,
      sym__newline_token,
    ACTIONS(3021), 1,
      sym__last_token_whitespace,
    STATE(436), 1,
      sym__soft_line_break,
    ACTIONS(2977), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5449] = 6,
    ACTIONS(2906), 1,
      sym__newline_token,
    ACTIONS(2909), 1,
      sym__whitespace_ge_2,
    ACTIONS(2912), 1,
      aux_sym__whitespace_token1,
    STATE(777), 2,
      sym__whitespace,
      sym__soft_line_break,
    ACTIONS(2678), 6,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
  [5515] = 5,
    ACTIONS(775), 1,
      sym__newline_token,
    ACTIONS(3019), 1,
      sym__last_token_punctuation,
    STATE(436), 1,
      sym__soft_line_break,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5579] = 9,
    ACTIONS(2944), 1,
      sym__backslash_escape,
    ACTIONS(2954), 1,
      sym__newline_token,
    ACTIONS(2956), 1,
      sym__whitespace_ge_2,
    ACTIONS(2958), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3023), 1,
      anon_sym_RBRACK,
    ACTIONS(2950), 3,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(210), 7,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      sym__text_base,
      sym__text_inline_no_link,
      aux_sym_link_label_repeat1,
    ACTIONS(2964), 11,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(2952), 27,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [5651] = 3,
    ACTIONS(3019), 1,
      sym__last_token_punctuation,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5710] = 3,
    ACTIONS(3029), 1,
      sym__last_token_whitespace,
    ACTIONS(3027), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3025), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5769] = 3,
    ACTIONS(1407), 1,
      sym__last_token_punctuation,
    ACTIONS(3033), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3031), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5828] = 4,
    ACTIONS(109), 1,
      anon_sym_RBRACK,
    ACTIONS(1407), 1,
      sym__last_token_punctuation,
    ACTIONS(3033), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3031), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5889] = 3,
    ACTIONS(2979), 1,
      sym__last_token_whitespace,
    ACTIONS(2977), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [5948] = 3,
    ACTIONS(2991), 1,
      sym__last_token_whitespace,
    ACTIONS(2977), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6007] = 4,
    ACTIONS(3019), 1,
      sym__last_token_punctuation,
    ACTIONS(3035), 1,
      anon_sym_LBRACK,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6068] = 3,
    ACTIONS(2973), 1,
      sym__last_token_punctuation,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6127] = 4,
    ACTIONS(2971), 1,
      sym__last_token_punctuation,
    ACTIONS(3038), 1,
      anon_sym_LBRACK,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6188] = 3,
    ACTIONS(3041), 1,
      sym__last_token_whitespace,
    ACTIONS(3027), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3025), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6247] = 3,
    ACTIONS(3005), 1,
      sym__last_token_whitespace,
    ACTIONS(2977), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6306] = 3,
    ACTIONS(1407), 1,
      sym__last_token_punctuation,
    ACTIONS(3033), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3031), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6365] = 3,
    ACTIONS(1407), 1,
      sym__last_token_punctuation,
    ACTIONS(3033), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3031), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6424] = 4,
    ACTIONS(109), 1,
      anon_sym_RBRACK,
    ACTIONS(1407), 1,
      sym__last_token_punctuation,
    ACTIONS(3033), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3031), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6485] = 3,
    ACTIONS(3021), 1,
      sym__last_token_whitespace,
    ACTIONS(2977), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6544] = 3,
    ACTIONS(1343), 1,
      sym__last_token_punctuation,
    ACTIONS(3043), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(480), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6603] = 3,
    ACTIONS(3045), 1,
      sym__last_token_whitespace,
    ACTIONS(3027), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3025), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6662] = 3,
    ACTIONS(1407), 1,
      sym__last_token_punctuation,
    ACTIONS(3033), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3031), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6721] = 4,
    ACTIONS(2973), 1,
      sym__last_token_punctuation,
    ACTIONS(3047), 1,
      anon_sym_LBRACK,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6782] = 6,
    ACTIONS(2941), 1,
      sym__word_no_digit,
    ACTIONS(3050), 1,
      anon_sym_SLASH,
    ACTIONS(3053), 1,
      sym__last_token_punctuation,
    STATE(894), 1,
      sym__tag_name,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__digits,
  [6847] = 4,
    ACTIONS(2904), 1,
      sym__last_token_punctuation,
    ACTIONS(3055), 1,
      anon_sym_LBRACK,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6908] = 3,
    ACTIONS(2971), 1,
      sym__last_token_punctuation,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [6967] = 3,
    ACTIONS(1402), 1,
      sym__last_token_punctuation,
    ACTIONS(3058), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(297), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7026] = 5,
    ACTIONS(1073), 1,
      sym__newline_token,
    ACTIONS(3053), 1,
      sym__last_token_punctuation,
    STATE(552), 1,
      sym__soft_line_break,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7089] = 3,
    ACTIONS(3060), 1,
      sym__last_token_whitespace,
    ACTIONS(3027), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3025), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7148] = 4,
    ACTIONS(109), 1,
      anon_sym_RBRACK,
    ACTIONS(1407), 1,
      sym__last_token_punctuation,
    ACTIONS(3033), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3031), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7209] = 3,
    ACTIONS(1284), 1,
      sym__last_token_punctuation,
    ACTIONS(3062), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(102), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7268] = 3,
    ACTIONS(2904), 1,
      sym__last_token_punctuation,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7327] = 3,
    ACTIONS(1225), 1,
      sym__last_token_punctuation,
    ACTIONS(3064), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(109), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7386] = 5,
    ACTIONS(1073), 1,
      sym__newline_token,
    ACTIONS(3066), 1,
      sym__last_token_whitespace,
    STATE(552), 1,
      sym__soft_line_break,
    ACTIONS(2977), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7449] = 6,
    ACTIONS(2906), 1,
      sym__newline_token,
    ACTIONS(2909), 1,
      sym__whitespace_ge_2,
    ACTIONS(2912), 1,
      aux_sym__whitespace_token1,
    STATE(785), 2,
      sym__whitespace,
      sym__soft_line_break,
    ACTIONS(2678), 6,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
    ACTIONS(2665), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
  [7514] = 2,
    ACTIONS(3070), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3068), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7570] = 2,
    ACTIONS(3074), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3072), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7626] = 2,
    ACTIONS(3078), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3076), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7682] = 2,
    ACTIONS(3082), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3080), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7738] = 2,
    ACTIONS(3086), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3084), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7794] = 2,
    ACTIONS(3090), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3088), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7850] = 2,
    ACTIONS(3094), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3092), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7906] = 2,
    ACTIONS(3098), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3096), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [7962] = 2,
    ACTIONS(3102), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3100), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8018] = 2,
    ACTIONS(3106), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3104), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8074] = 3,
    ACTIONS(3112), 1,
      sym__emphasis_close_star,
    ACTIONS(3110), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3108), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8132] = 3,
    ACTIONS(3119), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3117), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3115), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8190] = 2,
    ACTIONS(3124), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3122), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8246] = 2,
    ACTIONS(3128), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3126), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8302] = 2,
    ACTIONS(3132), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3130), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8358] = 4,
    ACTIONS(3053), 1,
      sym__last_token_punctuation,
    ACTIONS(3134), 1,
      anon_sym_LBRACK,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8418] = 3,
    ACTIONS(3136), 1,
      sym__emphasis_close_star,
    ACTIONS(3110), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3108), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8476] = 2,
    ACTIONS(3141), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3139), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8532] = 2,
    ACTIONS(3145), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3143), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8588] = 2,
    ACTIONS(3149), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3147), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8644] = 3,
    ACTIONS(3151), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3117), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3115), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8702] = 2,
    ACTIONS(3156), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3154), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8758] = 2,
    ACTIONS(3160), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3158), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8814] = 3,
    ACTIONS(3162), 1,
      sym__emphasis_close_star,
    ACTIONS(3110), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3108), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8872] = 2,
    ACTIONS(3167), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3165), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8928] = 2,
    ACTIONS(3171), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3169), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [8984] = 2,
    ACTIONS(3175), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3173), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9040] = 2,
    ACTIONS(3179), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3177), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9096] = 2,
    ACTIONS(3183), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3181), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9152] = 2,
    ACTIONS(3187), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3185), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9208] = 2,
    ACTIONS(3191), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3189), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9264] = 2,
    ACTIONS(3195), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3193), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9320] = 2,
    ACTIONS(3199), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3197), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9376] = 2,
    ACTIONS(3203), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3201), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9432] = 2,
    ACTIONS(3207), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3205), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9488] = 3,
    ACTIONS(3066), 1,
      sym__last_token_whitespace,
    ACTIONS(2977), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9546] = 2,
    ACTIONS(3203), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3201), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9602] = 2,
    ACTIONS(3211), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3209), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9658] = 3,
    ACTIONS(3213), 1,
      sym__emphasis_close_star,
    ACTIONS(3110), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3108), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9716] = 3,
    ACTIONS(3216), 1,
      sym__last_token_whitespace,
    ACTIONS(3027), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3025), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9774] = 2,
    ACTIONS(3220), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3218), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9830] = 4,
    ACTIONS(2973), 1,
      sym__last_token_punctuation,
    ACTIONS(3222), 1,
      anon_sym_LBRACK,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9890] = 2,
    ACTIONS(3226), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3224), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [9946] = 3,
    ACTIONS(3053), 1,
      sym__last_token_punctuation,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10004] = 2,
    ACTIONS(3195), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3193), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10060] = 3,
    ACTIONS(3228), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3117), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3115), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10118] = 2,
    ACTIONS(3179), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3177), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10174] = 2,
    ACTIONS(3233), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10230] = 2,
    ACTIONS(3237), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3235), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10286] = 2,
    ACTIONS(3241), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3239), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10342] = 2,
    ACTIONS(3245), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3243), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10398] = 2,
    ACTIONS(3207), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3205), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10454] = 3,
    ACTIONS(3249), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3252), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3247), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10512] = 2,
    ACTIONS(3175), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3173), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10568] = 2,
    ACTIONS(3171), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3169), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10624] = 3,
    ACTIONS(3254), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3117), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3115), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10682] = 2,
    ACTIONS(3117), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3115), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10738] = 2,
    ACTIONS(3259), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3257), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10794] = 2,
    ACTIONS(3110), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3108), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10850] = 3,
    ACTIONS(1407), 1,
      sym__last_token_punctuation,
    ACTIONS(3064), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(109), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10908] = 2,
    ACTIONS(3191), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3189), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [10964] = 2,
    ACTIONS(3187), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3185), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11020] = 4,
    ACTIONS(1407), 1,
      sym__last_token_punctuation,
    ACTIONS(3261), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3064), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(109), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11080] = 2,
    ACTIONS(3156), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3154), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11136] = 2,
    ACTIONS(3145), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3143), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11192] = 2,
    ACTIONS(3265), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3263), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11248] = 2,
    ACTIONS(3269), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3267), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11304] = 2,
    ACTIONS(3191), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3189), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11360] = 2,
    ACTIONS(3187), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3185), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11416] = 2,
    ACTIONS(3273), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3271), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11472] = 2,
    ACTIONS(3277), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3275), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11528] = 3,
    ACTIONS(3249), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3252), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3247), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11586] = 2,
    ACTIONS(3281), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3279), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11642] = 3,
    ACTIONS(3285), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3288), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3283), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11700] = 2,
    ACTIONS(3292), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3290), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11756] = 2,
    ACTIONS(3296), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3294), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11812] = 2,
    ACTIONS(3094), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3092), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11868] = 2,
    ACTIONS(3300), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3298), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11924] = 3,
    ACTIONS(3302), 1,
      sym__emphasis_close_star,
    ACTIONS(3110), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3108), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [11982] = 2,
    ACTIONS(3307), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3305), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12038] = 2,
    ACTIONS(3090), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3088), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12094] = 2,
    ACTIONS(3265), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3263), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12150] = 2,
    ACTIONS(3237), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3235), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12206] = 2,
    ACTIONS(3269), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3267), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12262] = 2,
    ACTIONS(3273), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3271), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12318] = 2,
    ACTIONS(3311), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12374] = 2,
    ACTIONS(3102), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3100), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12430] = 2,
    ACTIONS(3106), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3104), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12486] = 2,
    ACTIONS(3300), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3298), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12542] = 2,
    ACTIONS(3183), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3181), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12598] = 2,
    ACTIONS(3167), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3165), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12654] = 2,
    ACTIONS(3315), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3313), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12710] = 2,
    ACTIONS(3128), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3126), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12766] = 2,
    ACTIONS(3160), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3158), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12822] = 2,
    ACTIONS(3132), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3130), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12878] = 2,
    ACTIONS(3124), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3122), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12934] = 2,
    ACTIONS(3078), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3076), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [12990] = 2,
    ACTIONS(3319), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3317), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13046] = 2,
    ACTIONS(3323), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3321), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13102] = 2,
    ACTIONS(3327), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3325), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13158] = 2,
    ACTIONS(3090), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3088), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13214] = 3,
    ACTIONS(1407), 1,
      sym__last_token_punctuation,
    ACTIONS(3033), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3031), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13272] = 2,
    ACTIONS(3141), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3139), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13328] = 2,
    ACTIONS(3102), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3100), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13384] = 2,
    ACTIONS(3106), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3104), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13440] = 2,
    ACTIONS(3311), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13496] = 2,
    ACTIONS(3331), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3329), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13552] = 2,
    ACTIONS(3335), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3333), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13608] = 2,
    ACTIONS(3339), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3337), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13664] = 2,
    ACTIONS(3343), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3341), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13720] = 2,
    ACTIONS(3331), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3329), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13776] = 2,
    ACTIONS(3311), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13832] = 2,
    ACTIONS(3141), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3139), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13888] = 2,
    ACTIONS(3128), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3126), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [13944] = 2,
    ACTIONS(3343), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3341), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14000] = 2,
    ACTIONS(3339), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3337), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14056] = 2,
    ACTIONS(3335), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3333), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14112] = 2,
    ACTIONS(3347), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3345), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14168] = 2,
    ACTIONS(3070), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3068), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14224] = 2,
    ACTIONS(3347), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3345), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14280] = 2,
    ACTIONS(3351), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3349), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14336] = 2,
    ACTIONS(3351), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3349), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14392] = 2,
    ACTIONS(3265), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3263), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14448] = 2,
    ACTIONS(3355), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3353), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14504] = 2,
    ACTIONS(3098), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3096), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14560] = 2,
    ACTIONS(3094), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3092), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14616] = 2,
    ACTIONS(3296), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3294), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14672] = 2,
    ACTIONS(3277), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3275), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14728] = 2,
    ACTIONS(3355), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3353), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14784] = 2,
    ACTIONS(3098), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3096), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14840] = 2,
    ACTIONS(3327), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3325), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14896] = 2,
    ACTIONS(3323), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3321), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [14952] = 2,
    ACTIONS(3319), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3317), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15008] = 2,
    ACTIONS(3078), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3076), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15064] = 2,
    ACTIONS(3145), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3143), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15120] = 2,
    ACTIONS(3156), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3154), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15176] = 2,
    ACTIONS(3124), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3122), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15232] = 2,
    ACTIONS(3307), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3305), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15288] = 2,
    ACTIONS(3207), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3205), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15344] = 2,
    ACTIONS(3203), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3201), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15400] = 2,
    ACTIONS(3195), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3193), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15456] = 2,
    ACTIONS(3179), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3177), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15512] = 2,
    ACTIONS(3175), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3173), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15568] = 2,
    ACTIONS(3171), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3169), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15624] = 2,
    ACTIONS(3359), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3357), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15680] = 2,
    ACTIONS(3259), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3257), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15736] = 2,
    ACTIONS(3323), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3321), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15792] = 4,
    ACTIONS(3019), 1,
      sym__last_token_punctuation,
    ACTIONS(3361), 1,
      anon_sym_LBRACK,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15852] = 2,
    ACTIONS(3269), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3267), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15908] = 2,
    ACTIONS(3273), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3271), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [15964] = 2,
    ACTIONS(3132), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3130), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16020] = 2,
    ACTIONS(3365), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3363), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16076] = 2,
    ACTIONS(3082), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3080), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16132] = 2,
    ACTIONS(3327), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3325), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16188] = 2,
    ACTIONS(3292), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3290), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16244] = 2,
    ACTIONS(3319), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3317), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16300] = 2,
    ACTIONS(3277), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3275), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16356] = 3,
    ACTIONS(3249), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3252), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3247), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16414] = 2,
    ACTIONS(3281), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3279), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16470] = 3,
    ACTIONS(3285), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3288), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3283), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16528] = 2,
    ACTIONS(3292), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3290), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16584] = 2,
    ACTIONS(3082), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3080), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16640] = 3,
    ACTIONS(3285), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3288), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3283), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16698] = 2,
    ACTIONS(3307), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3305), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16754] = 2,
    ACTIONS(3241), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3239), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16810] = 2,
    ACTIONS(3237), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3235), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16866] = 2,
    ACTIONS(3233), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16922] = 2,
    ACTIONS(3226), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3224), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [16978] = 2,
    ACTIONS(3220), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3218), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17034] = 2,
    ACTIONS(3211), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3209), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17090] = 2,
    ACTIONS(3199), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3197), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17146] = 2,
    ACTIONS(3183), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3181), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17202] = 2,
    ACTIONS(3167), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3165), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17258] = 2,
    ACTIONS(3281), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3279), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17314] = 2,
    ACTIONS(3160), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3158), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17370] = 2,
    ACTIONS(3132), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3130), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17426] = 2,
    ACTIONS(3124), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3122), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17482] = 2,
    ACTIONS(3078), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3076), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17538] = 2,
    ACTIONS(3319), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3317), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17594] = 2,
    ACTIONS(3323), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3321), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17650] = 2,
    ACTIONS(3327), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3325), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17706] = 2,
    ACTIONS(3098), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3096), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17762] = 2,
    ACTIONS(3355), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3353), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17818] = 2,
    ACTIONS(3351), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3349), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17874] = 2,
    ACTIONS(3070), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3068), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17930] = 2,
    ACTIONS(3347), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3345), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [17986] = 2,
    ACTIONS(3335), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3333), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18042] = 2,
    ACTIONS(3339), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3337), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18098] = 2,
    ACTIONS(3343), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3341), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18154] = 2,
    ACTIONS(3331), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3329), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18210] = 2,
    ACTIONS(3311), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18266] = 2,
    ACTIONS(3141), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3139), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18322] = 2,
    ACTIONS(3128), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3126), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18378] = 2,
    ACTIONS(3160), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3158), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18434] = 2,
    ACTIONS(3331), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3329), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18490] = 2,
    ACTIONS(3199), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3197), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18546] = 2,
    ACTIONS(3211), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3209), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18602] = 2,
    ACTIONS(3220), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3218), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18658] = 2,
    ACTIONS(3106), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3104), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18714] = 2,
    ACTIONS(3102), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3100), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18770] = 2,
    ACTIONS(3226), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3224), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18826] = 2,
    ACTIONS(3300), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3298), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18882] = 2,
    ACTIONS(3090), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3088), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18938] = 2,
    ACTIONS(3300), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3298), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [18994] = 2,
    ACTIONS(3094), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3092), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19050] = 2,
    ACTIONS(3296), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3294), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19106] = 2,
    ACTIONS(3277), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3275), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19162] = 2,
    ACTIONS(3233), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19218] = 2,
    ACTIONS(3167), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3165), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19274] = 2,
    ACTIONS(3241), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3239), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19330] = 2,
    ACTIONS(3273), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3271), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19386] = 2,
    ACTIONS(3269), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3267), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19442] = 2,
    ACTIONS(3265), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3263), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19498] = 2,
    ACTIONS(3145), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3143), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19554] = 2,
    ACTIONS(3156), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3154), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19610] = 2,
    ACTIONS(3187), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3185), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19666] = 2,
    ACTIONS(3191), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3189), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19722] = 2,
    ACTIONS(3207), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3205), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19778] = 2,
    ACTIONS(3203), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3201), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19834] = 2,
    ACTIONS(3195), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3193), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19890] = 2,
    ACTIONS(3179), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3177), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [19946] = 2,
    ACTIONS(3175), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3173), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20002] = 2,
    ACTIONS(3171), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3169), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20058] = 2,
    ACTIONS(3259), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3257), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20114] = 2,
    ACTIONS(3259), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3257), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20170] = 4,
    ACTIONS(2971), 1,
      sym__last_token_punctuation,
    ACTIONS(3367), 1,
      anon_sym_LBRACK,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20230] = 2,
    ACTIONS(3355), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3353), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20286] = 2,
    ACTIONS(3351), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3349), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20342] = 2,
    ACTIONS(3296), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3294), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20398] = 2,
    ACTIONS(3070), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3068), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20454] = 2,
    ACTIONS(3347), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3345), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20510] = 2,
    ACTIONS(3183), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3181), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20566] = 2,
    ACTIONS(3335), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3333), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20622] = 3,
    ACTIONS(3369), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3117), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3115), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20680] = 2,
    ACTIONS(3339), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3337), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20736] = 4,
    ACTIONS(3053), 1,
      sym__last_token_punctuation,
    ACTIONS(3372), 1,
      anon_sym_LBRACK,
    ACTIONS(2678), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20796] = 3,
    ACTIONS(3249), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3252), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3247), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20854] = 2,
    ACTIONS(3281), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3279), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20910] = 3,
    ACTIONS(3285), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3288), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3283), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [20968] = 2,
    ACTIONS(3292), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3290), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21024] = 2,
    ACTIONS(3082), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3080), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21080] = 2,
    ACTIONS(3343), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3341), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      ts_builtin_sym_end,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21136] = 2,
    ACTIONS(3307), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3305), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21192] = 2,
    ACTIONS(3241), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3239), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21248] = 2,
    ACTIONS(3237), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3235), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21304] = 2,
    ACTIONS(3233), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21360] = 2,
    ACTIONS(3226), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3224), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21416] = 2,
    ACTIONS(3220), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3218), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21472] = 2,
    ACTIONS(3211), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3209), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21528] = 2,
    ACTIONS(3199), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3197), 44,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21584] = 2,
    ACTIONS(3156), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3154), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21639] = 2,
    ACTIONS(3207), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3205), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21694] = 2,
    ACTIONS(3183), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3181), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21749] = 2,
    ACTIONS(3167), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3165), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21804] = 4,
    ACTIONS(3285), 1,
      anon_sym_LPAREN,
    ACTIONS(3375), 1,
      anon_sym_LBRACK,
    ACTIONS(3288), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3283), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21863] = 2,
    ACTIONS(3160), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3158), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21918] = 2,
    ACTIONS(3132), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3130), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [21973] = 2,
    ACTIONS(3124), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3122), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22028] = 2,
    ACTIONS(3078), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3076), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22083] = 2,
    ACTIONS(3319), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3317), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22138] = 2,
    ACTIONS(3323), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3321), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22193] = 2,
    ACTIONS(3327), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3325), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22248] = 2,
    ACTIONS(3191), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3189), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22303] = 2,
    ACTIONS(3335), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3333), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22358] = 2,
    ACTIONS(3339), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3337), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22413] = 2,
    ACTIONS(3343), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3341), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22468] = 2,
    ACTIONS(3331), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3329), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22523] = 2,
    ACTIONS(3311), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3309), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22578] = 2,
    ACTIONS(3141), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3139), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22633] = 2,
    ACTIONS(3128), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3126), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22688] = 2,
    ACTIONS(3187), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3185), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22743] = 2,
    ACTIONS(3265), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3263), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22798] = 2,
    ACTIONS(3307), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3305), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22853] = 2,
    ACTIONS(3094), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3092), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22908] = 2,
    ACTIONS(3296), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3294), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [22963] = 2,
    ACTIONS(3277), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3275), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23018] = 2,
    ACTIONS(3245), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3243), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23073] = 2,
    ACTIONS(3359), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3357), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23128] = 2,
    ACTIONS(3365), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3363), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23183] = 2,
    ACTIONS(3145), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3143), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23238] = 3,
    ACTIONS(3249), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3252), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3247), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23295] = 2,
    ACTIONS(3237), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3235), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23350] = 4,
    ACTIONS(3285), 1,
      anon_sym_LPAREN,
    ACTIONS(3375), 1,
      anon_sym_LBRACK,
    ACTIONS(3288), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3283), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23409] = 2,
    ACTIONS(3203), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3201), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23464] = 2,
    ACTIONS(3195), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3193), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23519] = 2,
    ACTIONS(3273), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3271), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23574] = 2,
    ACTIONS(3179), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3177), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23629] = 2,
    ACTIONS(3175), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3173), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23684] = 2,
    ACTIONS(3171), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3169), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23739] = 2,
    ACTIONS(3269), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3267), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23794] = 2,
    ACTIONS(3082), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3080), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23849] = 2,
    ACTIONS(3241), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3239), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23904] = 2,
    ACTIONS(3233), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [23959] = 2,
    ACTIONS(3226), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3224), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24014] = 2,
    ACTIONS(3220), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3218), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24069] = 2,
    ACTIONS(3259), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3257), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24124] = 2,
    ACTIONS(3211), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3209), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24179] = 3,
    ACTIONS(3285), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(3288), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3283), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24236] = 2,
    ACTIONS(3199), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3197), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24291] = 2,
    ACTIONS(3098), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3096), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24346] = 2,
    ACTIONS(3355), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3353), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24401] = 2,
    ACTIONS(3351), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3349), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24456] = 2,
    ACTIONS(3070), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3068), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24511] = 2,
    ACTIONS(3347), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3345), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24566] = 2,
    ACTIONS(3106), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3104), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24621] = 2,
    ACTIONS(3102), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3100), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24676] = 2,
    ACTIONS(3090), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3088), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24731] = 4,
    ACTIONS(3285), 1,
      anon_sym_LPAREN,
    ACTIONS(3375), 1,
      anon_sym_LBRACK,
    ACTIONS(3288), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3283), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24790] = 2,
    ACTIONS(3281), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3279), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24845] = 4,
    ACTIONS(3285), 1,
      anon_sym_LPAREN,
    ACTIONS(3375), 1,
      anon_sym_LBRACK,
    ACTIONS(3288), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3283), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24904] = 2,
    ACTIONS(3292), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3290), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [24959] = 2,
    ACTIONS(3300), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3298), 43,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25014] = 2,
    ACTIONS(3379), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3377), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25068] = 3,
    ACTIONS(3385), 1,
      sym__emphasis_close_star,
    ACTIONS(3383), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3381), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25124] = 2,
    ACTIONS(3379), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3377), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25178] = 2,
    ACTIONS(3389), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3387), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25232] = 2,
    ACTIONS(3393), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3391), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25286] = 2,
    ACTIONS(3397), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3395), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25340] = 2,
    ACTIONS(3401), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3399), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25394] = 2,
    ACTIONS(3405), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3403), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25448] = 2,
    ACTIONS(3409), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3407), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25502] = 2,
    ACTIONS(3409), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3407), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25556] = 2,
    ACTIONS(3389), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3387), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25610] = 2,
    ACTIONS(3379), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3377), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25664] = 2,
    ACTIONS(3413), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3411), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25718] = 2,
    ACTIONS(3413), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3411), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25772] = 2,
    ACTIONS(3405), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3403), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25826] = 2,
    ACTIONS(3401), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3399), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25880] = 2,
    ACTIONS(3397), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3395), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25934] = 2,
    ACTIONS(3393), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3391), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [25988] = 2,
    ACTIONS(3417), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3415), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26042] = 2,
    ACTIONS(3379), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3377), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26096] = 2,
    ACTIONS(3389), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3387), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26150] = 3,
    ACTIONS(3419), 1,
      sym__emphasis_close_star,
    ACTIONS(3383), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3381), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26206] = 2,
    ACTIONS(3383), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3381), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26260] = 3,
    ACTIONS(3425), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3423), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3421), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26316] = 2,
    ACTIONS(3389), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3387), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26370] = 2,
    ACTIONS(3423), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3421), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26424] = 2,
    ACTIONS(3413), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3411), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26478] = 3,
    ACTIONS(3427), 1,
      sym__emphasis_close_star,
    ACTIONS(3383), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3381), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26534] = 3,
    ACTIONS(3429), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3423), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3421), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26590] = 3,
    ACTIONS(3431), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3423), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3421), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26646] = 2,
    ACTIONS(3435), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3433), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26700] = 2,
    ACTIONS(3413), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3411), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__strikethrough_close,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26754] = 2,
    ACTIONS(3405), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3403), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26808] = 2,
    ACTIONS(3401), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3399), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26862] = 2,
    ACTIONS(3397), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3395), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26916] = 2,
    ACTIONS(3393), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3391), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [26970] = 2,
    ACTIONS(3409), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3407), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__emphasis_close_star,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27024] = 3,
    ACTIONS(3437), 1,
      sym__emphasis_close_underscore,
    ACTIONS(3423), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3421), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27080] = 3,
    ACTIONS(3439), 1,
      sym__emphasis_close_star,
    ACTIONS(3383), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3381), 41,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27136] = 2,
    ACTIONS(3443), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3441), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27190] = 2,
    ACTIONS(3405), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3403), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27244] = 2,
    ACTIONS(3401), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3399), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27298] = 2,
    ACTIONS(3397), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3395), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27352] = 2,
    ACTIONS(3393), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3391), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27406] = 2,
    ACTIONS(3409), 7,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      aux_sym__whitespace_token1,
    ACTIONS(3407), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__strikethrough_open,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym_uri_autolink,
      sym_email_autolink,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [27460] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3461), 1,
      anon_sym_RPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    STATE(1004), 1,
      sym_link_title,
    STATE(1007), 1,
      sym_link_destination,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(647), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [27541] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3469), 1,
      anon_sym_RPAREN,
    STATE(1003), 1,
      sym_link_title,
    STATE(1005), 1,
      sym_link_destination,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(646), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [27622] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3471), 1,
      anon_sym_RPAREN,
    STATE(967), 1,
      sym_link_destination,
    STATE(975), 1,
      sym_link_title,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(638), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [27703] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3473), 1,
      anon_sym_RPAREN,
    STATE(1001), 1,
      sym_link_title,
    STATE(1015), 1,
      sym_link_destination,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(645), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [27784] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3475), 1,
      anon_sym_RPAREN,
    STATE(928), 1,
      sym_link_destination,
    STATE(929), 1,
      sym_link_title,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(642), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [27865] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3477), 1,
      anon_sym_RPAREN,
    STATE(1009), 1,
      sym_link_destination,
    STATE(1010), 1,
      sym_link_title,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(693), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [27946] = 15,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3485), 1,
      anon_sym_SQUOTE,
    ACTIONS(3487), 1,
      anon_sym_LPAREN,
    ACTIONS(3489), 1,
      anon_sym_RPAREN,
    ACTIONS(3492), 1,
      sym__newline_token,
    ACTIONS(3495), 1,
      sym__whitespace_ge_2,
    ACTIONS(3498), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3501), 1,
      sym__last_token_punctuation,
    STATE(796), 1,
      sym__soft_line_break,
    ACTIONS(3483), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(664), 2,
      sym__whitespace,
      aux_sym_link_title_repeat2,
    STATE(673), 2,
      sym__link_destination_parenthesis,
      aux_sym_link_destination_repeat2,
    STATE(808), 2,
      sym_backslash_escape,
      sym__word,
    ACTIONS(3479), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3481), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [28025] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3503), 1,
      anon_sym_RPAREN,
    STATE(919), 1,
      sym_link_title,
    STATE(1006), 1,
      sym_link_destination,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(693), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [28106] = 15,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3485), 1,
      anon_sym_DQUOTE,
    ACTIONS(3492), 1,
      sym__newline_token,
    ACTIONS(3495), 1,
      sym__whitespace_ge_2,
    ACTIONS(3498), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3501), 1,
      sym__last_token_punctuation,
    ACTIONS(3511), 1,
      anon_sym_LPAREN,
    ACTIONS(3513), 1,
      anon_sym_RPAREN,
    STATE(792), 1,
      sym__soft_line_break,
    ACTIONS(3509), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(665), 2,
      sym__whitespace,
      aux_sym_link_title_repeat1,
    STATE(673), 2,
      sym__link_destination_parenthesis,
      aux_sym_link_destination_repeat2,
    STATE(809), 2,
      sym_backslash_escape,
      sym__word,
    ACTIONS(3505), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3507), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [28185] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3516), 1,
      anon_sym_RPAREN,
    STATE(948), 1,
      sym_link_destination,
    STATE(949), 1,
      sym_link_title,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(693), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [28266] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3518), 1,
      anon_sym_RPAREN,
    STATE(1031), 1,
      sym_link_title,
    STATE(1032), 1,
      sym_link_destination,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(693), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [28347] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3520), 1,
      anon_sym_RPAREN,
    STATE(931), 1,
      sym_link_destination,
    STATE(932), 1,
      sym_link_title,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(637), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [28428] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3522), 1,
      anon_sym_RPAREN,
    STATE(996), 1,
      sym_link_destination,
    STATE(997), 1,
      sym_link_title,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(633), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [28509] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3524), 1,
      anon_sym_RPAREN,
    STATE(999), 1,
      sym_link_destination,
    STATE(1000), 1,
      sym_link_title,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(643), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [28590] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3526), 1,
      anon_sym_RPAREN,
    STATE(918), 1,
      sym_link_title,
    STATE(944), 1,
      sym_link_destination,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(693), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [28671] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3528), 1,
      anon_sym_RPAREN,
    STATE(1013), 1,
      sym_link_destination,
    STATE(1014), 1,
      sym_link_title,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(693), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [28752] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3530), 1,
      anon_sym_RPAREN,
    STATE(983), 1,
      sym_link_title,
    STATE(984), 1,
      sym_link_destination,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(693), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [28833] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3532), 1,
      anon_sym_RPAREN,
    STATE(982), 1,
      sym_link_destination,
    STATE(985), 1,
      sym_link_title,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(693), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [28914] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3534), 1,
      anon_sym_RPAREN,
    STATE(993), 1,
      sym_link_destination,
    STATE(995), 1,
      sym_link_title,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(693), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [28995] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3536), 1,
      anon_sym_RPAREN,
    STATE(977), 1,
      sym_link_title,
    STATE(979), 1,
      sym_link_destination,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    STATE(693), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [29076] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3538), 1,
      anon_sym_RPAREN,
    STATE(1011), 1,
      sym_link_title,
    STATE(1018), 1,
      sym_link_destination,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(644), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [29157] = 16,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3451), 1,
      anon_sym_LT,
    ACTIONS(3453), 1,
      anon_sym_DQUOTE,
    ACTIONS(3457), 1,
      anon_sym_SQUOTE,
    ACTIONS(3459), 1,
      anon_sym_LPAREN,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3540), 1,
      anon_sym_RPAREN,
    STATE(976), 1,
      sym_link_destination,
    STATE(978), 1,
      sym_link_title,
    ACTIONS(3455), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(635), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    STATE(677), 3,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
    ACTIONS(3447), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3449), 25,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [29238] = 9,
    ACTIONS(2716), 1,
      sym__newline_token,
    ACTIONS(2721), 1,
      sym__whitespace_ge_2,
    ACTIONS(2724), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3542), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(2710), 2,
      anon_sym_RBRACK,
      anon_sym_LT,
    ACTIONS(3544), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(758), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 5,
      sym__code_span_close,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2713), 30,
      anon_sym_LBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [29304] = 3,
    ACTIONS(3547), 1,
      sym__last_token_punctuation,
    ACTIONS(2678), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [29358] = 13,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3555), 1,
      anon_sym_LPAREN,
    ACTIONS(3557), 1,
      anon_sym_RPAREN,
    STATE(811), 1,
      sym__soft_line_break,
    ACTIONS(3553), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(675), 2,
      sym__whitespace,
      aux_sym_link_title_repeat3,
    STATE(799), 2,
      sym__link_destination_parenthesis,
      aux_sym_link_destination_repeat2,
    STATE(806), 2,
      sym_backslash_escape,
      sym__word,
    ACTIONS(3549), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(3551), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [29432] = 3,
    ACTIONS(3559), 1,
      sym__last_token_whitespace,
    ACTIONS(3027), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3025), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [29486] = 3,
    ACTIONS(3561), 1,
      sym__last_token_whitespace,
    ACTIONS(2977), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [29540] = 9,
    ACTIONS(2675), 1,
      sym__newline_token,
    ACTIONS(2682), 1,
      sym__whitespace_ge_2,
    ACTIONS(2685), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3563), 1,
      anon_sym_QMARK_GT,
    ACTIONS(2669), 2,
      anon_sym_LT,
      anon_sym_QMARK,
    ACTIONS(3565), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(756), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2665), 5,
      sym__code_span_close,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(2672), 30,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [29606] = 10,
    ACTIONS(2759), 1,
      sym__newline_token,
    ACTIONS(2764), 1,
      sym__whitespace_ge_2,
    ACTIONS(2767), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3571), 1,
      anon_sym_LT,
    ACTIONS(3574), 1,
      anon_sym_DASH,
    ACTIONS(3577), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3579), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(755), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(2665), 6,
      sym__code_span_close,
      anon_sym_GT,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
    ACTIONS(3568), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [29673] = 2,
    ACTIONS(3241), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3239), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [29724] = 2,
    ACTIONS(3259), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3257), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [29775] = 2,
    ACTIONS(3233), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [29826] = 2,
    ACTIONS(3199), 4,
      anon_sym_LT,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3197), 42,
      sym__code_span_start,
      sym__emphasis_open_star,
      sym__emphasis_open_underscore,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [29877] = 10,
    ACTIONS(3582), 1,
      sym__backslash_escape,
    ACTIONS(3594), 1,
      anon_sym_SQUOTE,
    ACTIONS(3596), 1,
      sym__newline_token,
    ACTIONS(3599), 1,
      sym__whitespace_ge_2,
    ACTIONS(3602), 1,
      aux_sym__whitespace_token1,
    STATE(796), 1,
      sym__soft_line_break,
    ACTIONS(3591), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3585), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(661), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat2,
    ACTIONS(3588), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [29943] = 10,
    ACTIONS(3605), 1,
      sym__backslash_escape,
    ACTIONS(3617), 1,
      anon_sym_LPAREN,
    ACTIONS(3620), 1,
      anon_sym_RPAREN,
    ACTIONS(3625), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3627), 1,
      sym__last_token_punctuation,
    ACTIONS(3614), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3623), 2,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3608), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(799), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3611), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30009] = 10,
    ACTIONS(3629), 1,
      sym__backslash_escape,
    ACTIONS(3641), 1,
      anon_sym_LPAREN,
    ACTIONS(3644), 1,
      anon_sym_RPAREN,
    ACTIONS(3649), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3651), 1,
      sym__last_token_punctuation,
    ACTIONS(3638), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3647), 2,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3632), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(799), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3635), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30075] = 10,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3659), 1,
      anon_sym_SQUOTE,
    STATE(796), 1,
      sym__soft_line_break,
    ACTIONS(3657), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3653), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(661), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat2,
    ACTIONS(3655), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [30141] = 10,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3659), 1,
      anon_sym_DQUOTE,
    STATE(792), 1,
      sym__soft_line_break,
    ACTIONS(3665), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3661), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(667), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat1,
    ACTIONS(3663), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [30207] = 9,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3501), 1,
      sym__last_token_punctuation,
    ACTIONS(3555), 1,
      anon_sym_LPAREN,
    ACTIONS(3675), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3671), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3673), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3667), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(673), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3669), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30271] = 10,
    ACTIONS(3677), 1,
      sym__backslash_escape,
    ACTIONS(3686), 1,
      anon_sym_DQUOTE,
    ACTIONS(3691), 1,
      sym__newline_token,
    ACTIONS(3694), 1,
      sym__whitespace_ge_2,
    ACTIONS(3697), 1,
      aux_sym__whitespace_token1,
    STATE(792), 1,
      sym__soft_line_break,
    ACTIONS(3688), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3680), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(667), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat1,
    ACTIONS(3683), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [30337] = 10,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3702), 1,
      anon_sym_SQUOTE,
    STATE(796), 1,
      sym__soft_line_break,
    ACTIONS(3657), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3700), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(664), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat2,
    ACTIONS(3655), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [30403] = 10,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3702), 1,
      anon_sym_DQUOTE,
    STATE(792), 1,
      sym__soft_line_break,
    ACTIONS(3665), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3704), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(665), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat1,
    ACTIONS(3663), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [30469] = 10,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3702), 1,
      anon_sym_RPAREN,
    STATE(811), 1,
      sym__soft_line_break,
    ACTIONS(3710), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3706), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(675), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat3,
    ACTIONS(3708), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30534] = 8,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3555), 1,
      anon_sym_LPAREN,
    ACTIONS(3716), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3671), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3714), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3712), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(679), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3669), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30595] = 10,
    ACTIONS(3718), 1,
      sym__backslash_escape,
    ACTIONS(3730), 1,
      anon_sym_RPAREN,
    ACTIONS(3732), 1,
      sym__newline_token,
    ACTIONS(3735), 1,
      sym__whitespace_ge_2,
    ACTIONS(3738), 1,
      aux_sym__whitespace_token1,
    STATE(811), 1,
      sym__soft_line_break,
    ACTIONS(3727), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3721), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(672), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat3,
    ACTIONS(3724), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30660] = 8,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3555), 1,
      anon_sym_LPAREN,
    ACTIONS(3743), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3671), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3741), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3712), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(679), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3669), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30721] = 8,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3555), 1,
      anon_sym_LPAREN,
    ACTIONS(3743), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3671), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3741), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3745), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(671), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3669), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30782] = 10,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3463), 1,
      sym__newline_token,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3659), 1,
      anon_sym_RPAREN,
    STATE(811), 1,
      sym__soft_line_break,
    ACTIONS(3710), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3747), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(672), 4,
      sym_backslash_escape,
      sym__whitespace,
      sym__word,
      aux_sym_link_title_repeat3,
    ACTIONS(3708), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30847] = 6,
    ACTIONS(2678), 1,
      anon_sym_LT,
    ACTIONS(2906), 1,
      sym__newline_token,
    ACTIONS(2909), 1,
      sym__whitespace_ge_2,
    ACTIONS(2912), 1,
      aux_sym__whitespace_token1,
    STATE(774), 2,
      sym__whitespace,
      sym__soft_line_break,
    ACTIONS(2665), 38,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__word_no_digit,
      sym__digits,
  [30904] = 8,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3555), 1,
      anon_sym_LPAREN,
    ACTIONS(3675), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3671), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3673), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3667), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(673), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3669), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [30965] = 6,
    ACTIONS(2941), 1,
      sym__word_no_digit,
    ACTIONS(3749), 1,
      anon_sym_SLASH,
    ACTIONS(3752), 1,
      sym__last_token_punctuation,
    STATE(889), 1,
      sym__tag_name,
    ACTIONS(2678), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 38,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__digits,
  [31022] = 8,
    ACTIONS(3754), 1,
      sym__backslash_escape,
    ACTIONS(3766), 1,
      anon_sym_LPAREN,
    ACTIONS(3771), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3763), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3769), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(3757), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(679), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3760), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [31083] = 3,
    ACTIONS(3752), 1,
      sym__last_token_punctuation,
    ACTIONS(2678), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(2665), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [31133] = 8,
    ACTIONS(3773), 1,
      sym__backslash_escape,
    ACTIONS(3782), 1,
      anon_sym_GT,
    ACTIONS(3787), 1,
      sym__whitespace_ge_2,
    ACTIONS(3790), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3784), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3776), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(681), 5,
      sym_backslash_escape,
      sym__text_no_angle,
      sym__whitespace,
      sym__word,
      aux_sym_link_destination_repeat1,
    ACTIONS(3779), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31193] = 9,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3799), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3807), 1,
      sym__last_token_punctuation,
    ACTIONS(3805), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(726), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31255] = 9,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3809), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3813), 1,
      sym__last_token_punctuation,
    ACTIONS(3811), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(739), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31317] = 8,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3819), 1,
      anon_sym_GT,
    ACTIONS(3821), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3815), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(691), 5,
      sym_backslash_escape,
      sym__text_no_angle,
      sym__whitespace,
      sym__word,
      aux_sym_link_destination_repeat1,
    ACTIONS(3817), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31377] = 9,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3823), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3827), 1,
      sym__last_token_punctuation,
    ACTIONS(3825), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(704), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31439] = 9,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3829), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3833), 1,
      sym__last_token_punctuation,
    ACTIONS(3831), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(733), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31501] = 3,
    ACTIONS(3835), 1,
      sym__last_token_whitespace,
    ACTIONS(3027), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3025), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [31551] = 9,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3837), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3841), 1,
      sym__last_token_punctuation,
    ACTIONS(3839), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(724), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31613] = 9,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3843), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3847), 1,
      sym__last_token_punctuation,
    ACTIONS(3845), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(747), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31675] = 9,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3849), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3853), 1,
      sym__last_token_punctuation,
    ACTIONS(3851), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(720), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31737] = 8,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3465), 1,
      sym__whitespace_ge_2,
    ACTIONS(3467), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3857), 1,
      anon_sym_GT,
    ACTIONS(3821), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3855), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(681), 5,
      sym_backslash_escape,
      sym__text_no_angle,
      sym__whitespace,
      sym__word,
      aux_sym_link_destination_repeat1,
    ACTIONS(3817), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31797] = 3,
    ACTIONS(3859), 1,
      sym__last_token_whitespace,
    ACTIONS(2977), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [31847] = 6,
    ACTIONS(3865), 1,
      sym__newline_token,
    ACTIONS(3868), 1,
      sym__whitespace_ge_2,
    ACTIONS(3871), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3863), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    STATE(693), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3861), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__word_no_digit,
      sym__digits,
  [31903] = 9,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3874), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3878), 1,
      sym__last_token_punctuation,
    ACTIONS(3876), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(732), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [31965] = 9,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3880), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3884), 1,
      sym__last_token_punctuation,
    ACTIONS(3882), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(717), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32027] = 9,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3886), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3890), 1,
      sym__last_token_punctuation,
    ACTIONS(3888), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(709), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32089] = 9,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3892), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3896), 1,
      sym__last_token_punctuation,
    ACTIONS(3894), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(737), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32151] = 9,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3898), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3902), 1,
      sym__last_token_punctuation,
    ACTIONS(3900), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(766), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32213] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3904), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3906), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(706), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32272] = 2,
    ACTIONS(3241), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3239), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [32319] = 8,
    ACTIONS(3908), 1,
      anon_sym_QMARK,
    ACTIONS(3910), 1,
      sym__newline_token,
    ACTIONS(3912), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3914), 1,
      sym__whitespace_ge_2,
    ACTIONS(3916), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3918), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(770), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2667), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32378] = 8,
    ACTIONS(3908), 1,
      anon_sym_QMARK,
    ACTIONS(3910), 1,
      sym__newline_token,
    ACTIONS(3914), 1,
      sym__whitespace_ge_2,
    ACTIONS(3916), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3920), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3918), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(770), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2667), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32437] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3886), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3888), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(709), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32496] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3904), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32555] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3809), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3811), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(739), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32614] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3924), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32673] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3880), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3882), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(717), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32732] = 8,
    ACTIONS(3908), 1,
      anon_sym_QMARK,
    ACTIONS(3910), 1,
      sym__newline_token,
    ACTIONS(3914), 1,
      sym__whitespace_ge_2,
    ACTIONS(3916), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3926), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3918), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(770), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2667), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32791] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3874), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32850] = 2,
    ACTIONS(3191), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3189), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [32897] = 8,
    ACTIONS(2708), 1,
      anon_sym_RBRACK,
    ACTIONS(3928), 1,
      sym__newline_token,
    ACTIONS(3930), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(3932), 1,
      sym__whitespace_ge_2,
    ACTIONS(3934), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3936), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(767), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2706), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [32956] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3898), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3900), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(766), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33015] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3837), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3839), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(724), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33074] = 8,
    ACTIONS(3908), 1,
      anon_sym_QMARK,
    ACTIONS(3910), 1,
      sym__newline_token,
    ACTIONS(3914), 1,
      sym__whitespace_ge_2,
    ACTIONS(3916), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3938), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3918), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(770), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2667), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33133] = 8,
    ACTIONS(2708), 1,
      anon_sym_RBRACK,
    ACTIONS(3928), 1,
      sym__newline_token,
    ACTIONS(3932), 1,
      sym__whitespace_ge_2,
    ACTIONS(3934), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3940), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(3936), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(767), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2706), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33192] = 2,
    ACTIONS(3187), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3185), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [33239] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3837), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33298] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3942), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33357] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3944), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3946), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(718), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33416] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3944), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33475] = 2,
    ACTIONS(3265), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3263), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [33522] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3948), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33581] = 2,
    ACTIONS(3269), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3267), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [33628] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3950), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33687] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3952), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3954), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(722), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33746] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3952), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33805] = 2,
    ACTIONS(3273), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3271), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [33852] = 8,
    ACTIONS(2708), 1,
      anon_sym_RBRACK,
    ACTIONS(3928), 1,
      sym__newline_token,
    ACTIONS(3932), 1,
      sym__whitespace_ge_2,
    ACTIONS(3934), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3956), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(3936), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(767), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2706), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [33911] = 2,
    ACTIONS(3300), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3298), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [33958] = 2,
    ACTIONS(3090), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3088), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [34005] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3874), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3876), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(732), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34064] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3958), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34123] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3823), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34182] = 2,
    ACTIONS(3102), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3100), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [34229] = 2,
    ACTIONS(3106), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3104), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [34276] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3958), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3960), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(768), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34335] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3849), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34394] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3962), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34453] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3799), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34512] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3799), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3805), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(726), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34571] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3950), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3964), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(746), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34630] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3966), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3968), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(738), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34689] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3849), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3851), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(720), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34748] = 8,
    ACTIONS(3973), 1,
      anon_sym_DASH,
    ACTIONS(3976), 1,
      sym__newline_token,
    ACTIONS(3979), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3981), 1,
      sym__whitespace_ge_2,
    ACTIONS(3984), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3987), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3970), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34807] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3823), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3825), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(704), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34866] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3990), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34925] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3966), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [34984] = 8,
    ACTIONS(2708), 1,
      anon_sym_RBRACK,
    ACTIONS(3928), 1,
      sym__newline_token,
    ACTIONS(3932), 1,
      sym__whitespace_ge_2,
    ACTIONS(3934), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3992), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(3936), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(767), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2706), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35043] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3843), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3845), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(747), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35102] = 2,
    ACTIONS(3082), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3080), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35149] = 8,
    ACTIONS(2708), 1,
      anon_sym_RBRACK,
    ACTIONS(3928), 1,
      sym__newline_token,
    ACTIONS(3932), 1,
      sym__whitespace_ge_2,
    ACTIONS(3934), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3994), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(3936), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(767), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2706), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35208] = 2,
    ACTIONS(3233), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35255] = 2,
    ACTIONS(3226), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3224), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35302] = 8,
    ACTIONS(3908), 1,
      anon_sym_QMARK,
    ACTIONS(3910), 1,
      sym__newline_token,
    ACTIONS(3914), 1,
      sym__whitespace_ge_2,
    ACTIONS(3916), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3996), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3918), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(770), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2667), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35361] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3892), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3894), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(737), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35420] = 8,
    ACTIONS(3908), 1,
      anon_sym_QMARK,
    ACTIONS(3910), 1,
      sym__newline_token,
    ACTIONS(3914), 1,
      sym__whitespace_ge_2,
    ACTIONS(3916), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3998), 1,
      anon_sym_QMARK_GT,
    ACTIONS(3918), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(770), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2667), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35479] = 2,
    ACTIONS(3347), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3345), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35526] = 8,
    ACTIONS(2708), 1,
      anon_sym_RBRACK,
    ACTIONS(3928), 1,
      sym__newline_token,
    ACTIONS(3932), 1,
      sym__whitespace_ge_2,
    ACTIONS(3934), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4000), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(3936), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(767), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(2706), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35585] = 2,
    ACTIONS(3220), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3218), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35632] = 2,
    ACTIONS(3211), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3209), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35679] = 2,
    ACTIONS(3199), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3197), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35726] = 2,
    ACTIONS(3098), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3096), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35773] = 2,
    ACTIONS(3355), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3353), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35820] = 2,
    ACTIONS(3351), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3349), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [35867] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3829), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3831), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(733), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35926] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3843), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [35985] = 8,
    ACTIONS(4005), 1,
      anon_sym_RBRACK,
    ACTIONS(4008), 1,
      sym__newline_token,
    ACTIONS(4011), 1,
      anon_sym_RBRACK_RBRACK_GT,
    ACTIONS(4013), 1,
      sym__whitespace_ge_2,
    ACTIONS(4016), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4019), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(767), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(4002), 31,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36044] = 8,
    ACTIONS(3795), 1,
      anon_sym_DASH,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4022), 1,
      anon_sym_DASH_DASH_GT,
    ACTIONS(3922), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(744), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__html_comment_repeat1,
    ACTIONS(3793), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36103] = 2,
    ACTIONS(3070), 2,
      anon_sym_LT,
      aux_sym__whitespace_token1,
    ACTIONS(3068), 40,
      sym__code_span_close,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_LT_BANG_DASH_DASH,
      anon_sym_LT_QMARK,
      aux_sym__declaration_token1,
      anon_sym_LT_BANG_LBRACKCDATA_LBRACK,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [36150] = 8,
    ACTIONS(4011), 1,
      anon_sym_QMARK_GT,
    ACTIONS(4027), 1,
      anon_sym_QMARK,
    ACTIONS(4030), 1,
      sym__newline_token,
    ACTIONS(4033), 1,
      sym__whitespace_ge_2,
    ACTIONS(4036), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4039), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(770), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__processing_instruction_repeat1,
    ACTIONS(4024), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36209] = 7,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3555), 1,
      anon_sym_LPAREN,
    ACTIONS(4044), 1,
      anon_sym_RPAREN,
    ACTIONS(3671), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(4042), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(799), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3669), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [36265] = 7,
    ACTIONS(4048), 1,
      anon_sym_GT,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4056), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(778), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4046), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36321] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4060), 1,
      anon_sym_DQUOTE,
    ACTIONS(4062), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(801), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__attribute_value_repeat2,
    ACTIONS(4058), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36377] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4064), 1,
      anon_sym_GT,
    ACTIONS(4066), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(779), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4046), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36433] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4068), 1,
      anon_sym_GT,
    ACTIONS(4070), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(782), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4046), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36489] = 7,
    ACTIONS(4075), 1,
      anon_sym_SQUOTE,
    ACTIONS(4077), 1,
      sym__newline_token,
    ACTIONS(4080), 1,
      sym__whitespace_ge_2,
    ACTIONS(4083), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4086), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(776), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__attribute_value_repeat1,
    ACTIONS(4072), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36545] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4089), 1,
      anon_sym_GT,
    ACTIONS(4091), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(772), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4046), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36601] = 7,
    ACTIONS(4096), 1,
      anon_sym_GT,
    ACTIONS(4098), 1,
      sym__newline_token,
    ACTIONS(4101), 1,
      sym__whitespace_ge_2,
    ACTIONS(4104), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4107), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(778), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4093), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36657] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4110), 1,
      anon_sym_GT,
    ACTIONS(4056), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(778), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4046), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36713] = 3,
    ACTIONS(4112), 1,
      sym__last_token_whitespace,
    ACTIONS(2977), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [36761] = 3,
    ACTIONS(4114), 1,
      sym__last_token_whitespace,
    ACTIONS(3027), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3025), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [36809] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4116), 1,
      anon_sym_GT,
    ACTIONS(4056), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(778), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4046), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36865] = 7,
    ACTIONS(4121), 1,
      anon_sym_DQUOTE,
    ACTIONS(4123), 1,
      sym__newline_token,
    ACTIONS(4126), 1,
      sym__whitespace_ge_2,
    ACTIONS(4129), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4132), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(783), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__attribute_value_repeat2,
    ACTIONS(4118), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36921] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4137), 1,
      anon_sym_SQUOTE,
    ACTIONS(4139), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(776), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__attribute_value_repeat1,
    ACTIONS(4135), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [36977] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4141), 1,
      anon_sym_GT,
    ACTIONS(4143), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(788), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4046), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37033] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4060), 1,
      anon_sym_SQUOTE,
    ACTIONS(4145), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(784), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__attribute_value_repeat1,
    ACTIONS(4135), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37089] = 3,
    ACTIONS(4151), 1,
      sym__last_token_punctuation,
    ACTIONS(4149), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4147), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [37137] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4153), 1,
      anon_sym_GT,
    ACTIONS(4056), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(778), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4046), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37193] = 3,
    ACTIONS(4161), 1,
      sym__last_token_punctuation,
    ACTIONS(4158), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4155), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [37241] = 5,
    ACTIONS(4151), 1,
      sym__last_token_punctuation,
    ACTIONS(4166), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4149), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(4163), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(4147), 34,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      sym__word_no_digit,
      sym__digits,
  [37293] = 3,
    ACTIONS(3651), 1,
      sym__last_token_punctuation,
    ACTIONS(3649), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3647), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [37341] = 4,
    ACTIONS(4169), 1,
      sym__newline_token,
    STATE(1078), 1,
      sym__soft_line_break,
    ACTIONS(3649), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3647), 36,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [37391] = 3,
    ACTIONS(4178), 1,
      sym__last_token_punctuation,
    ACTIONS(4175), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4172), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [37439] = 3,
    ACTIONS(3627), 1,
      sym__last_token_punctuation,
    ACTIONS(3625), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3623), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [37487] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4180), 1,
      anon_sym_GT,
    ACTIONS(4182), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(800), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4046), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37543] = 4,
    ACTIONS(4184), 1,
      sym__newline_token,
    STATE(1077), 1,
      sym__soft_line_break,
    ACTIONS(3625), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3623), 36,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [37593] = 6,
    ACTIONS(4147), 1,
      anon_sym_LPAREN,
    ACTIONS(4195), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4197), 1,
      sym__last_token_punctuation,
    ACTIONS(4190), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(4193), 2,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(4187), 34,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__word_no_digit,
      sym__digits,
  [37647] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4199), 1,
      anon_sym_GT,
    ACTIONS(4056), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(778), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4046), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37703] = 7,
    ACTIONS(3445), 1,
      sym__backslash_escape,
    ACTIONS(3555), 1,
      anon_sym_LPAREN,
    ACTIONS(4201), 1,
      anon_sym_RPAREN,
    ACTIONS(3671), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(3712), 4,
      sym_entity_reference,
      sym_numeric_character_reference,
      sym__word_no_digit,
      sym__digits,
    STATE(679), 4,
      sym_backslash_escape,
      sym__link_destination_parenthesis,
      sym__word,
      aux_sym_link_destination_repeat2,
    ACTIONS(3669), 28,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
  [37759] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4203), 1,
      anon_sym_GT,
    ACTIONS(4056), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(778), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4046), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37815] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4137), 1,
      anon_sym_DQUOTE,
    ACTIONS(4205), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(783), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__attribute_value_repeat2,
    ACTIONS(4058), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37871] = 7,
    ACTIONS(4050), 1,
      sym__newline_token,
    ACTIONS(4052), 1,
      sym__whitespace_ge_2,
    ACTIONS(4054), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4207), 1,
      anon_sym_GT,
    ACTIONS(4209), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(798), 4,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
      aux_sym__declaration_repeat1,
    ACTIONS(4046), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [37927] = 2,
    ACTIONS(4213), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4211), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [37972] = 2,
    ACTIONS(3233), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38017] = 2,
    ACTIONS(3259), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3257), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38062] = 5,
    ACTIONS(4147), 1,
      anon_sym_LPAREN,
    ACTIONS(4195), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4190), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(4193), 2,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(4187), 34,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__word_no_digit,
      sym__digits,
  [38113] = 2,
    ACTIONS(3199), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3197), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38158] = 2,
    ACTIONS(4175), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4172), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38203] = 2,
    ACTIONS(4158), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4155), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38248] = 4,
    ACTIONS(4222), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4217), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(4219), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(4215), 34,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      sym__word_no_digit,
      sym__digits,
  [38297] = 4,
    ACTIONS(4225), 1,
      sym__newline_token,
    STATE(1068), 1,
      sym__soft_line_break,
    ACTIONS(4195), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4193), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38346] = 2,
    ACTIONS(3771), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3769), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38391] = 2,
    ACTIONS(4217), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4215), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38436] = 2,
    ACTIONS(4230), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4228), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38481] = 2,
    ACTIONS(4234), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4232), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38526] = 2,
    ACTIONS(4239), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4236), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38571] = 3,
    ACTIONS(4242), 1,
      sym__last_token_punctuation,
    ACTIONS(4195), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4193), 36,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38618] = 2,
    ACTIONS(4244), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3686), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38663] = 2,
    ACTIONS(4249), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4246), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38708] = 5,
    ACTIONS(3769), 1,
      anon_sym_LPAREN,
    ACTIONS(4258), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3730), 2,
      sym__newline_token,
      sym__whitespace_ge_2,
    ACTIONS(4255), 2,
      anon_sym_AMP,
      anon_sym_BSLASH,
    ACTIONS(4252), 34,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__word_no_digit,
      sym__digits,
  [38759] = 2,
    ACTIONS(4260), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3594), 37,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38804] = 6,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4264), 2,
      sym__word_no_digit,
      sym__digits,
    STATE(839), 3,
      sym__whitespace,
      sym__word,
      sym__soft_line_break,
    ACTIONS(4262), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [38856] = 3,
    ACTIONS(4264), 1,
      sym__last_token_punctuation,
    ACTIONS(4268), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(4266), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38902] = 3,
    ACTIONS(4270), 1,
      sym__last_token_whitespace,
    ACTIONS(2977), 2,
      anon_sym_RBRACK,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 36,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_RBRACK_RBRACK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38948] = 3,
    ACTIONS(4276), 1,
      sym__last_token_punctuation,
    ACTIONS(4274), 2,
      anon_sym_QMARK,
      aux_sym__whitespace_token1,
    ACTIONS(4272), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_QMARK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [38994] = 2,
    ACTIONS(4280), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4278), 36,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39038] = 3,
    ACTIONS(4282), 1,
      sym__last_token_whitespace,
    ACTIONS(3027), 2,
      anon_sym_RBRACK,
      aux_sym__whitespace_token1,
    ACTIONS(3025), 36,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_RBRACK_RBRACK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39084] = 3,
    ACTIONS(4284), 1,
      sym__last_token_whitespace,
    ACTIONS(2977), 2,
      anon_sym_QMARK,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_QMARK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39130] = 3,
    ACTIONS(4286), 1,
      sym__last_token_whitespace,
    ACTIONS(3027), 2,
      anon_sym_QMARK,
      aux_sym__whitespace_token1,
    ACTIONS(3025), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_QMARK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39176] = 3,
    ACTIONS(4288), 1,
      sym__last_token_whitespace,
    ACTIONS(2977), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(2975), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39222] = 3,
    ACTIONS(4290), 1,
      sym__last_token_whitespace,
    ACTIONS(3027), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(3025), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39268] = 3,
    ACTIONS(4294), 1,
      sym__last_token_punctuation,
    ACTIONS(4292), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(3979), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39314] = 3,
    ACTIONS(4296), 1,
      sym__last_token_punctuation,
    ACTIONS(4274), 2,
      anon_sym_RBRACK,
      aux_sym__whitespace_token1,
    ACTIONS(4272), 36,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_RBRACK_RBRACK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39360] = 3,
    ACTIONS(4302), 1,
      sym__last_token_punctuation,
    ACTIONS(4300), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4298), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39406] = 2,
    ACTIONS(4258), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(3730), 36,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39450] = 2,
    ACTIONS(4306), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(4304), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39493] = 3,
    ACTIONS(4310), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4312), 1,
      sym__last_token_punctuation,
    ACTIONS(4308), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39538] = 3,
    ACTIONS(4316), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4318), 1,
      sym__last_token_punctuation,
    ACTIONS(4314), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39583] = 2,
    ACTIONS(4292), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(3979), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39626] = 2,
    ACTIONS(4322), 3,
      anon_sym_AMP,
      anon_sym_BSLASH,
      aux_sym__whitespace_token1,
    ACTIONS(4320), 35,
      sym__backslash_escape,
      sym_entity_reference,
      sym_numeric_character_reference,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39669] = 2,
    ACTIONS(4324), 2,
      anon_sym_RBRACK,
      aux_sym__whitespace_token1,
    ACTIONS(4011), 36,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_RBRACK_RBRACK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39712] = 2,
    ACTIONS(3233), 2,
      anon_sym_RBRACK,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 36,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_RBRACK_RBRACK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39755] = 2,
    ACTIONS(3233), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39798] = 2,
    ACTIONS(3199), 2,
      anon_sym_DASH,
      aux_sym__whitespace_token1,
    ACTIONS(3197), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_DASH_DASH_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39841] = 2,
    ACTIONS(3233), 2,
      anon_sym_QMARK,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_QMARK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39884] = 2,
    ACTIONS(3199), 2,
      anon_sym_QMARK,
      aux_sym__whitespace_token1,
    ACTIONS(3197), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_QMARK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39927] = 3,
    ACTIONS(3027), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4326), 1,
      sym__last_token_whitespace,
    ACTIONS(3025), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [39972] = 3,
    ACTIONS(2977), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4328), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [40017] = 3,
    ACTIONS(4332), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4334), 1,
      sym__last_token_punctuation,
    ACTIONS(4330), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [40062] = 2,
    ACTIONS(4324), 2,
      anon_sym_QMARK,
      aux_sym__whitespace_token1,
    ACTIONS(4011), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_QMARK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [40105] = 2,
    ACTIONS(3199), 2,
      anon_sym_RBRACK,
      aux_sym__whitespace_token1,
    ACTIONS(3197), 36,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      anon_sym_RBRACK_RBRACK_GT,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [40148] = 2,
    ACTIONS(4336), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4121), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [40190] = 2,
    ACTIONS(4338), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4075), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [40232] = 2,
    ACTIONS(4340), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4096), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [40274] = 2,
    ACTIONS(3233), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [40316] = 2,
    ACTIONS(3199), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3197), 36,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
      sym__word_no_digit,
      sym__digits,
  [40358] = 1,
    ACTIONS(4342), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40392] = 1,
    ACTIONS(4344), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40426] = 1,
    ACTIONS(4346), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40460] = 1,
    ACTIONS(4348), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40494] = 1,
    ACTIONS(4350), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40528] = 1,
    ACTIONS(4352), 31,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_DQUOTE,
      anon_sym_POUND,
      anon_sym_DOLLAR,
      anon_sym_PERCENT,
      anon_sym_AMP,
      anon_sym_SQUOTE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH,
      anon_sym_DOT,
      anon_sym_SLASH,
      anon_sym_COLON,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_AT,
      anon_sym_BSLASH,
      anon_sym_CARET,
      anon_sym__,
      anon_sym_BQUOTE,
      anon_sym_LBRACE,
      anon_sym_PIPE,
      anon_sym_RBRACE,
      anon_sym_TILDE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40562] = 5,
    ACTIONS(4354), 1,
      sym__newline_token,
    ACTIONS(4357), 1,
      sym__whitespace_ge_2,
    ACTIONS(4360), 1,
      aux_sym__whitespace_token1,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
    ACTIONS(3861), 6,
      anon_sym_GT,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_EQ,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
  [40585] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4369), 1,
      anon_sym_RPAREN,
    STATE(1017), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [40615] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4371), 1,
      anon_sym_RPAREN,
    STATE(946), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [40645] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4373), 1,
      anon_sym_RPAREN,
    STATE(940), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [40675] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4375), 1,
      anon_sym_RPAREN,
    STATE(966), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [40705] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4377), 1,
      anon_sym_RPAREN,
    STATE(970), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [40735] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4379), 1,
      anon_sym_RPAREN,
    STATE(1026), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [40765] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4381), 1,
      anon_sym_RPAREN,
    STATE(1024), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [40795] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4383), 1,
      anon_sym_RPAREN,
    STATE(1020), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [40825] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4385), 1,
      anon_sym_RPAREN,
    STATE(974), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [40855] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4387), 1,
      anon_sym_RPAREN,
    STATE(936), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [40885] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4389), 1,
      anon_sym_RPAREN,
    STATE(969), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [40915] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4391), 1,
      anon_sym_RPAREN,
    STATE(972), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [40945] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4393), 1,
      anon_sym_RPAREN,
    STATE(952), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [40975] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4395), 1,
      anon_sym_RPAREN,
    STATE(924), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41005] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4397), 1,
      anon_sym_RPAREN,
    STATE(955), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41035] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4399), 1,
      anon_sym_RPAREN,
    STATE(959), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41065] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4401), 1,
      anon_sym_RPAREN,
    STATE(953), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41095] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4403), 1,
      anon_sym_RPAREN,
    STATE(930), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41125] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4405), 1,
      anon_sym_RPAREN,
    STATE(926), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41155] = 9,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4363), 1,
      anon_sym_DQUOTE,
    ACTIONS(4365), 1,
      anon_sym_SQUOTE,
    ACTIONS(4367), 1,
      anon_sym_LPAREN,
    ACTIONS(4407), 1,
      anon_sym_RPAREN,
    STATE(961), 1,
      sym_link_title,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41185] = 7,
    ACTIONS(4409), 1,
      anon_sym_GT,
    ACTIONS(4411), 1,
      anon_sym_SLASH,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    STATE(892), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(912), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41210] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4419), 1,
      anon_sym_GT,
    ACTIONS(4421), 1,
      anon_sym_SLASH,
    STATE(893), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(916), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41235] = 8,
    ACTIONS(4423), 1,
      anon_sym_DQUOTE,
    ACTIONS(4425), 1,
      anon_sym_SQUOTE,
    ACTIONS(4427), 1,
      sym__newline_token,
    ACTIONS(4429), 1,
      aux_sym__attribute_value_token1,
    ACTIONS(4431), 1,
      sym__whitespace_ge_2,
    ACTIONS(4433), 1,
      aux_sym__whitespace_token1,
    STATE(1041), 1,
      sym__attribute_value,
    STATE(900), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41262] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4435), 1,
      anon_sym_GT,
    ACTIONS(4437), 1,
      anon_sym_SLASH,
    STATE(892), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(914), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41287] = 8,
    ACTIONS(4423), 1,
      anon_sym_DQUOTE,
    ACTIONS(4425), 1,
      anon_sym_SQUOTE,
    ACTIONS(4427), 1,
      sym__newline_token,
    ACTIONS(4429), 1,
      aux_sym__attribute_value_token1,
    ACTIONS(4431), 1,
      sym__whitespace_ge_2,
    ACTIONS(4433), 1,
      aux_sym__whitespace_token1,
    STATE(1041), 1,
      sym__attribute_value,
    STATE(907), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41314] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4439), 1,
      anon_sym_GT,
    ACTIONS(4441), 1,
      anon_sym_SLASH,
    STATE(890), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(909), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41339] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4443), 1,
      anon_sym_GT,
    ACTIONS(4445), 1,
      anon_sym_SLASH,
    STATE(892), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(910), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41364] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4447), 1,
      anon_sym_GT,
    ACTIONS(4449), 1,
      anon_sym_SLASH,
    STATE(897), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(904), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41389] = 6,
    ACTIONS(4453), 1,
      sym__newline_token,
    ACTIONS(4456), 1,
      sym__whitespace_ge_2,
    ACTIONS(4459), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4451), 2,
      anon_sym_GT,
      anon_sym_SLASH,
    STATE(892), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(994), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41412] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4462), 1,
      anon_sym_GT,
    ACTIONS(4464), 1,
      anon_sym_SLASH,
    STATE(892), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(906), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41437] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4466), 1,
      anon_sym_GT,
    ACTIONS(4468), 1,
      anon_sym_SLASH,
    STATE(884), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(903), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41462] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4470), 1,
      anon_sym_GT,
    ACTIONS(4472), 1,
      anon_sym_SLASH,
    STATE(892), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(901), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41487] = 8,
    ACTIONS(4423), 1,
      anon_sym_DQUOTE,
    ACTIONS(4425), 1,
      anon_sym_SQUOTE,
    ACTIONS(4427), 1,
      sym__newline_token,
    ACTIONS(4431), 1,
      sym__whitespace_ge_2,
    ACTIONS(4433), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4474), 1,
      aux_sym__attribute_value_token1,
    STATE(1045), 1,
      sym__attribute_value,
    STATE(888), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41514] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4476), 1,
      anon_sym_GT,
    ACTIONS(4478), 1,
      anon_sym_SLASH,
    STATE(892), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(913), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41539] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4480), 1,
      anon_sym_GT,
    ACTIONS(4482), 1,
      anon_sym_SLASH,
    STATE(895), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(915), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41564] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4484), 1,
      anon_sym_GT,
    ACTIONS(4486), 1,
      anon_sym_SLASH,
    STATE(887), 2,
      sym__attribute,
      aux_sym__open_tag_repeat1,
    STATE(908), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41589] = 8,
    ACTIONS(4423), 1,
      anon_sym_DQUOTE,
    ACTIONS(4425), 1,
      anon_sym_SQUOTE,
    ACTIONS(4427), 1,
      sym__newline_token,
    ACTIONS(4431), 1,
      sym__whitespace_ge_2,
    ACTIONS(4433), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4488), 1,
      aux_sym__attribute_value_token1,
    STATE(1042), 1,
      sym__attribute_value,
    STATE(907), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41616] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4490), 1,
      anon_sym_GT,
    ACTIONS(4492), 1,
      anon_sym_SLASH,
    ACTIONS(4494), 1,
      sym__attribute_name,
    STATE(917), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41640] = 4,
    ACTIONS(4500), 1,
      aux_sym__whitespace_token1,
    STATE(911), 1,
      aux_sym__tag_name_repeat1,
    ACTIONS(4498), 3,
      anon_sym_DASH,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(4496), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [41658] = 7,
    ACTIONS(4409), 1,
      anon_sym_GT,
    ACTIONS(4411), 1,
      anon_sym_SLASH,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4494), 1,
      sym__attribute_name,
    STATE(917), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41682] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4476), 1,
      anon_sym_GT,
    ACTIONS(4478), 1,
      anon_sym_SLASH,
    ACTIONS(4494), 1,
      sym__attribute_name,
    STATE(917), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41706] = 4,
    ACTIONS(4506), 1,
      aux_sym__whitespace_token1,
    STATE(902), 1,
      aux_sym__tag_name_repeat1,
    ACTIONS(4504), 3,
      anon_sym_DASH,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(4502), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [41724] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4494), 1,
      sym__attribute_name,
    ACTIONS(4508), 1,
      anon_sym_GT,
    ACTIONS(4510), 1,
      anon_sym_SLASH,
    STATE(917), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41748] = 5,
    ACTIONS(4512), 1,
      sym__newline_token,
    ACTIONS(4515), 1,
      sym__whitespace_ge_2,
    ACTIONS(4518), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3861), 3,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      aux_sym__attribute_value_token1,
    STATE(907), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41768] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4435), 1,
      anon_sym_GT,
    ACTIONS(4437), 1,
      anon_sym_SLASH,
    ACTIONS(4494), 1,
      sym__attribute_name,
    STATE(917), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41792] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4443), 1,
      anon_sym_GT,
    ACTIONS(4445), 1,
      anon_sym_SLASH,
    ACTIONS(4494), 1,
      sym__attribute_name,
    STATE(917), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41816] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4494), 1,
      sym__attribute_name,
    ACTIONS(4521), 1,
      anon_sym_GT,
    ACTIONS(4523), 1,
      anon_sym_SLASH,
    STATE(917), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41840] = 4,
    ACTIONS(4530), 1,
      aux_sym__whitespace_token1,
    STATE(911), 1,
      aux_sym__tag_name_repeat1,
    ACTIONS(4527), 3,
      anon_sym_DASH,
      sym__word_no_digit,
      sym__digits,
    ACTIONS(4525), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [41858] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4494), 1,
      sym__attribute_name,
    ACTIONS(4532), 1,
      anon_sym_GT,
    ACTIONS(4534), 1,
      anon_sym_SLASH,
    STATE(917), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41882] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4494), 1,
      sym__attribute_name,
    ACTIONS(4536), 1,
      anon_sym_GT,
    ACTIONS(4538), 1,
      anon_sym_SLASH,
    STATE(917), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41906] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4494), 1,
      sym__attribute_name,
    ACTIONS(4540), 1,
      anon_sym_GT,
    ACTIONS(4542), 1,
      anon_sym_SLASH,
    STATE(917), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41930] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4470), 1,
      anon_sym_GT,
    ACTIONS(4472), 1,
      anon_sym_SLASH,
    ACTIONS(4494), 1,
      sym__attribute_name,
    STATE(917), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41954] = 7,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4462), 1,
      anon_sym_GT,
    ACTIONS(4464), 1,
      anon_sym_SLASH,
    ACTIONS(4494), 1,
      sym__attribute_name,
    STATE(917), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41978] = 5,
    ACTIONS(4544), 1,
      sym__newline_token,
    ACTIONS(4547), 1,
      sym__whitespace_ge_2,
    ACTIONS(4550), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3861), 3,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__attribute_name,
    STATE(917), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [41998] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4393), 1,
      anon_sym_RPAREN,
    STATE(954), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42016] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4377), 1,
      anon_sym_RPAREN,
    STATE(968), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42034] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4553), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42052] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4555), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42070] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4557), 1,
      anon_sym_GT,
    STATE(937), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42088] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4387), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42106] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4373), 1,
      anon_sym_RPAREN,
    STATE(938), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42124] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4373), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42142] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4559), 1,
      anon_sym_RPAREN,
    STATE(920), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42160] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4559), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42178] = 5,
    ACTIONS(3526), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(876), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42196] = 5,
    ACTIONS(3526), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(943), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42214] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4561), 1,
      anon_sym_RPAREN,
    STATE(921), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42232] = 5,
    ACTIONS(3516), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(878), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42250] = 5,
    ACTIONS(3516), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(947), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42268] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4561), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42286] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4563), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42304] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4371), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42322] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4563), 1,
      anon_sym_RPAREN,
    STATE(945), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42340] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4565), 1,
      anon_sym_GT,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42358] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42376] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4569), 1,
      anon_sym_GT,
    STATE(981), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42394] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4567), 1,
      anon_sym_RPAREN,
    STATE(950), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42412] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4571), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42430] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4573), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42448] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4393), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42466] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4393), 1,
      anon_sym_RPAREN,
    STATE(879), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42484] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4575), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42502] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4577), 1,
      anon_sym_RPAREN,
    STATE(941), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42520] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4397), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42538] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4397), 1,
      anon_sym_RPAREN,
    STATE(883), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42556] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4397), 1,
      anon_sym_RPAREN,
    STATE(957), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42574] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4579), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42592] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4577), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42610] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4399), 1,
      anon_sym_RPAREN,
    STATE(958), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42628] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4581), 1,
      anon_sym_RPAREN,
    STATE(942), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42646] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4399), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42664] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4407), 1,
      anon_sym_RPAREN,
    STATE(960), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42682] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4581), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42700] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4407), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42718] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4583), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42736] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4583), 1,
      anon_sym_RPAREN,
    STATE(962), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42754] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4585), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42772] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4585), 1,
      anon_sym_RPAREN,
    STATE(963), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42790] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4587), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42808] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4589), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42826] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4591), 1,
      anon_sym_GT,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42844] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4389), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42862] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4403), 1,
      anon_sym_RPAREN,
    STATE(933), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42880] = 5,
    ACTIONS(3518), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(867), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42898] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4405), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42916] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4387), 1,
      anon_sym_RPAREN,
    STATE(934), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42934] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4405), 1,
      anon_sym_RPAREN,
    STATE(927), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42952] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4403), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42970] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4371), 1,
      anon_sym_RPAREN,
    STATE(951), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [42988] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4401), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43006] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4401), 1,
      anon_sym_RPAREN,
    STATE(956), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43024] = 5,
    ACTIONS(3518), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(1033), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43042] = 5,
    ACTIONS(3503), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(868), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43060] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4391), 1,
      anon_sym_RPAREN,
    STATE(935), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43078] = 5,
    ACTIONS(3503), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(1016), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43096] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4391), 1,
      anon_sym_RPAREN,
    STATE(865), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43114] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4391), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43132] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4593), 1,
      anon_sym_GT,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43150] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4389), 1,
      anon_sym_RPAREN,
    STATE(873), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43168] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4385), 1,
      anon_sym_RPAREN,
    STATE(973), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43186] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4385), 1,
      anon_sym_RPAREN,
    STATE(880), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43204] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4389), 1,
      anon_sym_RPAREN,
    STATE(923), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43222] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4595), 1,
      anon_sym_GT,
    STATE(1002), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43240] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4597), 1,
      anon_sym_EQ,
    STATE(998), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43258] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4385), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43276] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4395), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43294] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4599), 1,
      anon_sym_GT,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43312] = 3,
    ACTIONS(3027), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4601), 1,
      sym__last_token_whitespace,
    ACTIONS(3025), 5,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__attribute_name,
      sym__whitespace_ge_2,
  [43326] = 3,
    ACTIONS(2977), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4603), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 5,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__attribute_name,
      sym__whitespace_ge_2,
  [43340] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4395), 1,
      anon_sym_RPAREN,
    STATE(866), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43358] = 5,
    ACTIONS(4413), 1,
      sym__newline_token,
    ACTIONS(4415), 1,
      sym__whitespace_ge_2,
    ACTIONS(4417), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4494), 1,
      sym__attribute_name,
    STATE(917), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43376] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4395), 1,
      anon_sym_RPAREN,
    STATE(925), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43394] = 5,
    ACTIONS(3477), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(864), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43412] = 5,
    ACTIONS(3477), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(1008), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43430] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4605), 1,
      anon_sym_EQ,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43448] = 5,
    ACTIONS(3528), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(871), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43466] = 5,
    ACTIONS(3528), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(1012), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43484] = 5,
    ACTIONS(3532), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(965), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43502] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4607), 1,
      anon_sym_GT,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43520] = 5,
    ACTIONS(3534), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(989), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43538] = 5,
    ACTIONS(3536), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(980), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43556] = 5,
    ACTIONS(3534), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(877), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43574] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4377), 1,
      anon_sym_RPAREN,
    STATE(882), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43592] = 5,
    ACTIONS(3536), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(875), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43610] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4369), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43628] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4369), 1,
      anon_sym_RPAREN,
    STATE(870), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43646] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4369), 1,
      anon_sym_RPAREN,
    STATE(1019), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43664] = 5,
    ACTIONS(3530), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(988), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43682] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4383), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43700] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4383), 1,
      anon_sym_RPAREN,
    STATE(869), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43718] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4383), 1,
      anon_sym_RPAREN,
    STATE(1022), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43736] = 5,
    ACTIONS(3532), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(874), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43754] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4377), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43772] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4381), 1,
      anon_sym_RPAREN,
    STATE(1023), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43790] = 5,
    ACTIONS(3530), 1,
      anon_sym_RPAREN,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    STATE(872), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43808] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4381), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43826] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4379), 1,
      anon_sym_RPAREN,
    STATE(1025), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43844] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4609), 1,
      anon_sym_GT,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43862] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4379), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43880] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4611), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43898] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4611), 1,
      anon_sym_RPAREN,
    STATE(1027), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43916] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4613), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43934] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4613), 1,
      anon_sym_RPAREN,
    STATE(1028), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43952] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4615), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43970] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4617), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [43988] = 3,
    ACTIONS(2977), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4619), 1,
      sym__last_token_whitespace,
    ACTIONS(2975), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym__newline_token,
      aux_sym__attribute_value_token1,
      sym__whitespace_ge_2,
  [44002] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4621), 1,
      anon_sym_GT,
    STATE(964), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44020] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4375), 1,
      anon_sym_RPAREN,
    STATE(971), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44038] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4375), 1,
      anon_sym_RPAREN,
    STATE(881), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44056] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4375), 1,
      anon_sym_RPAREN,
    STATE(863), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44074] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4623), 1,
      anon_sym_GT,
    STATE(990), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44092] = 5,
    ACTIONS(3797), 1,
      sym__newline_token,
    ACTIONS(3801), 1,
      sym__whitespace_ge_2,
    ACTIONS(3803), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4625), 1,
      anon_sym_GT,
    STATE(1021), 3,
      sym__whitespace,
      sym__soft_line_break,
      aux_sym_inline_link_repeat1,
  [44110] = 3,
    ACTIONS(3027), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4627), 1,
      sym__last_token_whitespace,
    ACTIONS(3025), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym__newline_token,
      aux_sym__attribute_value_token1,
      sym__whitespace_ge_2,
  [44124] = 2,
    ACTIONS(3199), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3197), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym__newline_token,
      aux_sym__attribute_value_token1,
      sym__whitespace_ge_2,
  [44135] = 2,
    ACTIONS(3233), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 5,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym__newline_token,
      aux_sym__attribute_value_token1,
      sym__whitespace_ge_2,
  [44146] = 2,
    ACTIONS(3233), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3231), 5,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__attribute_name,
      sym__whitespace_ge_2,
  [44157] = 2,
    ACTIONS(3199), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3197), 5,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__attribute_name,
      sym__whitespace_ge_2,
  [44168] = 2,
    ACTIONS(4631), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4629), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [44178] = 2,
    ACTIONS(4635), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4633), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [44188] = 2,
    ACTIONS(4639), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4637), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [44198] = 2,
    ACTIONS(4643), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4641), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [44208] = 2,
    ACTIONS(4647), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4645), 4,
      anon_sym_GT,
      anon_sym_SLASH,
      sym__newline_token,
      sym__whitespace_ge_2,
  [44218] = 2,
    ACTIONS(3743), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3741), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
  [44227] = 2,
    ACTIONS(4651), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4649), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
  [44236] = 2,
    ACTIONS(4655), 1,
      aux_sym__whitespace_token1,
    ACTIONS(4653), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
  [44245] = 2,
    ACTIONS(3716), 1,
      aux_sym__whitespace_token1,
    ACTIONS(3714), 3,
      anon_sym_RPAREN,
      sym__newline_token,
      sym__whitespace_ge_2,
  [44254] = 3,
    ACTIONS(4657), 1,
      anon_sym_LBRACK,
    ACTIONS(4659), 1,
      anon_sym_LPAREN,
    STATE(299), 1,
      sym_link_label,
  [44264] = 3,
    ACTIONS(4661), 1,
      anon_sym_LBRACK,
    ACTIONS(4663), 1,
      anon_sym_LPAREN,
    STATE(524), 1,
      sym_link_label,
  [44274] = 3,
    ACTIONS(4665), 1,
      anon_sym_LBRACK,
    ACTIONS(4667), 1,
      anon_sym_LPAREN,
    STATE(523), 1,
      sym_link_label,
  [44284] = 3,
    ACTIONS(4669), 1,
      anon_sym_LBRACK,
    ACTIONS(4671), 1,
      anon_sym_LPAREN,
    STATE(442), 1,
      sym_link_label,
  [44294] = 3,
    ACTIONS(4673), 1,
      anon_sym_LBRACK,
    ACTIONS(4675), 1,
      anon_sym_LPAREN,
    STATE(443), 1,
      sym_link_label,
  [44304] = 3,
    ACTIONS(4677), 1,
      anon_sym_LBRACK,
    ACTIONS(4679), 1,
      anon_sym_LPAREN,
    STATE(295), 1,
      sym_link_label,
  [44314] = 3,
    ACTIONS(4681), 1,
      anon_sym_LBRACK,
    ACTIONS(4683), 1,
      anon_sym_LPAREN,
    STATE(361), 1,
      sym_link_label,
  [44324] = 3,
    ACTIONS(4685), 1,
      anon_sym_LBRACK,
    ACTIONS(4687), 1,
      anon_sym_LPAREN,
    STATE(360), 1,
      sym_link_label,
  [44334] = 3,
    ACTIONS(4689), 1,
      anon_sym_LBRACK,
    ACTIONS(4691), 1,
      anon_sym_LPAREN,
    STATE(479), 1,
      sym_link_label,
  [44344] = 3,
    ACTIONS(4693), 1,
      anon_sym_LBRACK,
    ACTIONS(4695), 1,
      anon_sym_LPAREN,
    STATE(502), 1,
      sym_link_label,
  [44354] = 2,
    ACTIONS(3025), 1,
      sym__trigger_error,
    ACTIONS(4697), 1,
      sym__last_token_whitespace,
  [44361] = 2,
    ACTIONS(4699), 1,
      sym__word_no_digit,
    STATE(1030), 1,
      sym__tag_name,
  [44368] = 2,
    ACTIONS(4699), 1,
      sym__word_no_digit,
    STATE(922), 1,
      sym__tag_name,
  [44375] = 1,
    ACTIONS(4701), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
  [44380] = 2,
    ACTIONS(4699), 1,
      sym__word_no_digit,
    STATE(1034), 1,
      sym__tag_name,
  [44387] = 2,
    ACTIONS(4699), 1,
      sym__word_no_digit,
    STATE(986), 1,
      sym__tag_name,
  [44394] = 2,
    ACTIONS(4699), 1,
      sym__word_no_digit,
    STATE(939), 1,
      sym__tag_name,
  [44401] = 2,
    ACTIONS(4699), 1,
      sym__word_no_digit,
    STATE(1035), 1,
      sym__tag_name,
  [44408] = 1,
    ACTIONS(4703), 1,
      sym__trigger_error,
  [44412] = 1,
    ACTIONS(4521), 1,
      anon_sym_GT,
  [44416] = 1,
    ACTIONS(4705), 1,
      anon_sym_GT,
  [44420] = 1,
    ACTIONS(4707), 1,
      ts_builtin_sym_end,
  [44424] = 1,
    ACTIONS(4476), 1,
      anon_sym_GT,
  [44428] = 1,
    ACTIONS(4709), 1,
      anon_sym_GT,
  [44432] = 1,
    ACTIONS(4409), 1,
      anon_sym_GT,
  [44436] = 1,
    ACTIONS(4435), 1,
      anon_sym_GT,
  [44440] = 1,
    ACTIONS(4711), 1,
      anon_sym_GT,
  [44444] = 1,
    ACTIONS(4713), 1,
      sym__trigger_error,
  [44448] = 1,
    ACTIONS(4715), 1,
      sym__trigger_error,
  [44452] = 1,
    ACTIONS(4490), 1,
      anon_sym_GT,
  [44456] = 1,
    ACTIONS(4540), 1,
      anon_sym_GT,
  [44460] = 1,
    ACTIONS(4462), 1,
      anon_sym_GT,
  [44464] = 1,
    ACTIONS(4536), 1,
      anon_sym_GT,
  [44468] = 1,
    ACTIONS(4717), 1,
      anon_sym_GT,
  [44472] = 1,
    ACTIONS(4508), 1,
      anon_sym_GT,
  [44476] = 1,
    ACTIONS(4719), 1,
      anon_sym_GT,
  [44480] = 1,
    ACTIONS(4721), 1,
      anon_sym_GT,
  [44484] = 1,
    ACTIONS(4443), 1,
      anon_sym_GT,
  [44488] = 1,
    ACTIONS(4470), 1,
      anon_sym_GT,
  [44492] = 1,
    ACTIONS(4532), 1,
      anon_sym_GT,
  [44496] = 1,
    ACTIONS(3231), 1,
      sym__trigger_error,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(166)] = 0,
  [SMALL_STATE(167)] = 95,
  [SMALL_STATE(168)] = 192,
  [SMALL_STATE(169)] = 289,
  [SMALL_STATE(170)] = 386,
  [SMALL_STATE(171)] = 481,
  [SMALL_STATE(172)] = 576,
  [SMALL_STATE(173)] = 671,
  [SMALL_STATE(174)] = 767,
  [SMALL_STATE(175)] = 861,
  [SMALL_STATE(176)] = 940,
  [SMALL_STATE(177)] = 1017,
  [SMALL_STATE(178)] = 1094,
  [SMALL_STATE(179)] = 1173,
  [SMALL_STATE(180)] = 1254,
  [SMALL_STATE(181)] = 1331,
  [SMALL_STATE(182)] = 1408,
  [SMALL_STATE(183)] = 1489,
  [SMALL_STATE(184)] = 1566,
  [SMALL_STATE(185)] = 1643,
  [SMALL_STATE(186)] = 1722,
  [SMALL_STATE(187)] = 1803,
  [SMALL_STATE(188)] = 1880,
  [SMALL_STATE(189)] = 1957,
  [SMALL_STATE(190)] = 2033,
  [SMALL_STATE(191)] = 2111,
  [SMALL_STATE(192)] = 2189,
  [SMALL_STATE(193)] = 2267,
  [SMALL_STATE(194)] = 2347,
  [SMALL_STATE(195)] = 2425,
  [SMALL_STATE(196)] = 2501,
  [SMALL_STATE(197)] = 2581,
  [SMALL_STATE(198)] = 2661,
  [SMALL_STATE(199)] = 2739,
  [SMALL_STATE(200)] = 2817,
  [SMALL_STATE(201)] = 2898,
  [SMALL_STATE(202)] = 2975,
  [SMALL_STATE(203)] = 3056,
  [SMALL_STATE(204)] = 3137,
  [SMALL_STATE(205)] = 3218,
  [SMALL_STATE(206)] = 3297,
  [SMALL_STATE(207)] = 3378,
  [SMALL_STATE(208)] = 3459,
  [SMALL_STATE(209)] = 3523,
  [SMALL_STATE(210)] = 3589,
  [SMALL_STATE(211)] = 3661,
  [SMALL_STATE(212)] = 3727,
  [SMALL_STATE(213)] = 3793,
  [SMALL_STATE(214)] = 3865,
  [SMALL_STATE(215)] = 3937,
  [SMALL_STATE(216)] = 4009,
  [SMALL_STATE(217)] = 4075,
  [SMALL_STATE(218)] = 4139,
  [SMALL_STATE(219)] = 4203,
  [SMALL_STATE(220)] = 4275,
  [SMALL_STATE(221)] = 4347,
  [SMALL_STATE(222)] = 4419,
  [SMALL_STATE(223)] = 4483,
  [SMALL_STATE(224)] = 4555,
  [SMALL_STATE(225)] = 4627,
  [SMALL_STATE(226)] = 4699,
  [SMALL_STATE(227)] = 4765,
  [SMALL_STATE(228)] = 4837,
  [SMALL_STATE(229)] = 4909,
  [SMALL_STATE(230)] = 4973,
  [SMALL_STATE(231)] = 5045,
  [SMALL_STATE(232)] = 5111,
  [SMALL_STATE(233)] = 5175,
  [SMALL_STATE(234)] = 5247,
  [SMALL_STATE(235)] = 5319,
  [SMALL_STATE(236)] = 5385,
  [SMALL_STATE(237)] = 5449,
  [SMALL_STATE(238)] = 5515,
  [SMALL_STATE(239)] = 5579,
  [SMALL_STATE(240)] = 5651,
  [SMALL_STATE(241)] = 5710,
  [SMALL_STATE(242)] = 5769,
  [SMALL_STATE(243)] = 5828,
  [SMALL_STATE(244)] = 5889,
  [SMALL_STATE(245)] = 5948,
  [SMALL_STATE(246)] = 6007,
  [SMALL_STATE(247)] = 6068,
  [SMALL_STATE(248)] = 6127,
  [SMALL_STATE(249)] = 6188,
  [SMALL_STATE(250)] = 6247,
  [SMALL_STATE(251)] = 6306,
  [SMALL_STATE(252)] = 6365,
  [SMALL_STATE(253)] = 6424,
  [SMALL_STATE(254)] = 6485,
  [SMALL_STATE(255)] = 6544,
  [SMALL_STATE(256)] = 6603,
  [SMALL_STATE(257)] = 6662,
  [SMALL_STATE(258)] = 6721,
  [SMALL_STATE(259)] = 6782,
  [SMALL_STATE(260)] = 6847,
  [SMALL_STATE(261)] = 6908,
  [SMALL_STATE(262)] = 6967,
  [SMALL_STATE(263)] = 7026,
  [SMALL_STATE(264)] = 7089,
  [SMALL_STATE(265)] = 7148,
  [SMALL_STATE(266)] = 7209,
  [SMALL_STATE(267)] = 7268,
  [SMALL_STATE(268)] = 7327,
  [SMALL_STATE(269)] = 7386,
  [SMALL_STATE(270)] = 7449,
  [SMALL_STATE(271)] = 7514,
  [SMALL_STATE(272)] = 7570,
  [SMALL_STATE(273)] = 7626,
  [SMALL_STATE(274)] = 7682,
  [SMALL_STATE(275)] = 7738,
  [SMALL_STATE(276)] = 7794,
  [SMALL_STATE(277)] = 7850,
  [SMALL_STATE(278)] = 7906,
  [SMALL_STATE(279)] = 7962,
  [SMALL_STATE(280)] = 8018,
  [SMALL_STATE(281)] = 8074,
  [SMALL_STATE(282)] = 8132,
  [SMALL_STATE(283)] = 8190,
  [SMALL_STATE(284)] = 8246,
  [SMALL_STATE(285)] = 8302,
  [SMALL_STATE(286)] = 8358,
  [SMALL_STATE(287)] = 8418,
  [SMALL_STATE(288)] = 8476,
  [SMALL_STATE(289)] = 8532,
  [SMALL_STATE(290)] = 8588,
  [SMALL_STATE(291)] = 8644,
  [SMALL_STATE(292)] = 8702,
  [SMALL_STATE(293)] = 8758,
  [SMALL_STATE(294)] = 8814,
  [SMALL_STATE(295)] = 8872,
  [SMALL_STATE(296)] = 8928,
  [SMALL_STATE(297)] = 8984,
  [SMALL_STATE(298)] = 9040,
  [SMALL_STATE(299)] = 9096,
  [SMALL_STATE(300)] = 9152,
  [SMALL_STATE(301)] = 9208,
  [SMALL_STATE(302)] = 9264,
  [SMALL_STATE(303)] = 9320,
  [SMALL_STATE(304)] = 9376,
  [SMALL_STATE(305)] = 9432,
  [SMALL_STATE(306)] = 9488,
  [SMALL_STATE(307)] = 9546,
  [SMALL_STATE(308)] = 9602,
  [SMALL_STATE(309)] = 9658,
  [SMALL_STATE(310)] = 9716,
  [SMALL_STATE(311)] = 9774,
  [SMALL_STATE(312)] = 9830,
  [SMALL_STATE(313)] = 9890,
  [SMALL_STATE(314)] = 9946,
  [SMALL_STATE(315)] = 10004,
  [SMALL_STATE(316)] = 10060,
  [SMALL_STATE(317)] = 10118,
  [SMALL_STATE(318)] = 10174,
  [SMALL_STATE(319)] = 10230,
  [SMALL_STATE(320)] = 10286,
  [SMALL_STATE(321)] = 10342,
  [SMALL_STATE(322)] = 10398,
  [SMALL_STATE(323)] = 10454,
  [SMALL_STATE(324)] = 10512,
  [SMALL_STATE(325)] = 10568,
  [SMALL_STATE(326)] = 10624,
  [SMALL_STATE(327)] = 10682,
  [SMALL_STATE(328)] = 10738,
  [SMALL_STATE(329)] = 10794,
  [SMALL_STATE(330)] = 10850,
  [SMALL_STATE(331)] = 10908,
  [SMALL_STATE(332)] = 10964,
  [SMALL_STATE(333)] = 11020,
  [SMALL_STATE(334)] = 11080,
  [SMALL_STATE(335)] = 11136,
  [SMALL_STATE(336)] = 11192,
  [SMALL_STATE(337)] = 11248,
  [SMALL_STATE(338)] = 11304,
  [SMALL_STATE(339)] = 11360,
  [SMALL_STATE(340)] = 11416,
  [SMALL_STATE(341)] = 11472,
  [SMALL_STATE(342)] = 11528,
  [SMALL_STATE(343)] = 11586,
  [SMALL_STATE(344)] = 11642,
  [SMALL_STATE(345)] = 11700,
  [SMALL_STATE(346)] = 11756,
  [SMALL_STATE(347)] = 11812,
  [SMALL_STATE(348)] = 11868,
  [SMALL_STATE(349)] = 11924,
  [SMALL_STATE(350)] = 11982,
  [SMALL_STATE(351)] = 12038,
  [SMALL_STATE(352)] = 12094,
  [SMALL_STATE(353)] = 12150,
  [SMALL_STATE(354)] = 12206,
  [SMALL_STATE(355)] = 12262,
  [SMALL_STATE(356)] = 12318,
  [SMALL_STATE(357)] = 12374,
  [SMALL_STATE(358)] = 12430,
  [SMALL_STATE(359)] = 12486,
  [SMALL_STATE(360)] = 12542,
  [SMALL_STATE(361)] = 12598,
  [SMALL_STATE(362)] = 12654,
  [SMALL_STATE(363)] = 12710,
  [SMALL_STATE(364)] = 12766,
  [SMALL_STATE(365)] = 12822,
  [SMALL_STATE(366)] = 12878,
  [SMALL_STATE(367)] = 12934,
  [SMALL_STATE(368)] = 12990,
  [SMALL_STATE(369)] = 13046,
  [SMALL_STATE(370)] = 13102,
  [SMALL_STATE(371)] = 13158,
  [SMALL_STATE(372)] = 13214,
  [SMALL_STATE(373)] = 13272,
  [SMALL_STATE(374)] = 13328,
  [SMALL_STATE(375)] = 13384,
  [SMALL_STATE(376)] = 13440,
  [SMALL_STATE(377)] = 13496,
  [SMALL_STATE(378)] = 13552,
  [SMALL_STATE(379)] = 13608,
  [SMALL_STATE(380)] = 13664,
  [SMALL_STATE(381)] = 13720,
  [SMALL_STATE(382)] = 13776,
  [SMALL_STATE(383)] = 13832,
  [SMALL_STATE(384)] = 13888,
  [SMALL_STATE(385)] = 13944,
  [SMALL_STATE(386)] = 14000,
  [SMALL_STATE(387)] = 14056,
  [SMALL_STATE(388)] = 14112,
  [SMALL_STATE(389)] = 14168,
  [SMALL_STATE(390)] = 14224,
  [SMALL_STATE(391)] = 14280,
  [SMALL_STATE(392)] = 14336,
  [SMALL_STATE(393)] = 14392,
  [SMALL_STATE(394)] = 14448,
  [SMALL_STATE(395)] = 14504,
  [SMALL_STATE(396)] = 14560,
  [SMALL_STATE(397)] = 14616,
  [SMALL_STATE(398)] = 14672,
  [SMALL_STATE(399)] = 14728,
  [SMALL_STATE(400)] = 14784,
  [SMALL_STATE(401)] = 14840,
  [SMALL_STATE(402)] = 14896,
  [SMALL_STATE(403)] = 14952,
  [SMALL_STATE(404)] = 15008,
  [SMALL_STATE(405)] = 15064,
  [SMALL_STATE(406)] = 15120,
  [SMALL_STATE(407)] = 15176,
  [SMALL_STATE(408)] = 15232,
  [SMALL_STATE(409)] = 15288,
  [SMALL_STATE(410)] = 15344,
  [SMALL_STATE(411)] = 15400,
  [SMALL_STATE(412)] = 15456,
  [SMALL_STATE(413)] = 15512,
  [SMALL_STATE(414)] = 15568,
  [SMALL_STATE(415)] = 15624,
  [SMALL_STATE(416)] = 15680,
  [SMALL_STATE(417)] = 15736,
  [SMALL_STATE(418)] = 15792,
  [SMALL_STATE(419)] = 15852,
  [SMALL_STATE(420)] = 15908,
  [SMALL_STATE(421)] = 15964,
  [SMALL_STATE(422)] = 16020,
  [SMALL_STATE(423)] = 16076,
  [SMALL_STATE(424)] = 16132,
  [SMALL_STATE(425)] = 16188,
  [SMALL_STATE(426)] = 16244,
  [SMALL_STATE(427)] = 16300,
  [SMALL_STATE(428)] = 16356,
  [SMALL_STATE(429)] = 16414,
  [SMALL_STATE(430)] = 16470,
  [SMALL_STATE(431)] = 16528,
  [SMALL_STATE(432)] = 16584,
  [SMALL_STATE(433)] = 16640,
  [SMALL_STATE(434)] = 16698,
  [SMALL_STATE(435)] = 16754,
  [SMALL_STATE(436)] = 16810,
  [SMALL_STATE(437)] = 16866,
  [SMALL_STATE(438)] = 16922,
  [SMALL_STATE(439)] = 16978,
  [SMALL_STATE(440)] = 17034,
  [SMALL_STATE(441)] = 17090,
  [SMALL_STATE(442)] = 17146,
  [SMALL_STATE(443)] = 17202,
  [SMALL_STATE(444)] = 17258,
  [SMALL_STATE(445)] = 17314,
  [SMALL_STATE(446)] = 17370,
  [SMALL_STATE(447)] = 17426,
  [SMALL_STATE(448)] = 17482,
  [SMALL_STATE(449)] = 17538,
  [SMALL_STATE(450)] = 17594,
  [SMALL_STATE(451)] = 17650,
  [SMALL_STATE(452)] = 17706,
  [SMALL_STATE(453)] = 17762,
  [SMALL_STATE(454)] = 17818,
  [SMALL_STATE(455)] = 17874,
  [SMALL_STATE(456)] = 17930,
  [SMALL_STATE(457)] = 17986,
  [SMALL_STATE(458)] = 18042,
  [SMALL_STATE(459)] = 18098,
  [SMALL_STATE(460)] = 18154,
  [SMALL_STATE(461)] = 18210,
  [SMALL_STATE(462)] = 18266,
  [SMALL_STATE(463)] = 18322,
  [SMALL_STATE(464)] = 18378,
  [SMALL_STATE(465)] = 18434,
  [SMALL_STATE(466)] = 18490,
  [SMALL_STATE(467)] = 18546,
  [SMALL_STATE(468)] = 18602,
  [SMALL_STATE(469)] = 18658,
  [SMALL_STATE(470)] = 18714,
  [SMALL_STATE(471)] = 18770,
  [SMALL_STATE(472)] = 18826,
  [SMALL_STATE(473)] = 18882,
  [SMALL_STATE(474)] = 18938,
  [SMALL_STATE(475)] = 18994,
  [SMALL_STATE(476)] = 19050,
  [SMALL_STATE(477)] = 19106,
  [SMALL_STATE(478)] = 19162,
  [SMALL_STATE(479)] = 19218,
  [SMALL_STATE(480)] = 19274,
  [SMALL_STATE(481)] = 19330,
  [SMALL_STATE(482)] = 19386,
  [SMALL_STATE(483)] = 19442,
  [SMALL_STATE(484)] = 19498,
  [SMALL_STATE(485)] = 19554,
  [SMALL_STATE(486)] = 19610,
  [SMALL_STATE(487)] = 19666,
  [SMALL_STATE(488)] = 19722,
  [SMALL_STATE(489)] = 19778,
  [SMALL_STATE(490)] = 19834,
  [SMALL_STATE(491)] = 19890,
  [SMALL_STATE(492)] = 19946,
  [SMALL_STATE(493)] = 20002,
  [SMALL_STATE(494)] = 20058,
  [SMALL_STATE(495)] = 20114,
  [SMALL_STATE(496)] = 20170,
  [SMALL_STATE(497)] = 20230,
  [SMALL_STATE(498)] = 20286,
  [SMALL_STATE(499)] = 20342,
  [SMALL_STATE(500)] = 20398,
  [SMALL_STATE(501)] = 20454,
  [SMALL_STATE(502)] = 20510,
  [SMALL_STATE(503)] = 20566,
  [SMALL_STATE(504)] = 20622,
  [SMALL_STATE(505)] = 20680,
  [SMALL_STATE(506)] = 20736,
  [SMALL_STATE(507)] = 20796,
  [SMALL_STATE(508)] = 20854,
  [SMALL_STATE(509)] = 20910,
  [SMALL_STATE(510)] = 20968,
  [SMALL_STATE(511)] = 21024,
  [SMALL_STATE(512)] = 21080,
  [SMALL_STATE(513)] = 21136,
  [SMALL_STATE(514)] = 21192,
  [SMALL_STATE(515)] = 21248,
  [SMALL_STATE(516)] = 21304,
  [SMALL_STATE(517)] = 21360,
  [SMALL_STATE(518)] = 21416,
  [SMALL_STATE(519)] = 21472,
  [SMALL_STATE(520)] = 21528,
  [SMALL_STATE(521)] = 21584,
  [SMALL_STATE(522)] = 21639,
  [SMALL_STATE(523)] = 21694,
  [SMALL_STATE(524)] = 21749,
  [SMALL_STATE(525)] = 21804,
  [SMALL_STATE(526)] = 21863,
  [SMALL_STATE(527)] = 21918,
  [SMALL_STATE(528)] = 21973,
  [SMALL_STATE(529)] = 22028,
  [SMALL_STATE(530)] = 22083,
  [SMALL_STATE(531)] = 22138,
  [SMALL_STATE(532)] = 22193,
  [SMALL_STATE(533)] = 22248,
  [SMALL_STATE(534)] = 22303,
  [SMALL_STATE(535)] = 22358,
  [SMALL_STATE(536)] = 22413,
  [SMALL_STATE(537)] = 22468,
  [SMALL_STATE(538)] = 22523,
  [SMALL_STATE(539)] = 22578,
  [SMALL_STATE(540)] = 22633,
  [SMALL_STATE(541)] = 22688,
  [SMALL_STATE(542)] = 22743,
  [SMALL_STATE(543)] = 22798,
  [SMALL_STATE(544)] = 22853,
  [SMALL_STATE(545)] = 22908,
  [SMALL_STATE(546)] = 22963,
  [SMALL_STATE(547)] = 23018,
  [SMALL_STATE(548)] = 23073,
  [SMALL_STATE(549)] = 23128,
  [SMALL_STATE(550)] = 23183,
  [SMALL_STATE(551)] = 23238,
  [SMALL_STATE(552)] = 23295,
  [SMALL_STATE(553)] = 23350,
  [SMALL_STATE(554)] = 23409,
  [SMALL_STATE(555)] = 23464,
  [SMALL_STATE(556)] = 23519,
  [SMALL_STATE(557)] = 23574,
  [SMALL_STATE(558)] = 23629,
  [SMALL_STATE(559)] = 23684,
  [SMALL_STATE(560)] = 23739,
  [SMALL_STATE(561)] = 23794,
  [SMALL_STATE(562)] = 23849,
  [SMALL_STATE(563)] = 23904,
  [SMALL_STATE(564)] = 23959,
  [SMALL_STATE(565)] = 24014,
  [SMALL_STATE(566)] = 24069,
  [SMALL_STATE(567)] = 24124,
  [SMALL_STATE(568)] = 24179,
  [SMALL_STATE(569)] = 24236,
  [SMALL_STATE(570)] = 24291,
  [SMALL_STATE(571)] = 24346,
  [SMALL_STATE(572)] = 24401,
  [SMALL_STATE(573)] = 24456,
  [SMALL_STATE(574)] = 24511,
  [SMALL_STATE(575)] = 24566,
  [SMALL_STATE(576)] = 24621,
  [SMALL_STATE(577)] = 24676,
  [SMALL_STATE(578)] = 24731,
  [SMALL_STATE(579)] = 24790,
  [SMALL_STATE(580)] = 24845,
  [SMALL_STATE(581)] = 24904,
  [SMALL_STATE(582)] = 24959,
  [SMALL_STATE(583)] = 25014,
  [SMALL_STATE(584)] = 25068,
  [SMALL_STATE(585)] = 25124,
  [SMALL_STATE(586)] = 25178,
  [SMALL_STATE(587)] = 25232,
  [SMALL_STATE(588)] = 25286,
  [SMALL_STATE(589)] = 25340,
  [SMALL_STATE(590)] = 25394,
  [SMALL_STATE(591)] = 25448,
  [SMALL_STATE(592)] = 25502,
  [SMALL_STATE(593)] = 25556,
  [SMALL_STATE(594)] = 25610,
  [SMALL_STATE(595)] = 25664,
  [SMALL_STATE(596)] = 25718,
  [SMALL_STATE(597)] = 25772,
  [SMALL_STATE(598)] = 25826,
  [SMALL_STATE(599)] = 25880,
  [SMALL_STATE(600)] = 25934,
  [SMALL_STATE(601)] = 25988,
  [SMALL_STATE(602)] = 26042,
  [SMALL_STATE(603)] = 26096,
  [SMALL_STATE(604)] = 26150,
  [SMALL_STATE(605)] = 26206,
  [SMALL_STATE(606)] = 26260,
  [SMALL_STATE(607)] = 26316,
  [SMALL_STATE(608)] = 26370,
  [SMALL_STATE(609)] = 26424,
  [SMALL_STATE(610)] = 26478,
  [SMALL_STATE(611)] = 26534,
  [SMALL_STATE(612)] = 26590,
  [SMALL_STATE(613)] = 26646,
  [SMALL_STATE(614)] = 26700,
  [SMALL_STATE(615)] = 26754,
  [SMALL_STATE(616)] = 26808,
  [SMALL_STATE(617)] = 26862,
  [SMALL_STATE(618)] = 26916,
  [SMALL_STATE(619)] = 26970,
  [SMALL_STATE(620)] = 27024,
  [SMALL_STATE(621)] = 27080,
  [SMALL_STATE(622)] = 27136,
  [SMALL_STATE(623)] = 27190,
  [SMALL_STATE(624)] = 27244,
  [SMALL_STATE(625)] = 27298,
  [SMALL_STATE(626)] = 27352,
  [SMALL_STATE(627)] = 27406,
  [SMALL_STATE(628)] = 27460,
  [SMALL_STATE(629)] = 27541,
  [SMALL_STATE(630)] = 27622,
  [SMALL_STATE(631)] = 27703,
  [SMALL_STATE(632)] = 27784,
  [SMALL_STATE(633)] = 27865,
  [SMALL_STATE(634)] = 27946,
  [SMALL_STATE(635)] = 28025,
  [SMALL_STATE(636)] = 28106,
  [SMALL_STATE(637)] = 28185,
  [SMALL_STATE(638)] = 28266,
  [SMALL_STATE(639)] = 28347,
  [SMALL_STATE(640)] = 28428,
  [SMALL_STATE(641)] = 28509,
  [SMALL_STATE(642)] = 28590,
  [SMALL_STATE(643)] = 28671,
  [SMALL_STATE(644)] = 28752,
  [SMALL_STATE(645)] = 28833,
  [SMALL_STATE(646)] = 28914,
  [SMALL_STATE(647)] = 28995,
  [SMALL_STATE(648)] = 29076,
  [SMALL_STATE(649)] = 29157,
  [SMALL_STATE(650)] = 29238,
  [SMALL_STATE(651)] = 29304,
  [SMALL_STATE(652)] = 29358,
  [SMALL_STATE(653)] = 29432,
  [SMALL_STATE(654)] = 29486,
  [SMALL_STATE(655)] = 29540,
  [SMALL_STATE(656)] = 29606,
  [SMALL_STATE(657)] = 29673,
  [SMALL_STATE(658)] = 29724,
  [SMALL_STATE(659)] = 29775,
  [SMALL_STATE(660)] = 29826,
  [SMALL_STATE(661)] = 29877,
  [SMALL_STATE(662)] = 29943,
  [SMALL_STATE(663)] = 30009,
  [SMALL_STATE(664)] = 30075,
  [SMALL_STATE(665)] = 30141,
  [SMALL_STATE(666)] = 30207,
  [SMALL_STATE(667)] = 30271,
  [SMALL_STATE(668)] = 30337,
  [SMALL_STATE(669)] = 30403,
  [SMALL_STATE(670)] = 30469,
  [SMALL_STATE(671)] = 30534,
  [SMALL_STATE(672)] = 30595,
  [SMALL_STATE(673)] = 30660,
  [SMALL_STATE(674)] = 30721,
  [SMALL_STATE(675)] = 30782,
  [SMALL_STATE(676)] = 30847,
  [SMALL_STATE(677)] = 30904,
  [SMALL_STATE(678)] = 30965,
  [SMALL_STATE(679)] = 31022,
  [SMALL_STATE(680)] = 31083,
  [SMALL_STATE(681)] = 31133,
  [SMALL_STATE(682)] = 31193,
  [SMALL_STATE(683)] = 31255,
  [SMALL_STATE(684)] = 31317,
  [SMALL_STATE(685)] = 31377,
  [SMALL_STATE(686)] = 31439,
  [SMALL_STATE(687)] = 31501,
  [SMALL_STATE(688)] = 31551,
  [SMALL_STATE(689)] = 31613,
  [SMALL_STATE(690)] = 31675,
  [SMALL_STATE(691)] = 31737,
  [SMALL_STATE(692)] = 31797,
  [SMALL_STATE(693)] = 31847,
  [SMALL_STATE(694)] = 31903,
  [SMALL_STATE(695)] = 31965,
  [SMALL_STATE(696)] = 32027,
  [SMALL_STATE(697)] = 32089,
  [SMALL_STATE(698)] = 32151,
  [SMALL_STATE(699)] = 32213,
  [SMALL_STATE(700)] = 32272,
  [SMALL_STATE(701)] = 32319,
  [SMALL_STATE(702)] = 32378,
  [SMALL_STATE(703)] = 32437,
  [SMALL_STATE(704)] = 32496,
  [SMALL_STATE(705)] = 32555,
  [SMALL_STATE(706)] = 32614,
  [SMALL_STATE(707)] = 32673,
  [SMALL_STATE(708)] = 32732,
  [SMALL_STATE(709)] = 32791,
  [SMALL_STATE(710)] = 32850,
  [SMALL_STATE(711)] = 32897,
  [SMALL_STATE(712)] = 32956,
  [SMALL_STATE(713)] = 33015,
  [SMALL_STATE(714)] = 33074,
  [SMALL_STATE(715)] = 33133,
  [SMALL_STATE(716)] = 33192,
  [SMALL_STATE(717)] = 33239,
  [SMALL_STATE(718)] = 33298,
  [SMALL_STATE(719)] = 33357,
  [SMALL_STATE(720)] = 33416,
  [SMALL_STATE(721)] = 33475,
  [SMALL_STATE(722)] = 33522,
  [SMALL_STATE(723)] = 33581,
  [SMALL_STATE(724)] = 33628,
  [SMALL_STATE(725)] = 33687,
  [SMALL_STATE(726)] = 33746,
  [SMALL_STATE(727)] = 33805,
  [SMALL_STATE(728)] = 33852,
  [SMALL_STATE(729)] = 33911,
  [SMALL_STATE(730)] = 33958,
  [SMALL_STATE(731)] = 34005,
  [SMALL_STATE(732)] = 34064,
  [SMALL_STATE(733)] = 34123,
  [SMALL_STATE(734)] = 34182,
  [SMALL_STATE(735)] = 34229,
  [SMALL_STATE(736)] = 34276,
  [SMALL_STATE(737)] = 34335,
  [SMALL_STATE(738)] = 34394,
  [SMALL_STATE(739)] = 34453,
  [SMALL_STATE(740)] = 34512,
  [SMALL_STATE(741)] = 34571,
  [SMALL_STATE(742)] = 34630,
  [SMALL_STATE(743)] = 34689,
  [SMALL_STATE(744)] = 34748,
  [SMALL_STATE(745)] = 34807,
  [SMALL_STATE(746)] = 34866,
  [SMALL_STATE(747)] = 34925,
  [SMALL_STATE(748)] = 34984,
  [SMALL_STATE(749)] = 35043,
  [SMALL_STATE(750)] = 35102,
  [SMALL_STATE(751)] = 35149,
  [SMALL_STATE(752)] = 35208,
  [SMALL_STATE(753)] = 35255,
  [SMALL_STATE(754)] = 35302,
  [SMALL_STATE(755)] = 35361,
  [SMALL_STATE(756)] = 35420,
  [SMALL_STATE(757)] = 35479,
  [SMALL_STATE(758)] = 35526,
  [SMALL_STATE(759)] = 35585,
  [SMALL_STATE(760)] = 35632,
  [SMALL_STATE(761)] = 35679,
  [SMALL_STATE(762)] = 35726,
  [SMALL_STATE(763)] = 35773,
  [SMALL_STATE(764)] = 35820,
  [SMALL_STATE(765)] = 35867,
  [SMALL_STATE(766)] = 35926,
  [SMALL_STATE(767)] = 35985,
  [SMALL_STATE(768)] = 36044,
  [SMALL_STATE(769)] = 36103,
  [SMALL_STATE(770)] = 36150,
  [SMALL_STATE(771)] = 36209,
  [SMALL_STATE(772)] = 36265,
  [SMALL_STATE(773)] = 36321,
  [SMALL_STATE(774)] = 36377,
  [SMALL_STATE(775)] = 36433,
  [SMALL_STATE(776)] = 36489,
  [SMALL_STATE(777)] = 36545,
  [SMALL_STATE(778)] = 36601,
  [SMALL_STATE(779)] = 36657,
  [SMALL_STATE(780)] = 36713,
  [SMALL_STATE(781)] = 36761,
  [SMALL_STATE(782)] = 36809,
  [SMALL_STATE(783)] = 36865,
  [SMALL_STATE(784)] = 36921,
  [SMALL_STATE(785)] = 36977,
  [SMALL_STATE(786)] = 37033,
  [SMALL_STATE(787)] = 37089,
  [SMALL_STATE(788)] = 37137,
  [SMALL_STATE(789)] = 37193,
  [SMALL_STATE(790)] = 37241,
  [SMALL_STATE(791)] = 37293,
  [SMALL_STATE(792)] = 37341,
  [SMALL_STATE(793)] = 37391,
  [SMALL_STATE(794)] = 37439,
  [SMALL_STATE(795)] = 37487,
  [SMALL_STATE(796)] = 37543,
  [SMALL_STATE(797)] = 37593,
  [SMALL_STATE(798)] = 37647,
  [SMALL_STATE(799)] = 37703,
  [SMALL_STATE(800)] = 37759,
  [SMALL_STATE(801)] = 37815,
  [SMALL_STATE(802)] = 37871,
  [SMALL_STATE(803)] = 37927,
  [SMALL_STATE(804)] = 37972,
  [SMALL_STATE(805)] = 38017,
  [SMALL_STATE(806)] = 38062,
  [SMALL_STATE(807)] = 38113,
  [SMALL_STATE(808)] = 38158,
  [SMALL_STATE(809)] = 38203,
  [SMALL_STATE(810)] = 38248,
  [SMALL_STATE(811)] = 38297,
  [SMALL_STATE(812)] = 38346,
  [SMALL_STATE(813)] = 38391,
  [SMALL_STATE(814)] = 38436,
  [SMALL_STATE(815)] = 38481,
  [SMALL_STATE(816)] = 38526,
  [SMALL_STATE(817)] = 38571,
  [SMALL_STATE(818)] = 38618,
  [SMALL_STATE(819)] = 38663,
  [SMALL_STATE(820)] = 38708,
  [SMALL_STATE(821)] = 38759,
  [SMALL_STATE(822)] = 38804,
  [SMALL_STATE(823)] = 38856,
  [SMALL_STATE(824)] = 38902,
  [SMALL_STATE(825)] = 38948,
  [SMALL_STATE(826)] = 38994,
  [SMALL_STATE(827)] = 39038,
  [SMALL_STATE(828)] = 39084,
  [SMALL_STATE(829)] = 39130,
  [SMALL_STATE(830)] = 39176,
  [SMALL_STATE(831)] = 39222,
  [SMALL_STATE(832)] = 39268,
  [SMALL_STATE(833)] = 39314,
  [SMALL_STATE(834)] = 39360,
  [SMALL_STATE(835)] = 39406,
  [SMALL_STATE(836)] = 39450,
  [SMALL_STATE(837)] = 39493,
  [SMALL_STATE(838)] = 39538,
  [SMALL_STATE(839)] = 39583,
  [SMALL_STATE(840)] = 39626,
  [SMALL_STATE(841)] = 39669,
  [SMALL_STATE(842)] = 39712,
  [SMALL_STATE(843)] = 39755,
  [SMALL_STATE(844)] = 39798,
  [SMALL_STATE(845)] = 39841,
  [SMALL_STATE(846)] = 39884,
  [SMALL_STATE(847)] = 39927,
  [SMALL_STATE(848)] = 39972,
  [SMALL_STATE(849)] = 40017,
  [SMALL_STATE(850)] = 40062,
  [SMALL_STATE(851)] = 40105,
  [SMALL_STATE(852)] = 40148,
  [SMALL_STATE(853)] = 40190,
  [SMALL_STATE(854)] = 40232,
  [SMALL_STATE(855)] = 40274,
  [SMALL_STATE(856)] = 40316,
  [SMALL_STATE(857)] = 40358,
  [SMALL_STATE(858)] = 40392,
  [SMALL_STATE(859)] = 40426,
  [SMALL_STATE(860)] = 40460,
  [SMALL_STATE(861)] = 40494,
  [SMALL_STATE(862)] = 40528,
  [SMALL_STATE(863)] = 40562,
  [SMALL_STATE(864)] = 40585,
  [SMALL_STATE(865)] = 40615,
  [SMALL_STATE(866)] = 40645,
  [SMALL_STATE(867)] = 40675,
  [SMALL_STATE(868)] = 40705,
  [SMALL_STATE(869)] = 40735,
  [SMALL_STATE(870)] = 40765,
  [SMALL_STATE(871)] = 40795,
  [SMALL_STATE(872)] = 40825,
  [SMALL_STATE(873)] = 40855,
  [SMALL_STATE(874)] = 40885,
  [SMALL_STATE(875)] = 40915,
  [SMALL_STATE(876)] = 40945,
  [SMALL_STATE(877)] = 40975,
  [SMALL_STATE(878)] = 41005,
  [SMALL_STATE(879)] = 41035,
  [SMALL_STATE(880)] = 41065,
  [SMALL_STATE(881)] = 41095,
  [SMALL_STATE(882)] = 41125,
  [SMALL_STATE(883)] = 41155,
  [SMALL_STATE(884)] = 41185,
  [SMALL_STATE(885)] = 41210,
  [SMALL_STATE(886)] = 41235,
  [SMALL_STATE(887)] = 41262,
  [SMALL_STATE(888)] = 41287,
  [SMALL_STATE(889)] = 41314,
  [SMALL_STATE(890)] = 41339,
  [SMALL_STATE(891)] = 41364,
  [SMALL_STATE(892)] = 41389,
  [SMALL_STATE(893)] = 41412,
  [SMALL_STATE(894)] = 41437,
  [SMALL_STATE(895)] = 41462,
  [SMALL_STATE(896)] = 41487,
  [SMALL_STATE(897)] = 41514,
  [SMALL_STATE(898)] = 41539,
  [SMALL_STATE(899)] = 41564,
  [SMALL_STATE(900)] = 41589,
  [SMALL_STATE(901)] = 41616,
  [SMALL_STATE(902)] = 41640,
  [SMALL_STATE(903)] = 41658,
  [SMALL_STATE(904)] = 41682,
  [SMALL_STATE(905)] = 41706,
  [SMALL_STATE(906)] = 41724,
  [SMALL_STATE(907)] = 41748,
  [SMALL_STATE(908)] = 41768,
  [SMALL_STATE(909)] = 41792,
  [SMALL_STATE(910)] = 41816,
  [SMALL_STATE(911)] = 41840,
  [SMALL_STATE(912)] = 41858,
  [SMALL_STATE(913)] = 41882,
  [SMALL_STATE(914)] = 41906,
  [SMALL_STATE(915)] = 41930,
  [SMALL_STATE(916)] = 41954,
  [SMALL_STATE(917)] = 41978,
  [SMALL_STATE(918)] = 41998,
  [SMALL_STATE(919)] = 42016,
  [SMALL_STATE(920)] = 42034,
  [SMALL_STATE(921)] = 42052,
  [SMALL_STATE(922)] = 42070,
  [SMALL_STATE(923)] = 42088,
  [SMALL_STATE(924)] = 42106,
  [SMALL_STATE(925)] = 42124,
  [SMALL_STATE(926)] = 42142,
  [SMALL_STATE(927)] = 42160,
  [SMALL_STATE(928)] = 42178,
  [SMALL_STATE(929)] = 42196,
  [SMALL_STATE(930)] = 42214,
  [SMALL_STATE(931)] = 42232,
  [SMALL_STATE(932)] = 42250,
  [SMALL_STATE(933)] = 42268,
  [SMALL_STATE(934)] = 42286,
  [SMALL_STATE(935)] = 42304,
  [SMALL_STATE(936)] = 42322,
  [SMALL_STATE(937)] = 42340,
  [SMALL_STATE(938)] = 42358,
  [SMALL_STATE(939)] = 42376,
  [SMALL_STATE(940)] = 42394,
  [SMALL_STATE(941)] = 42412,
  [SMALL_STATE(942)] = 42430,
  [SMALL_STATE(943)] = 42448,
  [SMALL_STATE(944)] = 42466,
  [SMALL_STATE(945)] = 42484,
  [SMALL_STATE(946)] = 42502,
  [SMALL_STATE(947)] = 42520,
  [SMALL_STATE(948)] = 42538,
  [SMALL_STATE(949)] = 42556,
  [SMALL_STATE(950)] = 42574,
  [SMALL_STATE(951)] = 42592,
  [SMALL_STATE(952)] = 42610,
  [SMALL_STATE(953)] = 42628,
  [SMALL_STATE(954)] = 42646,
  [SMALL_STATE(955)] = 42664,
  [SMALL_STATE(956)] = 42682,
  [SMALL_STATE(957)] = 42700,
  [SMALL_STATE(958)] = 42718,
  [SMALL_STATE(959)] = 42736,
  [SMALL_STATE(960)] = 42754,
  [SMALL_STATE(961)] = 42772,
  [SMALL_STATE(962)] = 42790,
  [SMALL_STATE(963)] = 42808,
  [SMALL_STATE(964)] = 42826,
  [SMALL_STATE(965)] = 42844,
  [SMALL_STATE(966)] = 42862,
  [SMALL_STATE(967)] = 42880,
  [SMALL_STATE(968)] = 42898,
  [SMALL_STATE(969)] = 42916,
  [SMALL_STATE(970)] = 42934,
  [SMALL_STATE(971)] = 42952,
  [SMALL_STATE(972)] = 42970,
  [SMALL_STATE(973)] = 42988,
  [SMALL_STATE(974)] = 43006,
  [SMALL_STATE(975)] = 43024,
  [SMALL_STATE(976)] = 43042,
  [SMALL_STATE(977)] = 43060,
  [SMALL_STATE(978)] = 43078,
  [SMALL_STATE(979)] = 43096,
  [SMALL_STATE(980)] = 43114,
  [SMALL_STATE(981)] = 43132,
  [SMALL_STATE(982)] = 43150,
  [SMALL_STATE(983)] = 43168,
  [SMALL_STATE(984)] = 43186,
  [SMALL_STATE(985)] = 43204,
  [SMALL_STATE(986)] = 43222,
  [SMALL_STATE(987)] = 43240,
  [SMALL_STATE(988)] = 43258,
  [SMALL_STATE(989)] = 43276,
  [SMALL_STATE(990)] = 43294,
  [SMALL_STATE(991)] = 43312,
  [SMALL_STATE(992)] = 43326,
  [SMALL_STATE(993)] = 43340,
  [SMALL_STATE(994)] = 43358,
  [SMALL_STATE(995)] = 43376,
  [SMALL_STATE(996)] = 43394,
  [SMALL_STATE(997)] = 43412,
  [SMALL_STATE(998)] = 43430,
  [SMALL_STATE(999)] = 43448,
  [SMALL_STATE(1000)] = 43466,
  [SMALL_STATE(1001)] = 43484,
  [SMALL_STATE(1002)] = 43502,
  [SMALL_STATE(1003)] = 43520,
  [SMALL_STATE(1004)] = 43538,
  [SMALL_STATE(1005)] = 43556,
  [SMALL_STATE(1006)] = 43574,
  [SMALL_STATE(1007)] = 43592,
  [SMALL_STATE(1008)] = 43610,
  [SMALL_STATE(1009)] = 43628,
  [SMALL_STATE(1010)] = 43646,
  [SMALL_STATE(1011)] = 43664,
  [SMALL_STATE(1012)] = 43682,
  [SMALL_STATE(1013)] = 43700,
  [SMALL_STATE(1014)] = 43718,
  [SMALL_STATE(1015)] = 43736,
  [SMALL_STATE(1016)] = 43754,
  [SMALL_STATE(1017)] = 43772,
  [SMALL_STATE(1018)] = 43790,
  [SMALL_STATE(1019)] = 43808,
  [SMALL_STATE(1020)] = 43826,
  [SMALL_STATE(1021)] = 43844,
  [SMALL_STATE(1022)] = 43862,
  [SMALL_STATE(1023)] = 43880,
  [SMALL_STATE(1024)] = 43898,
  [SMALL_STATE(1025)] = 43916,
  [SMALL_STATE(1026)] = 43934,
  [SMALL_STATE(1027)] = 43952,
  [SMALL_STATE(1028)] = 43970,
  [SMALL_STATE(1029)] = 43988,
  [SMALL_STATE(1030)] = 44002,
  [SMALL_STATE(1031)] = 44020,
  [SMALL_STATE(1032)] = 44038,
  [SMALL_STATE(1033)] = 44056,
  [SMALL_STATE(1034)] = 44074,
  [SMALL_STATE(1035)] = 44092,
  [SMALL_STATE(1036)] = 44110,
  [SMALL_STATE(1037)] = 44124,
  [SMALL_STATE(1038)] = 44135,
  [SMALL_STATE(1039)] = 44146,
  [SMALL_STATE(1040)] = 44157,
  [SMALL_STATE(1041)] = 44168,
  [SMALL_STATE(1042)] = 44178,
  [SMALL_STATE(1043)] = 44188,
  [SMALL_STATE(1044)] = 44198,
  [SMALL_STATE(1045)] = 44208,
  [SMALL_STATE(1046)] = 44218,
  [SMALL_STATE(1047)] = 44227,
  [SMALL_STATE(1048)] = 44236,
  [SMALL_STATE(1049)] = 44245,
  [SMALL_STATE(1050)] = 44254,
  [SMALL_STATE(1051)] = 44264,
  [SMALL_STATE(1052)] = 44274,
  [SMALL_STATE(1053)] = 44284,
  [SMALL_STATE(1054)] = 44294,
  [SMALL_STATE(1055)] = 44304,
  [SMALL_STATE(1056)] = 44314,
  [SMALL_STATE(1057)] = 44324,
  [SMALL_STATE(1058)] = 44334,
  [SMALL_STATE(1059)] = 44344,
  [SMALL_STATE(1060)] = 44354,
  [SMALL_STATE(1061)] = 44361,
  [SMALL_STATE(1062)] = 44368,
  [SMALL_STATE(1063)] = 44375,
  [SMALL_STATE(1064)] = 44380,
  [SMALL_STATE(1065)] = 44387,
  [SMALL_STATE(1066)] = 44394,
  [SMALL_STATE(1067)] = 44401,
  [SMALL_STATE(1068)] = 44408,
  [SMALL_STATE(1069)] = 44412,
  [SMALL_STATE(1070)] = 44416,
  [SMALL_STATE(1071)] = 44420,
  [SMALL_STATE(1072)] = 44424,
  [SMALL_STATE(1073)] = 44428,
  [SMALL_STATE(1074)] = 44432,
  [SMALL_STATE(1075)] = 44436,
  [SMALL_STATE(1076)] = 44440,
  [SMALL_STATE(1077)] = 44444,
  [SMALL_STATE(1078)] = 44448,
  [SMALL_STATE(1079)] = 44452,
  [SMALL_STATE(1080)] = 44456,
  [SMALL_STATE(1081)] = 44460,
  [SMALL_STATE(1082)] = 44464,
  [SMALL_STATE(1083)] = 44468,
  [SMALL_STATE(1084)] = 44472,
  [SMALL_STATE(1085)] = 44476,
  [SMALL_STATE(1086)] = 44480,
  [SMALL_STATE(1087)] = 44484,
  [SMALL_STATE(1088)] = 44488,
  [SMALL_STATE(1089)] = 44492,
  [SMALL_STATE(1090)] = 44496,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(212),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(208),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(250),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [45] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(495),
  [48] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(149),
  [51] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(89),
  [54] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(262),
  [57] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(216),
  [60] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(261),
  [63] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(248),
  [66] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(261),
  [69] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(232),
  [72] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(264),
  [75] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(198),
  [78] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(177),
  [81] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(211),
  [84] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(181),
  [87] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(222),
  [90] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(245),
  [93] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(166),
  [96] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(7),
  [99] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(5),
  [102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1),
  [104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(12),
  [109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element, 1),
  [111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(328),
  [114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(150),
  [117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(88),
  [120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(255),
  [123] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(231),
  [126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(247),
  [129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(258),
  [132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(247),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(217),
  [138] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(241),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(192),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(183),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(237),
  [150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(188),
  [153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(218),
  [156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(244),
  [159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(171),
  [162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(39),
  [165] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(8),
  [168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(10),
  [173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(416),
  [176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(153),
  [179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(87),
  [182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(266),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(235),
  [188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(240),
  [191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(246),
  [194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(240),
  [197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(238),
  [200] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(249),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(199),
  [206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(184),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(226),
  [212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(187),
  [215] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(236),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(254),
  [221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(172),
  [224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(9),
  [227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(46),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(2),
  [235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(416),
  [238] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(153),
  [241] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(87),
  [244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(266),
  [247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(235),
  [250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(240),
  [253] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(246),
  [256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(240),
  [259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(238),
  [262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(249),
  [265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(199),
  [268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(184),
  [271] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(226),
  [274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(187),
  [277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(236),
  [280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(254),
  [283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(172),
  [286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(9),
  [289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(46),
  [292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(2),
  [297] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1),
  [299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(495),
  [302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(149),
  [305] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(89),
  [308] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(262),
  [311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(216),
  [314] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(261),
  [317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(248),
  [320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(261),
  [323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(232),
  [326] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(264),
  [329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(198),
  [332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(177),
  [335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(211),
  [338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(181),
  [341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(222),
  [344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(245),
  [347] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(166),
  [350] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(7),
  [353] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(5),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [358] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(12),
  [361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(328),
  [364] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(150),
  [367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(88),
  [370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(255),
  [373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(231),
  [376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(247),
  [379] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(258),
  [382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(247),
  [385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(217),
  [388] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(241),
  [391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(192),
  [394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(183),
  [397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(237),
  [400] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(188),
  [403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(218),
  [406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(244),
  [409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(171),
  [412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(39),
  [415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(8),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [420] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(10),
  [423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(416),
  [426] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(153),
  [429] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(87),
  [432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(266),
  [435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(235),
  [438] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(240),
  [441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(246),
  [444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(240),
  [447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(238),
  [450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(249),
  [453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(199),
  [456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(184),
  [459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(226),
  [462] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(187),
  [465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(236),
  [468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(254),
  [471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(172),
  [474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(9),
  [477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(46),
  [480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1),
  [482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [484] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(2),
  [487] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(328),
  [490] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(150),
  [493] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(88),
  [496] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(255),
  [499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(231),
  [502] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(247),
  [505] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(258),
  [508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(247),
  [511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(217),
  [514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(241),
  [517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(192),
  [520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(183),
  [523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(237),
  [526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(188),
  [529] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(218),
  [532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(244),
  [535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(171),
  [538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(39),
  [541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(8),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(10),
  [549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(495),
  [552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(149),
  [555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(89),
  [558] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(262),
  [561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(216),
  [564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(261),
  [567] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(248),
  [570] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(261),
  [573] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(232),
  [576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(264),
  [579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(198),
  [582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(177),
  [585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(211),
  [588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(181),
  [591] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(222),
  [594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(245),
  [597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(166),
  [600] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(7),
  [603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(5),
  [606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(12),
  [611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(328),
  [614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(150),
  [617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(88),
  [620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(255),
  [623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(231),
  [626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(247),
  [629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(258),
  [632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(247),
  [635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(217),
  [638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(241),
  [641] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(192),
  [644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(183),
  [647] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(237),
  [650] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(188),
  [653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(218),
  [656] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(244),
  [659] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(171),
  [662] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(39),
  [665] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(8),
  [668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2),
  [670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star, 2), SHIFT_REPEAT(10),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(216),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(232),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(211),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(245),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(231),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(247),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(217),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(244),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(226),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(254),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline, 2),
  [805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(494),
  [808] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(152),
  [811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(86),
  [814] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(268),
  [817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(212),
  [820] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(267),
  [823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(260),
  [826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(267),
  [829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(208),
  [832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(256),
  [835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(191),
  [838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(176),
  [841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(209),
  [844] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(180),
  [847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(229),
  [850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(250),
  [853] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(170),
  [856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(3),
  [859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(4),
  [862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(6),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [885] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(495),
  [888] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(149),
  [891] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(89),
  [894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(262),
  [897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(216),
  [900] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(261),
  [903] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(248),
  [906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(261),
  [909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(232),
  [912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(264),
  [915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(198),
  [918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(177),
  [921] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(211),
  [924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(181),
  [927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(222),
  [930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(245),
  [933] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(166),
  [936] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(7),
  [939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(5),
  [942] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2), SHIFT_REPEAT(12),
  [945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde, 2),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline, 1),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(376),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(416),
  [980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(153),
  [983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(87),
  [986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(266),
  [989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(235),
  [992] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(240),
  [995] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(246),
  [998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(240),
  [1001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(238),
  [1004] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(249),
  [1007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(199),
  [1010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(184),
  [1013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(226),
  [1016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(187),
  [1019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(236),
  [1022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(254),
  [1025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(172),
  [1028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(9),
  [1031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(46),
  [1034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2),
  [1036] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore, 2), SHIFT_REPEAT(2),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline, 2),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [1105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(566),
  [1108] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(157),
  [1111] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(90),
  [1114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(330),
  [1117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(259),
  [1120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(314),
  [1123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(506),
  [1126] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(314),
  [1129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(263),
  [1132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(310),
  [1135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(201),
  [1138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(189),
  [1141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(270),
  [1144] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(195),
  [1147] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(269),
  [1150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(306),
  [1153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(174),
  [1156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(51),
  [1159] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(49),
  [1162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline, 2), SHIFT_REPEAT(45),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [1171] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(566),
  [1174] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(161),
  [1177] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(1063),
  [1180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(259),
  [1183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(314),
  [1186] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(286),
  [1189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(314),
  [1192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(263),
  [1195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(310),
  [1198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(205),
  [1201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(190),
  [1204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(270),
  [1207] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(194),
  [1210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(269),
  [1213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element, 1), SHIFT(306),
  [1216] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(173),
  [1219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(99),
  [1222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(98),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [1227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element, 1), SHIFT(97),
  [1230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(566),
  [1233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(161),
  [1236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(1063),
  [1239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(259),
  [1242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(314),
  [1245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(286),
  [1248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(314),
  [1251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(263),
  [1254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(310),
  [1257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(205),
  [1260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(190),
  [1263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(270),
  [1266] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(194),
  [1269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(269),
  [1272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(306),
  [1275] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(173),
  [1278] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(99),
  [1281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(98),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1286] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1), SHIFT(97),
  [1289] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(566),
  [1292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(161),
  [1295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(1063),
  [1298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(259),
  [1301] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(314),
  [1304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(286),
  [1307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(314),
  [1310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(263),
  [1313] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(310),
  [1316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(205),
  [1319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(190),
  [1322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(270),
  [1325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(194),
  [1328] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(269),
  [1331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(306),
  [1334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(173),
  [1337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(99),
  [1340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(98),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1345] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1), SHIFT(97),
  [1348] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(566),
  [1351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(161),
  [1354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(1063),
  [1357] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(259),
  [1360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(314),
  [1363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(286),
  [1366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(314),
  [1369] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(263),
  [1372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(310),
  [1375] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(205),
  [1378] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(190),
  [1381] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(270),
  [1384] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(194),
  [1387] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(269),
  [1390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(306),
  [1393] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(173),
  [1396] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(99),
  [1399] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(98),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [1404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1), SHIFT(97),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [1409] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(416),
  [1412] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(165),
  [1415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(235),
  [1418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(240),
  [1421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(418),
  [1424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(240),
  [1427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(238),
  [1430] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(249),
  [1433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(193),
  [1436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(175),
  [1439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(226),
  [1442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(179),
  [1445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(236),
  [1448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(254),
  [1451] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(167),
  [1454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(93),
  [1457] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(120),
  [1460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1),
  [1462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(94),
  [1467] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(495),
  [1470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(160),
  [1473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(216),
  [1476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(261),
  [1479] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(496),
  [1482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(261),
  [1485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(232),
  [1488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(264),
  [1491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(196),
  [1494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(185),
  [1497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(211),
  [1500] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(182),
  [1503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(222),
  [1506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(245),
  [1509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(168),
  [1512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(95),
  [1515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(96),
  [1518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1), SHIFT(129),
  [1523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(328),
  [1526] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(159),
  [1529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(231),
  [1532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(247),
  [1535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(312),
  [1538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(247),
  [1541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(217),
  [1544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(241),
  [1547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(197),
  [1550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(178),
  [1553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(237),
  [1556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(186),
  [1559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(218),
  [1562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(244),
  [1565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(169),
  [1568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(112),
  [1571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(91),
  [1574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1),
  [1576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(92),
  [1581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(495),
  [1584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(160),
  [1587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(216),
  [1590] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(261),
  [1593] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(496),
  [1596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(261),
  [1599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(232),
  [1602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(264),
  [1605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(196),
  [1608] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(185),
  [1611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(211),
  [1614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(182),
  [1617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(222),
  [1620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(245),
  [1623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(168),
  [1626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(95),
  [1629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(96),
  [1632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1634] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1), SHIFT(129),
  [1637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(328),
  [1640] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(159),
  [1643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(231),
  [1646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(247),
  [1649] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(312),
  [1652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(247),
  [1655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(217),
  [1658] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(241),
  [1661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(197),
  [1664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(178),
  [1667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(237),
  [1670] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(186),
  [1673] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(218),
  [1676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(244),
  [1679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(169),
  [1682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(112),
  [1685] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(91),
  [1688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(92),
  [1693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1),
  [1695] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(416),
  [1698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(165),
  [1701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(235),
  [1704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(240),
  [1707] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(418),
  [1710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(240),
  [1713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(238),
  [1716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(249),
  [1719] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(193),
  [1722] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(175),
  [1725] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(226),
  [1728] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(179),
  [1731] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(236),
  [1734] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(254),
  [1737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(167),
  [1740] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(93),
  [1743] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(120),
  [1746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1748] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1), SHIFT(94),
  [1751] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(495),
  [1754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(160),
  [1757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1),
  [1759] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(216),
  [1762] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(261),
  [1765] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(496),
  [1768] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(261),
  [1771] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(232),
  [1774] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(264),
  [1777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(196),
  [1780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(185),
  [1783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(211),
  [1786] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(182),
  [1789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(222),
  [1792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(245),
  [1795] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(168),
  [1798] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(95),
  [1801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(96),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(129),
  [1809] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(416),
  [1812] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(165),
  [1815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(235),
  [1818] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(240),
  [1821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(418),
  [1824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(240),
  [1827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(238),
  [1830] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(249),
  [1833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(193),
  [1836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(175),
  [1839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(226),
  [1842] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(179),
  [1845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(236),
  [1848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(254),
  [1851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(167),
  [1854] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(93),
  [1857] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(120),
  [1860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(94),
  [1865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(328),
  [1868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(159),
  [1871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(231),
  [1874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(247),
  [1877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(312),
  [1880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(247),
  [1883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(217),
  [1886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(241),
  [1889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(197),
  [1892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(178),
  [1895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(237),
  [1898] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(186),
  [1901] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(218),
  [1904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(244),
  [1907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(169),
  [1910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(112),
  [1913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(91),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1), SHIFT(92),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(205),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(190),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [1945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [1979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [1985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [1991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2035] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(328),
  [2038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(159),
  [2041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(231),
  [2044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(247),
  [2047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(312),
  [2050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(247),
  [2053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(217),
  [2056] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(241),
  [2059] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(197),
  [2062] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(178),
  [2065] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(237),
  [2068] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(186),
  [2071] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(218),
  [2074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(244),
  [2077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(169),
  [2080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(112),
  [2083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(91),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2),
  [2088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_star_no_link, 2), SHIFT_REPEAT(92),
  [2091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [2097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(416),
  [2100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(165),
  [2103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(235),
  [2106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(240),
  [2109] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(418),
  [2112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(240),
  [2115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(238),
  [2118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(249),
  [2121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(193),
  [2124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(175),
  [2127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(226),
  [2130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(179),
  [2133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(236),
  [2136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(254),
  [2139] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(167),
  [2142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(93),
  [2145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(120),
  [2148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2),
  [2150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_underscore_no_link, 2), SHIFT_REPEAT(94),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [2157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(495),
  [2160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(160),
  [2163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(216),
  [2166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(261),
  [2169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(496),
  [2172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(261),
  [2175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(232),
  [2178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(264),
  [2181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(196),
  [2184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(185),
  [2187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(211),
  [2190] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(182),
  [2193] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(222),
  [2196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(245),
  [2199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(168),
  [2202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(95),
  [2205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(96),
  [2208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2), SHIFT_REPEAT(129),
  [2211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_tilde_no_link, 2),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2221] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(566),
  [2224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(161),
  [2227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2),
  [2229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(259),
  [2232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(314),
  [2235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(286),
  [2238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(314),
  [2241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(263),
  [2244] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(310),
  [2247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(205),
  [2250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(190),
  [2253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(270),
  [2256] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(194),
  [2259] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(269),
  [2262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(306),
  [2265] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(173),
  [2268] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(99),
  [2271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(98),
  [2274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 2), SHIFT_REPEAT(97),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [2281] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(495),
  [2284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(148),
  [2287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2),
  [2289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(216),
  [2292] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(261),
  [2295] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(248),
  [2298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(261),
  [2301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(232),
  [2304] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(264),
  [2307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(198),
  [2310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(177),
  [2313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(211),
  [2316] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(181),
  [2319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(222),
  [2322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(245),
  [2325] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(166),
  [2328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_base, 1),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [2334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(328),
  [2337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(151),
  [2340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(231),
  [2343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(247),
  [2346] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(258),
  [2349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(247),
  [2352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(217),
  [2355] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(241),
  [2358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(192),
  [2361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(183),
  [2364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(237),
  [2367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(188),
  [2370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(218),
  [2373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(244),
  [2376] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(171),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [2383] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(416),
  [2386] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(154),
  [2389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(235),
  [2392] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(240),
  [2395] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(246),
  [2398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(240),
  [2401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(238),
  [2404] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(249),
  [2407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(199),
  [2410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(184),
  [2413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(226),
  [2416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(187),
  [2419] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(236),
  [2422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(254),
  [2425] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(172),
  [2428] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(494),
  [2431] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(155),
  [2434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(212),
  [2437] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(267),
  [2440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(260),
  [2443] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(267),
  [2446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(208),
  [2449] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(256),
  [2452] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(191),
  [2455] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(176),
  [2458] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(209),
  [2461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(180),
  [2464] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(229),
  [2467] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(250),
  [2470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(170),
  [2473] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(566),
  [2476] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(156),
  [2479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(259),
  [2482] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(314),
  [2485] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(506),
  [2488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(314),
  [2491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(263),
  [2494] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(310),
  [2497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(201),
  [2500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(189),
  [2503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(270),
  [2506] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(195),
  [2509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(269),
  [2512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(306),
  [2515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(174),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [2520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(158),
  [2523] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(418),
  [2526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(193),
  [2529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(175),
  [2532] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(179),
  [2535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(167),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [2544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(162),
  [2547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(286),
  [2550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(205),
  [2553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(190),
  [2556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(194),
  [2559] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(173),
  [2562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(163),
  [2565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(496),
  [2568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(196),
  [2571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(185),
  [2574] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(182),
  [2577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(168),
  [2580] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(164),
  [2583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(312),
  [2586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(197),
  [2589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(178),
  [2592] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(186),
  [2595] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 2), SHIFT_REPEAT(169),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 1),
  [2602] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(206),
  [2605] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(678),
  [2608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(680),
  [2611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(680),
  [2614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(687),
  [2617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(656),
  [2620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(655),
  [2623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(676),
  [2626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(650),
  [2629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(692),
  [2632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(692),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [2639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(204),
  [2642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [2644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [2646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [2648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(207),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [2653] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(203),
  [2656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [2658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [2660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 1), SHIFT(200),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [2665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__text_base, 1),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [2669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(825),
  [2672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(825),
  [2675] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(829),
  [2678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__text_base, 1),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [2682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(828),
  [2685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(828),
  [2688] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(702),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [2693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(714),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [2698] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(754),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [2703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(701),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [2710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(833),
  [2713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(833),
  [2716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(827),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(824),
  [2724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(824),
  [2727] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(751),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [2732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(715),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [2737] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(748),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [2742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(728),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [2747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(708),
  [2750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(698),
  [2753] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(698),
  [2756] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(859),
  [2759] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(831),
  [2762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [2764] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(830),
  [2767] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(830),
  [2770] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(712),
  [2773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(683),
  [2776] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(683),
  [2779] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(861),
  [2782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [2784] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(705),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(696),
  [2792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(696),
  [2795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(858),
  [2798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [2800] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(703),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [2805] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(711),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2810] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(686),
  [2813] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(686),
  [2816] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(862),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [2821] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(765),
  [2824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [2830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [2832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [2836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [2844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [2848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(695),
  [2851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(695),
  [2854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(857),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [2859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(707),
  [2862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(202),
  [2865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(678),
  [2868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(680),
  [2871] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(687),
  [2874] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(656),
  [2877] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(655),
  [2880] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(676),
  [2883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(650),
  [2886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(692),
  [2889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_code_span_repeat1, 2), SHIFT_REPEAT(692),
  [2892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_code_span_repeat1, 2),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [2906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(847),
  [2909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(848),
  [2912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(848),
  [2915] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(658),
  [2918] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(210),
  [2921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2),
  [2923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(651),
  [2926] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(651),
  [2929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(653),
  [2932] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(654),
  [2935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_label_repeat1, 2), SHIFT_REPEAT(654),
  [2938] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(1066),
  [2941] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(905),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [2946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [2948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [2950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(651),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(654),
  [2960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [2962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [2964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [2966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [2968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(1065),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [2975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__whitespace, 1),
  [2977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__whitespace, 1),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [2991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [2993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [3003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [3005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [3007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [3009] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(1064),
  [3012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [3014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [3016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(1062),
  [3019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [3021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [3023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [3025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__soft_line_break, 1),
  [3027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__soft_line_break, 1),
  [3029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [3031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_description_non_empty, 4, .production_id = 6),
  [3033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_description_non_empty, 4, .production_id = 6),
  [3035] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(59),
  [3038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(66),
  [3041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [3043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1),
  [3045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3047] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(70),
  [3050] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(1067),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [3055] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(74),
  [3058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [3062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1),
  [3064] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element, 1),
  [3066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [3068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 3, .dynamic_precedence = 100),
  [3070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration, 3, .dynamic_precedence = 100),
  [3072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 1, .production_id = 2),
  [3074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 1, .production_id = 2),
  [3076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_underscore, 3, .dynamic_precedence = 1, .production_id = 4),
  [3078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_underscore, 3, .dynamic_precedence = 1, .production_id = 4),
  [3080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_tag, 1),
  [3082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_tag, 1),
  [3084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 2),
  [3086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 2),
  [3088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_comment, 4, .dynamic_precedence = 100),
  [3090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_comment, 4, .dynamic_precedence = 100),
  [3092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_label, 3),
  [3094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_label, 3),
  [3096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__open_tag, 3, .dynamic_precedence = 100),
  [3098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__open_tag, 3, .dynamic_precedence = 100),
  [3100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__open_tag, 4, .dynamic_precedence = 100),
  [3102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__open_tag, 4, .dynamic_precedence = 100),
  [3104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__closing_tag, 4, .dynamic_precedence = 100),
  [3106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__closing_tag, 4, .dynamic_precedence = 100),
  [3108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1, .production_id = 2),
  [3110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_star, 1, .production_id = 2),
  [3112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1, .production_id = 2), SHIFT(366),
  [3115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1, .production_id = 2),
  [3117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_underscore, 1, .production_id = 2),
  [3119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1, .production_id = 2), SHIFT(368),
  [3122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strong_emphasis_star, 3, .dynamic_precedence = 2, .production_id = 4),
  [3124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strong_emphasis_star, 3, .dynamic_precedence = 2, .production_id = 4),
  [3126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strikethrough, 4, .dynamic_precedence = 1, .production_id = 4),
  [3128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strikethrough, 4, .dynamic_precedence = 1, .production_id = 4),
  [3130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_star, 3, .dynamic_precedence = 1, .production_id = 4),
  [3132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_star, 3, .dynamic_precedence = 1, .production_id = 4),
  [3134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [3136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1, .production_id = 2), SHIFT(407),
  [3139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_underscore, 4, .dynamic_precedence = 1, .production_id = 4),
  [3141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_underscore, 4, .dynamic_precedence = 1, .production_id = 4),
  [3143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_link, 5, .dynamic_precedence = 10),
  [3145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_link, 5, .dynamic_precedence = 10),
  [3147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_star, 2),
  [3149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_star, 2),
  [3151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1, .production_id = 2), SHIFT(530),
  [3154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_inline_link, 5, .dynamic_precedence = 10),
  [3156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_inline_link, 5, .dynamic_precedence = 10),
  [3158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_code_span, 3, .dynamic_precedence = 100, .production_id = 3),
  [3160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_code_span, 3, .dynamic_precedence = 100, .production_id = 3),
  [3162] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1, .production_id = 2), SHIFT(528),
  [3165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_full_reference_link, 2, .dynamic_precedence = 10),
  [3167] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_full_reference_link, 2, .dynamic_precedence = 10),
  [3169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_inline_link, 8, .dynamic_precedence = 10),
  [3171] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_inline_link, 8, .dynamic_precedence = 10),
  [3173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_link, 8, .dynamic_precedence = 10),
  [3175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_link, 8, .dynamic_precedence = 10),
  [3177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_inline_link, 7, .dynamic_precedence = 10),
  [3179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_inline_link, 7, .dynamic_precedence = 10),
  [3181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_full_reference_link, 2, .dynamic_precedence = 20),
  [3183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_full_reference_link, 2, .dynamic_precedence = 20),
  [3185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__open_tag, 6, .dynamic_precedence = 100),
  [3187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__open_tag, 6, .dynamic_precedence = 100),
  [3189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_comment, 6, .dynamic_precedence = 100),
  [3191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_comment, 6, .dynamic_precedence = 100),
  [3193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_link, 7, .dynamic_precedence = 10),
  [3195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_link, 7, .dynamic_precedence = 10),
  [3197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__whitespace, 2),
  [3199] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__whitespace, 2),
  [3201] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_inline_link, 6, .dynamic_precedence = 10),
  [3203] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_inline_link, 6, .dynamic_precedence = 10),
  [3205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_link, 6, .dynamic_precedence = 10),
  [3207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_link, 6, .dynamic_precedence = 10),
  [3209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cdata_section, 2, .dynamic_precedence = 100),
  [3211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cdata_section, 2, .dynamic_precedence = 100),
  [3213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1, .production_id = 2), SHIFT(447),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [3218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__processing_instruction, 2, .dynamic_precedence = 100),
  [3220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__processing_instruction, 2, .dynamic_precedence = 100),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [3224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_comment, 2, .dynamic_precedence = 100),
  [3226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_comment, 2, .dynamic_precedence = 100),
  [3228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1, .production_id = 2), SHIFT(449),
  [3231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__soft_line_break, 2),
  [3233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__soft_line_break, 2),
  [3235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hard_line_break, 2),
  [3237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hard_line_break, 2),
  [3239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__text_base, 2),
  [3241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__text_base, 2),
  [3243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element, 2),
  [3245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element, 2),
  [3247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shortcut_link, 1, .dynamic_precedence = 10),
  [3249] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__link_text, 1, .dynamic_precedence = 10), REDUCE(sym_shortcut_link, 1, .dynamic_precedence = 10),
  [3252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_shortcut_link, 1, .dynamic_precedence = 10),
  [3254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1, .production_id = 2), SHIFT(426),
  [3257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_backslash_escape, 1),
  [3259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_backslash_escape, 1),
  [3261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_description, 3, .dynamic_precedence = 30),
  [3263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_comment, 5, .dynamic_precedence = 100),
  [3265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_comment, 5, .dynamic_precedence = 100),
  [3267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__open_tag, 5, .dynamic_precedence = 100),
  [3269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__open_tag, 5, .dynamic_precedence = 100),
  [3271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__closing_tag, 5, .dynamic_precedence = 100),
  [3273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__closing_tag, 5, .dynamic_precedence = 100),
  [3275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_inline_link, 4, .dynamic_precedence = 10),
  [3277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_inline_link, 4, .dynamic_precedence = 10),
  [3279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_image, 1),
  [3281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_image, 1),
  [3283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_shortcut_link, 1, .dynamic_precedence = 30),
  [3285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__image_shortcut_link, 1, .dynamic_precedence = 30), REDUCE(sym__image_description, 1, .dynamic_precedence = 30),
  [3288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_shortcut_link, 1, .dynamic_precedence = 30),
  [3290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_base_repeat1, 1, .production_id = 1),
  [3292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__inline_base_repeat1, 1, .production_id = 1),
  [3294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_link, 4, .dynamic_precedence = 10),
  [3296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_link, 4, .dynamic_precedence = 10),
  [3298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 4, .dynamic_precedence = 100),
  [3300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration, 4, .dynamic_precedence = 100),
  [3302] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_star, 1, .production_id = 2), SHIFT(283),
  [3305] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_code_span, 2, .dynamic_precedence = 100, .production_id = 3),
  [3307] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_code_span, 2, .dynamic_precedence = 100, .production_id = 3),
  [3309] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_star, 4, .dynamic_precedence = 1, .production_id = 4),
  [3311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_star, 4, .dynamic_precedence = 1, .production_id = 4),
  [3313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_tilde, 2),
  [3315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_tilde, 2),
  [3317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strong_emphasis_underscore, 3, .dynamic_precedence = 2, .production_id = 4),
  [3319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strong_emphasis_underscore, 3, .dynamic_precedence = 2, .production_id = 4),
  [3321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strikethrough, 3, .dynamic_precedence = 1, .production_id = 4),
  [3323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strikethrough, 3, .dynamic_precedence = 1, .production_id = 4),
  [3325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__link_text_non_empty, 3, .production_id = 5),
  [3327] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__link_text_non_empty, 3, .production_id = 5),
  [3329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_inline_link, 3, .dynamic_precedence = 10),
  [3331] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_inline_link, 3, .dynamic_precedence = 10),
  [3333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_collapsed_reference_link, 3, .dynamic_precedence = 10),
  [3335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_collapsed_reference_link, 3, .dynamic_precedence = 10),
  [3337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inline_link, 3, .dynamic_precedence = 10),
  [3339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inline_link, 3, .dynamic_precedence = 10),
  [3341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_collapsed_reference_link, 3, .dynamic_precedence = 10),
  [3343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__image_collapsed_reference_link, 3, .dynamic_precedence = 10),
  [3345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__cdata_section, 3, .dynamic_precedence = 100),
  [3347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__cdata_section, 3, .dynamic_precedence = 100),
  [3349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__processing_instruction, 3, .dynamic_precedence = 100),
  [3351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__processing_instruction, 3, .dynamic_precedence = 100),
  [3353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__html_comment, 3, .dynamic_precedence = 100),
  [3355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__html_comment, 3, .dynamic_precedence = 100),
  [3357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element, 1, .production_id = 2),
  [3359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element, 1, .production_id = 2),
  [3361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [3363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline, 1),
  [3365] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__inline, 1),
  [3367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [3369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__inline_element_no_underscore, 1, .production_id = 2), SHIFT(403),
  [3372] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(76),
  [3375] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__image_description, 1, .dynamic_precedence = 30),
  [3377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_underscore_no_link, 4, .dynamic_precedence = 1, .production_id = 4),
  [3379] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_underscore_no_link, 4, .dynamic_precedence = 1, .production_id = 4),
  [3381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_star_no_link, 1, .production_id = 2),
  [3383] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_star_no_link, 1, .production_id = 2),
  [3385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [3387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strikethrough_no_link, 4, .dynamic_precedence = 1, .production_id = 4),
  [3389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strikethrough_no_link, 4, .dynamic_precedence = 1, .production_id = 4),
  [3391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strong_emphasis_star_no_link, 3, .dynamic_precedence = 2, .production_id = 4),
  [3393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strong_emphasis_star_no_link, 3, .dynamic_precedence = 2, .production_id = 4),
  [3395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_underscore_no_link, 3, .dynamic_precedence = 1, .production_id = 4),
  [3397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_underscore_no_link, 3, .dynamic_precedence = 1, .production_id = 4),
  [3399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strong_emphasis_underscore_no_link, 3, .dynamic_precedence = 2, .production_id = 4),
  [3401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strong_emphasis_underscore_no_link, 3, .dynamic_precedence = 2, .production_id = 4),
  [3403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__strikethrough_no_link, 3, .dynamic_precedence = 1, .production_id = 4),
  [3405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__strikethrough_no_link, 3, .dynamic_precedence = 1, .production_id = 4),
  [3407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_star_no_link, 3, .dynamic_precedence = 1, .production_id = 4),
  [3409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_star_no_link, 3, .dynamic_precedence = 1, .production_id = 4),
  [3411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__emphasis_star_no_link, 4, .dynamic_precedence = 1, .production_id = 4),
  [3413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__emphasis_star_no_link, 4, .dynamic_precedence = 1, .production_id = 4),
  [3415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_link, 1, .production_id = 2),
  [3417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_link, 1, .production_id = 2),
  [3419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [3421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_underscore_no_link, 1, .production_id = 2),
  [3423] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_underscore_no_link, 1, .production_id = 2),
  [3425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [3427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [3429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [3431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [3433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__inline_element_no_tilde_no_link, 1, .production_id = 2),
  [3435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__inline_element_no_tilde_no_link, 1, .production_id = 2),
  [3437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [3439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [3441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__inline_no_link, 1),
  [3443] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__inline_no_link, 1),
  [3445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [3447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [3449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [3451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [3453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [3455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(666),
  [3457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [3459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [3461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [3463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [3465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(780),
  [3467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [3469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [3471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [3473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [3475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [3477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [3479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [3481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [3483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [3485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [3487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [3489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10), SHIFT(794),
  [3492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10), SHIFT(781),
  [3495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10), SHIFT(780),
  [3498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10), SHIFT(780),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [3503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [3505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [3507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [3509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [3511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [3513] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10), SHIFT(791),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [3544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(758),
  [3547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [3549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(806),
  [3551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [3553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [3555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [3557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(810),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [3565] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(756),
  [3568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(697),
  [3571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(697),
  [3574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__text_base, 1), SHIFT(860),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [3579] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(755),
  [3582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(805),
  [3585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(661),
  [3588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(794),
  [3591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(794),
  [3594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2),
  [3596] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(781),
  [3599] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(780),
  [3602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 2), SHIFT_REPEAT(780),
  [3605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT(805),
  [3608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT(799),
  [3611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT(787),
  [3614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT(787),
  [3617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT(771),
  [3620] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT(813),
  [3623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1),
  [3625] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 1),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [3629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT(805),
  [3632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT(799),
  [3635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT(787),
  [3638] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT(787),
  [3641] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT(771),
  [3644] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT(813),
  [3647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1),
  [3649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 1),
  [3651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [3653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [3655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [3657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [3659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [3661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [3663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [3665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [3667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [3669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [3671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [3673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10),
  [3675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_destination, 1, .dynamic_precedence = 10),
  [3677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(805),
  [3680] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(667),
  [3683] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(791),
  [3686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2),
  [3688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(791),
  [3691] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(781),
  [3694] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(780),
  [3697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 2), SHIFT_REPEAT(780),
  [3700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [3704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [3706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [3710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(817),
  [3712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [3714] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_destination, 3, .dynamic_precedence = 10),
  [3716] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_destination, 3, .dynamic_precedence = 10),
  [3718] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(805),
  [3721] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(672),
  [3724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(817),
  [3727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(817),
  [3730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2),
  [3732] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(781),
  [3735] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(780),
  [3738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_title_repeat3, 2), SHIFT_REPEAT(780),
  [3741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_destination, 2, .dynamic_precedence = 10),
  [3743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_destination, 2, .dynamic_precedence = 10),
  [3745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [3747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [3749] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__text_base, 1), SHIFT(1061),
  [3752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [3754] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(805),
  [3757] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(679),
  [3760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(787),
  [3763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(787),
  [3766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), SHIFT_REPEAT(771),
  [3769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2),
  [3771] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 2),
  [3773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(805),
  [3776] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(681),
  [3779] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(834),
  [3782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat1, 2),
  [3784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(834),
  [3787] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(780),
  [3790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat1, 2), SHIFT_REPEAT(780),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [3795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(822),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [3799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [3803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [3809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [3813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [3819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [3821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(752),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(730),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [3861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2),
  [3863] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_inline_link_repeat1, 2),
  [3865] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(781),
  [3868] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(780),
  [3871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(780),
  [3874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [3878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [3880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [3882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [3884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [3888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [3890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [3894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [3896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(743),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [3900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [3902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [3906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [3908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [3916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [3918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [3920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [3926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [3928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [3930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [3934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [3936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [3940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [3942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [3946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(718),
  [3948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [3952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [3954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [3958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [3960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [3964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [3966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [3970] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_comment_repeat1, 2), SHIFT_REPEAT(823),
  [3973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__html_comment_repeat1, 2), SHIFT_REPEAT(822),
  [3976] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_comment_repeat1, 2), SHIFT_REPEAT(831),
  [3979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__html_comment_repeat1, 2),
  [3981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_comment_repeat1, 2), SHIFT_REPEAT(830),
  [3984] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__html_comment_repeat1, 2), SHIFT_REPEAT(830),
  [3987] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__html_comment_repeat1, 2), SHIFT_REPEAT(744),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [3996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [4000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [4002] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(833),
  [4005] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(833),
  [4008] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(827),
  [4011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2),
  [4013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(824),
  [4016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(824),
  [4019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(767),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [4024] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(825),
  [4027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(825),
  [4030] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(829),
  [4033] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(828),
  [4036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(828),
  [4039] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 2), SHIFT_REPEAT(770),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [4054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [4056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(837),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [4072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat1, 2), SHIFT_REPEAT(838),
  [4075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat1, 2),
  [4077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat1, 2), SHIFT_REPEAT(847),
  [4080] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat1, 2), SHIFT_REPEAT(848),
  [4083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__attribute_value_repeat1, 2), SHIFT_REPEAT(848),
  [4086] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat1, 2), SHIFT_REPEAT(776),
  [4089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [4091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [4093] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(849),
  [4096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 2),
  [4098] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(847),
  [4101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(848),
  [4104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(848),
  [4107] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 2), SHIFT_REPEAT(778),
  [4110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [4112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [4114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [4116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [4118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat2, 2), SHIFT_REPEAT(837),
  [4121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat2, 2),
  [4123] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat2, 2), SHIFT_REPEAT(847),
  [4126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat2, 2), SHIFT_REPEAT(848),
  [4129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__attribute_value_repeat2, 2), SHIFT_REPEAT(848),
  [4132] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat2, 2), SHIFT_REPEAT(783),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [4145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [4147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 1),
  [4149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 1),
  [4151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [4153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [4155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(aux_sym_link_title_repeat1, 1),
  [4158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(aux_sym_link_title_repeat1, 1),
  [4161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [4163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(sym_link_title, 2),
  [4166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(sym_link_title, 2),
  [4169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 1), SHIFT_REPEAT(1060),
  [4172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(aux_sym_link_title_repeat2, 1),
  [4175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(aux_sym_link_title_repeat2, 1),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [4184] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 1), SHIFT_REPEAT(1060),
  [4187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(aux_sym_link_title_repeat3, 1),
  [4190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 1), REDUCE(aux_sym_link_title_repeat3, 1),
  [4193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 1),
  [4195] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat3, 1),
  [4197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [4199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [4201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [4203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [4205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [4207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [4209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [4211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__link_destination_parenthesis, 3),
  [4213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__link_destination_parenthesis, 3),
  [4215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__link_destination_parenthesis, 2),
  [4217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__link_destination_parenthesis, 2),
  [4219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__link_destination_parenthesis, 2), REDUCE(sym_link_title, 2),
  [4222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__link_destination_parenthesis, 2), REDUCE(sym_link_title, 2),
  [4225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 1), SHIFT_REPEAT(1060),
  [4228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat2, 3),
  [4230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 3),
  [4232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat1, 3),
  [4234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 3),
  [4236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), REDUCE(aux_sym_link_title_repeat1, 2),
  [4239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 2), REDUCE(aux_sym_link_title_repeat1, 2),
  [4242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [4244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat1, 2),
  [4246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), REDUCE(aux_sym_link_title_repeat2, 2),
  [4249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 2), REDUCE(aux_sym_link_title_repeat2, 2),
  [4252] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_link_destination_repeat2, 2), REDUCE(aux_sym_link_title_repeat3, 2),
  [4255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_link_destination_repeat2, 2), REDUCE(aux_sym_link_title_repeat3, 2),
  [4258] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat3, 2),
  [4260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat2, 2),
  [4262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [4264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [4266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__html_comment_repeat1, 1),
  [4268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__html_comment_repeat1, 1),
  [4270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [4272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__processing_instruction_repeat1, 1),
  [4274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__processing_instruction_repeat1, 1),
  [4276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [4278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_link_title_repeat3, 3),
  [4280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_link_title_repeat3, 3),
  [4282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [4284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [4286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [4288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [4290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [4292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__html_comment_repeat1, 2),
  [4294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [4296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [4298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__text_no_angle, 1),
  [4300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__text_no_angle, 1),
  [4302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [4304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__html_comment_repeat1, 3),
  [4306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__html_comment_repeat1, 3),
  [4308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat2, 1),
  [4310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__attribute_value_repeat2, 1),
  [4312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [4314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__attribute_value_repeat1, 1),
  [4316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__attribute_value_repeat1, 1),
  [4318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [4320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__text_no_angle, 2),
  [4322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__text_no_angle, 2),
  [4324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__processing_instruction_repeat1, 2),
  [4326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [4328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [4330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__declaration_repeat1, 1),
  [4332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 1),
  [4334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [4336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__attribute_value_repeat2, 2),
  [4338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__attribute_value_repeat1, 2),
  [4340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__declaration_repeat1, 2),
  [4342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [4344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [4346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [4348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [4350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [4352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [4354] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(831),
  [4357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(830),
  [4360] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(830),
  [4363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [4365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [4367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [4369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [4371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [4373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [4375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [4377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [4379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [4381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [4383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [4385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [4387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [4389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [4391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [4393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [4395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [4397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [4399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [4401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [4403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [4405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [4407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [4409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [4411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [4413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [4415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [4417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [4419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [4421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [4423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [4425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [4427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [4429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [4431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [4433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [4435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [4437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [4439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [4441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [4443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [4445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [4447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [4449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [4451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__open_tag_repeat1, 2),
  [4453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__open_tag_repeat1, 2), SHIFT_REPEAT(991),
  [4456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__open_tag_repeat1, 2), SHIFT_REPEAT(992),
  [4459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__open_tag_repeat1, 2), SHIFT_REPEAT(992),
  [4462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [4470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [4472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [4474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [4476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [4478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [4480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [4482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [4484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [4486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [4488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [4492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [4496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tag_name, 2),
  [4498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [4500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tag_name, 2),
  [4502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__tag_name, 1),
  [4504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [4506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__tag_name, 1),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [4510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [4512] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(1036),
  [4515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(1029),
  [4518] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(1029),
  [4521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [4523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [4525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__tag_name_repeat1, 2),
  [4527] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__tag_name_repeat1, 2), SHIFT_REPEAT(911),
  [4530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__tag_name_repeat1, 2),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [4534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [4538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [4540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [4542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [4544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(991),
  [4547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(992),
  [4550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_inline_link_repeat1, 2), SHIFT_REPEAT(992),
  [4553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [4555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [4557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [4559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [4561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [4563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [4565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [4567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [4569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [4571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [4573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [4583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [4585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [4587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [4589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [4591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [4593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [4607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [4621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [4623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [4625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [4627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [4629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute, 5),
  [4631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute, 5),
  [4633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute, 6),
  [4635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute, 6),
  [4637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_value, 2),
  [4639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_value, 2),
  [4641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute_value, 3),
  [4643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute_value, 3),
  [4645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__attribute, 4),
  [4647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__attribute, 4),
  [4649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_title, 3),
  [4651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_title, 3),
  [4653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_link_title, 2),
  [4655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_link_title, 2),
  [4657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [4659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [4661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [4663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [4665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [4667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [4669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [4671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [4673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [4675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [4677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [4679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [4681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [4683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [4685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [4687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [4689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [4691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [4693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [4695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [4697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [4699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [4701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__link_text, 2, .dynamic_precedence = 10),
  [4703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [4705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [4707] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [4709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [4711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [4713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [4715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [4717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [4719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [4721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_markdown_inline_external_scanner_create(void);
void tree_sitter_markdown_inline_external_scanner_destroy(void *);
bool tree_sitter_markdown_inline_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_markdown_inline_external_scanner_serialize(void *, char *);
void tree_sitter_markdown_inline_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_markdown_inline(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_markdown_inline_external_scanner_create,
      tree_sitter_markdown_inline_external_scanner_destroy,
      tree_sitter_markdown_inline_external_scanner_scan,
      tree_sitter_markdown_inline_external_scanner_serialize,
      tree_sitter_markdown_inline_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
